/*->c.caret */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "akbd.h"
#include "deb.h"
#include "transform.h"
#include "poll.h"
#include "key.h"
#include "etc.h"
#include "bits.h"

#include "xext.h"

#include "str.h"
#include "constants.h"


#include "object.h"
#include "chain.h"

#include "view.h"
#include "file.h"

#include "tools.h"

#include "macros.h"
#include "trap.h"


#include "caret.h"



static viewstr * activeview;


void setactiveview(viewstr * view)
{
 if(view!=activeview)
 {
  event(EVENT_ACTIVEVIEW,activeview,0);
  activeview=view;
  event(EVENT_ACTIVEVIEW,activeview,1);
 }
}


void clearactiveview(viewstr * view)
{
	if(view==activeview)
	{
  event(EVENT_ACTIVEVIEW,activeview,0);
  activeview=NULL;
  event(EVENT_ACTIVEVIEW,activeview,1);
	}
}


int xactiveview(int fp)
{
	return((int)activeview);
 USE(fp);
}




viewstr * caretview;

static viewstr * lastcaretview;




/* ensure that the caret is at least in a window */

os_error * caretensure(viewstr * view)
{
 if(caretview!=view)
 {
  setfocus(view->handle);
  if(caretview) toolcaret(caretview,0);
  caretview=lastcaretview=view;
  toolcaret(caretview,1);
 }
 return(NULL);
}



/* all main windows declare this function to handle loss/gain events */

os_error * carethandler(int handle,int userhandle,int gain)
{
/*
 if(gain) keyboard_on(1);
 else     keyboard_off();
*/
 if(gain) 
 {
  caretview=lastcaretview=(viewstr*)userhandle;
 }
 else
 {
  caretview=NULL;
 }

 toolcaret((viewstr*)userhandle,gain);

 event(EVENT_CARET,(viewstr*)userhandle,gain);

 return(NULL);

 USE(handle);
}



/*
static void keyzero(int userhandle)
{
 int key;

 menuview=(viewstr*)userhandle;
 menufile=menuview->file;
 key=-1;
 report(toolkey(&key)); 
 remzeroevent(keyzero,userhandle);
}
*/

/* all main windows declare this function to handle key presses */

os_error * keyhandler(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 int        count;
 int        ch;

 menuview=(viewstr*)userhandle;
 menufile=menuview->file;

// cprintf("key %x",*key);

 err=event(EVENT_KEYPRESS,menuview,(int)key);
 if(!err)
 {
  count=key[KEYDATA] & 0xFFFF;
  ch=*key;
  while(1)
  {
   err=keymacro(toolkey,key,MACENVKEY,(int)menuview);
   if(err) break;
   if(*key!=-1) break;
   count--;
   if(count>0)
   {
    *key=ch;
   }
   else
   {
    break;
   }
  }

  if(*key==-1 && !err)  /* we used the key press */
  {
   err=toolkey(key);


  /*  if(!bbc_adval(-1)) err=toolkey(key);
   else               addzeroevent(keyzero,userhandle); */
  }
 }

 return(err);

 USE(icon);
 USE(handle);
}


static os_error * toolkeyp(int ch)
{
// if(ch>0 && ch<256) cprintf("ch %c",ch);
// else cprintf("ch %x",ch);

 int key[4];

 key[KEYCODE]=ch;
 key[KEYTIME]=0;
 key[KEYDATA]=0;              
 key[KEYFLAGS]=0;

 return(toolkey(key));
}


os_error * expandtoolmacro(int n,viewstr * view,int macenv)
{
 os_error * err;

 menuview=view;
 menufile=menuview->file;

          err=expandamacro(toolkeyp,n,macenv,(int)view);
// problem macro may change or zero menufile/view e.g. new doc macro
// should we skip the next line or reset values?

 if(!err && menufile) err=toolkeyp(-1);

 return(err);
}


void type(int fp)
{
 os_error * err;
 char       string[1024];

 if(lastcaretview)
 {
  menuview=lastcaretview;
  menufile=menuview->file;

  xzstrncpy(string,stringptr(stack[fp]),sizeof(string));

//  cprintf("type %s",string);
  
  err=expandmacro(toolkeyp,string);
  if(!err) err=toolkeyp(-1);

  zreport(err);
 }
}


static os_error * eventhandler(int eventn,int userhandle,void * data,int data1)
{

 switch(eventn)
 {
  case EVENT_ENDPROGRAM:
//                        keyboard_off();
                        break;


      case EVENT_VCLOSE:
                        if(caretview==(viewstr*)data)
                        {
//                         keyboard_off();
                         caretview=NULL;
                        }

                        if(lastcaretview==(viewstr*)data) lastcaretview=NULL;
                        if(activeview==(viewstr*)data)    activeview=NULL;
                        break;
 }

 USE(userhandle);
 USE(data);
 USE(data1);

 return(NULL);
}


os_error * caretinit(void)
{
 os_error * err;

          err=addevent(EVENT_ENDPROGRAM,eventhandler,0);
 if(!err) err=addevent(EVENT_VCLOSE,eventhandler,0);

 return(err);
}

