/*->h.curvelo */

#define MAXBCUT 16

typedef struct cutstr
{
 coordstr c;
 int      type;

 int      u1;
 int      umin1;
 int      umax1;

 int      u2;
 int      umin2;
 int      umax2;

 int      dx1;       /* 1==increasing u, increases x */
 int      dy1;       /* 1==increasing u, increases y */
 int      d2x1;
 int      d2y1;

 int      dx2;
 int      dy2;
 int      d2x2;
 int      d2y2;
} cutstr;


/* results of a ray from x,y to left infinity, on a line cx[0],cx[1]    */
/* in INTERXY X denotes the line, and Y the end of the other line on it */

#define INTER     0x1
#define INTERCO   0x2
#define INTER00   0x4
#define INTER01   0x8
#define INTER10   0x10
#define INTER11   0x20
#define INTERMX1  0x40
#define INTERMX2  0x80



extern int hintersection(int x,int y,coordstr * cx);

/* intersections of horizontal ray  ray[0]->ray[1] with cx[0],cx[1] */

extern int hintersectionr(coordstr * ray,coordstr * cx,coordstr * result);
extern int vintersectionr(coordstr * ray,coordstr * cy,coordstr * result);

extern int hintersectionc(coordstr * ray,coordstr * cx,cutstr * result);
extern int vintersectionc(coordstr * ray,coordstr * cx,cutstr * result);


extern int linefraction(coordstr * cx,int x,int y);


extern int hbintersection(int x,int y,coordstr * cx);
extern int hbintersectionr(coordstr * ray,coordstr * cx,cutstr * result);
extern int vbintersectionr(coordstr * ray,coordstr * cx,cutstr * result);
extern int hbintersectionc(coordstr * ray,coordstr * cx,cutstr * result);
extern int vbintersectionc(coordstr * ray,coordstr * cx,cutstr * result);

extern int intersection(coordstr * coord0,coordstr * coord1,cutstr *result);
extern int bintersection(coordstr * coord0,coordstr * coord1,cutstr *result);
extern int bbintersection(coordstr * coord0,coordstr * coord1,cutstr * result);



extern int  bezval1(int p0,int p1,int p2,int p3,int u);
extern int  bezvalx(int p0,int p1,int p2,int p3,int u);

extern void bezval(bezier * b,coordstr * c,int u);
extern void bezgetext1(int p0,int p1,int p2,int p3,int * min,int * max
                                                  ,int * umin,int * umax);
extern void bezgetext(bezier * b,aboxstr * abox);

extern void bezsplit2(bezier * p,bezier * a,bezier * b,int u);
extern void bezsplit3(bezier * p,bezier * a,bezier * b,bezier * c,
                                                       int u1,int u2);

extern int  bezmaxmin(int p0,int p1,int p2,int p3,int * val,int * uval);


extern void bezdev(bezier * b,int u,int * dx,int * dy,int * d2x,int * d2y);


typedef struct bezsplitstr
{
 int    umin;
 int    umax;
 bezier b;
} bezsplitstr;


extern void bezchunks(bezier * p,bezsplitstr * bp,int * np,bezier * r);

extern void validpath(boxstr * box,int * flags,int * p);


extern os_error * bezinit(void);