/*->h.obj */                                                  

typedef void ** objptr;

typedef struct lockstr
{
 void  ** ptr;
 int      key;
 void   * obj;
} lockstr;


#define DMMAXLOCK 16


typedef struct domainstr
{
 char *  domaindata;      /* i.e. where all the stuff goes    */
 int     root;            /* offset of root pointer           */
 int     maxobject;       /* number of highest object in tree */
 int     bottom;          /* offset of lowest object          */
 int     size;            /* size of data used in buffer      */

 struct  domainstr * next;
 struct  domainstr * prev;

 int     lockn;
 lockstr lock[DMMAXLOCK];

} domainstr;



typedef struct objfilehdr
{
 char progname[12];
 char progmark[8];
 char progdate[64];

                      /* 172 bytes of stuff for compatability */

 int  version;        /* binary version */
 int  compatability;  /* if this is smaller than prog value, can't load */

 int  object;         /* number of ...         */
 int  type;           /* what on earth is this */


 int  root;
 int  maxobject;
 int  size;

 int  os;
 int  crc;

 char x[136];

} objfilehdr;


extern void     * ob_find(int n,domainstr * d);
extern os_error * ob_mod(int n,domainstr * d,objptr pointer);
extern os_error * ob_change(int n,domainstr * d,int newsize,objptr pointer);
extern os_error * ob_create(int size,domainstr * d,int type,objptr pointer);
extern os_error * ob_delete(int n,domainstr * d);
extern os_error * ob_lock(void ** ptr,int n,domainstr * d);
extern os_error * ob_unlock(void ** ptr,domainstr * d);
extern os_error * ob_copy(void ** dptr,domainstr * dd,int sn,domainstr * sd);

extern os_error * ob_static(void ** ptr,int n,domainstr * d);
extern os_error * ob_free(void ** ptr,domainstr * d);
extern int        ob_size(int n,domainstr * d,objptr pointer);


#define OBJ_CCINSTANCE  0x1

extern os_error * ob_setbits(int n,domainstr * d,int bits,objptr pointer);

extern os_error * ob_loadfile(char * name,domainstr ** d,int * object,int flags,int * xcompatability);
extern os_error * ob_readfile(buffer * bf,objfilehdr * hdr,domainstr ** d,
                                                           int * object);

extern os_error * ob_savefile(char * name,domainstr * d,int object,int ftype,int flags,int xcompatability);
extern os_error * ob_createdomain(domainstr ** d);
extern os_error * ob_deletedomain(domainstr ** d);
extern os_error * ob_compactdomain(domainstr * d);
extern os_error * ob_compactall(void);
extern os_error * ob_checkfree(int need,domainstr * d);


extern os_error * ob_test(domainstr * d);


typedef os_error * (*obenumfn)(void * obj);

extern os_error * ob_enum(domainstr * d,obenumfn fn);

extern os_error * ob_init(void);




