/*->c.posn */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "akbd.h"
#include "transform.h"


#include "err.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"
#include "dbhi.h"
#include "trans.h"
#include "xmath.h"
#include "colour.h"
#include "key.h"
#include "deb.h"


#include "etc.h"


#include "str.h"

#include "mhi.h"
#include "geometry.h"
#include "reslink.h"
#include "file.h"
#include "page.h"
#include "object.h"


#include "viewo.h"
#include "view.h"
#include "toolstr.h"

#include "posn.h"



/*****************************************************************************/

/* input is page relative x,y - output is the object the pointer is over     */
/* return 1 on success                                                       */
/* find box behind before                                                    */

int findbox(posnstr * posn,int before)
{
 posn->handle=posn->htype=0;

 posn->object=objectfind(posn,(objhdrstr*)fob_find(posn->page,posn->file),
                                                                  &before,0);
 if(posn->object)
 {
  posn->otype=((objhdrstr*)fob_find(posn->object,posn->file))->type;
  objectmaster(posn->object,posn->file,&posn->master,&posn->bits);
 }
 return(posn->object!=posn->page);
}


/* input is mouse position + view            */
/* output page, section page relative coords */
/* NB does not find objects, need to call above for that */


os_error * getposn(posnstr * posn)
{
 os_error   * err;
 int          x;
 int          y;
 viewstr    * view;
 filestr    * file;
 sectionstr * section;
 pagestr    * page;
 int          xshift=0;
 int          xshift1;
 int          xshift2;
 int          yshift=0;
 int          height;
 int          width1;
 int          width2;
 int          nextsection;

 view=posn->view;
 file=posn->file;
 posn->valid=0;

 width1=width2=file->hdr.maxpagewidth[view->branch];
 if(view->data.dble)
 {
  xshift1=view->border.leftborder+view->border.leftpb;
  width1+=xshift1;
  width1+=view->border.mid1pb;

  xshift2=view->border.mid2pb+view->border.vmidborder;
  width2+=xshift2;
  width2+=view->border.rightborder+view->border.rightpb;
 }
 else
 {
  xshift1=xshift2=view->border.leftborder+view->border.leftpb;
  width1+=xshift1;
  width1+=view->border.rightborder+view->border.rightpb;
 }

/* err=getw(view->handle,&window); */
 err=NULL;

 if(1 /* !err */)
 {
  x=posn->mousex-view->mainwindow.bx;//mainpane
  y=view->mainwindow.by-posn->mousey;

  x=ourunits(x,view);
  y=ourunits(y,view);

  posn->page=view->page;
  posn->section=view->section;


  posn->yps=view->ps;

  section=(sectionstr*)fob_find(posn->section,file);
  nextsection=section->chain.next;
                  
  while(1)
  {
   height=viewpageheight(view,posn->page,posn->section,&yshift);

   page=(pagestr*)fob_find(posn->page,file);

   posn->ype=posn->yps+height;
   posn->xps=0;
   posn->xpe=width1;
   xshift=xshift1;

   posn->ghost=isghost(view,posn->page,
                            posn->section,posn->xps); /* left hand page */

   if(((x>=posn->xps && x<=posn->xpe) || x<0) && 
      ((y>=posn->yps && y<=posn->ype) || y<0)) break;

   if(view->data.dble)
   {
                                        /* then right hand page */
    if(!posn->ghost && (page->chain.next || nextsection))
    {
     posn->page=page->chain.next;
     if(!posn->page)
     {
      posn->section=nextsection;
      if(posn->section)
      {
       section=(sectionstr*)fob_find(posn->section,file);
       nextsection=section->chain.next;
       posn->page=section->chain.child;
      }
     }
    }
    else if(!posn->ghost) return(err);

    page=(pagestr*)fob_find(posn->page,file);

    posn->xps=posn->xpe;
    posn->xpe+=width2;
    xshift=xshift2;

    posn->ghost=isghost(view,posn->page,posn->section,posn->xps);
    if((x>=posn->xps && x<=posn->xpe) && 
       ((y>=posn->yps && y<=posn->ype) || y<0)) break;
   }
  
   if(!posn->ghost && (page->chain.next || nextsection))
   {
    posn->page=page->chain.next;
    if(!posn->page)
    {
     posn->section=nextsection;
     if(posn->section)
     {
      section=(sectionstr*)fob_find(posn->section,file);
      nextsection=section->chain.next;
      posn->page=section->chain.child;
     }
    }
   }
   else if(!posn->ghost) return(err);

   posn->yps=posn->ype;
  }

  posn->xpo=posn->xps+xshift;
  posn->ypo=posn->yps+yshift;
  posn->y=y-posn->ypo;
  posn->x=x-posn->xpo;
  posn->valid=1;
 }
 return(err);
}




/* do initial set up on position str, get shift key state */

os_error * initposn(posnstr * posn,viewstr * view,filestr * file,
                                                       wimp_mousestr * m)
{
 memset(posn,0,sizeof(posnstr));

	if(m)
	{
  posn->mousex=m->x;
  posn->mousey=m->y;
  posn->buttons=m->bbits;
	}

 posn->view=view;
 posn->file=file;
 posn->branch=view->branch;
 posn->shift=isshift;
 posn->ctrl=isctrl;
 posn->alt=isalt;
 posn->chain=0;

// cprintf("alt=%d ctrl %d shift %d",posn->alt,posn->ctrl,posn->shift);

 posn->buttons|=posn->shift<<12;
 posn->buttons|=posn->ctrl<<13;
 posn->buttons|=posn->alt<<14;

 return(NULL);
}



os_error * initposn2(posnstr * posn,mousestr * mouse)
{
 os_error      * err;
 viewstr       * view;

 err=NULL;

 posn->valid=0;

 view=findview(mouse->handle);
 if(view)
 {
  initposn(posn,view,view->file,(wimp_mousestr*)mouse);
  err=getposn(posn);
 }

 return(err);
}

