/*->c.select */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"

#include "err.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "xmath.h"
#include "deb.h"


#include "etc.h"

#include "constants.h"
#include "str.h"
#include "object.h"
#include "reslink.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "xredraw.h"
#include "geometry.h"
#include "curve.h"

#include "posn.h"

#include "xcolour.h"

#include "frameflow.h"


#include "undo.h"
#include "clip.h"
#include "grid.h"


#include "select.h"
#include "selectx.h"



#define USADD           0x1100
#define USREM           0x1101
#define USTRANS         0x1102
#define USTRANF         0x1103
#define USFLOWS         0x1104
#define USFLOWF         0x1105
#define USDEL           0x1106
#define USMAKELOCALS    0x1107
#define USMAKELOCALF    0x1108
#define USMAKEMASTERS   0x1109
#define USMAKEMASTERF   0x110A
#define USDELETES       0x110B
#define USDELETEF       0x110C
#define UUNDUPFORWARD   0x110D
#define UDUPSCRAP       0x110E
#define UUNDUPBACKS     0x110F
#define UUNDUPBACKF     0x1110
#define USHAPES         0x1111
#define USHAPEF         0x1112
#define USHAPEFORWARD   0x1113
#define USSET           0x1114
#define USMODIFYS       0x1115
#define USMODIFYF       0x1116
#define USMOVES         0x1117
#define USMOVEF         0x1118
#define USCOPYS         0x1119
#define USCOPYF         0x111A
#define USMCOPY         0x111B
#define USMDELETE       0x111C
#define USMFORWARD      0x111D
#define USMBACKWARD     0x111E
#define UNDUPDELETE     0x111F
#define UNDUPS          0x1120
#define UNDUPF          0x1121

/* in h.selectx

#define USCOLOURS       0x1122
#define USCOLOURF       0x1123

*/



#define SELCHUNK 16*sizeof(selectedobjectstr)



       selectedobjectstr * selection; /* is there something selected ? */
       int                 selectn;   /* number of objects             */
       filestr           * selfile;
       int                 selpagek;
       int                 selsectk;
       int                 selmaster;

static int                 selrobject; /* single object we want to redraw */

       colourvalue         selcv;     /* colour of page */

       int                 crosshairs;


/*****************************************************************************/



os_error * makeaselectionlist(int ** list,int * listn,int * sect,int * page)
{
 os_error * err;
 int        i;
 int      * slx;
 int        sln;

 sln=*listn=selectn;
 if(sect) *sect=selsectk;
 if(page) *page=selpagek;

 err=flex_alloc((flex_ptr)list,sizeof(int)*sln);
 if(!err)
 {
  slx=*list;
  for(i=0;i<sln;i++) slx[i]=selection[i].object;
 }

 return(err);
}


os_error * clearaselectionlist(int ** list)
{
 return(flex_free((flex_ptr)list));
}


int inslist(int object,int * list,int listn)
{
 int i;

 for(i=0;i<listn;i++)
   if(list[i]==object) break;

 return(i<listn);
}


void sortselectionlist(filestr * file,int ** list,int listn)
{
 int object;
 int last;
 int lastn;
 int n;
 int i;
 sobjectstr * sob;
 int temp;

 n=listn;
 while(n>1)
 {
  lastn=0;
  last=object=(*list)[0];
  while(object)
  {
   sob=(sobjectstr*)fob_find(object,file);
   object=sob->chain.next;
   for(i=0;i<n;i++)
   {
    if((*list)[i]==object)
    {
     last=object;
     lastn=i;
     break;
    }
   }
  }
  temp=(*list)[n-1];
  (*list)[n-1]=(*list)[lastn];
  (*list)[lastn]=temp;

  n--;
 }
}


void getslistbox(boxstr * box,filestr * file,int ** list,int listn)
{
 int          i;
 sobjectstr * sob;

 for(i=0;i<listn;i++)
 {
  sob=(sobjectstr*)fob_find((*list)[i],file);
  if(i==0) *box=sob->box;
  else     getsumbox(box,&sob->box);
 }
}


int getselectionbox(boxstr * box,filestr * file)
{
 int          i;
 sobjectstr * sob;

 if(selectn && selfile==file)
 {
  for(i=0;i<selectn;i++)
  {
   sob=(sobjectstr*)fob_find(selection[i].object,file);
   if(i==0) *box=sob->box;
   else     getsumbox(box,&sob->box);
  }
  return(1);
 }
 else return(0);
}



int getfirstselected(filestr * file,int page) 
{
 os_error * err;
 int        object;
 int      * list;
 int        listn;

 object=-1;

 if(file==selfile && page==selpagek && selectn)
 {
  err=makeaselectionlist(&list,&listn,NULL,NULL);
  if(!err)
  {
   sortselectionlist(file,&list,listn);
   object=list[0];

   clearaselectionlist(&list);
  }
 }

 return(object);
}



os_error * selectionmessage(filestr * file,int * message,void * data)
{
 os_error * err;
 int        i;
 int      * list;
 int        listn;

 err=NULL;

 if(nselected(NULL,file))
 {
  err=makeaselectionlist(&list,&listn,NULL,NULL);
  if(!err)
  {
   i=0;

   while(i<listn)
   {
    objectmessage2(list[i],file,message,data);
    if(!*message) break;
    i++;
   }

   clearaselectionlist(&list);
  }
 }

 return(err);
}


/*****************************************************************************/

void selsetpagesection(int pagek,int sectionk,filestr * file)
{
 sectionstr * sectionp;
 pagestr    * pagep;
 int          hand;

 selsectk=sectionk;
 selpagek=pagek;
 selfile=file;

 pagep=(pagestr*)fob_find(pagek,file);
 hand=pagep->data.number & 0x1;

 sectionp=(sectionstr*)fob_find(sectionk,file);
 selmaster=sectionp->branch;

 selcv=sectionp->data.colour[hand];
}


int isselected(int object,filestr * file)
{
 int i;

 if(file==selfile)
 {
  for(i=0;i<selectn;i++)
  {
   if(selection[i].object==object) return(1);
  }
 }

 return(0);
}



int isselectedbig(int object,filestr * file)
{
 int i;

 if(file==selfile)
 {
  for(i=0;i<selectn;i++)
  {
   if(selection[i].object==object) return(object);
   else
   if(objectinobject(object,selection[i].object,file)) 
                                          return(selection[i].object);
  }
 }
 return(0);
}




int selectedparent(int object,filestr * file)
{
 chainobject * link;

 while(1)
 {
  if(!object || isselected(object,file)) break;

  link=(chainobject*)fob_find(object,file);
  object=parentof(link,file);
 }

 return(object);
}


int isselectedpage(int page,filestr * file)
{
 return(file==selfile && page==selpagek && selectn);
}


// /def:".\dtp.def"
/* selected objects in this file, and return first one */

int nselected(int * object,filestr * file)
{
 int n;

 n=0;


 if(file==selfile)
 {
  n=selectn;
  if(n && object) *object=selection[0].object;
 }

 return(n);
}



int xnselected(int fp)
{
 return(nselected(NULL,menufile));
 USE(fp);
}



int selectionfile(int fp)
{
 return(selectn?(int)selfile:0);
 USE(fp);
}



int selectedbranch(filestr * file,int branch)
{
	return(file==selfile && selmaster==branch);
}



int nselectedobject(int n,filestr * file)
{
 if(file==selfile && n<selectn) return(selection[n].object);
 else                           return(0);
}



int selectiontype(int * object,filestr * file)
{
 int          i;
 sobjectstr * sob;
 int          type;

 type=0;
 *object=0;

 if(file==selfile)
 {
  for(i=0;i<selectn;i++)
  {
   sob=(sobjectstr*)fob_find(selection[i].object,file);
   if(i==0) 
   {
    type=sob->type;
    *object=selection[i].object;
   }
   else
   if(type!=sob->type) return(0);
  }
  return(type);
 }

 return(0);
}




filestr * getselection(int * page,int * section,
                             selectedobjectstr ** selectionp,int * selectnp)
{
 if(page)       *page=selpagek;
 if(section)    *section=selsectk;
 if(selectionp) *selectionp=selection;
 if(selectnp)   *selectnp=selectn;

 return(selfile);
}







/* eor's the selection for just one object */

static os_error * updateselection(int object)
{
 os_error * err;
 selrobject=object;
 err=viewrefresharea(selfile,selpagek,NULL,VRSELECTION|VRONELAYER);
 selrobject=0;

 return(err);
}



/* closing the editpath file */

static os_error * selfileclose(int eventn,int user,filestr * file,int data1)
{
 if(file==selfile && selectn)
 {
  selectn=0;
 }

 USE(data1);
 USE(user);
 USE(eventn);

 return(NULL);
}



os_error * addselection(int object,filestr * file,int seltype)
{
 os_error * err;
 int        data[2];

 err=NULL;

 if(!isselected(object,file) && seltype)
 {
  if(!selection) err=flex_alloc((flex_ptr)&selection,SELCHUNK);
  else           err=flex_chunk((flex_ptr)&selection,
                              (selectn+1)*sizeof(selectedobjectstr),SELCHUNK);

  if(!err)
  {
   event(EVENT_OBJECTSELECTED0,file,object);

   selection[selectn].object=object;
   selection[selectn].seltype=seltype;

   selectn++;

   updateselection(object);

   data[0]=object;
   data[1]=seltype;
   undowritefn(file,USREM,data,sizeof(data));

//   cprintf("add selection %d",object);

   event(EVENT_OBJECTSELECTED1,file,object);
  }
 }
 return(err);
}


os_error * remselection(int object,filestr * file,int seltype)
{
 int i;
 int data[2];

 for(i=0;i<selectn;i++)
 {
  if(selection[i].object==object)
  {
   event(EVENT_OBJECTDESELECTED0,file,object);

   data[0]=object;
   data[1]=selection[i].seltype;
   undowritefn(file,USADD,data,sizeof(data));

   updateselection(object);
   selection[i]=selection[selectn-1];
   selectn--;

   if(!selectn) 
   {
    data[0]=selpagek;
    data[1]=selsectk;
    undowritefn(file,USSET,data,sizeof(data));
   }

   event(EVENT_OBJECTDESELECTED1,file,object);
   break;
  }
 }
 return(NULL);

 USE(file);
 USE(seltype);
}


/* tagged to USADD */

static os_error * unaddselection(filestr * file)
{
 int data[2];
 undoread(file,data,sizeof(data));
 return(addselection(data[0],file,data[1]));
}


/* tagged to USREM */

static os_error * unremselection(filestr * file)
{
 int data[2];
 undoread(file,data,sizeof(data));
 return(remselection(data[0],file,data[1]));
}


/* tagged to USSET */

static os_error * unsetselection(filestr * file)
{
 int data[2];

 clearselection();

 undoread(file,data,sizeof(data));
 selsetpagesection(data[0],data[1],file);

 return(NULL);
}



os_error * ssaveselection(filestr * file)
{
 int data[2];
 int i;

 if(selectn && file==selfile)
 {
  for(i=0;i<selectn;i++)
  {
   data[0]=selection[i].object;
   data[1]=selection[i].seltype;
   undowritefn(file,USADD,data,sizeof(data));
  }

  data[0]=selpagek;
  data[1]=selsectk;
  undowritefn(file,USSET,data,sizeof(data));
 }

 return(NULL);
}


os_error * clearselectionlo(void)
{
 posnstr posn;

 posn.file=selfile;

 if(selection)
 {
  while(selectn)
  {
   objectselect((objhdrstr *)fob_find(selection[0].object,selfile),
                                                    &posn,DESELECTOBJECT);
  }
 }

 return(NULL);
}




os_error * clearselectionff(filestr * file,int section,int page,int branch)
{

 if(selection && selectn && selfile==file)
 {
  if(section==selsectk || section==-1)
  {
   if(page==selpagek || page==-1)
   {
    if(branch==selmaster || branch==-1)
    {
     return(clearselectionlo());
    }
   }
  }
 }

 return(NULL);
}



os_error * clearselectionf(filestr * file)
{
 return(clearselectionff(file,-1,-1,-1));
}



os_error * clearselection(void)
{
 if(selection && selectn)
 {
  undostart(selfile);
  clearselectionlo();
  undoend(selfile);
 }
 return(NULL);
}


os_error * selectobject(int object,int page,int section,filestr * file)
{
 posnstr posn;

 posn.file=file;
 posn.page=page;
 posn.section=section;

 objectselect((objhdrstr *)fob_find(object,file),&posn,SELECTOBJECT);

 return(NULL);
}


os_error * changeselection(posnstr * posn,int type,int clear)
{
 undostart(posn->file);

 if(clear || (selectn && (selfile!=posn->file || selpagek!=posn->page ||
                          selsectk!=posn->section))) clearselection();

 objectselect((objhdrstr *)fob_find(posn->object,posn->file),posn,type);
 undoend(posn->file);

 return(NULL);
}



#define SELSUB 16


/* generate sub box given number and frame curve */


static void setsubbox(curvestr * c,viewstr * view,transformstr * tr,
                      transformstr * xtr,transformstr * ytr,int * invert)
{
 int             dim;
 transformbitstr bits;

 tr_getbits(tr,&bits);

 tr_setbits(xtr,&bits,TR_SHIFT|TR_ROTATE);
 tr_setbits(ytr,&bits,TR_SCALE|TR_SKEW);

 *invert=(bits.yscale<0);

 dim=ourunits(SELSUB,view);
 c->box.w=dim;
 c->box.h=dim;
 c->type=CBOX;
}



static char tagmap[]={
                      0, /* 0 */
                      7, /* 1 */
                      6, /* 2 */
                      5, /* 3 */
                      4, /* 4 */
                      3, /* 5 */
                      2, /* 6 */
                      1, /* 7 */ 
                      8, /* 8 */
                     };


static void getsubbox(int tag,curvestr * fcurve,
                      curvestr * c,transformstr * ytr,int invert)
{
 coordstr cx;

 if(invert) tag=tagmap[tag];

 switch(tag)
 {
  case 0:     /* init */
  case 1:     /* top left */
         cx.x=fcurve->box.x;
         cx.y=fcurve->box.y;
         break;


  case 2:    /* top mid */
         cx.x=fcurve->box.x+fcurve->box.w/2;
         cx.y=fcurve->box.y;
         break;

  case 3:    /* top right */
         cx.x=fcurve->box.x+fcurve->box.w;
         cx.y=fcurve->box.y;
         break;

  case 4:    /* right mid */
         cx.y=fcurve->box.y+fcurve->box.h/2;
         cx.x=fcurve->box.x+fcurve->box.w;
         break;

  case 5:    /* bottom right */
         cx.y=fcurve->box.y+fcurve->box.h;
         cx.x=fcurve->box.x+fcurve->box.w;
         break;

  case 6:    /* bottom mid */
         cx.x=fcurve->box.x+fcurve->box.w/2;
         cx.y=fcurve->box.y+fcurve->box.h;
         break;

  case 7:    /* bottom left */
         cx.x=fcurve->box.x;
         cx.y=fcurve->box.y+fcurve->box.h;
         break;

  case 8:    /* left mid */
         cx.y=fcurve->box.y+fcurve->box.h/2;
         cx.x=fcurve->box.x;
         break;

 }


 tr_transformset(&cx,1,ytr);

 c->box.x=cx.x-c->box.w/2;
 c->box.y=cx.y-c->box.h/2;
}



/* see if the position is over one of the box handles */

int findboxhandle(posnstr * posn)
{
 viewstr      * view;
 int            i;
 int            j;
 curvestr       c;
 coordstr       point;
 int            master;
 objectbitstr   bits;
 transformstr   xtr;
 transformstr   ytr;
 outlineinfostr outline;
 int            invert;


 posn->handle=0;
 posn->htype=0;

 if(selection && selectn)
 {
  if(posn->file==selfile && posn->page==selpagek)
  {
   view=posn->view;

   for(i=0;i<selectn;i++)
   {
    objectmaster(selection[i].object,posn->file,&master,&bits);
    if((!master || bits.local) && !bits.locked && !bits.noresize)
    {
     objectoread(SELECTINFO,selection[i].object,posn->file,&outline);

     point.x=posn->x;
     point.y=posn->y;

     /* generate ears */

     setsubbox(&c,view,&outline.tr,&xtr,&ytr,&invert);
   
     tr_inverseset(&point,1,&xtr);

     for(j=1;j<9;j++)
     {
      getsubbox(j,&outline.fcurve,&c,&ytr,invert);

      if(insidebox(point.x,point.y,&c.box))
      {
       posn->handle=j;
       posn->object=selection[i].object;
       if(posn->object)
       {
        posn->otype=((objhdrstr*)fob_find(posn->object,posn->file))->type;
        objectmaster(posn->object,posn->file,&posn->master,&posn->bits);
       }
       return(1);
      }
     }
    }
   }
  }
 }
 return(0);
}




os_error * redrawselection(viewredrawstr * v)
{
 os_error     * err;
 viewstr      * view;
 int            i;
 int            j;
 curvestr       c;
 int            master;
 objectbitstr   bits;
 int            wimpcolour;
 transformstr   xtr;
 transformstr   ytr;
 outlineinfostr outline;
 int            invert;


 err=NULL;


 if(selection && selectn)
 {
  if(v->file==selfile && !v->isprinter && v->page==selpagek)
  {
   view=v->view;

   for(i=0;i<selectn;i++)
   {
    if(!selrobject || selection[i].object==selrobject)
    {
     objectoread(SELECTINFO,selection[i].object,v->file,&outline); 

     if(outline.fcurve.type==CBOX && view->data.guides)
     {
      wimpcolour=(WIMPGREY3<<4)|SELECTCOLOUR|OUTLINEWIMPLINE|OUTLINEEOR;
     }
     else
     {
     /* wimpcolour=SELECTCOLOUR|OUTLINEWIMPLINE|OUTLINEEOR|OUTLINECVBACK; */
      wimpcolour=(WIMPWHITE<<4)|SELECTCOLOUR|OUTLINEWIMPLINE|OUTLINEEOR;
     }

     if(outline.fcurve.type==CLINE) /* only ever used on guide lines */
      err=outlineline(v,&outline.fcurve,wimpcolour,&selcv,&outline.tr,CLINE);
     else
      err=outlinebox(v,&outline.fcurve,wimpcolour,&selcv,&outline.tr);

     objectmaster(selection[i].object,v->file,&master,&bits);
     if((!master || bits.local) && !bits.locked && !bits.noresize)
     {
      /* generate ears */

      setsubbox(&c,view,&outline.tr,&xtr,&ytr,&invert);

      for(j=1;j<9;j++)
      {
       getsubbox(j,&outline.fcurve,&c,&ytr,invert);
    /* wimpcolour=HANDLECOLOUR|OUTLINEWIMPLINE|OUTLINEEOR|OUTLINECVBACK;*/
       wimpcolour=(WIMPWHITE<<4)|HANDLECOLOUR|OUTLINEWIMPLINE|OUTLINEEOR;
       err=outlinecurve(v,&c,wimpcolour,&selcv,&xtr);
      }
     }
    }
   }
  }
 }

 return(err);
}



os_error * redrawselectiont(viewredrawstr * v,transformfn trf,int flags)
{
 os_error   * err;
 viewstr    * view;
 int          i;
 sobjectstr * sob;
 transformstr r;
 curvestr     xcurve;
 int          master;
 objectbitstr bits;
 int          wimpcolour;
 int          type;
 int          chn;
 boxstr       maxbox;
 boxstr       box;
 int          xcrosshairs;


 err=NULL;

 if(selection && selectn)
 {
  if(!v->isprinter)
  {
   view=v->view;

 /* wimpcolour=SELECTDRAGCOLOUR|OUTLINEWIMPLINE|OUTLINEEOR|OUTLINECVBACK; */
   wimpcolour=(WIMPWHITE<<4)|SELECTDRAGCOLOUR|OUTLINEWIMPLINE|OUTLINEEOR;
   chn=0;
   xcrosshairs=crosshairs && (flags & 0x1);

   for(i=0;i<selectn;i++)
   {
    objectmaster(selection[i].object,selfile,&master,&bits);
    if((!master || bits.local) && !bits.locked)
    {
     sob=(sobjectstr*)fob_find(selection[i].object,selfile);
     xcurve=sob->fcurve;

     type=trf(&r,&sob->transform,&sob->fcurve,&sob->transform); 
     correctcurve(&r,&sob->transform,&xcurve);

     if(bits.hlock || bits.vlock)
     {
      if((type & TR_SHIFT)!=type) r=sob->transform; /* nb other bits! */
      else
      {
       if(bits.hlock) r.e=sob->transform.e;
       else
       /*if(bits.vlock)*/ r.f=sob->transform.f;
      }
     }

     if(xcrosshairs)
     {
      getmaxbox(&box,&xcurve.box,&r);
      if(i==0) maxbox=box;
      else     getsumbox(&maxbox,&box);
      chn++;
     }
     else
     {
      err=outlinecurve(v,&xcurve,wimpcolour,&selcv,&r);
     }
    }
   }

   if(chn)
   {
    err=outlinecross(v,&maxbox,wimpcolour,&selcv);
   }
  }
 }
 return(err);
}


/* tagged to USTRANS */
/* this function is always called last in undo/redo */

static os_error * untransformselections(filestr * file)
{
 event(EVENT_TRANSFORMSELECTION,file,0);

 frflflush(file);
 vxflush(file,VRBACK,selpagek,selsectk);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 selrobject=0;
 viewrefresharea(file,selpagek,NULL,VRSELECTION|VRONELAYER);
 event(EVENT_TRANSFORMSELECTION1,file,0);

 return(undowritefn(file,USTRANF,NULL,0));
}


/* tagged to USTRANF */

static os_error * untransformselectionf(filestr * file)
{
 event(EVENT_TRANSFORMSELECTION0,file,0);
 viewrefresharea(file,selpagek,NULL,VRSELECTION|VRONELAYER);
 selrobject=-1;
 vxstart(file);
 frflstart(file);

 return(undowritefn(file,USTRANS,NULL,0));
}


/*

typedef int (*transformfn)(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct);

Parameters are
in
c  the curve which defines what is to be transformed
ct the transform matrix for the curve
t  the transform to be transformed

out
 r the resulting transform

 */


os_error * transformselections(transformfn trf,int flags,modifyfn modfn)
{
 os_error   * err;
 int          i;
 objhdrstr  * sob;
 int          master;
 objectbitstr bits;


 err=NULL;

 if(selection && selectn)
 {
  err=modfile(selfile,selsectk);
  if(!err)
  {
   undostart(selfile);

   event(EVENT_TRANSFORMSELECTIONR0,selfile,0);

   untransformselectionf(selfile);

   for(i=0;i<selectn;i++)
   {
    objectmaster(selection[i].object,selfile,&master,&bits);
    if((!master || bits.local) && !bits.locked && 
        !((flags & TRMIRROR) && !bits.canmirror))
    {
     if(modfn) err=modfn(selection[i].object,selfile);

     sob=(objhdrstr*)fob_find(selection[i].object,selfile);

     err=objecttransform(sob,selfile,trf,flags);
     if(err) break;
    }
   }

   untransformselections(selfile);

   event(EVENT_TRANSFORMSELECTIONR1,selfile,0);

   undoend(selfile);
  }
 }
 return(err);
}


os_error * transformselection(transformfn trf,int flags)
{
 return(transformselections(trf,flags,NULL));
}


/***************************************************************************/

static viewstr * sview;

static int snaptrans(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 coordstr     cx;
 int          dx;
 int          dy;
 transformstr t1;

 cx.x=c->box.x;
 cx.y=c->box.y;

 tr_transformset(&cx,1,ct);

 dx=gridsnapx(cx.x,sview,1)-cx.x;
 dy=gridsnapy(cx.y,sview,1)-cx.y;

 tr_setshift(&t1,dx,dy);

 tr_multiply(r,t,&t1);

 return(TR_SHIFT);

 USE(ct);
}


void snaptogrid(int fp)
{
 sview=menuview;
 zreport(transformselection(snaptrans,0));
 USE(fp);
}




/*****************************************************************************/


#ifdef NEVER

static int xxxdx;
static int xxxdy;


static int xxxtrans(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 coordstr     cx;
 transformstr t1;

 cx.x=c->box.x;
 cx.y=c->box.y;

 tr_transformset(&cx,1,ct);

 tr_setshift(&t1,xxxdx,xxxdy);

 tr_multiply(r,t,&t1);

 return(TR_SHIFT);

 USE(ct);
}


void xtrans(int fp)
{
 sview=menuview;

 xxxdx=0;
 xxxdy=rand()>>22;

 zreport(transformselection(xxxtrans,0));
 USE(fp);
}


#endif





/*****************************************************************************/

/* tagged to USFLOWS */
/* this function is always called last in undo/redo */

static os_error * unupdateflowselections(filestr * file)
{
 event(EVENT_TEXTFLOWSELECTION,file,0);

 frflflush(file);
 vxflush(file,VRBACK,selpagek,selsectk);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 event(EVENT_TEXTFLOWSELECTION1,file,0);

 return(undowritefn(file,USFLOWF,NULL,0));
}


/* tagged to USFLOWF */

static os_error * unupdateflowselectionf(filestr * file)
{
 event(EVENT_TEXTFLOWSELECTION0,file,0);
 vxstart(file);
 frflstart(file);

 return(undowritefn(file,USFLOWS,NULL,0));
}



static os_error * sflowobject(int object,int donext,
                                         filestr * file,objectflowstr * flow)
{
 os_error    * err;
 int           master;
 objectbitstr  bits;
 int           child;
 sobjectstr  * sob;

 err=NULL;

 while(object)
 {
  objectmaster(object,file,&master,&bits);
  if(!master || bits.local)
  {
   sob=(sobjectstr*)fob_find(object,file);
   object=sob->chain.next;
   child=sob->chain.child;
   err=objectflow((objhdrstr*)sob,selfile,flow,0);
   if(err) break;
   err=sflowobject(child,1,file,flow);
   if(err) break;
  }
  if(!donext) break;
 }

 return(err);
}



os_error * updateflowselection(objectflowstr * flow)
{
 os_error   * err;
 int          i;


 err=NULL;

 if(selection && selectn)
 {
  err=modfile(selfile,selsectk);
  if(!err)
  {
   err=undostart(selfile);
   if(!err)
   {
    unupdateflowselectionf(selfile);

    for(i=0;i<selectn;i++)
    {
     err=sflowobject(selection[i].object,0,selfile,flow);
     if(err) break;
    }

    unupdateflowselections(selfile);

    undoend(selfile);
   }
  }
 }

 return(err);
}

/****************************************************************************/


/* tagged to USMODIFYS */
/* this function is always called last in undo/redo */

static os_error * unmodifyselections(filestr * file)
{

 event(EVENT_MODIFYSELECTION,file,0);

 frflflush(file);
 vxflush(file,VRBACK,selpagek,selsectk);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 selrobject=0;
 viewrefresharea(file,selpagek,NULL,VRSELECTION|VRONELAYER);
 event(EVENT_MODIFYSELECTION1,file,0);

 return(undowritefn(file,USMODIFYF,NULL,0));
}


/* tagged to USMODIFYF */

static os_error * unmodifyselectionf(filestr * file)
{

 event(EVENT_MODIFYSELECTION0,file,0);
 viewrefresharea(file,selpagek,NULL,VRSELECTION|VRONELAYER);
 selrobject=-1;
 vxstart(file);
 frflstart(file);

 return(undowritefn(file,USMODIFYS,NULL,0));
}



os_error * modifyselection(modifyfn modfn)
{
 os_error   * err;
 int          i;
 objhdrstr  * sob;
 int          master;
 objectbitstr bits;


 err=NULL;

 if(selection && selectn)
 {
  err=modfile(selfile,selsectk);
  if(!err)
  {
   undostart(selfile);

   unmodifyselectionf(selfile);

   for(i=0;i<selectn;i++)
   {
    objectmaster(selection[i].object,selfile,&master,&bits);
    if(!master || bits.local)
    {
     sob=(objhdrstr*)fob_find(selection[i].object,selfile);
     err=modfn(selection[i].object,selfile);
     if(err) break;
    }
   }

   unmodifyselections(selfile);

   undoend(selfile);
  }
 }
 return(err);
}


/*****************************************************************************/
/* delete the selected objects */


/* tagged to USDELETES */
/* this function is always called last in undo/redo */

static os_error * undeleteselections(filestr * file) 
{
 event(EVENT_SELECTIONDELETED,file,0);

 frflflush(file);
 vxflush(file,VRBACK,selpagek,selsectk);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 return(undowritefn(file,USDELETEF,NULL,0));
}


/* tagged to USDELETEF */

static os_error * undeleteselectionf(filestr * file)
{
 frflstart(file);
 vxstart(file);

 return(undowritefn(file,USDELETES,NULL,0));
}




os_error * deleteselection(filestr * file)
{
 os_error    * err;
 int           i;
 int           object;
 int           master;
 objectbitstr  bits;
 int           message;
 chainobject * link;
 int         * list=NULL;
 int           listn=0;


 err=NULL;

 if(nselected(NULL,file)>=1)
 {
  err=modfile(selfile,selsectk);
  if(!err) err=makeaselectionlist(&list,&listn,NULL,NULL);
  if(!err)
  {
   if(!err)
   {
    undeleteselectionf(selfile);

    clearselectionlo();

    for(i=0;i<listn;i++)
    {
     object=list[i];
     objectmaster(object,selfile,&master,&bits);
     if((!master || bits.local) && !bits.nodelete && !bits.locked)
     {
      if(embededobject(object,selfile))
      {
       message=OM_DELEMBED;
       link=(chainobject*)fob_find(object,selfile);

       objectmessage2(link->chain.parent,selfile,&message,(void*)object);
      }
      else
      {
       err=objectdelete((objhdrstr*)fob_find(object,selfile),0,selfile);
      }
     }
    }

    undeleteselections(selfile);
   }
   clearaselectionlist(&list);
  }
 }

 return(err);
}

/*****************************************************************************/


#ifdef NEVER


/* tagged to UDUPSCRAP */

static os_error * undupscrap(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(objectdelete((objhdrstr*)fob_find(object,file),DELETESCRAP,file));
}



static os_error * duplicateselectionsub(int times,int dx,int dy)
{
 os_error   * err;
 int          i;
 int          j;
 boxstr       bbox;
 boxstr       pbox;
 pagestr    * page;
 filestr    * file;
 int          pagek;
 int          sectionk;
 int          branch;
 int          after;
 int          parent;
 objectloc    sloc;
 objectloc    dloc;
 transformstr tr;
 int          firstlast;
 int          tdx;
 int          tdy;

 err=NULL;



 undowritefn(selfile,UUNDUPBACKS,&times,sizeof(int));
 undowrite(selfile,&dx,sizeof(int));
 undowrite(selfile,&dy,sizeof(int));


 if(selection && selectn)
 {
  if(!err)
  {
   file=selfile;
   pagek=selpagek;
   sectionk=selsectk;
   branch=selmaster;
                                                                                   page=fob_find(selpagek,selfile);
   pbox=page->box;

   after=endofchain(selection[0].object,file); /* was page->chain.child   */
                         /* by doing this can avoid ref. to which chain   */
                         /* assume that there must be something in chain  */
                         /* already */

   if(after) parent=0;
   else      parent=pagek;

   frflstart(selfile);
   vxstart(file);

   makeselectionlist();

   getslistbox(&bbox,file);

   sortselectionlist(file);

   clearselectionlo();

   tdx=tdy=0;

   for(i=0;i<times;i++)
   {
    while(1)
    {                                  /* check dimensions of parent etc */
     if((bbox.x+dx)<pbox.x) dx=-dx/2;
     else
     if((bbox.x+bbox.w+dx)>(pbox.x+pbox.w)) dx=-dx/2;
     else
     if((bbox.y+dy)<pbox.y) dy=-dy/2;
     else
     if((bbox.y+bbox.h+dy)>(pbox.y+pbox.h)) dy=-dy/2;
     else                             /* converges to original box */
     break;
    }

    tdx+=dx;
    tdy+=dy;
    bbox.x+=dx;
    bbox.y+=dy;

    for(j=0;j<slistn;j++)
    {
     memset(&sloc,0,sizeof(objectloc));
     memset(&dloc,0,sizeof(objectloc));

     sloc.file=file;
     sloc.object=slist[j];
     sloc.page=pagek;
     sloc.section=sectionk;
     sloc.branch=branch;

    /* 
     sloc.parent=0;
     sloc.after=0;
     sloc.chain=0;
     sloc.copymode=0; */

     dloc.file=file;
     dloc.object=0;
     dloc.page=pagek;
     dloc.section=sectionk;
     dloc.parent=parent;
     dloc.after=after;
     dloc.branch=branch;

   /* 
     dloc.chain=0;
     dloc.copymode=0;  */

     tr_setshift(&tr,tdx,tdy);

     err=objectcopy(&sloc,&dloc,&tr);

     after=dloc.object;
     undowritefn(selfile,UDUPSCRAP,&after,sizeof(int));

     parent=0;
     if(!j) firstlast=dloc.object;
    }
   }

   clearselectionlist();

   frflflush(file);
   vxflush(file,VRBACK,selpagek,selsectk);

   frflvalid(file);

   frflscrap(file);
   vxscrap();
  }
 }

 undowritefn(selfile,UUNDUPBACKF,NULL,0);

 return(err);
}





static os_error * undupbacks(filestr * file)
{
 int        times;
 int        dx;
 int        dy;


 undoread(file,&times,sizeof(int));
 undoread(file,&dx,sizeof(int));
 undoread(file,&dy,sizeof(int));

 undowritefn(file,UUNDUPFORWARD,&times,sizeof(int));
 undowrite(file,&dx,sizeof(int));
 undowrite(file,&dy,sizeof(int));


 frflflush(file);
 vxflush(file,VRBACK,selpagek,selsectk);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 return(NULL);
}


static os_error * undupbackf(filestr * file)
{
 frflstart(file);
 vxstart(file);

 return(NULL);
}




/* tagged to UUNDUPFORWARD */

static os_error * undupforward(filestr * file)
{
 os_error * err;
 int        times;
 int        dx;
 int        dy;

 undoread(file,&times,sizeof(int));
 undoread(file,&dx,sizeof(int));
 undoread(file,&dy,sizeof(int));

 err=duplicateselectionsub(times,dx,dy);

 return(err);
}


#endif





static os_error * undupdelete(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(objectdelete((objhdrstr*)fob_find(object,file),0,file));
}



static os_error * undups(filestr * file)
{
 frflflush(file);
 vxflush(file,VRBACK,selpagek,selsectk);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 return(undowritefn(file,UNDUPF,NULL,0));
}


static os_error * undupf(filestr * file)
{
 frflstart(file);
 vxstart(file);

 return(undowritefn(file,UNDUPS,NULL,0));
}





static os_error * duplicateselectionsub(int times,int dx,int dy)
{
 os_error    * err;
 int           i;
 int           j;
 boxstr        bbox;
 boxstr        pbox;
 pagestr     * page;
 filestr     * file;
 int           pagek;
 int           sectionk;
 int           branch;
 int           after;
 int           parent;
 objectloc     sloc;
 objectloc     dloc;
 transformstr  tr;
 int           firstlast;
 int           tdx;
 int           tdy;
 int         * list;
 int           listn;
 int           first;
 int           object;
 chainobject * link;


 err=NULL;


 if(selection && selectn)
 {
  file=selfile;

  err=undupf(file);

  if(!err)
  {
   pagek=selpagek;
   sectionk=selsectk;
   branch=selmaster;
   page=(pagestr*)fob_find(selpagek,selfile);
   pbox=page->box;

   after=endofchain(selection[0].object,file); /* was page->chain.child   */
                         /* by doing this can avoid ref. to which chain   */
                         /* assume that there must be something in chain  */
                         /* already */

   if(after) parent=0;
   else      parent=pagek;

   first=0;

   makeaselectionlist(&list,&listn,NULL,NULL);

   getslistbox(&bbox,file,&list,listn);


   getsumbox(&pbox,&bbox);  /* fix problem with duplicate on pasteboard */
                            /* looping for ever */

   sortselectionlist(file,&list,listn);

   clearselectionlo();

   tdx=tdy=0;

   for(i=0;i<times;i++)
   {
    while(1)
    {                                  /* check dimensions of parent etc */
     if((bbox.x+dx)<pbox.x) dx=-dx/2;
     else
     if((bbox.x+bbox.w+dx)>(pbox.x+pbox.w)) dx=-dx/2;
     else
     if((bbox.y+dy)<pbox.y) dy=-dy/2;
     else
     if((bbox.y+bbox.h+dy)>(pbox.y+pbox.h)) dy=-dy/2;
     else                             /* converges to original box */
     break;
    }

    tdx+=dx;
    tdy+=dy;
    bbox.x+=dx;
    bbox.y+=dy;

    for(j=0;j<listn;j++)
    {
     memset(&sloc,0,sizeof(objectloc));
     memset(&dloc,0,sizeof(objectloc));

     sloc.file=file;
     sloc.object=list[j];
     sloc.page=pagek;
     sloc.section=sectionk;
     sloc.branch=branch;

    /* 
     sloc.parent=0;
     sloc.after=0;
     sloc.chain=0;
     sloc.copymode=0; */

     dloc.file=file;
     dloc.object=0;
     dloc.page=pagek;
     dloc.section=sectionk;
     dloc.parent=parent;
     dloc.after=after;
     dloc.branch=branch;

   /* 
     dloc.chain=0;
     dloc.copymode=0;  */

     tr_setshift(&tr,tdx,tdy);

     err=objectcopy(&sloc,&dloc,&tr);

     after=dloc.object;
     undowritefn(selfile,UNDUPDELETE,&after,sizeof(int));

     if(!first) first=after;

     parent=0;
     if(!j) firstlast=dloc.object;
    }
   }

   clearaselectionlist(&list);

   listn*=times;

   if(first)
   {
    object=first;
    while(listn-- && object)
    {
     selectobject(object,pagek,sectionk,file);
     link=(chainobject*)fob_find(object,file);
     object=link->chain.next;
    }
   }

   undups(file);
  }
 }

 return(err);
}





os_error * duplicateselection(filestr * file,int times,int dx,int dy)
{
 os_error    * err;
 int           i;
 int           master;
 objectbitstr  bits;


 err=NULL;


 if(nselected(NULL,file)>=1)
 {
  for(i=0;i<selectn;i++)
  {
   if(embededobject(selection[i].object,selfile))
   {
    err=geterror(EOB01);
    break;
   }
  }

  if(!err)
  {
   for(i=0;i<selectn;i++)
   {
    objectmaster(selection[i].object,file,&master,&bits);
    if(bits.nocopy) break;
   }

   if(i>=selectn)
   {
    if(!err) err=modfile(selfile,selsectk);
    if(!err)
    {
     err=undostart(selfile);
     if(!err)
     {
      err=duplicateselectionsub(times,dx,dy);
      undoend(selfile);
     }
    }
   }
  }
 }
 return(err);
}


/****************************************************************************/


static os_error * shapeselectionsub(int shape,int data)
{
 os_error * err;
 int        i;

 err=NULL;

 if(selection && selectn)
 {
  err=modfile(selfile,selsectk);
  if(!err)
  {
   undowritefn(selfile,USHAPES,&shape,sizeof(int));
   undowrite(selfile,&data,sizeof(int));

   event(EVENT_SHAPESELECTION0,selfile,0);

   frflstart(selfile);
   vxstart(selfile);

   for(i=0;i<selectn;i++)
   {
    objectshape(selection[i].object,shape,data,selfile);
   }

   frflflush(selfile);
   vxflush(selfile,VRBACK,selpagek,selsectk);

   frflvalid(selfile);

   frflscrap(selfile);
   vxscrap();

   event(EVENT_SHAPESELECTION1,selfile,0);

   undowritefn(selfile,USHAPEF,NULL,0);
  }
 }

 return(err);
}



/* tagged to USHAPES */
/* called last       */

static os_error * unshapes(filestr * file)
{
 int        shape;
 int        data;

 undoread(file,&shape,sizeof(int));
 undoread(file,&data,sizeof(int));

 undowritefn(selfile,USHAPEFORWARD,&shape,sizeof(int));
 undowrite(selfile,&data,sizeof(int));

 frflflush(file);
 vxflush(file,VRBACK,selpagek,selsectk);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 event(EVENT_SHAPESELECTION1,file,0);

 return(NULL);
}


/* tagged to USHAPEF */
/* called first      */

static os_error * unshapef(filestr * file)
{
 event(EVENT_SHAPESELECTION0,file,0);

 frflstart(file);
 vxstart(file);

 return(NULL);
}


/* tagged to USHAPEFORWARD */

static os_error * unshapeforward(filestr * file)
{
 os_error * err;
 int        shape;
 int        data;

 undoread(file,&shape,sizeof(int));
 undoread(file,&data,sizeof(int));

 err=shapeselectionsub(shape,data);

 return(err);
}




static int canshapeselection(void)
{
 int          i;
 int          master;
 objectbitstr bits;


 if(selection && selectn)
 {
  for(i=0;i<selectn;i++)
  {
   objectmaster(selection[i].object,selfile,&master,&bits);
   if(!((!master || bits.local) && !bits.noshape)) return(0);
  }
  return(1);
 }

 return(0);
}


os_error * shapeselection(int shape,int data)
{
 os_error * err;

 err=NULL;

 if(canshapeselection())
 {
  err=undostart(selfile);
  if(!err)
  {
   err=shapeselectionsub(shape,data);
   undoend(selfile);
  }
 }

 return(err);
}


/****************************************************************************/


os_error * copyselection(filestr * sfile)
{
 os_error   * err;
 int          after;
 int          parent;
 boxstr       box;
 objectloc    sloc;
 objectloc    dloc;
 transformstr tr;
 int          page;
 int          sect;
 filestr    * dfile;
 int          j;
 int          master;
 objectbitstr bits;
 int        * list;
 int          listn;


 err=NULL;

 if(nselected(NULL,sfile)>=1)
 {
  makeaselectionlist(&list,&listn,NULL,NULL);

  for(j=0;j<listn;j++)
  {
   objectmaster(list[j],sfile,&master,&bits);
   if(bits.nocopy) break;
  }

  if(j>=listn)
  {
   getslistbox(&box,sfile,&list,listn);

   sortselectionlist(sfile,&list,listn);

   clipstart(&box,&page,&sect,&dfile);
   frflstart(dfile);

   parent=page;
   after=0;

   for(j=0;j<listn;j++)
   {
    sloc.file=sfile;
    sloc.object=list[j];
    sloc.page=selpagek;
    sloc.section=selsectk;
    sloc.parent=0;
    sloc.after=0;
    sloc.chain=0;
    sloc.branch=0;
    sloc.copymode=0;

    dloc.file=dfile;
    dloc.object=0;
    dloc.page=page;
    dloc.section=sect;
    dloc.parent=parent;
    dloc.after=after;
    dloc.chain=0;
    dloc.branch=0;
    dloc.copymode=LOCOVERWRITE|LOCCLIP;

    tr_setshift(&tr,-box.x,-box.y);

    err=objectcopy(&sloc,&dloc,&tr);

    after=dloc.object;
    parent=0;
   }

   clipend(CLIP_OBJECT,NULL);
   frflend(dfile);
  }
  clearaselectionlist(&list);
 }

 return(err);
}



/*****************************************************************************/

/* tagged to USMOVES */
/* this function is always called last in undo/redo */

typedef struct pagesectstr
{
 int page;
 int section;
 int branch;
} pagesectstr;

static pagesectstr xpages;


static os_error * unsmoves(filestr * file)
{
 pagesectstr xpages2;

 xpages2.page=selpagek;
 xpages2.section=selsectk;

 selsetpagesection(xpages.page,xpages.section,file);

 frflflush(file);
 vxflushn(VRBACK);

 frflvalid(file);

 frflscrap(file);
 vxscrap();


 selrobject=0;
 viewrefresharea(file,xpages.page,NULL,VRSELECTION|VRONELAYER);

 event(EVENT_MOVESELECTION1,file,0);

 return(undowritefn(file,USMOVEF,&xpages2,sizeof(pagesectstr)));
}


/* tagged to USMOVEF */

static os_error * unsmovefsub(filestr * file)
{
 event(EVENT_MOVESELECTION0,file,0);

 viewrefresharea(file,selpagek,NULL,VRSELECTION|VRONELAYER);
 selrobject=-1;
  
 vxstartn(file,selpagek,selsectk,0);
 vxstartn(file,xpages.page,xpages.section,1);

 frflstart(file);

 return(undowritefn(file,USMOVES,NULL,0));
}


static os_error * unsmovef(filestr * file)
{
 undoread(file,&xpages,sizeof(pagesectstr));
 return(unsmovefsub(file));
}




/* tagged to USCOPYS */
/* this function is always called last in undo/redo */

static os_error * unscopys(filestr * file)
{
 frflflush(file);
 vxflush(file,VRBACK,xpages.page,xpages.section);

 frflvalid(file);

 frflscrap(file);
 vxscrap();


 return(undowritefn(file,USCOPYF,&xpages,sizeof(pagesectstr)));
}


/* tagged to USCOPYF */


static os_error * unscopyfsub(filestr * file)
{

 vxstart(file);
 frflstart(file);

 return(undowritefn(file,USCOPYS,NULL,0));
}



static os_error * unscopyf(filestr * file)
{
 undoread(file,&xpages,sizeof(pagesectstr));
 return(unscopyfsub(file));
}


/* tagged to USMCOPY */

static os_error * uncopydelete(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(objectdelete((objhdrstr*)fob_find(object,file),0,file));
}


#ifdef NEVER

/* scrap for above, *and* tagged to USMDELETE */
static os_error * uncopyscrap(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(objectdelete(fob_find(object,file),DELETESCRAP,file));
}

/* tagged to USMBACKWARD */

static os_error * uncopybackward(filestr * file)
{
 os_error     * err;
 transformstr   tr;
 int            after;
 int            parent;
 int            branch;
 objectloc      sloc;
 objectloc      dloc;
 int            i;
 sectionstr   * sectionp;
 int          * list;
 int            listn;


 undoread(file,&tr,sizeof(transformstr));
 undowritefn(file,USMFORWARD,&tr,sizeof(transformstr));

 /* copy selection */

 sectionp=fob_find(xpages.section,file);
 branch=sectionp->branch;

 pagenext(file,xpages.page,&after,&parent);

 memset(&sloc,0,sizeof(objectloc));
 memset(&dloc,0,sizeof(objectloc));

 makeaselectionlist(&list,&listn,NULL,NULL);
 sortselectionlist(file,&list,listn);

 
 for(i=0;i<listn;i++)
 {
  sloc.file=file;
  sloc.object=list[i];
  sloc.page=selpagek;
  sloc.section=selsectk;
  sloc.copymode=0;
  sloc.chain=0;
  sloc.branch=selmaster;

  dloc.file=file;
  dloc.object=0;
  dloc.page=xpages.page;
  dloc.section=xpages.section;
  dloc.parent=parent;
  dloc.after=after;
  dloc.copymode=0;
  dloc.chain=0;
  dloc.branch=branch;

  err=objectcopy(&sloc,&dloc,&tr);

  after=dloc.object;

  undowritefn(file,USMDELETE,&after,sizeof(int));

  parent=0;
 }

 clearaselectionlist(&list);

 return(NULL);
}


/* tagged to USMFORWARD */

static os_error * uncopyforward(filestr * file)
{
 transformstr tr;

 undoread(file,&tr,sizeof(transformstr));
 return(undowritefn(file,USMBACKWARD,&tr,sizeof(transformstr)));
}


static os_error * uncopyforwards(filestr * file,transformstr * tr)
{
 return(undowritefn(file,USMFORWARD,tr,sizeof(transformstr)));
}

#endif




os_error * moveselection(posnstr * s,posnstr * d,int copy,
                                             transformfn trf,transformstr * tr)
{
 os_error     * err;
 objectloc      sloc;
 objectloc      dloc;
 int            i;
 int            j;
 int            parent;
 int            after;
 filestr      * sfile;
 filestr      * dfile;
 int            master;
 objectbitstr   bits;
 int          * list;
 int            listn;


 err=NULL;

 sfile=s->file;
 dfile=d->file;


 /* object can be the page... */


 if(!copy && sfile==dfile && s->page==d->page) err=transformselection(trf,0);
 else
 {
  if(nselected(NULL,sfile)>=1)
  {
   makeaselectionlist(&list,&listn,NULL,NULL);
   sortselectionlist(sfile,&list,listn);

// unicode compatability check

   for(j=0;j<listn;j++)
   {
    err=checkcompatability(sfile,list[j],0,dfile);
			 if(err) break;
			}

   if(!err) err=modfile(dfile,d->section);
   if(!err)
   {
    if(!copy) err=modfile(sfile,s->section);
    if(!err)
    {
     pagenext(dfile,d->page,&after,&parent);

     memset(&sloc,0,sizeof(objectloc));
     memset(&dloc,0,sizeof(objectloc));

     if(copy || sfile!=dfile)
     {
      for(j=0;j<listn;j++)
      {
       objectmaster(list[j],sfile,&master,&bits);
       if((master && !bits.local) || 
          (bits.nocopy && copy) ||
          (bits.nodelete && !copy)
         ) break;
      }

      if(j>=listn)
      {
       xpages.page=d->page;
       xpages.section=d->section;

       err=undostart(dfile);
       if(!err)
       {
        unscopyfsub(dfile);

   /*  if(sfile==dfile) uncopyforwards(sfile,tr); */
 
        for(i=0;i<listn;i++)
        {
         sloc.file=sfile;
         sloc.object=list[i];
         sloc.page=selpagek;
         sloc.section=selsectk;
         sloc.copymode=0;
         sloc.chain=0;
         sloc.branch=selmaster;

         dloc.file=dfile;
         dloc.object=0;
         dloc.page=d->page;
         dloc.section=d->section;
         dloc.parent=parent;
         dloc.after=after;
         dloc.copymode=0;
         dloc.chain=0;
         dloc.branch=d->branch;

         err=objectcopy(&sloc,&dloc,tr);
         if(err) break;

         after=dloc.object;
     /*  if(sfile!=dfile) undowritefn(dfile,USMCOPY,&after,sizeof(int));
         else             undowritefn(sfile,USMDELETE,&after,sizeof(int)); */

         undowritefn(dfile,USMCOPY,&after,sizeof(int));

         parent=0;
        }

        unscopys(dfile);
        undoend(dfile);
       }
      }

      if(!err)
      {
       if(j>=listn)
       {
        if(!copy && sfile!=dfile)
        {
         /* delete source */
         err=undostart(sfile);
         if(!err)
         {
          err=deleteselection(sfile);
          undoend(sfile);
         }
        }
       }
      }
     }
     else /* moving frames within a document */
     {
//      makeaselectionlist(&list,&listn,NULL,NULL);
//      sortselectionlist(sfile,&list,listn);
                                      /* good idea to move back frames first */

      for(j=0;j<listn;j++)
      {
       objectmaster(list[j],sfile,&master,&bits);
       if((master && !bits.local) || 
          (bits.nopagemove && d->page!=selpagek) ||
          (bits.nosectionmove && d->section!=selsectk)
         ) break;
      }

      if(j>=listn)
      {
       err=undostart(sfile);
       if(!err)
       {
        xpages.page=d->page;
        xpages.section=d->section;

        unsmovefsub(sfile);

        for(j=0;j<listn;j++)
        {
         sloc.file=sfile;
         sloc.object=list[j];
         sloc.page=selpagek;
         sloc.section=selsectk;
         sloc.branch=selmaster;
         sloc.chain=0;

         dloc.file=sfile;
         dloc.object=0;
         dloc.page=d->page;
         dloc.section=d->section;
         dloc.parent=parent;
         dloc.after=after;
         dloc.copymode=LOCUNDO|LOCMOVE;
         dloc.branch=d->branch;
         dloc.chain=0;

         err=objectcopy(&sloc,&dloc,tr);

         after=dloc.object;
         parent=0;
        }

        unsmoves(sfile);

        undoend(sfile);
       }
      }
      else
      {
       /* can't move part of a selection */
      }


     }
    }
   }
   clearaselectionlist(&list);
  }
 }

 return(err);
}


/***************************************************************************/



os_error * checkcompatability(filestr * sfile,int object,int flags,filestr * dfile)
{
	os_error * err;
	int        message;

	err=NULL;

	cprintf("check compat");

	if(dfile->compatability<sfile->compatability)
	{
		message=OM_COMPATABILITY;

		if(object)
  {
			if(flags & CHECKC_CHAIN)
			{
    err=objectchainmessage(object,sfile,&message,dfile);
			}
			else
			{
			 err=objectmessage2(object,sfile,&message,dfile);
			}
		}
		else
  {
		 err=broadcastmessage(sfile,&message,dfile);
		}
	}

	if(err) cprintf("check compat raises err");

	return(err);
}



/****************************************************************************/

#ifdef NEVER

/* tagged to USDEL */

static os_error * undodeleteobjectscrap(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(fob_delete(object,file));
}


/* when we delete an object (with no sub objects etc)                   */
/* can leave all subpointers etc. the object will remain until scrapped */
/* by the fn above                                                      */

os_error * undodeleteobject(filestr * file,int object)
{
 os_error * err;

 if(object)
 {
  err=undowritefn(file,USDEL,&object,sizeof(int));
 }
 else err=NULL;

 return(err);
}

#endif


/*****************************************************************************/

/* tagged to USMAKELOCALS */
/* this function is always called last in undo/redo */

static os_error * unmakelocals(filestr * file) 
{
 event(EVENT_LOCALSELECTION,file,0);
 selrobject=0;
 viewrefresharea(file,selpagek,NULL,VRSELECTION|VRONELAYER);

 return(undowritefn(file,USMAKELOCALF,NULL,0));
}

/* tagged to USMAKELOCALF */

static os_error * unmakelocalf(filestr * file)
{
 selrobject=0;
 viewrefresharea(file,selpagek,NULL,VRSELECTION|VRONELAYER);
 selrobject=-1;

 return(undowritefn(file,USMAKELOCALS,NULL,0));
}

static os_error * localselection(void)
{
 os_error   * err;
 int          i;
 int          object;

 err=NULL;

 if(selection && selectn)
 {
  err=modfile(selfile,selsectk);
  if(!err)
  {
   undostart(selfile);
   unmakelocalf(selfile);

   for(i=0;i<selectn;i++)
   {
    object=selection[i].object;
    err=objectlocal(object,selfile,1);
   }

   unmakelocals(selfile);
   undoend(selfile);
  }
 }
 return(err);
}








/* tagged to USMAKEMASTERS */
/* this function is always called last in undo/redo */

static os_error * unmakemasters(filestr * file) 
{
 event(EVENT_MASTERSELECTION,file,0);

 frflflush(file);
 vxflush(file,VRBACK,selpagek,selsectk);

 frflvalid(file);

 frflscrap(file);
 vxscrap();

 selrobject=0;
 viewrefresharea(file,selpagek,NULL,VRSELECTION|VRONELAYER);

 return(undowritefn(file,USMAKEMASTERF,NULL,0));
}


/* tagged to USMAKEMASTERF */

static os_error * unmakemasterf(filestr * file)
{
 selrobject=0;
 viewrefresharea(selfile,selpagek,NULL,VRSELECTION|VRONELAYER);
 selrobject=-1;

 frflstart(file);
 vxstart(file);

 return(undowritefn(file,USMAKEMASTERS,NULL,0));
}


static os_error * masterselection(void)
{
 os_error   * err;
 int          i;
 int          object;

 err=NULL;

 if(selection && selectn)
 {
  err=modfile(selfile,selsectk);
  if(!err)
  {
   undostart(selfile);

   unmakemasterf(selfile);

   for(i=0;i<selectn;i++)
   {
    object=selection[i].object;
    err=objectlocal(object,selfile,0);
   }

   unmakemasters(selfile);

   undoend(selfile);
  }
 }

 return(err);
}





void makeselectionlocal(int fp)
{
 report(localselection());
 USE(fp);
}



void makeselectionmaster(int fp)
{
 report(masterselection());
 USE(fp);
}



int canmakelocal(int fp)
{
 int          i;
 int          master;
 objectbitstr bits;

 if(selection && selectn)
 {
  for(i=0;i<selectn;i++)
  {
   objectmaster(selection[i].object,menufile,&master,&bits);
   if(master && !bits.local && bits.canmakelocal) return(1);
  }
 }

 return(0);

 USE(fp);
}



int canmakemaster(int fp)
{
 int          i;
 int          master;
 objectbitstr bits;

 if(selection && selectn)
 {
  for(i=0;i<selectn;i++)
  {
   objectmaster(selection[i].object,menufile,&master,&bits);
   if(master && bits.local) return(1);
  }
 }

 return(0);

 USE(fp);
}




static int cancopys(void)
{
 int          i;
 int          master;
 objectbitstr bits;

 if(selection && selectn)
 {
  for(i=0;i<selectn;i++)
  {
   objectmaster(selection[i].object,menufile,&master,&bits);
   if(bits.nocopy) return(0);
  }
  return(1);
 }
 else
 {
  return(0);
 }
}



int cancopy(int fp)
{
 int claim;

 claim=0;
 event(EVENT_CANCOPYSELECTION,menufile,(int)&claim);
 if(claim==1) return(1);
 else
 if(claim==2) return(0);

 return(cancopys());

 USE(fp);
}


int canduplicate(int fp)
{
 return(cancopys());

 USE(fp);
}




int canshape(int fp)
{
 int          i;
 int          master;
 objectbitstr bits;

 if(selection && selectn)
 {
  for(i=0;i<selectn;i++)
  {
   objectmaster(selection[i].object,menufile,&master,&bits);
   if((master && !bits.local) || bits.noshape) return(0);
  }
  return(1);
 }
 else
 {
  return(0);
 }

 USE(fp);
}


int canmodify(int fp)
{
 int          i;
 int          master;
 objectbitstr bits;

 if(selection && selectn)
 {
  for(i=0;i<selectn;i++)
  {
   objectmaster(selection[i].object,menufile,&master,&bits);
   if(master && !bits.local) return(0);
  }
  return(1); 
 }
 else
 {
  return(0);
 }

 USE(fp);
}


int candelete(int fp)
{
 int          i;
 int          master;
 objectbitstr bits;
 int          claim;

 claim=0;
 event(EVENT_CANDELETESELECTION,menufile,(int)&claim);
 if(claim==1) return(1);
 else
 if(claim==2) return(0);

 if(selection && selectn)
 {
  for(i=0;i<selectn;i++)
  {
   objectmaster(selection[i].object,menufile,&master,&bits);
   if((master && !bits.local) || bits.nodelete) return(0);
  }
  return(1);
 }
 else
 {
  return(0);
 }

 USE(fp);
}

/*****************************************************************************/

#define UNDOS 32

static undofnstr undos[UNDOS]=
{
 unaddselection,        NULL, USADD,        "{UADD}",
 unremselection,        NULL, USREM,        "{UREM}",
 unsetselection,        NULL, USSET,        "{UADD}",

 untransformselections, NULL, USTRANS,      "{UTRANS}",
 untransformselectionf, NULL, USTRANF,      "{UTRANS}",

 unupdateflowselections,NULL, USFLOWS,       "{UFLOW}",
 unupdateflowselectionf,NULL, USFLOWF,       "{UFLOW}",

 unmodifyselections,    NULL, USMODIFYS,    "{UMODIFY}",
 unmodifyselectionf,    NULL, USMODIFYF,    "{UMODIFY}",

/* NULL, undodeleteobjectscrap, USDEL,        NULL, defined above - not used */

 unmakelocals,          NULL, USMAKELOCALS, "{ULOCAL}",
 unmakelocalf,          NULL, USMAKELOCALF, "{UMASTER}",

 unmakemasters,         NULL, USMAKEMASTERS,"{UMASTER}",
 unmakemasterf,         NULL, USMAKEMASTERF,"{ULOCAL}",

 undeleteselections,    NULL, USDELETES,    "{USDELETE}",
 undeleteselectionf,    NULL, USDELETEF,    "{USDELETE}",


#ifdef NEVER
 undupforward,          NULL, UUNDUPFORWARD,"{UDUPLICATE}",
 undupscrap,            NULL, UDUPSCRAP,    NULL,

 undupbacks,            NULL, UUNDUPBACKS,  "{UDUPLICATE}",
 undupbackf,            NULL, UUNDUPBACKF,  "{UDUPLICATE}",
#endif


 unshapes,              NULL, USHAPES,      "{USHAPE}",
 unshapef,              NULL, USHAPEF,      "{USHAPE}",
 unshapeforward,        NULL, USHAPEFORWARD,"{USHAPE}",

 unsmoves,              NULL, USMOVES,      "{USMOVE}",
 unsmovef,              NULL, USMOVEF,      "{USMOVE}",
 unscopys,              NULL, USCOPYS,      "{USCOPY}",
 unscopyf,              NULL, USCOPYF,      "{USCOPY}",

 uncopydelete,          NULL, USMCOPY,      NULL,

#ifdef NEVER
 uncopyscrap,           NULL, USMDELETE,    NULL,
 uncopyforward,         NULL, USMFORWARD,   NULL,
 uncopybackward,        NULL, USMBACKWARD,  NULL,
#endif

 undupdelete,           NULL, UNDUPDELETE,  NULL,
 undups,                NULL, UNDUPS,       "{UDUPLICATE}",
 undupf,                NULL, UNDUPF,       "{UDUPLICATE}",

 uncolourselections,    NULL, USCOLOURS,    "{USCOLOUR}",
 uncolourselectionf,    NULL, USCOLOURF,    "{USCOLOUR}",
 uncolourselection,     NULL, USCOLOUR,     NULL,

};





os_error * selectinit(void)
{
 os_error * err;

 err=undoaddblock(undos,UNDOS);
 addevent(EVENT_FCLOSE,(eventfn)selfileclose,0);

 return(err);
}


