/*->c.dbflow */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "etc.h"
#include "dbhi.h"
#include "deb.h"


#include "str.h"

#include "units.h"
#include "reslink.h"
#include "mhi.h"
#include "view.h"
#include "file.h"
#include "object.h"
#include "select.h"

#include "dbscale.h"


#include "mhi.h"


#include "dbflow.h"




static filestr   * cfile;
static viewstr   * cview;
static int         co;
static int         cfmode;
static int         comode;
static int         changeo;



static os_error * flowclose(int code)
{
 os_error       * err;
 objectflowstr    cflow;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  cflow.flow.changeo=changeo;

  if(co<0) co=0;
  else     cflow.flow.o=co;

  cflow.flow.omode=comode;
  cflow.flow.fmode=cfmode;
  err=updateflowselection(&cflow);
 }
 return(err);
}



static os_error * flowoutu(int value,char * string)
{
 if(changeo) *string=0;
 else        strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}



static os_error * flowinu(int * value,char * string)
{
 if(*string)
 {
  changeo=0;
  return(stringtounits(string,value,cview->data.units));
 }
 else
 {
  changeo=1;
  return(NULL);
 }
}


static dbiconstr flowicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */


    9,  &cfmode,      DBRADIO, 0,    0,FRFWIDEST,F2,    1,  0,  NULL,   0,

   10,  &cfmode,      DBRADIO, 0,    0,FRFLEFT,  F3,    1,  0,  NULL,   0,

   11,  &cfmode,      DBRADIO, 0,    0,FRFRIGHT, F4,    1,  0,  NULL,   0,

   12,  &cfmode,      DBRADIO, 0,    0,FRFBOTH,  F5,    1,  0,  NULL,   0,

   15,  &cfmode,      DBRADIO, 0,    0,FRFNEITHER,F6,   1,  0,  NULL,   0,


    4,  &comode,      DBRADIO, 0,    0,FRONONE,  F7,    2,  0,  NULL,   0,
    3,  &comode,      DBRADIO, 0,    0,FROFRAME, F8,    2,  0,  NULL,   0,
   14,  &comode,      DBRADIO, 0,    0,FROUSER,  F9,    2,  0,  NULL,   0,


 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    6,  &co,         DBWRITE,  0,   0,   -1, -1, -1, -1, flowinu, flowoutu,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr flowboxdata=
{
 0,
 TFLOW,
 DBFIX,
 0,
 flowclose,
 NULL,
 NULL,
 NULL,
 flowicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};


static int getflow(int object,filestr * file,int next,objectflowstr * flow)
{
 sobjectstr * sob;
 int          child;

 while(object)
 {
  sob=(sobjectstr*)fob_find(object,cfile);
  object=sob->chain.next;
  child=sob->chain.child;
  objectflow((objhdrstr*)sob,file,flow,1);
  if(flow->flow.omode!=FRONONE) return(1);
  if(getflow(child,file,1,flow)) return(1);
  if(!next) break;
 }

 return(0);
}


/* script function opens the new document dialogue box */

int opentextflowbox(int fp)
{
 os_error      * err;
 int             ob;
 objectflowstr   flow;

 cfile=menufile;
 cview=menuview;

 if(nselected(&ob,menufile))
 {
  getflow(ob,menufile,0,&flow);

  co=flow.flow.o;
  cfmode=flow.flow.fmode;
  comode=flow.flow.omode;
  changeo=flow.flow.changeo;
  err=dodboxspparent(&flowboxdata,1,&flowboxdata,&dbviewstack,cview->handle);
 }
 return(0);

 USE(fp);
}



/*****************************************************************************/


extern dboxstr shapeboxdata;

static int shape;
static int ssides;


static os_error * shapeclose(int code)
{
 os_error    * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(shape==CREGULAR || shape==CSTAR)
  {
   if(ssides<3) err=geterror(ESH0);
  }

  if(!err) err=shapeselection(shape,ssides);
 }

 return(err);
}





static os_error * out(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}


static os_error * in(int * value,char * string)
{
 return(stringtonumber(string,value));
}



static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 if(shape!=CREGULAR && shape!=CSTAR)
 {
  shape=CREGULAR;
  dbchangevalue(&shape,&shapeboxdata);
 }
 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}




static dbiconstr shapeicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */


    0,  &shape,       DBRADIO, 0,    0,CBOX,     F2,    1,  0,  NULL,   0,

    9,  &shape,       DBRADIO, 0,    0,CELLIPSE, F3,    1,  0,  NULL,   0,

    8,  &shape,       DBRADIO, 0,    0,CPATH,    F4,    1,  0,  NULL,   0,

    3,  &shape,       DBRADIO, 0,    0,CREGULAR, F5,    1,  0,  NULL,   0,

   10,  &shape,       DBRADIO, 0,    0,CSTAR,    F6,    1,  0,  NULL,   0,


 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    4,  &ssides,      DBWRITE,  0,   DBASSOCINC,   -1, -1, -1, -1,  in,  out,
    7,  &ssides,      DBINC,    0,   0,       1, -1, 24, 3, (dbreadfn)optfn,0,
    6,  &ssides,      DBDEC,    0,   0,       1, -1, 24, 3, (dbreadfn)optfn,0,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

   1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
   2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr shapeboxdata=
{
 0,
 TSHAPE,
 DBFIX,
 0,
 shapeclose,
 NULL,
 NULL,
 NULL,
 shapeicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



/* script function opens the new document dialogue box */

int openshapebox(int fp)
{
 os_error   * err;
 sobjectstr * sob;
 int          ob;
 int          type;

// cprintf("openshapebox");

 cfile=menufile;
 cview=menuview;

 if(nselected(&ob,menufile))
 {
  sob=(sobjectstr*)fob_find(ob,cfile);

  ssides=4;
  type=sob->fcurve.type;

  if(type==CBOX || type==CBOXR)
  {
   shape=CBOX;
  }
  else
  if(type==CELLIPSE)
  {
   shape=CELLIPSE;
  }
  else
  if(type==CPATH || type==CLINE  || type==CLINEX 
                 || type==CLINER || type==CLINEXR)
  {
   shape=CPATH;
  }

  err=dodboxspparent(&shapeboxdata,1,&shapeboxdata,&dbviewstack,cview->handle);
 }

 return(0);

 USE(fp);
}


