/*->c.dbgroup */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"
#include "xprocess.h"
#include "etc.h"
#include "xmath.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "fsx.h"
#include "bf.h"



#include "dbhi.h"
#include "mhi.h"

#include "str.h"
#include "reslink.h"
#include "units.h"
#include "geometry.h"
#include "xcolour.h"
#include "file.h"
#include "posn.h"
#include "object.h"
#include "select.h"

#include "dbcolour.h"
#include "view.h"
#include "viewr.h"

#include "dbscale.h"


#include "group.h"

#include "dbgroup.h"




/*****************************************************************************/


static boxbitstr   ob;
static boxbitstr   nb;


static int lock;
static int spread;

static filestr * cfile;
static viewstr * cview;
static int       cobject;
static int       xdotrans;



static os_error * groupup(int object,filestr * file)
{
 objhdrstr * obj;

 groupupdate(object,lock,spread,file);
 if(xdotrans)
 {
  obj=(objhdrstr*)fob_find(object,file);
  objecttransform(obj,file,boxtrans,0);
 }

 return(NULL);
}



static os_error * groupclose(int code)
{
 os_error      * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY) 
 {
  if((xdotrans=cmpboxbits(&ob,&nb))!=0)
  {
   setboxtrans(&ob,&nb);
   ob=nb;
  }
  modifyselection(groupup);
 }
 return(err);
}


static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}





static dbiconstr groupicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */
   15,  &nb.orgx,    DBWRITE,  0,   0,      -1, -1, 3, -1,    inu,  outu,
    3,  &nb.orgy,    DBWRITE,  0,   0,      -1, -1, 5,  1,    inu,  outu,
    5,  &nb.width,   DBWRITE,  0,   0,      -1, -1, 7,  3,    inu,  outu,
    7,  &nb.height,  DBWRITE,  0,   0,      -1, -1, 9,  5,    inu,  outu,
    9,  &nb.angle,   DBWRITE,  0,   DBASSOCINC,      -1, -1,25,  7,readangle,writeangle,
   18,  &nb.skew,    DBWRITE,  0,   DBASSOCINC,      -1, -1,25,  7,readskew ,writeskew,


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,
   23, NULL,         DBACTION, 0,   0,      DBAPPLY,-1, 0,0,NULL, 0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   11, &nb.angle,    DBDEC   ,0,    0,       -0x10000,-1,MAXANGLE,
                                                        MINANGLE,NULL,0,

   12, &nb.angle,    DBINC   ,0,    0,       -0x10000,-1,MAXANGLE,
                                                        MINANGLE,NULL,0,

   20, &nb.skew,     DBDEC   ,0,    0,       -0x10000,-1,MAXSKEW,
                                                        MINSKEW,NULL,0,

   21, &nb.skew,     DBINC   ,0,    0,       -0x10000,-1,MAXSKEW,
                                                        MINSKEW,NULL,0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   13, &lock,        DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,
   14, &spread,      DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr groupbox=
{
 0,
 TOBJECT,
 DBFIX,
 0,
 groupclose,
 NULL,
 NULL,
 NULL,
 groupicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * opengroupbox(sobjectstr * groupp,filestr * file,viewstr * view)
{
 os_error        * err;

 cfile=file;
 cview=view;
 cobject=groupp->key;
 lock=groupp->flags.locked;
 spread=groupp->flags.spread;

 getboxbits(&groupp->fcurve.box,&groupp->transform,&ob);
 nb=ob;

 err=dodboxspparent(&groupbox,1,&groupbox,&dbviewstack,cview->handle);
 return(err);
}

