/*->h.impex */


typedef os_error * (*importloadpostfn)(int ftype,int object,filestr * file);
typedef os_error * (*importloadfn)(char * name,int ftype,int xv,
                    int * object,filestr * file);
typedef os_error * (*exportfn)(char * name,int object,int ftype,int xv,
                                                          filestr * file);
typedef os_error * (*renderfn)(aboxstr * abox,transformstr * tr,
                 processstr * pr,picturestr * picturep,viewredrawstr * v);

typedef os_error * (*dsexportfn)(int ftype,int object,
                                           filestr * file,buffer * bf);

typedef os_error * (*dsimportfn)(int ftype,int fp,int argc,objectloc * loc);

typedef os_error * (*intexportfn)(int object,int ftype,
                                              filestr * file,posnstr * posn);

typedef os_error * (*exportinfofn)(int object,int ftype,
                                              filestr * file,int * len);

typedef os_error * (*cachefn)(picturestr * picturep,filestr * file);

typedef int        (*rendermemfn)(picturestr * picturep,
                     transformstr * tr,processstr * pr,viewredrawstr * v);


typedef int        (*imdatashiftfn)(picturestr * picturep);


typedef os_error * (*impxinfofn)(int object,int ftype,
                                       filestr * file,int * info);


typedef os_error * (*referencefn)(char * name,char * expandedname,int ftype,
                                           int * object,filestr * file);


typedef os_error * (*refreloadfn)(char * name,char * expname,int ftype,
                                           int object,filestr * file);


typedef os_error * (*makeproxyfn)(int ftype,int object,filestr * file,
                                                       pxproxystr *proxy);


typedef os_error * (*removeproxyfn)(int ftype,int object,filestr * file);


typedef os_error * (*embedimagefn)(int ftype,int object,filestr * file);




#define IMPFTYPE   0xFFFF


#define IMPXLOAD   0x1
#define IMPXPICT   0x2
#define IMPXTEXT   0x4



typedef struct impexstr
{
 int              ftype;         /* file type */
 char           * xtypename;

 int              data;
 importloadfn     import;
 importloadpostfn importpost;
 exportfn         export;
 renderfn         render;

 dsexportfn       dsexport;
 dsimportfn       dsimport;

 intexportfn      intexport;
 exportinfofn     exportinfo;

 cachefn          cache;         /* fonts */

 rendermemfn      rendermem;

 imdatashiftfn    datashift;     /* offset of real data */
 impxinfofn       pxinfo;


 referencefn      reference;        /* set up data from path */
 makeproxyfn      makeproxy;        /* make proxy image      */
 removeproxyfn    removeproxy;      /* remove proxy image    */

 embedimagefn     importembed;      /* embed referenced image */
 refreloadfn      referencereload;

 cachefn          listfonts;
 char           * x3;


} impexstr;


extern os_error * impexregister(impexstr * impex);

extern os_error * importloadpost(int ftype,int object,filestr * file);
extern os_error * importload(char * name,int ftype,int xv,
                                               int * object,filestr * file);

extern os_error * importreferenceload(char * name,int ftype,int * object,filestr * file);

extern os_error * importmakeproxy(int ftype,int object,filestr * file,
                                                        pxproxystr *proxy);

extern os_error * importremoveproxy(int ftype,int object,filestr * file);


extern os_error * importembed(int ftype,int object,filestr * file);

extern os_error * importreferencereload(char * name,char * expname,int ftype,
                                                    int object,filestr * file);



extern os_error * render(aboxstr * abox,transformstr * tr,
                 processstr * pr,picturestr * picturep,viewredrawstr * v);

extern int        impexdata(int ftype);
extern char *     impexname(int ftype);

extern int        impexdatatrans(int ftype,char * name);

extern int        impexftypeindex(int i,int flags);


extern os_error * export(char * name,int object,int ftype,int xv,
                                                           filestr * file);


//extern os_error * exportsave(int ftype,int object,filestr * file,int * handle);
extern os_error * exportsave2(int ftype,int object,viewstr * view,int spare);

//extern os_error * exportdirect(int ftype,int object,filestr * file);

extern os_error * exportglobal(int ftype,int object,filestr * file,char * name);
extern os_error * importglobal(char * name,posnstr * loadposn,int type,int flags);

extern os_error * imcache(int picture,filestr * file);

extern os_error * imlist(int picture,filestr * file);

extern int        imrendermem(picturestr * picturep,
                     transformstr * tr,processstr * pr,viewredrawstr * v);


extern int        imdatashift(picturestr * picturep);


extern os_error * impexpxinfo(int object,int ftype,
                                         filestr * file,int * info);



extern int impexbitx(int type,int bic,int orr);
extern int impexbits(int fp);
extern int impexcopy(int fp);


#define DSTDATA       0x1200




extern os_error * dsexport(int ftype,int object,
                                           filestr * file,buffer * bf);

extern os_error * impexinit(void);





typedef os_error * (*oloadfn)(char * name,buffer * bf,
                                           int stylesheet,filestr * file);
typedef os_error * (*oloadpostfn)(filestr * file,int ftype,int * load);

extern void registeroload(oloadfn xoloadfile,oloadpostfn xoloadfilepost);




