/*->c.line */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "err.h"
#include "fsx.h"
#include "bf.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "deb.h"


#include "constants.h"
#include "str.h"
#include "object.h"
#include "reslink.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "undo.h"
#include "chain.h"
#include "xredraw.h"
#include "curve.h"
#include "posn.h"
#include "frameflow.h"

#include "select.h"
#include "units.h"

#include "xcolour.h"
#include "geometry.h"


#include "editpath.h"


#include "objectdb.h"



#include "dscript.h"
#include "fillstub.h"

#include "mpage.h"


#include "linetool.h"
#include "line.h"
#include "dbline.h"






#define ULTRAN      0x3000
#define ULUPDATE    0x3001
#define ULDELETE    0x3002
#define ULRECREATE  0x3003
#define ULSHAPE     0x3004
#define ULMXLOCAL   0x3005
#define ULMXMASTER  0x3006
#define UMAKEMASTER 0x3007
#define ULMOVE      0x3008
#define UUDM        0x3009
#define URDM        0x300A






static os_error * redrawline(viewredrawstr * v,linestr * line)
{
 os_error      * err;
 curvestylestr   cstyle;

 err=NULL;

 if(line->key==v->object) v->ignore=0;

 if(!v->ignore && !line->flags.invisible)
 {
  if(boxinredraw(v,&line->box))
  {
   XMEMCPYX(&cstyle,&line->data,sizeof(linedatastr));
   cstyle.pstyle.action=0x3;
   cstyle.fill=line->data.fill;

   err=renderfill(v,&line->fcurve,&cstyle,&line->transform);
   v->sshortcuts=0;
  }
 }
 return(err);
}


static os_error * linebox(linestr * linep,filestr * file)
{
 pathstyle pstyle;

 XMEMCPYX(&pstyle,&linep->data.thickness,sizeof(pathstyle));
 pstyle.action=0x3;

 return(truecurvebox(&linep->fcurve,&pstyle,file,&linep->transform,
                                                 &linep->xcurve.box));
}


static os_error * lineboxplus(linestr * linep,filestr * file)
{
 os_error * err;
 setcurveradius(&linep->fcurve,linep->data.radius,&linep->transform);
 err=linebox(linep,file);
 getmaxbox(&linep->box,&linep->xcurve.box,&linep->transform);
 return(err);
}




linedatastr defltlinedata=
{
 OURBLACK,
 OURTRANS,
 0,
 0xFFFFFFFF,    /* solid */
 0x1400,        /* 5120 style scale */

 0,             /* end caps */
 0x20000,
 0x10000,

 0,             /* start caps */
 0x20000,
 0x10000,

 2,             /* join         */

 2,             /* winding rule */

 0,             /* radius */

 FILLSTR,

};


#define DEFOUTSET MMSIZE



static os_error * createline1(objectloc * loc,curvestr * c,
                              linedatastr * data,transformstr * tr)
{
 os_error   * err;
 filestr    * file;
 int          linek;
 linestr    * linep;
 curvestr     fcurve;

 file=loc->file;

 err=fob_create(sizeof(linestr),file,OLINE,(fobjptr)&linep);
 if(!err)
 {
  linek=linep->key;

  linep->transform=*tr;
  linep->data=*data;


  if((fcurve.type=curveisline(c,file,&fcurve.box))==0)
  {
   copycurve(&fcurve,file,c,file);
  }

  linep=(linestr*)fob_find(linek,file);

  linep->fcurve=fcurve;

  nullcurve(&linep->xcurve);
  linep->xcurve.type=CBOX;

  lineboxplus(linep,file);

  vxadd((sobjectstr **)&linep,file);

  insafter(linek,loc->after,loc->parent,loc->chain,file);

  loc->object=linek;

  undowritefn(file,ULDELETE,&loc->object,sizeof(int));
 }
 return(err);
}



static os_error * createline(objectloc * loc,curvestr * c)
{
 transformstr tr;
 tr_setidentity(&tr);
 return(createline1(loc,c,&defltlinedata,&tr));
}



/***************************************************************************/
/* move an object - within the same file */

static transformstr xtransform;

static int xtrf(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 tr_multiply(r,t,&xtransform);

 return(0);

 USE(c);
 USE(ct);
}



typedef struct lxmovestr
{
 int            line;
 int            spage;
 int            dpage;
 int            parent;
 int            after;
 transformstr   tr;
} lxmovestr;



static os_error * unlinemove(filestr * file)
{
 lxmovestr    old;
 lxmovestr    xnew;
 linestr    * linep;


 undoread(file,&xnew,sizeof(lxmovestr));

 old=xnew;
 old.spage=xnew.dpage;
 old.dpage=xnew.spage;

 linep=(linestr*)fob_find(old.line,file);

 old.tr=linep->transform;
 old.after=linep->chain.prev;
 old.parent=parentof((chainobject*)linep,file);

 undowritefn(file,ULMOVE,&old,sizeof(lxmovestr));

 linep=(linestr*)fob_find(xnew.line,file);

 vxaddn((sobjectstr**)&linep,file,xnew.spage);

 unlinkobject(old.line,0,file);
 insafter(xnew.line,xnew.after,xnew.parent,0,file);

 linep=(linestr*)fob_find(xnew.line,file);
 linep->transform=xnew.tr;

 lineboxplus(linep,file);

 vxaddn((sobjectstr **)&linep,file,xnew.dpage);

 return(NULL);
}




static os_error * linecopym(objectloc * src,objectloc * dest,transformstr * tr)
{
 linestr    * linep;
 filestr    * sfile;
 int          object;
 int          trmode;
 lxmovestr    old;

 sfile=src->file;
 object=src->object;

 linep=(linestr*)fob_find(object,sfile);
 vxaddn((sobjectstr**)&linep,sfile,src->page);

 if(dest->copymode & LOCUNDO)
 {
  old.line=object;
  old.spage=dest->page;
  old.dpage=src->page;
  old.tr=linep->transform;
  old.after=linep->chain.prev;
  old.parent=parentof((chainobject*)linep,sfile);

  undowritefn(sfile,ULMOVE,&old,sizeof(lxmovestr));
 }

 unlinkobject(object,0,sfile);
 dest->object=object;
 insafter(object,dest->after,dest->parent,0,sfile);

 linep=(linestr*)fob_find(object,sfile);
 xtransform=*tr;

 trmode=TRNOUPDATE|TRNOUNDO;

 transline(linep,sfile,xtrf,trmode);

 linep=(linestr*)fob_find(object,sfile);
 vxaddn((sobjectstr**)&linep,sfile,dest->page);

 return(NULL);
}




static os_error * linecopyc(objectloc * src,objectloc * dest,transformstr * tr)
{
 os_error * err;
 int        linek;
 linestr  * linep;
 linestr    srcline;
 linestr    destline;
 filestr  * sfile;
 filestr  * dfile;


 err=NULL;

 sfile=src->file;
 dfile=dest->file;

 linep=(linestr*)fob_find(src->object,sfile);
 srcline=*linep;
 destline=srcline;

          err=copycurve(&destline.fcurve,dfile,&srcline.fcurve,sfile);
 if(!err) err=copycurve(&destline.xcurve,dfile,&srcline.xcurve,sfile);
 if(!err) err=copyfillm(&destline.data.fill,dfile,
                        &srcline.data.fill,sfile,dest->copymode);
 if(!err) err=mapcolour(sfile,dfile,&destline.data.linecolour,dest->copymode);
 if(!err) err=mapcolour(sfile,dfile,&destline.data.fillcolour,dest->copymode);
 if(!err) err=fob_create(sizeof(linestr),dfile,OLINE,(fobjptr)&linep);
 if(!err)
 {
  linek=linep->key;

  linep->fcurve=destline.fcurve;
  linep->xcurve=destline.xcurve;
  linep->data=destline.data;

  linep->flags.locked=destline.flags.locked;
  linep->flags.spread=destline.flags.spread;

  if(src->branch && !dest->branch)  linep->master=srcline.key;

  if(dest->copymode & LOCOLDMASTER) linep->master=srcline.master;
  else
  if(!src->branch && !dest->branch)
  {
   if(srcline.master && (dest->copymode & LOCKEEPMASTER))
   { 
    linep->flags.local=destline.flags.local;
    mapmaster(src,dest,srcline.master,&destline.master);
    linep=(linestr*)fob_find(linek,dfile);
    linep->master=destline.master;
    linep->flags.local=destline.flags.local;
    linep->flags.masterdata=destline.flags.masterdata;
   }
  }

  tr_multiply(&linep->transform,&destline.transform,tr);

  setcurveradius(&linep->fcurve,linep->data.radius,&linep->transform);
  getmaxbox(&linep->box,&linep->xcurve.box,&linep->transform);

  insafter(linek,dest->after,dest->parent,dest->chain,dfile);

  dest->object=linek;

  vxadd((sobjectstr **)&linep,dfile);
 }

 return(err);
}



static os_error * linecopy(objectloc * src,objectloc * dest,transformstr * tr)
{
 if(dest->copymode & LOCMOVE) return(linecopym(src,dest,tr));
 else                         return(linecopyc(src,dest,tr));
}




static int findline(posnstr * posn,linestr * linep,int * before,int last)
{
 int           linek;
 int           childk;
 chainobject * childp;
 int           dx;
 int           dy;
 filestr     * file;
 int           x;
 int           y;

 file=posn->file;

 linek=linep->key;

 dx=2*ourunits(cvdu.deltax,posn->view);
 dy=2*ourunits(cvdu.deltay,posn->view);

 if(nearlyinsidebox(x=posn->x,y=posn->y,dx,dy,&linep->box))
 {
  if(insidecurve(x,y,&linep->fcurve,&linep->transform,file)) last=linek;
  else
  if(nearcurve(x,y,dx,dy,&linep->fcurve,&linep->transform,file)) last=linek;
 }

 childk=linep->chain.child;
 while(childk)
 {
  childp=(chainobject*)fob_find(childk,file);
  childk=childp->chain.next;
  last=objectfind(posn,(objhdrstr*)childp,before,last);
 }
 return(last);
}



static int selectline(linestr * linep,posnstr * posn,int type)
{
 int           linek;
 int           parent;
 filestr     * file;

 linek=linep->key;
 file=posn->file;

 if(type==SELECTOBJECT)
 {
  parent=parentof((chainobject*)linep,file);
  if(parent) type=objectselect((objhdrstr*)fob_find(parent,file),posn,SELECT1);

  addselection(linek,file,type);
 }
 else
 if(type==DESELECTOBJECT)
 {
  remselection(linek,file,type);
 }

 return(type);
}



/* writes data that can be changed by a transform */

static os_error * writetransdata(linestr * linep,filestr * file)
{
 os_error     * err;
 err=undowrite(file,&linep->transform,sizeof(transformstr));
 return(err);
}


/* reads data that can be changed by a transform */

static os_error * readtransdata(linestr * linep,filestr * file)
{
 os_error     * err;
 err=undoread(file,&linep->transform,sizeof(transformstr));
 return(err);
}


/* tagged to ULTRAN */

static os_error * untransline(filestr * file)
{
 os_error     * err;
 int            line;
 linestr      * linep;

 err=undoread(file,&line,sizeof(int));

 linep=(linestr*)fob_find(line,file);

 if(linep)
 {
  vxadd((sobjectstr **)&linep,file);

           err=undowritefn(file,ULTRAN,&line,sizeof(int));
  if(!err) err=writetransdata(linep,file);
  if(!err) err=readtransdata(linep,file);

  lineboxplus(linep,file);

  vxadd((sobjectstr **)&linep,file);

  if(embededobject(linep->key,file)) frameflow((sobjectstr **)&linep,file);
 }

 return(err);
}





os_error * transline(linestr * linep,filestr * file,
                                      transformfn trf,int flags)
{
 os_error     * err;
 transformstr   r1;
 int            embedded;

 err=NULL;

 if(!(flags & TRNOUPDATE)) vxadd((sobjectstr **)&linep,file);

 embedded=embededobject(linep->key,file);

 if(embedded && (!(flags & TRNOREFLOWS)))frameflow((sobjectstr **)&linep,file);

 if(!(flags & TRNOUNDO))
 {
           err=undowritefn(file,ULTRAN,&linep->key,sizeof(int));
  if(!err) err=writetransdata(linep,file);
 }

 trf(&r1,&linep->transform,&linep->xcurve,&linep->transform); // change to linep->xcurve from linep->fcurve 24/2/2007
 linep->transform=r1;

 lineboxplus(linep,file);

 if(!(flags & TRNOUPDATE)) vxadd((sobjectstr **)&linep,file);

 if(embedded && (!(flags & TRNOREFLOWD))) frameflow((sobjectstr **)&linep,file);
 return(err);
}

/*****************************************************************************/

static textflowstr deflttextflow=
{
 DEFOUTSET,
 FRFBOTH,
 FRONONE,
};


static os_error * lineflow(linestr * linep,filestr * file,
                                             objectflowstr * flow,int read)
{
 if(read)
 {
  flow->flow=deflttextflow;
  flow->tr=linep->transform;
 }

 return(NULL);

 USE(file);
}


static os_error * linesetflow(linestr * linep,sobjectstr * fix,
                              filestr * file,int * end)
{
 if(fix->key==linep->key)
 {
  *end=1;
 }
 return(NULL);
 USE(file);
}

/*****************************************************************************/


static os_error *  linescrap(int object,filestr * file,int flags)
{
 os_error * err;
 linestr    line;
 linestr  * linep;

 if(flags & DELETEUNLINK) unlinkobject(object,0,file);

 linep=(linestr*)fob_find(object,file);

 vxadd((sobjectstr **)&linep,file);

 line=*linep;

          err=deletecurve(&line.fcurve,file);
 if(!err) err=deletecurve(&line.xcurve,file);
 if(!err) err=deletefill(&line.data.fill,file);

 if(!err) err=fob_delete(line.key,file);

 return(err);
}



static os_error *  uldeletesub(int object,filestr * file)
{
 os_error * err;
 linestr  * line;
 int        parent;
 int        after;

 err=NULL;

 line=(linestr*)fob_find(object,file);
 if(line)
 {
  vxadd((sobjectstr **)&line,file);

  parent=line->chain.parent;
  after=line->chain.prev;

  unlinkobject(object,0,file);

  undowritefn(file,ULRECREATE,&object,sizeof(int));
  undowrite(file,&parent,sizeof(int));
  undowrite(file,&after,sizeof(int));
 }

 return(err);
}


/* tagged to ULRECREATE */

static os_error *  ulrecreate(filestr * file)
{
 linestr * linep;
 int       object;
 int       parent;
 int       after;

 undoread(file,&object,sizeof(int));
 undoread(file,&parent,sizeof(int));
 undoread(file,&after,sizeof(int));

 insafter(object,after,parent,0,file);

 undowritefn(file,ULDELETE,&object,sizeof(int));

 linep=(linestr*)fob_find(object,file);
 vxadd((sobjectstr **)&linep,file);

 return(NULL);
}



/* scrap function for ULRECREATE */

static os_error * ultrash(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(linescrap(object,file,0));
}




/* tagged to ULDELETE */

static os_error *  uldelete(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 uldeletesub(object,file);
 return(NULL);
}



static os_error * linedelete(linestr * linep,int dm,filestr * file)
{
 if(dm & DELETESCRAP) return(linescrap(linep->key,file,dm));
 else                 return(uldeletesub(linep->key,file));
}


/****************************************************************************/
/* tagged to ULUPDATE */



void unpackline(linestr * linep,unpackedlinedatastr * ld)
{
 ld->data=linep->data;
 ld->lock=linep->flags.locked;
 ld->spread=linep->flags.spread;
}



void packline(linestr * linep,unpackedlinedatastr * ld)
{
 linep->data=ld->data;
 linep->flags.locked=ld->lock;
 linep->flags.spread=ld->spread;
}




static void filllinedata(unpackedlinedatastr * od,
                         unpackedlinedatastr * pd,linechangebits * bits)
{
 if(bits->xlinecolour) od->data.linecolour=pd->data.linecolour;
 if(bits->xfillcolour) od->data.fillcolour=pd->data.fillcolour;
 if(bits->xthickness)  od->data.thickness=pd->data.thickness;
 if(bits->xstyle)      od->data.style=pd->data.style;
 if(bits->xstylescale) od->data.stylescale=pd->data.stylescale;

 if(bits->xendcaps)    od->data.endcaps=pd->data.endcaps;
 if(bits->xendwidth)   od->data.endwidth=pd->data.endwidth;
 if(bits->xendheight)  od->data.endheight=pd->data.endheight;

 if(bits->xstartcaps)  od->data.startcaps=pd->data.startcaps;
 if(bits->xstartwidth) od->data.startwidth=pd->data.startwidth;
 if(bits->xstartheight)od->data.startheight=pd->data.startheight;
 
 if(bits->xjoin)       od->data.join=pd->data.join;

 if(bits->xwindingrule)od->data.windingrule=pd->data.windingrule;

 if(bits->xradius)     od->data.radius=pd->data.radius;

 if(bits->xfill)       od->data.fill=pd->data.fill;

 if(bits->xlock)       od->lock=pd->lock;
 if(bits->xspread)     od->spread=pd->spread;
}



os_error * linechanges(int line,filestr * file,
                              unpackedlinedatastr * pd,linechangebits * bits)
{
 linestr             * linep;

 linep=(linestr*)fob_find(line,file);

 bits->xlinecolour=(cmpcolourval(&linep->data.linecolour,
                                 &pd->data.linecolour)!=0);

 bits->xfillcolour=(cmpcolourval(&linep->data.fillcolour,
                                 &pd->data.fillcolour)!=0);

 bits->xthickness=(linep->data.thickness!=pd->data.thickness);

 bits->xstyle=(linep->data.style!=pd->data.style);

 bits->xstylescale=(linep->data.stylescale!=pd->data.stylescale);

 bits->xendcaps=(linep->data.endcaps!=pd->data.endcaps);
 bits->xendwidth=(linep->data.endwidth!=pd->data.endwidth);
 bits->xendheight=(linep->data.endheight!=pd->data.endheight);

 bits->xstartcaps=(linep->data.startcaps!=pd->data.startcaps);
 bits->xstartwidth=(linep->data.startwidth!=pd->data.startwidth);
 bits->xstartheight=(linep->data.startheight!=pd->data.startheight);
 
 bits->xjoin=(linep->data.join!=pd->data.join);

 bits->xwindingrule=(linep->data.windingrule!=pd->data.windingrule);

 bits->xradius=(linep->data.radius!=pd->data.radius);

 bits->xfill=(linep->data.fill.fill!=pd->data.fill.fill);

 bits->xlock=((int)linep->flags.locked!=pd->lock);
 bits->xspread=((int)linep->flags.spread!=pd->spread);

 return(NULL);
}



static os_error * unupdateline(filestr * file)
{
 os_error            * err;
 int                   line;
 linestr             * linep;
 unpackedlinedatastr   ld;

 err=undoread(file,&line,sizeof(int));

 linep=(linestr*)fob_find(line,file);

 if(linep)
 {
  vxadd((sobjectstr **)&linep,file);

  unpackline(linep,&ld);

           err=undowritefn(file,ULUPDATE,&line,sizeof(int));

  if(!err) err=undowrite(file,&ld,sizeof(unpackedlinedatastr));
  if(!err) err=undoread(file,&ld,sizeof(unpackedlinedatastr));

  packline(linep,&ld);

  lineboxplus(linep,file);

  vxadd((sobjectstr **)&linep,file);
 }

 return(err);
}


os_error * lineupdate(unpackedlinedatastr * pd,linechangebits * bits,
                                                   int line,filestr * file)
{
 os_error             * err;
 linestr              * linep;
 unpackedlinedatastr    od;


 linep=(linestr*)fob_find(line,file);
 vxadd((sobjectstr **)&linep,file);

 unpackline(linep,&od);

          err=undowritefn(file,ULUPDATE,&line,sizeof(int));
 if(!err) err=undowrite(file,&od,sizeof(unpackedlinedatastr));

 linep=(linestr*)fob_find(line,file);

 filllinedata(&od,pd,bits);
 packline(linep,&od);

 lineboxplus(linep,file);

 vxadd((sobjectstr **)&linep,file);

 return(err);
}


static os_error * linesetfill(linestr * linep,filestr * file,fillstr * fill)
{
 linep->data.fill=*fill;
 return(vxadd((sobjectstr **)&linep,file));
}


/*****************************************************************************/


static os_error * lineeditpath(linestr * linep,filestr * file,
                                                   int * message,epstr * ep)
{
 os_error * err;
 int        type;
 curvestr   c;
 int        line;

 err=NULL;

 line=linep->key;

 nullcurve(&ep->curve[EP_INNER]);
 nullcurve(&ep->curve[EP_OUTER]);

 type=linep->fcurve.type;

 if(type==CLINE || type==CLINEX || type==CLINER || type==CLINEXR)
 {
  c=linep->fcurve;
  curvetopath(&c,file);
  fob_mod(line,file,(fobjptr)&linep);
  linep->fcurve=c;
 }

 ep->curve[EP_FRAME]=linep->fcurve;

 if(editpathcanedit(ep->curve))
 {
  *message=0;

  tr_setidentity(&ep->tr[EP_INNER]);
  ep->tr[EP_FRAME]=linep->transform;
  tr_setidentity(&ep->tr[EP_OUTER]);

  ep->colour.cv=linep->data.linecolour;
  ep->coltype=EPC_CV;
 
  linep->flags.invisible=ep->invisible;

  if(ep->invisible) vxadd((sobjectstr **)&linep,file);
 }

 return(err);
}



static os_error * linechangepath(linestr * linep,filestr * file,
                                                   int * message,epstr * ep)
{
 os_error * err;
 curvestr   c;
 int        line;

 err=NULL;

 *message=0;
 line=linep->key;

 if(ep->quit)
 {
  c=ep->curve[EP_FRAME];
  curvetoline(&c,file);
  fob_mod(line,file,(fobjptr)&linep);
  linep->fcurve=c;
 }
 else
 {
  linep->fcurve=ep->curve[EP_FRAME];
 }

 /* refresh twice, depending on if box is getting bigger or smaller */

 if(!ep->invisible) vxadd((sobjectstr **)&linep,file);


 linebox(linep,file);
 getmaxbox(&linep->box,&linep->xcurve.box,&linep->transform);

 linep->flags.invisible=ep->invisible;

 if(!ep->invisible) vxadd((sobjectstr **)&linep,file);

 if(ep->quit) changesize((chainobject*)linep,file);

 return(err);
}


/***************************************************************************/




static void dsname(linestr * linep,char * data)
{
 sprintf(data,"LINE_%02x",linep->key);
}


static os_error * dsmessage(linestr * linep,filestr * file,buffer * bf)
{
 os_error * err;
 int        line;

 line=linep->key;

 err=bf_printfeol(bf,"LINE_%02x={line",line);

 if(linep->master)
 {
  bf_printfeol(bf,"{master LINE_%02x}{local %d}",linep->master,
                                                linep->flags.local);
 }


 if(!linep->master || linep->flags.local)
 {
  bf_printfeol(bf,"{lock %d} {spread %d}",linep->flags.locked,
                                         linep->flags.spread);

  bf_printfeol(bf,"{thickness %d}",linep->data.thickness);
  bf_printfeol(bf,"{linecolour %s}",dscvstring2(&linep->data.linecolour,file));

  bf_printfeol(bf,"{fillcolour %s}",dscvstring2(&linep->data.fillcolour,file));

  bf_printfeol(bf,"{radius %d}",linep->data.radius);
  bf_printfeol(bf,"{linestyle 0x%x %d}",
                                  linep->data.style,linep->data.stylescale);

  bf_printfeol(bf,"{endcaps %d 0x%x 0x%x}",linep->data.endcaps,
                                     linep->data.endwidth,
                                     linep->data.endheight);

  bf_printfeol(bf,"{startcaps %d 0x%x 0x%x}",linep->data.startcaps,
                                       linep->data.startwidth,
                                       linep->data.startheight);

  bf_printfeol(bf,"{join %d}",linep->data.join);
 
  bf_printfeol(bf,"{windingrule %d}",linep->data.windingrule);

  dswritefill(&linep->data.fill,bf,file);

  dscurve(&linep->fcurve,&linep->transform,"fcurve",bf,file);
  dstransform(&linep->fcurve.box,&linep->transform,bf);
 }

 err=bf_printfeoln(bf,2,"}");
 
 return(err);
}





static os_error * dsline(int fp,int argc,objectloc * loc)
{
 os_error    * err;
 linedatastr   data;
 int           sp;
 int           nsp;
 dsobjectstr * ds;
 dsobjectstr * ds1;
 curvestr      c;
 curvestr      t;
 transformstr  tr;
 int           angle;
 int           skew;
 int           master;
 int           local;
 linestr     * linep;
 int           lock;
 int           spread;


 sp=fp+2; /* skip leading type/len */

 data=defltlinedata;
 tr_setidentity(&tr);
 angle=skew=master=local=lock=spread=0;

 nullcurve(&c);

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case     DSTLOCAL:
                     local=ds1->data.integer;
                     break;

   case    DSTMASTER:
                     master=ds1->data.integer;
                     linep=(linestr*)fob_find(master,loc->file);
                     data=linep->data;
                     tr=linep->transform;
                     t=linep->fcurve;
                     deletecurve(&c,loc->file);
                     copycurve(&c,loc->file,&t,loc->file);
                     lock=linep->flags.locked;
                     spread=linep->flags.spread;
                     break;

   case      DSTLOCK:
                     lock=ds1->data.integer;
                     break;

   case    DSTSPREAD:
                     spread=ds1->data.integer;
                     break;

   case DSTTHICKNESS:
                     data.thickness=ds1->data.integer;
                     break;

  case DSTLINECOLOUR:
                     data.linecolour.data.tint.key=ds1->data.integer;
                     ds1=(dsobjectstr*)(dsstack+sp+2+3);
                     data.linecolour.data.tint.tint=ds1->data.integer;
                     if(nsp>(sp+2+6))
                     {
                      ds1=(dsobjectstr*)(dsstack+sp+2+6);
                      data.linecolour.data.tint.overprint=ds1->data.integer;
                     }
                     break;

  case DSTFILLCOLOUR:
                     data.fillcolour.data.tint.key=ds1->data.integer;
                     ds1=(dsobjectstr*)(dsstack+sp+2+3);
                     data.fillcolour.data.tint.tint=ds1->data.integer;
                     if(nsp>(sp+2+6))
                     {
                      ds1=(dsobjectstr*)(dsstack+sp+2+6);
                      data.fillcolour.data.tint.overprint=ds1->data.integer;
                     }
                     break;

   case    DSTRADIUS:
                     data.radius=ds1->data.integer;
                     break;

   case DSTLINESTYLE:
                     data.style=ds1->data.integer;
                     ds1=(dsobjectstr*)(dsstack+sp+2+3);
                     data.stylescale=ds1->data.integer;
                     break;

    case  DSTENDCAPS:
                     data.endcaps=ds1->data.integer;
                     break;

    case  DSTSTARTCAPS:
                     data.startcaps=ds1->data.integer;
                     break;

    case      DSTJOIN:
                      data.join=ds1->data.integer;
                      break;

    case     DSTANGLE:
                      angle=-ds1->data.integer;
                      break;

    case      DSTSKEW:
                      skew=-ds1->data.integer;
                      break;

    case DSTWINDINGRULE:
                      data.windingrule=ds1->data.integer;
                      break;

    case     DSTFCURVE:
                       deletecurve(&c,loc->file);
                       c=ds->data.curve;
                       break;

    case       DSTFILL:
                       data.fill.fill=ds->data.integer;
                       break;
  }

  sp=nsp;
 }

 getboxtransform(&tr,&c,skew,angle);

 err=createline1(loc,&c,&data,&tr);
 if(!err)
 {
  linep=(linestr*)fob_find(loc->object,loc->file);
  linep->flags.local=local;
  linep->master=master;
  linep->flags.locked=lock;
  linep->flags.spread=spread;

  loc->after=loc->object;
  loc->parent=0;

  ds=(dsobjectstr*)(dsstack+fp);
  ds->data.integer=loc->object;
  ds->len=3*sizeof(int);
 }

 deletecurve(&c,loc->file);

 return(err);
}




static int dsblanklist[]={
                     DSTENDLIST
                    };




static dscreator dsdefs[]=
{
 0,0,0,0, "linestyle",  NULL,   0, DSTLINESTYLE,     dsblanklist,
 0,0,0,0, "endcaps",    NULL,   0, DSTENDCAPS,       dsblanklist,
 0,0,0,0, "startcaps",  NULL,   0, DSTSTARTCAPS,     dsblanklist, 
 0,0,0,0, "join",       NULL,   0, DSTJOIN,          dsblanklist,
 0,0,0,0, "windingrule",NULL,   0, DSTWINDINGRULE,   dsblanklist,
 0,0,0,0, "line",       dsline, 0, DSTLINE,          dsblanklist,
};


/***************************************************************************/




static os_error * linemessage(linestr * linep,filestr * file,
                                                   int * message,void * data)

{
 omessagefn fn;
 snapfn     snapbox;

 switch(*message)
 {

  case OM_EDITCHANGE:
                     return(linechangepath(linep,file,message,(epstr*)data));
                     break;

  case   OM_EDITPATH:
                     return(lineeditpath(linep,file,message,(epstr*)data));
                     break;


  case   OM_FUNCTION:
  case  OM_FUNCTION2:
                     fn=((omessagefn)data);
                     return(fn((objhdrstr*)linep,file,message));
                     break;


   case    OM_DSNAME:
                     dsname(linep,(char*)data);
                     break;

   case    OM_DSSAVE:
                     return(dsmessage(linep,file,(buffer*)data));
                     break;

  case OM_FINDMASTER:
                     if((*((int*)data))==linep->master)
                     {
                      *((int*)data)=linep->key;
                      *message=0;
                     }
                     break;


   case   OM_SNAPBOX:
                     snapbox=((snapfn)data);
                     snapbox(linep->key,&linep->transform,&linep->fcurve.box);
                     break;


   case   OM_SETFILL:
                     linesetfill(linep,file,(fillstr*)data);
                     break;

   case   OM_GETFILL:
                     *((fillstr*)data)=linep->data.fill;
                     *message=0;
                     break;

   case OM_GETCOLOUR:
                     if(*((int*)data)==SELECTION_FILLCOLOUR)
                     {
                      *message=0;
                      *((colourvalue*)data)=linep->data.fillcolour;
                     }
                     else 
                     if(*((int*)data)==SELECTION_BORDERCOLOUR)
                     {
                      *message=0;
                      *((colourvalue*)data)=linep->data.linecolour;
                     }
                     break;

   case OM_SETCOLOUR:
                     if(*((int*)data)==SELECTION_FILLCOLOUR)
                     {
                      linep->data.fillcolour=*((colourvalue*)(((int*)data)+1));
                      vxadd((sobjectstr **)&linep,file);
                     }
                     else 
                     if(*((int*)data)==SELECTION_BORDERCOLOUR)
                     {
                      linep->data.linecolour=*((colourvalue*)(((int*)data)+1));
                      vxadd((sobjectstr **)&linep,file);
                     }
                     break;



 }

 return(NULL);
}





static os_error * linedb(linestr * linep,filestr * file,
                                         viewstr * view,objectdbstr * cont)
{
 switch(cont->type)
 {
  case  ODB_OBJECTNAMEPLURAL:
                             tsprintf(ODBCONLEN,cont->name,"{LX00}");
                             break;

  case ODB_OBJECTNAMEPLURALC:
                             tsprintf(ODBCONLEN,cont->name,"{LX01}");
                             break;

  case            ODB_MODIFY:
                             openlinebox(linep,file,view);
                             break;

  case        ODB_OBJECTNAME:
                             tsprintf(ODBCONLEN,cont->name,"{LX02}");
                             break;
 }
 return(NULL);
}



static os_error * masterobject(linestr * linep,filestr * file,int * master,
                                                          objectbitstr * bits)
{
 *master=linep->master;
 memset(bits,0,sizeof(objectbitstr));
 bits->local=linep->flags.local;
 bits->canmakelocal=1;
 bits->canmirror=1;
 bits->locked=linep->flags.locked;

 return(NULL);
 USE(file);
}



static os_error * lineloadtype(char * name,int ftype,posnstr * posn,int * method)
{
 return(geterror(DR00));
 USE(ftype);
 USE(posn);
 USE(method);
 USE(name);
}



/***************************************************************************/
/* this is the trivial operation */

/* tagged to ULMXLOCAL */

static os_error *  unlmakelocal(filestr * file)
{
 os_error   * err;
 int          object;
 linestr    * linep=NULL;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undowritefn(file,ULMXMASTER,&object,sizeof(int));
 if(!err) err=fob_mod(object,file,(fobjptr)&linep);
 if(!err)
 {
  linep->flags.local=1;
 }

 return(err);
}


/* tagged to ULMXMASTER */

static os_error *  unlmakemaster(filestr * file)
{
 os_error   * err;
 int          object;
 linestr    * linep=NULL;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undowritefn(file,ULMXLOCAL,&object,sizeof(int));
 if(!err) err=fob_mod(object,file,(fobjptr)&linep);
 if(!err)
 {
  linep->flags.local=0;
 }

 return(err);
}




static os_error * makeobjectlocal(linestr * linep,filestr * file)
{
 int master;

 master=linep->master;

 if(master)
 {
  if(!linep->flags.local)  
  {
   linep->flags.local=1;
   undowritefn(file,ULMXMASTER,&linep->key,sizeof(int));
  }
 }

 return(NULL);
}

/***************************************************************************/


static os_error * makemastersub(int linek,linestr * xnew,filestr * file)
{
 os_error   * err;
 linestr    * linep;

 err=fob_mod(linek,file,(fobjptr)&linep);

 vxadd((sobjectstr **)&linep,file);

 linep->data=xnew->data;
 linep->fcurve=xnew->fcurve;
 linep->transform=xnew->transform;
 linep->flags.spread=xnew->flags.spread;
 linep->flags.locked=xnew->flags.locked;


 lineboxplus(linep,file);

 vxadd((sobjectstr **)&linep,file);

 linep->flags.local=linep->flags.local ^ 1;

 return(err);
}


/* tagged to UMAKEMASTER */


static os_error * unmakemasterscrap(filestr * file)
{
 os_error            * err;
 linestr               xnew;
 unpackedlinedatastr   ld;
 int                   linek;

          err=undoread(file,&linek,sizeof(int));
 if(!err) err=undoread(file,&xnew.transform,sizeof(transformstr));
 if(!err) err=undoread(file,&ld,sizeof(unpackedlinedatastr));
 if(!err) err=undoread(file,&xnew.fcurve,sizeof(curvestr));

 deletefill(&xnew.data.fill,file);
 deletecurve(&xnew.fcurve,file);

 return(err);
}


static os_error * unmakemaster(filestr * file)
{
 os_error            * err;
 linestr               xnew;
 linestr               old;
 unpackedlinedatastr   ld;
 int                   linek;
 linestr             * linep;


          err=undoread(file,&linek,sizeof(int));
 if(!err) err=undoread(file,&xnew.transform,sizeof(transformstr));
 if(!err) err=undoread(file,&ld,sizeof(unpackedlinedatastr));
          packline(&xnew,&ld);
 if(!err) err=undoread(file,&xnew.fcurve,sizeof(curvestr));


 linep=(linestr*)fob_find(linek,file);
 old=*linep;

 if(!err) err=undowritefn(file,UMAKEMASTER,&linek,sizeof(int));
 if(!err) err=undowrite(file,&old.transform,sizeof(transformstr));
          unpackline(&old,&ld);
 if(!err) err=undowrite(file,&ld,sizeof(unpackedlinedatastr));
 if(!err) err=undowrite(file,&old.fcurve,sizeof(curvestr));

 if(!err) err=makemastersub(linek,&xnew,file);

 return(err);
}



/* this is not trivial */

static os_error * makeobjectmaster(linestr * linep,filestr * file)
{
 os_error          * err;
 int                 master;
 linestr             old;
 int                 line;
 unpackedlinedatastr ld;
 curvestr            fcurve;


 err=NULL;
 master=linep->master;

 if(master)
 {
  if(linep->flags.local)
  {
   line=linep->key;
   old=*linep;

   unpackline(&old,&ld);

            err=undowritefn(file,UMAKEMASTER,&line,sizeof(int));
   if(!err) err=undowrite(file,&old.transform,sizeof(transformstr));
   if(!err) err=undowrite(file,&ld,sizeof(unpackedlinedatastr));
   if(!err) err=undowrite(file,&old.fcurve,sizeof(curvestr));

   linep=(linestr*)fob_find(master,file);
   old=*linep;
   fcurve=linep->fcurve;

   copyfill(&old.data.fill,&old.data.fill,file);
   copycurve(&old.fcurve,file,&fcurve,file);

   makemastersub(line,&old,file);
  }
 }
 return(err);
}



static os_error * forceobjectmaster(int mode,linestr * linep,filestr * file)
{
 os_error * err;
 linestr    xnew;
 linestr    old;
 int        line;
 int        master;


 err=NULL;


 if(mode==FORCEMASTER || mode==FORCEMASTERU || mode==FORCEMASTERR)
 {
  line=linep->key;

  master=linep->master;

  if(mode==FORCEMASTERU) master=findoldmaster(master,file,0);

  if(master)
  {
   vxadd((sobjectstr **)&linep,file);

   old=*linep;

   deletecurve(&old.xcurve,file);
   deletecurve(&old.fcurve,file);
   deletefill(&old.data.fill,file);

   linep=(linestr*)fob_find(master,file);
   xnew=*linep;

   copycurve(&old.xcurve,file,&xnew.xcurve,file);
   copycurve(&old.fcurve,file,&xnew.fcurve,file);
   copyfill(&xnew.data.fill,&old.data.fill,file);

   err=fob_mod(line,file,(fobjptr)&linep);

   linep->data=xnew.data;
   linep->transform=xnew.transform;
   linep->box=xnew.box;
   linep->xcurve=old.xcurve;
   linep->fcurve=old.fcurve;
   linep->flags.spread=xnew.flags.spread;
   linep->flags.locked=xnew.flags.locked;

   vxadd((sobjectstr **)&linep,file);
  }
 }

 return(err);
}




static os_error * uudm(filestr * file)
{
 mrefstr      mref;
 objectloc    src;
 objectloc    dest;
 transformstr tr;

 undoread(file,&mref,sizeof(mrefstr));
 mpageundelete(&mref,0,&src,&dest,&tr,file);
 linecopyc(&src,&dest,&tr);
 return(undowritefn(file,URDM,&dest.object,sizeof(int)));
}


static os_error * deletemaster(linestr * linep,filestr * file)
{
 int     line;
 mrefstr mref;

 line=linep->key;

 mref.master=linep->master;
 mref.after=linep->chain.prev;

 linescrap(line,file,DELETEUNLINK);

 return(undowritefn(file,UUDM,&mref,sizeof(mrefstr)));
}


static os_error * urdm(filestr * file)
{
 int       line;
 linestr * linep;

 undoread(file,&line,sizeof(int));
 linep=(linestr*)fob_find(line,file);
 return(deletemaster(linep,file));
}






static os_error * localobject(linestr * linep,filestr * file,int makelocal)
{
 if(makelocal==MAKELOCAL)    return(makeobjectlocal(linep,file));
 else
 if(makelocal==MAKEMASTER)   return(makeobjectmaster(linep,file));
 else
 if(makelocal==DELETEMASTER) return(deletemaster(linep,file));
 else                        return(forceobjectmaster(makelocal,linep,file));
}


/*****************************************************************************/


/* tagged to ULSHAPE */

static os_error * ustrash(filestr * file)
{
 os_error     * err;
 int            line;
 curvestr       fcurve;

          err=undoread(file,&line,sizeof(int));
 if(!err) err=undoread(file,&fcurve,sizeof(curvestr));

 err=deletecurve(&fcurve,file);

 return(err);
}


static os_error * unshapeline(filestr * file)
{
 os_error     * err;
 int            line;
 linestr      * linep;
 curvestr       fcurve;
 curvestr       ocurve;

          err=undoread(file,&line,sizeof(int));
 if(!err) err=undoread(file,&fcurve,sizeof(curvestr));

 linep=(linestr*)fob_find(line,file);
 if(linep)
 {
  fob_mod(line,file,(fobjptr)&linep);

  vxadd((sobjectstr **)&linep,file);

  ocurve=linep->fcurve;
  linep->fcurve=fcurve;

  lineboxplus(linep,file);

  vxadd((sobjectstr **)&linep,file);

  deletecurve(&ocurve,file);
 }

 return(err);
}



static os_error * shapeobject(linestr * linep,int shape,
                                              int data,filestr * file)
{
 int      linek;
 curvestr fcurve;

 linek=linep->key;

 vxadd((sobjectstr **)&linep,file);

 fcurve=linep->fcurve;

 undowritefn(file,ULSHAPE,&linek,sizeof(int));
 undowrite(file,&fcurve,sizeof(curvestr));

 makecurve(&fcurve,shape,data,file);

 fob_mod(linek,file,(fobjptr)&linep);
 linep->fcurve=fcurve;

 lineboxplus(linep,file);

 vxadd((sobjectstr **)&linep,file);

 return(NULL);

}




static os_error * oreaddata(int action,linestr * linep,
                                             filestr * file,void * data)

{

 switch(action)
 {
  case SELECTINFO:
                  ((outlineinfostr*)data)->fcurve=linep->xcurve;
                  ((outlineinfostr*)data)->tr=linep->transform;
                  ((outlineinfostr*)data)->frame=0;
                  break;

  case  OREADFILL:
                  *((colourvalue*)data)=linep->data.fillcolour;
                  break;

 }

 return(NULL);

 USE(file);
}





static os_error * lxdocinit2(int eventn,int user,filestr * file,
                                                            void * data)
{
 int          line;
 linestr    * linep;

 if((line=xprototype(OLINE))!=0)
 {
  linep=(linestr*)fob_find(line,deffile);

  defltlinedata=linep->data;
  defltlinedata.fill.fill=FILLSTR;
 }

 return(remevent(EVENT_DOCINIT2,(eventfn)lxdocinit2,0));

 USE(eventn);
 USE(data);
 USE(user);
 USE(file);
}









/*****************************************************************************/




static objectstr lineobject=
{
 OLINE,                           /* type */
 NULL,                            /* new  */
 (objectcopyfn)linecopy,          /* copy */
 (objectredrawfn)redrawline,      /* redraw */
 (objectcreatefn)createline,      /* create */
 (objectfindfn)findline,          /* find   */
 (objectselectfn)selectline,      /* select */
 (objecttransformfn)transline,    /* transform */
 (objectloadtypefn)lineloadtype,  /* load type   */
 NULL,                            /* load */
 NULL,                            /* load post */
 (objectmessagefn)linemessage,    /* message */
 (objectdbfn)linedb,              /* object db */
 (objectflowfn)lineflow,          /* text flow   */
 (objectdeletefn)linedelete,      /* delete      */
 NULL,                            /* text reflow */
 (objectsetflowfn)linesetflow,    /* object set flow */
 (objectmasterfn)masterobject,    /* master object?  */
 (objectlocalfn)localobject,      /* local object    */
 (objectshapefn)shapeobject,      /* change shape    */
 (objectreadfn)oreaddata,         /* read data */
 NULL,                            /* x12 */

};


#define UNDOS 11

static undofnstr undos[UNDOS]=
{
 untransline,   NULL,                 ULTRAN,        "{UTRANS}",
 unupdateline,  NULL,                 ULUPDATE,      "{UMODIFY}",
 ulrecreate,    ultrash,              ULRECREATE,    NULL,
 uldelete,      NULL,                 ULDELETE,      NULL,
 unshapeline,   ustrash,              ULSHAPE,       NULL,
 unlmakelocal,  NULL,                 ULMXLOCAL,     NULL,
 unlmakemaster, NULL,                 ULMXMASTER,    NULL,
 unmakemaster,  unmakemasterscrap,    UMAKEMASTER,   NULL,
 unlinemove,    NULL,                 ULMOVE,        NULL,
 uudm,          NULL,                 UUDM,          NULL,
 urdm,          NULL,                 URDM,          NULL,
};



os_error * lineinit(void)
{
 os_error * err;
 err=undoaddblock(undos,UNDOS);
 if(!err) err=objectregister(&lineobject);
 if(!err) err=linetoolinit();
 if(!err) err=dblineinit();
 dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));
 if(!err) err=addevent(EVENT_DOCINIT2,(eventfn)lxdocinit2,0);

 return(err);
}


