/*->c.pref */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"


#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"
#include "trans.h"
#include "xmath.h"
#include "crc.h"
#include "etc.h"
#include "bf.h"
#include "dbhi.h"


#include "str.h"
#include "constants.h"


#include "file.h"

#include "dbchoices.h"
#include "pref.h"


/****************************************************************************/


prefdatastr * prefp(filestr * file)
{
 oprefstr * pref;

 pref=(oprefstr*)fob_find(file->hdr.preferences,file);
 if(pref) return(&pref->data);
 else     return(&defprefdata);
}



os_error * prefwrite(prefdatastr * p,filestr * file)
{
 oprefstr * pref;

 fob_change(file->hdr.preferences,file,sizeof(oprefstr),(fobjptr)&pref);
 /* pref=fob_find(file->hdr.preferences,file); */

 pref->data=*p;

 return(NULL);
}


os_error * prefread(prefdatastr * p,filestr * file)
{
 oprefstr * pref;

 pref=(oprefstr*)fob_find(file->hdr.preferences,file);

 *p=pref->data;

 return(NULL);
}


/* used by new doc code to twiddle units */

os_error * prefunits(int units,filestr * file)
{
 prefdatastr p;

 prefread(&p,file);

 p.units=units;

 return(prefwrite(&p,file));
}



static os_error * prefnew(filestr * file)
{
 os_error      * err;
 int             preferences=0; /* init to make compiler happy */
 oprefstr      * pref;

 err=fob_create(sizeof(oprefstr),file,OPREF,(fobjptr)&pref);
 if(!err)
 {
  preferences=pref->key;
  pref->data=defprefdata;
  file->hdr.preferences=preferences;
 }
 return(err);
}




/* NB s==source d==dest. */

static os_error * prefmkstyle(int eventn,int user,filestr * dfile,
                                                    filestr * sfile)
{
 os_error      * err;
 oprefstr      * pref;
 int             preferences;


 err=fob_copy((fobjptr)&pref,dfile,sfile->hdr.preferences,sfile);
 if(!err)
 {
  preferences=pref->key;
  dfile->hdr.preferences=preferences;
 }

 return(err);

 USE(eventn);
 USE(user);
}



static os_error * prefnewevent(int eventn,int user,filestr * file,
                                                             void * data)
{
 return(prefnew(file));
 USE(eventn);
 USE(data);
 USE(user);
}



static os_error * prefbareevent(int eventn,int user,filestr * file,
                                                             void * data)
{
 return(prefnew(file));
 USE(eventn);
 USE(data);
 USE(user);
}





/*

void password(string & readpw,string & writepw,int flags,int file);

flags

bit 0..2
      == 0 do nothing - just return bits value
      == 1 unlock file
      == 2 change passwords/read only bit

bit 3
      readpw is valid
bit 4
      writepw is valid
bit 5 
      read only bit is valid


bit 8
      file read only bit

Return

     bit 0  - read pw set
     bit 1  - write pw set
     bit 2  - file is readable
     bit 3  - file is writeable
     bit 4  - readunlocked
     bit 5  - writeunlocked
     bit 8  - file read only bit


*/


int password(int fp)
{
 filestr     * file;
 int           readpw;
 int           writepw;
 prefdatastr * pref;
 char        * p;
 int           mode;
 int           readonlybit;
 int           readpwvalid;
 int           writepwvalid;
 int           readonlybitvalid;


 file=(filestr*)stack[fp+3];
 readpw=writepw=0;

 p=stringptr(stack[fp]);
 crcblock32(&readpw,p,strlen(p));
 p=stringptr(stack[fp+1]);
 crcblock32(&writepw,p,strlen(p));

 mode=stack[fp+2] & 0x7;

 readonlybit=     (stack[fp+2] & (1<<8));
 readpwvalid=     (stack[fp+2] & (1<<3));
 writepwvalid=    (stack[fp+2] & (1<<4));
 readonlybitvalid=(stack[fp+2] & (1<<5));

 pref=prefp(file);

 if(mode==2)
 {
  if(file->writeunlocked)
  {
   if(readpwvalid)      pref->readpw=readpw;
   if(writepwvalid)     pref->writepw=writepw;
   if(readonlybitvalid) pref->readonly=(readonlybit!=0);
   file->writeable=!pref->readonly;
  }
 }
 else
 if(mode==1)
 {
  if(pref->readpw==readpw && readpwvalid)   
  {
   file->readable=1;
   file->readunlocked=1;
  }

  if(pref->writepw==writepw && writepwvalid && writepw!=0)
  {
   file->writeable=!pref->readonly;
   file->writeunlocked=1;
   file->readable=1;
   file->readunlocked=1;
  }
 }

 return(
        (pref->readpw!=0)      |
        ((pref->writepw!=0)<<1)|
        (file->readable<<2)    |
        (file->writeable<<3)   |
        (file->readunlocked<<4)|
        (file->writeunlocked<<5)|
        (pref->readonly<<8)
       );
}




os_error * prefinitpassword(filestr * file)
{
 oprefstr    * pref;
 int           size;

 size=fob_size(file->hdr.preferences,file,(fobjptr)&pref);
 if(size>=0)
 {
  if(size!=sizeof(oprefstr))
  {
   fob_change(file->hdr.preferences,file,sizeof(oprefstr),(fobjptr)&pref);
   memset(((char*)pref)+size,0,sizeof(oprefstr)-size);
  }

  file->readable=file->readunlocked=(pref->data.readpw==0);
  file->writeunlocked=(pref->data.writepw==0);
  file->writeable=file->writeunlocked && (!pref->data.readonly);
 }

 return(NULL);
}




static os_error * prefsaveevent(int eventn,int user,filestr * file,buffer * bf)
{
 os_error      * err;
 subchoicestr  * choice;  
 prefdatastr     p;

 prefread(&p,file);

 err=bf_printfeoln(bf,2,"// Preferences");

 choice=firstpref;
 while(choice)
 {
  if(choice->dscript) err=choice->dscript(bf,&p,file);
  if(err) break;
  choice=choice->next;
 }

 if(!err) err=bf_printfeol(bf,"");

 return(err);

 USE(user);
 USE(eventn);
}





os_error * prefinit(void)
{
 os_error * err;

 err=addevent(EVENT_MKSTYLE1,(eventfn)prefmkstyle,0);
 if(!err) err=addevent(EVENT_NEWDOC1,(eventfn)prefnewevent,0);
 if(!err) err=addevent(EVENT_BAREDOC1,(eventfn)prefbareevent,0);
 if(!err) err=addevent(EVENT_DSSAVE1,(eventfn)prefsaveevent,0);

 return(err);
}

