/*->h.pref */


typedef struct prefdatastr
{
 int autosave;
 int autosaveperiod;
 int autosaveprompt;
 int units;
 int chapterstart;
 int chapterseparator;		// used as two 16 bit characters

 int pasteboardx;
 int pasteboardy;
 int rulerx;
 int rulery;
 int snaprulerguidelines;
 int snapframes;
 int guidelinefb;

 int baselinegridspacing;
 int baselinegridorigin;
 int supersize;
 int subsize;
 int smallsize;
 char decimaltab1[4];				// used as UNC16 stream		was int

 int readpw;
 int writepw;
 unsigned int readonly:1;
 unsigned int autopageinsert:1;
 unsigned int autopageremove:1;
 unsigned int sparebits:29;

 char hyphenchar[12];				// used as UNC16 stream		changed from int to char[12]	2.77
	char decimaltab2[8];				// new from 2.77

	int  spare[12];									// was int spare[16];


} prefdatastr;



/* OPREF object, one per document */

typedef struct oprefstr
{
 int         key;
 int         type;

 prefdatastr data;

} oprefstr;



typedef struct prefteststr
{
 prefdatastr * pref;
	int           compatability;

} prefteststr;




extern prefdatastr   prefdata;
extern prefdatastr   defprefdata;

extern int           prefcompatability;

extern filestr *     preffile(void);



extern os_error    * prefwrite(prefdatastr * p,filestr * file);
extern os_error    * prefread(prefdatastr * p,filestr * file);
extern prefdatastr * prefp(filestr * file);

extern os_error    * prefunits(int units,filestr * file);


extern int           password(int fp);
extern os_error    * prefinitpassword(filestr * file);




extern os_error    * prefinit(void);



#define PREFVDATA    0x1
#define PREFMST      0x2
#define PREFDOC      0x4
#define PREFCURRENT  0x8
#define PREFRULERS   0x10
#define PREFDBLE     0x20
#define PREFFLOW     0x40
#define PREFCHAP     0x80
#define PREFAUTOSAVE 0x100


extern void prefchanges(int flag);



