/*->c.draw */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "sprite.h"
#include "sprx.h"
#include "xprocess.h"
#include "scrap.h"
#include "deb.h"

#include "Drawlevel0.h"
#include "Drawfile1.h"

#include "err.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "alloc.h"
#include "colour.h"
#include "etc.h"
#include "poll.h"
#include "xmath.h"
#include "imlib.h"
#include "xxjpeg.h"
#include "bits.h"
#include "dbhi.h"

#include "constants.h"
#include "str.h"
#include "reslink.h"
#include "xxcolour.h"

#include "obj.h"
#include "object.h"
#include "dscript.h"
#include "xrender.h"
#include "xprint.h"
#include "colsep.h"

#include "pxstr.h"
#include "pict.h"
#include "file.h"
#include "view.h"
#include "viewr.h"
#include "impex.h"
#include "pixtool.h"
#include "splib.h"
#include "splink.h"
#include "fit.h"
#include "xtrace.h"
#include "pxtags.h"
#include "pxref.h"
#include "pxcache.h"
#include "pxbmp.h"
#include "pxwmf.h"
#include "transload.h"

#include "fxdraw.h"

#include "draw.h"





#define DXLEN  80
#define DXQUAD 19

#define DXBASE '#'


os_error * dxwritedata(char * data,int len,buffer * bf)
{
 os_error    * err;
 int           c;
 int           d;

 static int    mask;
 static int    shift;
 static char   buff[DXLEN];
 static char * dxwr;
 static int    quad;
 static int    b;

 err=NULL;



 if(len==-1)
 {
  mask=0x3;
  shift=2;
  b=0;
  dxwr=buff;
  quad=0;
  *dxwr++='"';
 }
 else
 if(len==-2)
 {
  if(shift>2)
  {
   d=DXBASE+b;
   if(d=='\\') d=DXBASE+64;
   *dxwr++=(char)d;
  }

  if(quad || shift>2)
  {
   *dxwr++='"';
   *dxwr++='\r';
   *dxwr++='\n';
   err=bf_write(bf,buff,dxwr-buff);
  }
 }
 else
 {
  while(len--)
  {
   c=*data++;

   d=DXBASE+b+(c>>shift);
   if(d=='\\') d=DXBASE+64;
   *dxwr++=(char)d;

   if(shift==6)
   {
    d=DXBASE+(c & 0x3F);
    if(d=='\\') d=DXBASE+64;
    *dxwr++=(char)d;
    shift=2;
    b=0;
    mask=0x3;
    quad++;

    if(quad==DXQUAD)
    {
     *dxwr++='"';
     *dxwr++='\r';
     *dxwr++='\n';
     bf_write(bf,buff,dxwr-buff);
     dxwr=buff+1;
     quad=0;
    }
   }
   else
   {
    b=(c & mask)<<(6-shift);
    if(mask==0x3) mask=0xF;
    shift+=2;
   }
  }
 }

 return(err);
}




static int dxreaddata(char * w,char * r)
{
 char * base;
 int    c;

 static int shift;
 static int b;


 base=w;

 if(!r)
 {
  shift=2;
  b=0;
 }
 else
 {
  while((c=*r++)!=0)
  {
   if(c==(DXBASE+64)) c='\\';
   c-=DXBASE;


   if(shift<=0) 
   {
    b+=c>>(-shift);

    *w++=(char)b;

    b=(c<<(8+shift)) & 0xFF;
    shift+=2;
   }
   else /* shift == 2 */
   {
    b=c<<shift;
    shift-=6;
   }
  }
 }

 return(w-base);
}




os_error * dxloadblock(int sshift,int fp,int argc,objectloc * loc)
{              
 os_error          * err;
 filestr           * file;
 dsobjectstr       * ds;
 int                 type;
 int                 picture;

 static int          first;       
 static int          len;
 static picturestr * picturep;


 err=NULL;

 file=loc->file;

 if(argc==DSIMMINIT)
 {
  first=1;
 }
 else
 if(argc==DSIMMLAST || argc==DSIMMERR)
 {
  ds=(dsobjectstr*)(dsstack+fp);
  ds->data.integer=picturep->key;
  ds->len=3*sizeof(int);

  fob_unlock((fobjptr)&picturep,file);
 }
 else
 {
  ds=(dsobjectstr*)(dsstack+fp+2);
  type=ds->type;

  if(first)
  {
   if(type==DSTINT)
   {
    len=ds->data.integer;

    err=fob_create(len+sizeof(picturestr)+sshift,file,OPICTURE,
                                                 (fobjptr)&picturep);
    if(!err)
    {
     picture=picturep->key;
     fob_setbits(picture,file,OBJ_CCINSTANCE,(fobjptr)&picturep);
     picturep->imagelen=len+sshift;
     err=fob_lock((fobjptr)&picturep,picture,file);
     dxreaddata(NULL,NULL);
    }
   }
   first=0;
  }
  else
  {
   if(type==DSTSTR)
   {
    len-=dxreaddata(picturep->data+picturep->imagelen-len,ds->data.string);
   }
  }
 }

 return(err);
}





os_error * dxloadchunk(char * name,int sshift,
                                          int * object,filestr * file)
{
 os_error   * err;
 int          first;
 int          n;
 int          pkey;
 int          eof;
 int          chunk;
 int          read;
 picturestr * picturep;


 err=NULL;

 first=1;
 n=sshift;
 pkey=0;

 err=bf_loadstart(name);
 if(!err)
 {
  do
  {
   err=bf_loadsize(&chunk);
   if(err) break;

   if(first)
   {
    err=fob_create(n+chunk+sizeof(picturestr),file,
                                               OPICTURE,(fobjptr)&picturep);
    if(err) break;
    pkey=picturep->key;
    fob_setbits(pkey,file,OBJ_CCINSTANCE,(fobjptr)&picturep);
    first=0;
   }
   else
   {
    err=fob_change(pkey,file,n+chunk+sizeof(picturestr),(fobjptr)&picturep);
    if(err) break;
   }

   err=bf_loaddata(name,picturep->data+n,chunk,&read,&eof);
   if(err) break;

   n+=read;
  } while(!eof);

  if(err)
  {
   *object=0;
   if(pkey) fob_delete(pkey,file);
  }
  else
  {
   *object=pkey;
   fob_change(pkey,file,n+sizeof(picturestr),(fobjptr)&picturep);
   picturep->imagelen=n;
  }
 }

 return(err);
}



os_error * dxscrapchunk(int * object,filestr * file)
{
 os_error * err;
 err=fob_delete(*object,file);
 *object=0;
 return(err);
}



os_error * dxembedchunk(int sshift,int object,filestr * file)
{
 os_error          * err;
 picturestr        * picturep;
 fstat               fs;
 int                 len;
 int                 insert;
 pxpreftagstaticstr  reftag;
 char                name[FILENAMELEN];
 int                 ptype;
 int                 ftype;

 err=NULL;

 pxreadtag((pxtagstr*)&reftag,PXPREF1TAG,object,file);
 if(reftag.len)
 {
  err=pxexpandpath(name,NITEM(name),reftag.name,file);
  if(!err)
  {
   pxuncachename(name,file);

   picturep=(picturestr*)fob_find(object,file);
   len=picturep->proxylen+picturep->tagslen+sizeof(picturestr);
   ptype=picturep->ftype;
   ftype=fs_filetypefromextension(name);


   if(!err)
   {
    if(ptype!=ftype)
    {
     int        transhandle;
     char       transname[FILENAMELEN];
     void     * eh;

     cprintf("trans view");

     err=sc_create(&transhandle);
     if(!err)
     {
      xzstrncpy(transname,sc_name(transhandle),sizeof(transname));
      err=translatefile(name,-1,transname,ptype);
      if(!err)
      {
       err=fs_stat(transname,&fs);
       if(!err && !fs.object) err=geterrorf(EPX5,name);
       if(!err)
       {
        insert=(sshift+fs.length+3)&(~0x3);

        err=fob_change(object,file,insert+len,(fobjptr)&picturep);
        if(!err)
        {
         memmove(picturep->data+insert,picturep->data,len-sizeof(picturestr));
         err=fs_loadblock(transname,picturep->data+sshift);
         if(!err)
         {
          picturep->imagelen=sshift+fs.length;
         }
         else
         {
          memmove(picturep->data,picturep->data+insert,len-sizeof(picturestr));
          fob_change(object,file,len,(fobjptr)&picturep);
         }
        }
       }
      }

      eh=errsave(err);
      fs_delete(sc_name(transhandle));
      sc_remove(transhandle,err);
      err=errload(eh,NULL);
     }
    }
    else
    {
     err=fs_stat(name,&fs);
     if(!err && !fs.object) err=geterrorf(EPX5,name);
     if(!err)
     {
      insert=(sshift+fs.length+3)&(~0x3);

      err=fob_change(object,file,insert+len,(fobjptr)&picturep);
      if(!err)
      {
       memmove(picturep->data+insert,picturep->data,len-sizeof(picturestr));
       err=fs_loadblock(name,picturep->data+sshift);
       if(!err)
       {
        picturep->imagelen=sshift+fs.length;
       }
       else
       {
        memmove(picturep->data,picturep->data+insert,len-sizeof(picturestr));
        fob_change(object,file,len,(fobjptr)&picturep);
       }
      }
     }
    }
   }
  }
 }
 return(err);
}



os_error * dxscrapimage(int object,filestr * file)
{
 os_error   * err;
 picturestr * picturep;
 int          len;
 int          remove;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);
 len=picturep->proxylen+picturep->tagslen+sizeof(picturestr);
 remove=(picturep->imagelen+3)&(~0x3);
 if(remove)
 {
  memmove(picturep->data,picturep->data+remove,len-sizeof(picturestr));
  err=fob_change(object,file,len,(fobjptr)&picturep);
  picturep->imagelen=0;
 }

 return(err);
}




static Draw_error e;       /* static so we can pass error back */


static os_error * initpicture(picturestr * picturep)
{
 Draw_box  box;
 Draw_diag diag;

 diag.length=picturep->imagelen;
 diag.data=picturep->data;

 if(!Draw_verify_diag(diag,&e))
 {
  sprintf(e.err.os.errmess,"Draw verify failed: code %d at %d",
                                      e.err.draw.code, e.err.draw.location);
  e.err.os.errnum=0x4001;
  return(&e.err.os);
 }

 Draw_queryBox(diag,&box,FALSE);

 picturep->abox.x0=box.x0;
 picturep->abox.x1=box.x1;
 picturep->abox.y0=box.y0;
 picturep->abox.y1=box.y1;

 return(NULL);
}




static os_error * drawimportpost(int ftype,int object,filestr * file)
{
 USE(ftype);
 USE(object);
 USE(file);

 return(NULL);
}



static os_error * drawimport(char * name,int ftype,int xv,
                                                int * object,filestr * file)
{
 os_error   * err;
 picturestr * picturep;

 err=dxloadchunk(name,0,object,file);
 if(!err)
 {
  picturep=(picturestr*)fob_find(*object,file);
  picturep->ftype=ftype;
  err=initpicture(picturep);
  if(err) dxscrapchunk(object,file);
 }

 return(err);

 USE(xv);
}



static os_error * drawembed(int ftype,int object,filestr * file)
{
 os_error   * err;
 picturestr * picturep;

 err=dxembedchunk(0,object,file);
 if(!err)
 {
  picturep=(picturestr*)fob_find(object,file);
  picturep->ftype=ftype;
  err=initpicture(picturep);
  if(err)
  {
   dxscrapimage(object,file);
  }
  else
  {
   pxtagsize(object,file,PXPREF1TAG,0);
   pxtagsize(object,file,PXPREF2TAG,0);
  }
 }

 return(err);
}




/* render picture                */
/* given box in picture space    */
/* given transform to real space */




static os_error * drawrender(aboxstr * abox,transformstr * tr,
                  processstr * pr,picturestr * picturep,viewredrawstr * v)
{
 os_error        * err;
 Draw_diag         diag;
 int               oldmode;
 pxproxyimstr    * proxy;


 err=NULL;

 if(!pr->spotplate || pr->knockoutgraphics)
 {
  oldmode=pr->mode;
  if(pr->spotplate && pr->knockoutgraphics) pr->mode=PROCESSWHITE;


  if(pr->useproxies)
  {
   proxy=(pxproxyimstr*)(picturep->data+((picturep->imagelen+0x3)&(~0x3)));
   diag.length=proxy->imagelen;
   diag.data=proxy->data;
  }
  else
  {
   if(picturep->imagelen==0)
   {
    err=pxcache2(&picturep,v->file,NULL,NULL);
   }

   if(!err)
   {
    diag.length=picturep->imagelen;
    diag.data=picturep->data;
   }

  }

  if(!err)
  {
   fxdsetview(v);
   if(!Draw_render(&diag,(Draw_box*)abox,tr,pr,&e))
   {
    if(e.type==DrawOwnError)
    {
     sprintf(e.err.os.errmess,"Draw render failed: code %d at %d",
                  e.err.draw.code, e.err.draw.location);

     e.err.os.errnum=0x4000;
    }

    err=&e.err.os;
   }
   fxdsetview(NULL);
  }

  pr->mode=oldmode;
 }

 return(err);
}



static os_error * drawdsexport(int ftype,int object,
                                           filestr * file,buffer * bf)
{
 os_error   * err;
 picturestr * picturep;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 bf_printfeol(bf,"%d",picturep->imagelen);
 dxwritedata(NULL,-1,bf);
 dxwritedata(picturep->data,picturep->imagelen,bf);
 err=dxwritedata(NULL,-2,bf);

 return(err);

 USE(ftype);
}





static os_error * drawdsimport(int ftype,int fp,int argc,objectloc * loc)
{              
 os_error          * err;
 filestr           * file;
 dsobjectstr       * ds;
 int                 object;
 picturestr        * picturep;

 file=loc->file;

 err=dxloadblock(0,fp,argc,loc);

 if(argc==DSIMMLAST)
 {
  ds=(dsobjectstr*)(dsstack+fp);
  object=ds->data.integer;

  picturep=(picturestr*)fob_find(object,file);
  picturep->ftype=ftype;

  if(!err) err=initpicture(picturep);
  if(err) 
  {
   dxscrapchunk(&object,file);
   ds=(dsobjectstr*)(dsstack+fp);
   ds->data.integer=object;
  }
 }

 return(err);
}



static os_error * drawexport(char * name,int object,int ftype,int xv,
                                                              filestr * file)
{
 os_error   * err;
 picturestr * picturep;
/* pxproxyimstr * proxyim;  */

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

/* dprintf(2,"drawexport len=%d name=%s",picturep->imagelen,name); */

 if(!err) err=bf_saveblock(name,ftype,picturep->data,picturep->imagelen);

/* report(err); */

/* proxyim=(pxproxyimstr*)(picturep->data+((picturep->imagelen+0x3)&(~0x3)));
 err=bf_saveblock(name,ftype,proxyim->data,proxyim->imagelen); */

 return(err);

 USE(xv);
}





static os_error * drawinfo(int object,int ftype,filestr * file,int * len)
{
 os_error   * err;
 picturestr * picturep;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err) *len=picturep->imagelen;

 return(err);

 USE(ftype);
}



static os_error * drawcache(picturestr * picturep,filestr * file)
{
 os_error  * err;
 Draw_diag   diag;

 err=NULL;
            
 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err)
 {
  diag.length=picturep->imagelen;
  diag.data=picturep->data;

//		cprintf("drawcache");

  Draw_CacheFonts(&diag,printercachefont,printercachefontchar);
 }

 return(err);
}





static os_error * drawlistfonts(picturestr * picturep,filestr * file)
{
 os_error  * err;
 Draw_diag   diag;

 err=NULL;

 cprintf("drawlistfonts");

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err)
 {
  diag.length=picturep->imagelen;
  diag.data=picturep->data;

  Draw_CacheFonts(&diag,pxlistfont,NULL);
 }

 return(err);
}






static os_error * drawpxinfo(int object,int ftype,
                                       filestr * file,int * info)
{
 os_error         * err;
 picturestr       * picturep;
 char               string[256];
 int                len;



 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err)
 {
  *info++=PT_LENGTH;
  *info++=3*sizeof(int);
  *info++=picturep->imagelen;

  strcpy(string,impexname(ftype));
  len=strlen(string)+1;
  len=(len+3)&(~0x3);
  *info++=PT_INFO;
  *info++=2*sizeof(int)+len;
  strcpy((char*)info,string);
  info+=(len/sizeof(int));

  *info++=PT_DIM;
  *info++=4*sizeof(int);
  *info++=picturep->abox.x1-picturep->abox.x0;
  *info++=picturep->abox.y1-picturep->abox.y0;

  *info++=PT_CLASS;
  *info++=8*sizeof(int);
  *info++=PT_VEC;

  *info++=PT_RGB;
  *info++=3;
  *info++=8;
  *info++=0;
  *info++=0;
 
  *info++=PT_END;
  *info++=2*sizeof(int);
 }

 return(err);
}




static os_error * drawproxy(int ftype,int object,filestr * file,
                                                 pxproxystr * proxy)
{

 cprintf("draw proxy");

 return(spproxysub(SPPXMASK,object,file,proxy));
 USE(ftype);
}



os_error * dxremoveproxy(int ftype,int object,filestr * file)
{
 os_error   * err;
 picturestr * picturep;
 int          imagelen;
 int          proxylen;
 int          tagslen;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);
 if(picturep->proxylen)
 {
  proxylen=picturep->proxylen;
  tagslen=picturep->tagslen;
  imagelen=(picturep->imagelen+0x3) & (~0x3);

  memmove(picturep->data+imagelen,picturep->data+imagelen+proxylen,tagslen);
  picturep->proxylen=0;

  pxtagsize(object,file,PXPROXYTAG,0);
 }

 return(err);

 USE(ftype);
}




os_error * dxrefload(char * name,char * expandedname,int ftype,int * object,filestr * file)
{
 os_error         * err;
 int                cacheobject=0;
 filestr          * cachefile=NULL;
 picturestr       * picturep;
 int                pkey;
 aboxstr            abox;
 int                cftype;
 pxpreftagstaticstr reftag;



 err=pxcache(expandedname,ftype,file,&cacheobject,&cachefile);
 if(!err)
 {
  err=fob_create(sizeof(picturestr),file,OPICTURE,(fobjptr)&picturep);
  if(!err)
  {
   pkey=picturep->key;
   fob_setbits(pkey,file,OBJ_CCINSTANCE,(fobjptr)&picturep);

   picturep=(picturestr*)fob_find(cacheobject,cachefile);

   abox=picturep->abox;
   cftype=picturep->ftype;

   err=fob_mod(pkey,file,(fobjptr)&picturep);

   if(!err)
   {
    picturep->abox=abox;
    picturep->ftype=cftype;

    reftag.tag=PXPREF1TAG;
    strcpy(reftag.name,name);
    reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));

    err=pxwritetag((pxtagstr*)&reftag,pkey,file);
    if(!err)
    {
     reftag.tag=PXPREF2TAG;
     strcpy(reftag.name,expandedname);
     reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
     err=pxwritetag((pxtagstr*)&reftag,pkey,file);
    }

    *object=pkey;
   }

   if(err)
   {
    *object=0;
    fob_delete(pkey,file);
   }
  }
 }

 return(err);
}







os_error * dxrefreload(char * name,char * expname,int ftype,
                                                  int pkey,filestr * file)
{
 os_error         * err;
 int                cacheobject;
 filestr          * cachefile;
 picturestr       * picturep;
 aboxstr            abox;
 int                cftype;
 pxpreftagstaticstr reftag;


 err=pxcache(expname,ftype,file,&cacheobject,&cachefile);
 if(!err)
 {
  picturep=(picturestr*)fob_find(cacheobject,cachefile);

  abox=picturep->abox;
  cftype=picturep->ftype;

  err=fob_mod(pkey,file,(fobjptr)&picturep);

  if(!err)
  {
   picturep->abox=abox;
   picturep->ftype=cftype;

   dxscrapimage(pkey,file);

   reftag.tag=PXPREF1TAG;
   strcpy(reftag.name,name);
   reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));

   err=pxwritetag((pxtagstr*)&reftag,pkey,file);
   if(!err)
   {
    reftag.tag=PXPREF2TAG;
    strcpy(reftag.name,expname);
    reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
    err=pxwritetag((pxtagstr*)&reftag,pkey,file);
   }
  }
 }

 return(err);
}









static impexstr drawstr=
{
 DRAW,
 "Draw",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */
 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* info */
 dxrefload,           /* reference load */
 drawproxy,           /* make proxy     */
 dxremoveproxy,       /* remove proxy */

 drawembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 drawlistfonts,       /* listfonts              */
 NULL,                /* x3                     */


};



#define TABLEMATE 0xBCF

static impexstr tablematestr=
{
 TABLEMATE,
 "TableMate",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */

 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* x1 */
 dxrefload,           /* reference load */
 drawproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

 drawembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 drawlistfonts,       /* listfonts              */
 NULL,                /* x3                     */


};




#define EQUASOR   0xD91

static impexstr equasorstr=
{
 EQUASOR,
 "Equasor",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */

 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* x1 */
 dxrefload,           /* reference load */
 drawproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

 drawembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 drawlistfonts,       /* listfonts              */
 NULL,                /* x3                     */


};




#define FORMULIX  0xB98

static impexstr formulixstr=
{
 FORMULIX,
 "Formulix",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */

 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* x1 */
 dxrefload,           /* reference load */
 drawproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

 drawembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 drawlistfonts,       /* listfonts              */
 NULL,                /* x3                     */


};





#define EURSHEET  0xC37

static impexstr eurekastr=
{
 EURSHEET,
 "Eureka",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */

 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* x1 */
 dxrefload,           /* reference load */
 drawproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

 drawembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 drawlistfonts,       /* listfonts              */
 NULL,                /* x3                     */


};






#define DIAGRAMIT  0xB84

static impexstr diagramitstr=
{
 DIAGRAMIT,
 "DiagramIt",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */

 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* x1 */
 dxrefload,           /* reference load */
 drawproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

 drawembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 drawlistfonts,       /* listfonts              */
 NULL,                /* x3                     */


};





#define TABLECALC  0xB7D

static impexstr tablecalcstr=
{
 TABLECALC,
 "TabCalc",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */

 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* x1 */
 dxrefload,           /* reference load */
 drawproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

 drawembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 drawlistfonts,       /* listfonts              */
 NULL,                /* x3                     */


};






#define GRAPHMATE  0xB83

static impexstr graphmatestr=
{
 GRAPHMATE,
 "GraphMate",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */

 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* x1 */
 dxrefload,           /* reference load */
 drawproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

 drawembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 drawlistfonts,       /* listfonts              */
 NULL,                /* x3                     */


};








#ifdef NEVER

#define VECTOR  0xC56

static impexstr vectorfilestr=
{
 VECTOR,
 "VecFile",

 IMPXLOAD|IMPXPICT, /* flags       */
 drawimport,          /* import      */
 drawimportpost,      /* import post */
 drawexport,          /* export      */
 drawrender,          /* render      */
 drawdsexport,        /* dsexport    */
 drawdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 drawcache,           /* cache */

 NULL,                /* rendermem */

 NULL,                /* data shift */

 drawpxinfo,          /* x1 */
 drawref,             /* reference load */
 drawproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

};


#endif


/****************************************************************************/

#define DRAWW 16

static void dummysprite(int * buff,int size,aboxstr * abox)
{
 char      * p;
 char      * q;
 int         h;
 int         w;
 int         xhi;
 int         xlo;
 int         yhi;
 int         ylo;
 int         mode;
 int         dx;
 int         dy;
 sprite_id   sid;
 sprite_info sinfo;


 /* sprite at offset 64 */

 if(abox)
 {
  xlo=abox->x0;
  xhi=abox->x1;
  ylo=abox->y0;
  yhi=abox->y1;
 }
 else
 {                                                                                sid.s.addr=(sprite_area *)(buff+DRAWW);
  sid.tag=sprite_id_addr;
  sprite_readsize((sprite_area *)(buff+DRAWW),&sid,&sinfo);

  w=sinfo.width;
  h=sinfo.height;
  mode=sinfo.mode;

  getdeltas(mode,&dx,&dy);

  xhi=w*256*dx;                         /* draw units */
  yhi=h*256*dy;
  xlo=ylo=0;
 }

 strcpy((char *)buff,"Draw");
 *(buff+1)=201;
 *(buff+2)=0;
 p=(char*)(buff+3);
 q=p+12;
 strcpy(p,"ArcDraw");
 p+=strlen(p);
 for(;p<q;p++) *p=32;

 *(buff+6)=xlo;
 *(buff+7)=ylo;
 *(buff+8)=xhi;
 *(buff+9)=yhi;

 *(buff+10)=5;
 *(buff+11)=size;

 *(buff+12)=xlo;
 *(buff+13)=ylo;
 *(buff+14)=xhi;
 *(buff+15)=yhi;
}




static void dradjustdimensions(int * buff,aboxstr * abox)
{
 int         xhi;
 int         xlo;
 int         yhi;
 int         ylo;

 /* sprite at offset 64 */

 xlo=abox->x0;
 xhi=abox->x1;
 ylo=abox->y0;
 yhi=abox->y1;


 *(buff+6)=xlo;
 *(buff+7)=ylo;
 *(buff+8)=xhi;
 *(buff+9)=yhi;

 *(buff+12)=xlo;
 *(buff+13)=ylo;
 *(buff+14)=xhi;
 *(buff+15)=yhi;
}





static os_error * spritedsexport(int ftype,int object,
                                           filestr * file,buffer * bf)
{
 int          nosprites=1;
 int          foffset=16;
 int          firstfree;
 int          spritelen;
 picturestr * picturep;
 char       * buff;


 picturep=(picturestr*)fob_find(object,file);
 buff=picturep->data;

 spritelen=*((int*)(buff+DRAWW*4));
 firstfree=spritelen+16;

 bf_printfeol(bf,"%d",spritelen+3*sizeof(int));

 dxwritedata(NULL,-1,bf);

 dxwritedata((char*)&nosprites,sizeof(int),bf);
 dxwritedata((char*)&foffset,sizeof(int),bf);
 dxwritedata((char*)&firstfree,sizeof(int),bf);
 dxwritedata(buff+DRAWW*4,spritelen,bf);

 return(dxwritedata(NULL,-2,bf));

 USE(ftype);
}












static os_error * spriteimportpost(int ftype,int object,filestr * file)
{
 USE(ftype);
 USE(object);
 USE(file);
 return(NULL);
}





#define SSHIFT ((DRAWW-3)*sizeof(int))




static os_error * spriteinit(int ftype,int object,filestr * file)
{
 os_error   * err;
 picturestr * picturep;
 int          nosprites;
 int          firstoff;
 int          firstfree;
 int          spritelen;
 int          bytes;
 int        * buff;
 int          n;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);
 n=picturep->imagelen;

 buff=(int*)(picturep->data+SSHIFT);
 nosprites=*buff++;
 firstoff=*buff++;
 firstfree=*buff++;

 /* can now trash firstoff-16 bytes */

 memmove((char*)buff,((char*)buff)+firstoff-16,
                                          n-DRAWW*sizeof(int)-firstoff+16);

 spritelen=*buff;

 bytes=((spritelen+3)&~3)+DRAWW*sizeof(int);

 buff=(int*)picturep->data;

 dummysprite(buff,((spritelen+3)&~3)+24,NULL); 

 err=fob_change(object,file,bytes+sizeof(picturestr),(fobjptr)&picturep);
 picturep->imagelen=bytes;
 picturep->ftype=ftype;

 if(!err) err=initpicture(picturep);

 return(err);
}




static os_error * spriteimport(char * name,int ftype,int xv,
                                                int * object,filestr * file)
{
 os_error   * err;

 err=dxloadchunk(name,SSHIFT,object,file);
 if(!err)
 {
  err=spriteinit(ftype,*object,file);
  if(err) dxscrapchunk(object,file);
 }

 return(err);

 USE(xv);
}





static os_error * spembed(int ftype,int object,filestr * file)
{
 os_error * err;

 err=dxembedchunk(SSHIFT,object,file);
 if(!err)
 {
  err=spriteinit(ftype,object,file);
  if(err)
  {
   dxscrapimage(object,file);
  }
  else
  {
   pxtagsize(object,file,PXPREF1TAG,0);
   pxtagsize(object,file,PXPREF2TAG,0);
  }
 }
 return(err);
}




static os_error * spritedsimport(int ftype,int fp,int argc,objectloc * loc)
{              
 os_error          * err;
 filestr           * file;
 dsobjectstr       * ds;
 int                 object;


 file=loc->file;

 err=dxloadblock(SSHIFT,fp,argc,loc);

 if(argc==DSIMMLAST)
 {
  ds=(dsobjectstr*)(dsstack+fp);
  object=ds->data.integer;
  if(!err) err=spriteinit(ftype,object,file);
  if(err)
  {
   dxscrapchunk(&object,file);
   ds=(dsobjectstr*)(dsstack+fp);
   ds->data.integer=object;
  }
 }

 return(err);
}



static os_error * spriteexport(char * name,int object,int ftype,int xv,
                                                              filestr * file)
{
 os_error   * err;
 picturestr * picturep;
 buffer       bf;
 int          nosprites=1;
 int          foffset=16;
 int          firstfree;
 int          spritelen;
 char       * buff;
/* pxproxyimstr * proxyim;  */


 err=NULL;

 err=bf_open(name,'w',BUFFMINSIZE,&bf);
 if(!err)
 {
  picturep=(picturestr*)fob_find(object,file);

/*proxyim=(pxproxyimstr*)(picturep->data+((picturep->imagelen+0x3)&(~0x3)));*/

  if(picturep->imagelen==0)
  {
   err=pxcache2(&picturep,file,NULL,NULL);
  }

  if(!err)
  {
   buff=picturep->data; 

/*  buff=proxyim->data; */

   if(!err)
   {
    spritelen=*((int*)(buff+DRAWW*4));
    firstfree=spritelen+16;

    bf_write(&bf,&nosprites,sizeof(int));
    bf_write(&bf,&foffset,sizeof(int));
    bf_write(&bf,&firstfree,sizeof(int));
    bf_write(&bf,buff+DRAWW*4,spritelen);
   }
  }

  err=bf_closec(&bf,err,name,ftype);
 }

 return(err);

 USE(xv);
}



static int spshift(picturestr * picturep)
{
 return(DRAWW*sizeof(int));
 USE(picturep);
}




static os_error * sppxinfo(int object,int ftype,
                                       filestr * file,int * info)
{
 os_error         * err;
 picturestr       * picturep;
 newsprite_header * sphdr;
 pixinfostr         px;
 char               string[128];
 int                len;
 int                spp;


 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err)
 {
  sphdr=(newsprite_header*)(picturep->data+DRAWW*4);
  getpixinfo((newsprite_header*)sphdr,&px);


  *info++=PT_LENGTH;
  *info++=3*sizeof(int);
  *info++=sphdr->next;

  *info++=PT_RES;
  *info++=4*sizeof(int);
  *info++=px.xdpi;
  *info++=px.ydpi;

  *info++=PT_BPP;
  *info++=3*sizeof(int);
  *info++=px.spbpp;

  *info++=PT_PIX;
  *info++=4*sizeof(int);
  *info++=px.spx;
  *info++=px.spy;

  if(px.sptype) sprintf(string,"Sprite type %d",px.sptype);
  else          sprintf(string,"Sprite Mode %d",px.spmode);
  len=strlen(string)+1;
  len=(len+3)&(~0x3);
  *info++=PT_INFO;
  *info++=2*sizeof(int)+len;
  strcpy((char*)info,string);
  info+=(len/sizeof(int));


  *info++=PT_DIM;
  *info++=4*sizeof(int);
  *info++=px.spdrx;
  *info++=px.spdry;


  *info++=PT_CLASS;
  *info++=8*sizeof(int);
  *info++=PT_BITMAP|
          (px.sphasmask?PT_MASK:0)|
          ((px.sptype<5)?PT_INDEX:0)|
          (px.palentries<<8);
  
  spp=(px.sptype<5)?1:((px.sptype==7)?4:3);

  *info++=(px.sptype==7)?PT_CMYK:PT_RGB;
  *info++=spp;
  *info++=(px.sptype<5)?(1<<px.spbpp):((px.sptype==5)?5:8);
  *info++=spp;
  *info++=(1<<px.spmaskbpp)/spp;



  *info++=PT_END;
  *info++=2*sizeof(int);
 }

 return(err);

 USE(ftype);
}





os_error * spproxysub(int flags,int object,filestr *file,pxproxystr *proxy)
{
 os_error      * err;
 picturestr    * picturep;
 int             xpix;
 int             ypix;
 int             delta;
 int             newlen;
 int             proxyimagelen;
 int             proxyoffset;
 int             proxydatalen;
 int             spritelen;
 newspstr        xnew;
 pxproxyimstr  * proxyim;
 aboxstr         dbox;
 transformstr    tr;
 transformstr    tra;
 transformstr    trb;
 viewredrawstr   v;
 processstr      pr;
 newsprite_header * spa;
 pxproxytagstr   proxytag;
 imagestr        im;
 imagescreenstr  imsc;


 err=NULL;

 
 initviewredraw(&v);
 v.file=file;


 picturep=(picturestr*)fob_find(object,file);

 /* determine size of proxy */

 xpix=scale(picturep->abox.x1-picturep->abox.x0,proxy->scale,256*2*0x10000);
 ypix=scale(picturep->abox.y1-picturep->abox.y0,proxy->scale,256*2*0x10000);


 xnew.spbpp=proxy->bpp;
 if(xnew.spbpp==2) xnew.spbpp=4;
 xnew.dx=xnew.dy=2;
 xnew.mask=(flags & SPPXMASK);
 xnew.palette=1;  /* source is greyscale? */
 xnew.mode=makemode(xnew.spbpp,xnew.dx,xnew.dy);
 xnew.fill=-1;
 xnew.maskfill=(flags & SPPXMASK)?0:-1;


 proxyoffset=(picturep->imagelen+0x3) & (~0x3);
 spritelen=spritesize(&xnew,xpix,ypix);
 proxyimagelen=spritelen+DRAWW*sizeof(int);
 proxydatalen=(sizeof(pxproxyimstr)+proxyimagelen+0x3) & (~0x3);

 /* make space */

 delta=(proxydatalen-picturep->proxylen);
 newlen=sizeof(picturestr)+proxyoffset+picturep->proxylen+
                                       picturep->tagslen+delta;


 err=fob_change(object,file,newlen,(fobjptr)&picturep);
 if(!err)
 {
  if(picturep->imagelen==0) err=pxcache2(&picturep,file,NULL,NULL);
  /* fiddle to ensure memory does not move during render */

 }

 if(!err)
 {
  picturep=(picturestr*)fob_find(object,file);

  memmove(picturep->data+proxyoffset+picturep->proxylen+delta,
         picturep->data+proxyoffset+picturep->proxylen,
         picturep->tagslen);

  picturep->proxylen+=delta;

  /* create proxy  */

  proxyim=(pxproxyimstr*)(picturep->data+proxyoffset);
  proxyim->ftype=SPRITE;
  proxyim->abox=picturep->abox;
  proxyim->imagelen=proxyimagelen;

/*dprintf(0,"xpix=%d ypix=%d len=%d fl=%d",xpix,ypix,proxyimagelen,flags); */

  memset(&pr,0,sizeof(processstr));

  /* create sprite */

  spa=(newsprite_header*)(proxyim->data+DRAWW*sizeof(int));

  createspritem(spa,&xnew,xpix,ypix);

  dummysprite((int*)proxyim->data,spritelen+24,&proxyim->abox);

  /* render image to proxy */

  im.xdpi=90;
  im.ydpi=90;
  imgetsppal(&im,spa);
  
  err=imnewscreen(xpix,ypix,xnew.spbpp,&im,&imsc);
  if(!err)
  {
   err=imsetscreen(&imsc,1);
   if(!err)
   {
    pr.isprinter=0;
//    pr.vdupal=&cvdu.vdupal;
//    pr.deltax=cvdu.deltax;
//    pr.deltay=cvdu.deltay;
//    pr.lndeltax=cvdu.lndeltax;
//    pr.lndeltay=cvdu.lndeltay;

    pr.xdpi=cvdu.xdpi;
    pr.ydpi=cvdu.ydpi;
    pr.ln2bpp=cvdu.ln2bpp;
    pr.tosprite=1;
    pr.fontbits=pixfontbits;
    pr.jpegbits=pixjpegbits;
    pr.spritebits=pixspritebits;
    if(!proxy->dither) pr.spritebits&=~((1<<5)|(1<<6));
    pr.useproxies=0;
    pr.scale.x=pr.scale.y=0x10000;
    pr.background=-1;
    pr.mode=PROCESSNONE;

    pr.handle2=NULL;	// view
    pr.cmyk2rgb=(processcmyk2rgbfn)xcmyk2rgb3232;
    pr.cmyk2bgr=(processcmyk2rgbfn)xcmyk2bgr3232;


    dbox=proxyim->abox;

    tr_setscale(&tra,proxyim->abox.x1-proxyim->abox.x0,scale(xpix,180*256,cvdu.xdpi),
                     proxyim->abox.y1-proxyim->abox.y0,scale(ypix,180*256,cvdu.ydpi));
//    tr_setshift(&trb,-proxyim->abox.x0,-proxyim->abox.y0);
    tr_setshift(&trb,-proxyim->abox.x0,-proxyim->abox.y1);

    tr_multiply(&tr,&trb,&tra);

    err=render(&dbox,&tr,&pr,picturep,&v);

    picturep=(picturestr*)fob_find(object,file);
    proxyim=(pxproxyimstr*)(picturep->data+proxyoffset);
    spa=(newsprite_header*)(proxyim->data+DRAWW*sizeof(int));

    imgetspritebits(&im,spa,0);


    if(!err)
    {
     if(flags & SPPXMASK)
     {
      if(!err)
      {
       pr.mode=PROCESSWHITE;
       render(&dbox,&tr,&pr,picturep,&v);

       imgetspritebits(&im,spa,1);
      }
     }
    }

    imsetscreen(&imsc,0);
   }
   imdeletescreen(&imsc);
  }


  if(!err)
  {
   proxytag.len=sizeof(pxproxytagstr);
   proxytag.tag=PXPROXYTAG;
   proxytag.proxy=*proxy;
   pxwritetag((pxtagstr*)&proxytag,object,file);
  }
 }


 return(err);
}


static os_error * spproxy(int ftype,int object,filestr *file,
                                                           pxproxystr *proxy)
{
 os_error      * err;
 newsprite_header * spa;
 picturestr    * picturep;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err)
 {
  spa=(newsprite_header*)(picturep->data+DRAWW*sizeof(int));
  err=spproxysub((spa->mask>spa->image)?SPPXMASK:0,object,file,proxy);
 }

 return(err);

 USE(ftype);
}





static os_error * changeproxysize(int proxyimagelen,int picture,filestr * file)
{
 os_error     * err;
 picturestr   * picturep;
 int            proxyoffset;
 int            proxydatalen;
 pxproxyimstr * proxyim;
 int            delta;
 int            newlen;



 proxydatalen=sizeof(pxproxyimstr)+((proxyimagelen+0x3) & (~0x3));
 picturep=(picturestr*)fob_find(picture,file);
 proxyoffset=(picturep->imagelen+0x3) & (~0x3);

 delta=(proxydatalen-picturep->proxylen);
 newlen=sizeof(picturestr)+proxyoffset+picturep->proxylen+
                                        picturep->tagslen+delta;

 err=fob_change(picture,file,newlen,(fobjptr)&picturep);
 if(!err)
 {
  memmove(picturep->data+proxyoffset+picturep->proxylen+delta,
          picturep->data+proxyoffset+picturep->proxylen,
          picturep->tagslen);

  picturep->proxylen+=delta;

  proxyim=(pxproxyimstr*)(picturep->data+proxyoffset);
  proxyim->imagelen=proxyimagelen;
 }

 return(err);
}






os_error * sploadproxy(char * name,int picture,filestr * file)
{
 os_error     * err;
 fstat          fs;
 picturestr   * picturep;
 int            proxyoffset;
 int            proxyimagelen;
 int            nosprites;
 int            firstoff;
 int            firstfree;
 int            spritelen;
 pxproxyimstr * proxyim;
 int          * buff;



 err=fs_stat(name,&fs);
 if(!err && fs.object)
 {
  proxyimagelen=fs.length+DRAWW*sizeof(int);

  err=changeproxysize(proxyimagelen,picture,file);
  if(!err)
  {
   picturep=(picturestr*)fob_find(picture,file);

   proxyoffset=(picturep->imagelen+0x3) & (~0x3);

   proxyim=(pxproxyimstr*)(picturep->data+proxyoffset);
   proxyim->ftype=SPRITE;
   proxyim->abox=picturep->abox;

   err=fs_loadblock(name,proxyim->data+SSHIFT);
   if(!err)
   {
    buff=(int*)(proxyim->data+SSHIFT);
    nosprites=*buff++;
    firstoff=*buff++;
    firstfree=*buff++;

    /* can now trash firstoff-16 bytes */

    memmove((char*)buff,((char*)buff)+firstoff-16,fs.length-firstoff+16);

    spritelen=*buff;

    proxyimagelen=((spritelen+3)&~3)+DRAWW*sizeof(int);

    buff=(int*)proxyim->data;

    dummysprite(buff,((spritelen+3)&~3)+24,&proxyim->abox); 

    err=changeproxysize(proxyimagelen,picture,file);
   }
  }
 }

 return(err);
}





os_error * drloadproxy(char * name,int picture,filestr * file)
{
 os_error     * err;
 fstat          fs;
 picturestr   * picturep;
 int            proxyoffset;
 int            proxyimagelen;
 pxproxyimstr * proxyim;




 err=fs_stat(name,&fs);
 if(!err && fs.object)
 {
  proxyimagelen=fs.length;

  err=changeproxysize(proxyimagelen,picture,file);
  if(!err)
  {
   picturep=(picturestr*)fob_find(picture,file);

   proxyoffset=(picturep->imagelen+0x3) & (~0x3);

   proxyim=(pxproxyimstr*)(picturep->data+proxyoffset);
   proxyim->ftype=DRAW;
   proxyim->abox=picturep->abox;

   err=fs_loadblock(name,proxyim->data);
   dradjustdimensions((int*)proxyim->data,&proxyim->abox);
  }
 }

 return(err);
}








static impexstr spritestr=
{
 SPRITE,
 "sprite",

 IMPXLOAD|IMPXPICT,   /* flags       */
 spriteimport,        /* import      */
 spriteimportpost,    /* import post */
 spriteexport,
 drawrender,          /* render      */
 spritedsexport,      /* dsexport    */
 spritedsimport,      /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 NULL,                /* cache */

 NULL,                /* rendermem */

 spshift,             /* data shift */

 sppxinfo,            /* info */
 dxrefload,           /* reference load */
 spproxy,             /* make proxy */
 dxremoveproxy,       /* remove proxy */

 spembed,             /* embed referenced image */
 dxrefreload,         /* reload                 */
 NULL,                /* list fonts             */
 NULL,                /* x3                     */


};



/****************************************************************************/


#define DRAWJPEG 27
#define JSHIFT (DRAWJPEG*sizeof(int))




static void dummyjpeg(int * buff,int size)
{
 char      * p;
 char      * q;
 int         xhi;
 int         yhi;
 int         width;
 int         height;
 int         xres;
 int         yres;
 jpeginfostr info;


 jpeg_info((buff+DRAWJPEG),size-DRAWJPEG*sizeof(int),&info); 
 
 width=info.xpix;
 height=info.ypix;
 xres=info.xdpi;
 yres=info.ydpi;

 width=((width*180)/xres)*256;
 height=((height*180)/yres)*256;

 xhi=width;
 yhi=height;


 strcpy((char *)buff,"Draw");
 *(buff+1)=201;
 *(buff+2)=0;
 p=(char*)(buff+3);
 q=p+12;
 strcpy(p,"ArcDraw");
 p+=strlen(p);
 for(;p<q;p++) *p=32;

 *(buff+6)=0;
 *(buff+7)=0;
 *(buff+8)=xhi;
 *(buff+9)=yhi;

 *(buff+10)=16;
 *(buff+11)=(size+0x3)&(~0x3);

 *(buff+12)=0;
 *(buff+13)=0;
 *(buff+14)=xhi;
 *(buff+15)=yhi;

 *(buff+16)=width;
 *(buff+17)=height;
 *(buff+18)=xres;
 *(buff+19)=yres;
 *(buff+20)=0x10000;
 *(buff+21)=0x0;
 *(buff+22)=0x0;
 *(buff+23)=0x10000;
 *(buff+24)=0x0;
 *(buff+25)=0x0;
 *(buff+26)=size-DRAWJPEG*sizeof(int);
}






static os_error * jpegpxinfo(int object,int ftype,
                                       filestr * file,int * info)
{
 os_error         * err;
 picturestr       * picturep;
 char               string[128];
 int                len;
 int              * buff;
 int                size;
 jpeginfostr        jpinfo;


 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err)
 {
  buff=(int*)picturep->data;
  size=picturep->imagelen;

  *info++=PT_LENGTH;
  *info++=3*sizeof(int);
  *info++=buff[11];

  *info++=PT_RES;
  *info++=4*sizeof(int);
  *info++=buff[18];
  *info++=buff[19];

  *info++=PT_PIX;
  *info++=4*sizeof(int);
  *info++=((buff[16]/256)*buff[18])/180;
  *info++=((buff[17]/256)*buff[19])/180;

  sprintf(string,"JPEG");

  len=strlen(string)+1;
  len=(len+3)&(~0x3);
  *info++=PT_INFO;
  *info++=2*sizeof(int)+len;
  strcpy((char*)info,string);
  info+=(len/sizeof(int));


  *info++=PT_DIM;
  *info++=4*sizeof(int);
  *info++=buff[16];
  *info++=buff[17];


  *info++=PT_CLASS;
  *info++=8*sizeof(int);
  *info++=PT_BITMAP;


  jpeg_info((buff+DRAWJPEG),size-DRAWJPEG*sizeof(int),&jpinfo); 

  if((jpinfo.components==1) || (jpinfo.components==3)) *info++=PT_RGB;
  else                                                 *info++=PT_CMYK;

  *info++=jpinfo.components;
  *info++=8;
  *info++=0;
  *info++=0;


  *info++=PT_END;
  *info++=2*sizeof(int);
 }

 return(err);

 USE(ftype);
}







static os_error * jpeginit(int ftype,int object,filestr * file)
{
 os_error   * err;
 picturestr * picturep;
 int          n;
 int          size;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);
 n=picturep->imagelen;

 size=(n+0x3)&(~0x3);

 err=fob_change(object,file,size+sizeof(picturestr),(fobjptr)&picturep);
 if(!err)
 {
  dummyjpeg((int*)picturep->data,n); 
  picturep->imagelen=n;
  picturep->ftype=ftype;
  err=initpicture(picturep);
 }

 return(err);
}





static os_error * jpegimportpost(int ftype,int object,filestr * file)
{
 USE(ftype);
 USE(object);
 USE(file);

 return(NULL);
}




static os_error * jpegimport(char * name,int ftype,int xv,
                                                int * object,filestr * file)
{
 os_error * err;

 err=dxloadchunk(name,JSHIFT,object,file);
 if(!err)
 {
  err=jpeginit(ftype,*object,file);
  if(err) dxscrapchunk(object,file);
 }

 return(err);

 USE(xv);
}




static os_error * jpegembed(int ftype,int object,filestr * file)
{
 os_error * err;

 err=dxembedchunk(JSHIFT,object,file);
 if(!err)
 {
  err=jpeginit(ftype,object,file);
  if(err)
  {
   dxscrapimage(object,file);
  }
  else
  {
   pxtagsize(object,file,PXPREF1TAG,0);
   pxtagsize(object,file,PXPREF2TAG,0);
  }
 }

 return(err);
}





static os_error * jpegdsexport(int ftype,int object,
                                           filestr * file,buffer * bf)
{
 picturestr * picturep;
 char       * buff;
 int          len;

 picturep=(picturestr*)fob_find(object,file);
 buff=picturep->data;

 len=picturep->imagelen-JSHIFT;

 bf_printfeol(bf,"%d",len);

 dxwritedata(NULL,-1,bf);

 dxwritedata(buff+JSHIFT,len,bf);

 return(dxwritedata(NULL,-2,bf));

 USE(ftype);
}




static os_error * jpegdsimport(int ftype,int fp,int argc,objectloc * loc)
{              
 os_error          * err;
 filestr           * file;
 dsobjectstr       * ds;
 int                 object;

 file=loc->file;

 err=dxloadblock(JSHIFT,fp,argc,loc);

 if(argc==DSIMMLAST)
 {
  ds=(dsobjectstr*)(dsstack+fp);
  object=ds->data.integer;
  if(!err) err=jpeginit(ftype,object,loc->file);
  if(err)
  {
   dxscrapchunk(&object,file);
   ds=(dsobjectstr*)(dsstack+fp);
   ds->data.integer=object;
  }
 }

 return(err);
}





static os_error * jpegexport(char * name,int object,int ftype,int xv,filestr * file)
{
 os_error   * err;
 picturestr * picturep;

 err=NULL;

 picturep=(picturestr*)fob_find(object,file);

 if(picturep->imagelen==0)
 {
  err=pxcache2(&picturep,file,NULL,NULL);
 }

 if(!err) err=bf_saveblock(name,ftype,picturep->data+JSHIFT,
                                picturep->imagelen-JSHIFT);

 return(err);

 USE(xv);
}




static int jpegshift(picturestr * picturep)
{
 return(DRAWJPEG*sizeof(int));
 USE(picturep);
}



static os_error * jpegproxy(int ftype,int object,filestr * file,
                                                 pxproxystr * proxy)
{
 return(spproxysub(0,object,file,proxy));
 USE(ftype);
}






static impexstr jpegstr=
{
 JPEG,
 "jpeg",

 IMPXLOAD|IMPXPICT,   /* flags       */
 jpegimport,          /* import      */
 jpegimportpost,      /* import post */
 jpegexport,          /* export      */
 drawrender,          /* render      */
 jpegdsexport,        /* dsexport    */
 jpegdsimport,        /* dsimport    */

 pictintexport,       /* internal export */
 drawinfo,            /* exportinfo      */

 NULL,                /* cache */

 NULL,                /* rendermem */

 jpegshift,           /* data shift */

 jpegpxinfo,          /* info */
 dxrefload,           /* reference load */
 jpegproxy,           /* make proxy */
 dxremoveproxy,       /* remove proxy */

 jpegembed,           /* embed referenced image */
 dxrefreload,         /* reload                 */
 NULL,                /* list fonts             */
 NULL,                /* x3                     */

};



/****************************************************************************/


static int Dalloc(void ** anchor, int n)
{
 return(flex_alloc(anchor,n)==NULL);
}

static int Dextend(void ** anchor, int n)
{
 return(flex_extend(anchor,n)==NULL);
}

static void Dfree(void ** anchor)
{
 flex_free(anchor);
}

/*

static int Dalloc(void **anchor, int n)
{

 dprintf(2,"alloc =%d",n);

  if ((*anchor = malloc(n)) == NULL)
    return (0);
  else
  {
   memset(*anchor,0,n);
   dprintf(2,"alloc =%d OK",n);
    return (1);
  }
}

static int Dextend(void **anchor, int n)
{
  char *newblock;

 dprintf(3,"extend =%d",n);

  if ((newblock = malloc(n)) == NULL)
    return (0);
  else
  {
    XMEMCPYX(newblock, *anchor, n);
    free (*anchor);
    *anchor = newblock;

   dprintf(3,"extend =%d OK",n);
    return (1);
  }
}

static void Dfree(void **anchor)
{
  free(*anchor);
  *anchor = 0;
}

*/




static os_error * Denhanced(draw_objptr * hdrptr,transformstr * tr,
                                         processstr * pr,int * claimed)
{
 os_error      * err;
 transformstr    result;


 err=NULL;

 *claimed=0;


 if(hdrptr->objhdrp->tag==draw_OBJSPRITE)
 {
  err=render_sp((newsprite_header*)&hdrptr->spritep->sprite,tr,pr,claimed,fxdview());
 }
 else
 if(hdrptr->objhdrp->tag==draw_OBJTRANSSPRITE)
 {
  tr_multiply(&result,(transformstr*)&hdrptr->transspritep->trans,tr);
  err=render_sp((newsprite_header*)&hdrptr->transspritep->sprite,&result,pr,claimed,fxdview());
 }
 else
 if(hdrptr->objhdrp->tag==draw_OBJTRANSJPEG)
 {
  tr_multiply(&result,(transformstr*)&hdrptr->transjpegp->trans,tr);
  err=render_jp(hdrptr->transjpegp->data,hdrptr->transjpegp->len,
                            &result,pr,claimed,fxdview());
 }


 return(err);
}






os_error * drawinit(void)
{
 os_error * err;

          err=impexregister(&drawstr);
 if(!err) err=impexregister(&tablematestr);
 if(!err) err=impexregister(&equasorstr);
 if(!err) err=impexregister(&formulixstr);
 if(!err) err=impexregister(&eurekastr);
 if(!err) err=impexregister(&diagramitstr);
 if(!err) err=impexregister(&tablecalcstr);
 if(!err) err=impexregister(&graphmatestr);
/* if(!err) err=impexregister(&vectorfilestr); */
 if(!err) err=impexregister(&spritestr);
 if(!err) err=impexregister(&jpegstr);

 if(!err) err=bmpinit();
 if(!err) err=wmfinit();

 Draw_registerMemoryFunctions(Dalloc,Dextend,Dfree);
 Draw_set_enhanced_object_handler((Draw_enhanced_object_handler)Denhanced);


 event(EVENT_DRAWINIT,NULL,0);

 return(err);
}


