/*->c.pixtool */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>
#include <time.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "akbd.h"


#include "transform.h"
#include "xprocess.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "colour.h"
#include "xmath.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"
#include "dbhi.h"
#include "deb.h"


#include "constants.h"
#include "str.h"

#include "object.h"

#include "reslink.h"
#include "units.h"

#include "file.h"
#include "view.h"
#include "viewr.h"
#include "undo.h"
#include "ole.h"



#include "xredraw.h"
#include "curve.h"
#include "geometry.h"

#include "posn.h"
#include "toolstr.h"
#include "tools.h"
#include "toolbox.h"
#include "caret.h"
#include "pref.h"
#include "select.h"
#include "chain.h"
#include "clip.h"



#include "txstr.h"
#include "text.h"
#include "mx.h"

#include "pxstr.h"
#include "pict.h"
#include "dbpict.h"
#include "dbpicture.h"
#include "pxconstant.h"
#include "pxref.h"
#include "pxcache.h"

#include "impex.h"


#include "pixtool.h"




typedef struct pixstr
{
 int       valid;
 filestr * file;
 int       object;
 int       page;
 int       section;

} pixstr;


static pixstr pix;




#define PXSOLID 0x1
#define PXROT   0x2
#define PXSCALE 0x3
#define PXLOCK  0x4



static int pxpass;
static int pxclaim;
static int pxdrag;
static int pxddrag;
static int pxskip;


/* values for valid */

#define PIXNONE   0
#define PIXOBJECT 1
#define PIXMARKED 2



static posnstr pixstart;
static int     pxxshift;
static int     pxyshift;
static int     pxangle;
static int     pxinitangle;
static int     pxscale;
static int     pxaspect;



static pointstr handptr=
{
 "p_hand",9,12
};


static pointstr lockptr=
{
 "p_lock",10,10
};



extern ipstr pipstr;


/*****************************************************************************/


static int clippicturetype(int * ftypes)
{
 int w;

 while((w=*ftypes)!=0)
 {
  if(w==DIB || w==EMETAF || w==WMETAF) return(1);
  ftypes++;
 }

 return(0);
}



static void pxupdate(void)
{
 viewrefresharea(pix.file,pix.page,NULL,VRTOOLS2|VRONELAYER);
}



static os_error * clearpix(int state,int all)
{
 if(pix.valid==PIXMARKED || (pix.valid && all))
 {
  undostart(pix.file);
  undowritefn(pix.file,UPXSAVE,&pix,sizeof(pixstr));
  undoend(pix.file);

  if(pix.valid==PIXMARKED)
  {
   viewrefresharea(pix.file,pix.page,NULL,VRTOOLS2|VRONELAYER);
  }
 }

 pix.valid=state;

 return(NULL);
}



/* used by undo fix to save tool posn on file save */

static os_error * pxsaveact(filestr * file)
{
 if(pix.valid && pix.file==file) 
 {
  undowritefn(pix.file,UPXSAVE,&pix,sizeof(pixstr));
 }

 return(NULL);
}



os_error * unsavepix(filestr * file)
{
 int tool;

 clearpix(PIXNONE,1);
 toolclaimsubtool(file,OPICTBOX);
 undoread(file,&pix,sizeof(pixstr));
 pix.file=file;

 if(pix.valid)
 {
  tool=toolcurrent(file);
  if(tool==TL_SELECT) ipchangepane(file->toolbox,IP_PANE2,&pipstr);
 }

 event(EVENT_SUBTOOL,file,pix.object);

 return(viewrefresharea(pix.file,pix.page,NULL,VRTOOLS2|VRONELAYER));
}




os_error * pixclear(int pict,filestr * file)
{
 os_error   * err;

 err=NULL;

 if(pix.valid && pix.file==file && pix.object==pict)
 {
  err=clearpix(PIXNONE,1);
  ipchangepane(file->toolbox,IP_PANE2,NULL);
 }

 return(err);
}





static os_error * pxrot(int eventn,int user,filestr * file,int * data)
{
 pictboxstr * pictp;

 if(pix.valid==PIXMARKED && pix.file==file)
 {
  *data++=1;
  pictp=(pictboxstr*)fob_find(pix.object,file);
  *data=pictp->pictdata.angle;
 }

 return(NULL);

 USE(eventn);
 USE(user);
}



static os_error * pxrotstart(int eventn,int user,int * claim,posnstr * posn)
{
 coordstr     cx;
 boxbitstr    bits;
 pictboxstr * pictp;

 if(pix.valid==PIXMARKED && pix.file==posn->file)
 {
  pxupdate();

  pixstart=*posn;
  toolsstartdrag(posn,/*TOOLDRAGNS|TOOLDRAGSCREEN|*/TOOLDRAGWINDOW|
                       TOOLDRAGKN|TOOLDRAGPTR);

  pictp=(pictboxstr*)fob_find(pix.object,posn->file);
 
  pxdrag=PXROT;

  pxxshift=pictp->pictdata.xshift;
  pxyshift=pictp->pictdata.yshift;
  pxangle=pictp->pictdata.angle;

  if(!rotgetcentre(pix.file,&cx))
  {
   getboxbits(&pictp->fcurve.box,&pictp->transform,&bits);
   cx.x=bits.cx;
   cx.y=bits.cy;
  }

  pxinitangle=scaleatan2(pixstart.x-cx.x,pixstart.y-cx.y);

  pixstart.x=cx.x;
  pixstart.y=cx.y;

  *claim=1;
 }

 return(NULL);

 USE(eventn);
 USE(user);
}




static os_error * pxdorot(int eventn,int user,filestr * file,int * data)
{
 os_error               * err;
 pictboxstr             * pictp;
 unpackedpicturedatastr   upd;
 coordstr                 cx;
 boxbitstr                bp;
 int                      dx;
 int                      dy;
 int                      dx2;
 int                      dy2;
 transformstr             tr;

 err=NULL;


 if(pix.valid==PIXMARKED && pix.file==file)
 {
  *data++=1;
  pictp=(pictboxstr*)fob_find(pix.object,file);
  unpackpicturedata(&upd,pictp);

  if(upd.pd.lockmode==2) err=geterror(EPX1);
  else
  {
   getboxbits(&pictp->fcurve.box,&pictp->transform,&bp);

   if(!rotgetcentre(file,&cx))
   {
    cx.x=bp.cx;
    cx.y=bp.cy;
   }

   dx=(cx.x-bp.orgx);

   if(upd.pd.hbits & HBBOTLEFT)
   {
    dy=(bp.org2y-cx.y);
   }
   else
   {
    dy=(bp.orgy-cx.y);
   }

   tr_setidentity(&tr);
   tr_setrotationa(&tr,bp.angle);
   tr_delta(&tr,&dx,&dy);

   dx2=upd.pd.xshift-dx;
   dy2=upd.pd.yshift+dy;

   tr_setrotationa(&tr,(*data)-upd.pd.angle);
   tr_delta(&tr,&dx2,&dy2);

   upd.pd.xshift=dx2+dx;
   upd.pd.yshift=dy2-dy;
   upd.pd.angle=*data;
  
   err=pictupdatecontents(pix.object,pix.section,file,&upd);
  }
 }

 return(err);

 USE(eventn);
 USE(user);
}



static os_error * pxrotlock(int eventn,int user,int * claim,filestr * file)
{
 pictboxstr * pictp;

 if(pix.valid==PIXMARKED && pix.file==file && pix.object==*claim)
 {
  pictp=(pictboxstr*)fob_find(pix.object,file);
 
  *claim=(pictp->pictdata.lockmode==2);  /* ==1 for locked */
 }

 return(NULL);

 USE(user);
 USE(eventn);
}



/****************************************************************************/


#define SELSUB 16


/* generate sub box given number and frame curve */



static void setsubbox(curvestr * c,viewstr * view,transformstr * tr,
                               transformstr * xtr,transformstr * ytr)
{
 int             dim;
 transformbitstr bits;

 tr_getbits(tr,&bits);

 tr_setbits(xtr,&bits,TR_SHIFT|TR_ROTATE);
 tr_setbits(ytr,&bits,TR_SCALE|TR_SKEW);

 dim=ourunits(SELSUB,view);
 c->box.w=dim;
 c->box.h=dim;
 c->type=CBOX;
}


static void getsubbox(int tag,curvestr * fcurve,coordstr * c)
{
 switch(tag)
 {
  case 1:     /* right */
         c->x=fcurve->box.x+(3*fcurve->box.w)/4;
         c->y=fcurve->box.y+fcurve->box.h/2;
         break;

  case 2:    /* right+bottom */
         c->x=fcurve->box.x+(3*fcurve->box.w)/4;
         c->y=fcurve->box.y+(3*fcurve->box.h)/4;
         break;

  case 3:    /* bottom */
         c->x=fcurve->box.x+fcurve->box.w/2;
         c->y=fcurve->box.y+(3*fcurve->box.h)/4;
         break;
 }
}



static os_error * pixcaret(viewredrawstr * v)
{
 os_error   * err;
 pictboxstr * pictp;
 curvestr     c;
 curvestr     l;
 viewstr    * view;
 int          j;
 int          wimpcolour;
 transformstr tr1;
 transformstr tr2;
 transformstr tr3;
 transformstr xtr;
 transformstr ytr;
 transformstr xtr1;
 coordstr     cx;

 err=NULL;

 if(!pxdrag && !pxskip)
 {
  view=v->view;

  pictp=(pictboxstr*)fob_find(pix.object,v->file);
  if(pictp)
  {
   l.type=CLINE;
   l.box.x=cx.x=pictp->fcurve.box.x+pictp->fcurve.box.w/2;
   l.box.y=cx.y=pictp->fcurve.box.y+pictp->fcurve.box.h/2;

   tr_transformset(&cx,1,&pictp->transform);

   tr_setshift(&tr1,-cx.x,-cx.y);
   tr_setidentity(&tr2);
   tr_setrotationa(&tr2,pictp->pictdata.angle);
   tr_multiply(&tr3,&tr1,&tr2);
   tr_setshift(&tr1,cx.x,cx.y);
   tr_multiply(&tr2,&tr3,&tr1);

   tr_multiply(&tr1,&pictp->transform,&tr2);

   setsubbox(&c,view,&pictp->transform,&xtr,&ytr);

   tr_multiply(&xtr1,&xtr,&tr2);

   for(j=1;j<4;j++)
   {
    getsubbox(j,&pictp->fcurve,&cx);
    l.box.w=cx.x-l.box.x;
    l.box.h=cx.y-l.box.y;

    tr_transformset(&cx,1,&ytr);

    c.box.x=cx.x-c.box.w/2;
    c.box.y=cx.y-c.box.h/2;

    wimpcolour=HANDLECOLOUR|OUTLINEWIMPLINE|OUTLINEEOR|OUTLINECVBACK;
             err=outlinecurve(v,&c,wimpcolour,&pictp->data.colour,&xtr1);
    if(!err) err=outlinecurve(v,&l,wimpcolour,&pictp->data.colour,&tr1);
   }
  }
 }

 return(err);
}



static int pxfindcarethandle(posnstr * posn)
{
 pictboxstr  * pictp;
 curvestr      c;
 int           j;
 transformstr  tr1;
 transformstr  tr2;
 transformstr  tr3;
 transformstr  xtr;
 transformstr  ytr;
 boxbitstr     bits;
 coordstr      point;
 coordstr      cx;

 pictp=(pictboxstr*)fob_find(pix.object,posn->file);
 if(pictp)
 {
  getboxbits(&pictp->fcurve.box,&pictp->transform,&bits);

  setsubbox(&c,posn->view,&pictp->transform,&xtr,&ytr);

  tr_setshift(&tr1,-bits.cx,-bits.cy);
  tr_setidentity(&tr2);
  tr_setrotationa(&tr2,pictp->pictdata.angle);
  tr_multiply(&tr3,&tr1,&tr2);
  tr_setshift(&tr1,bits.cx,bits.cy);
  tr_multiply(&tr2,&tr3,&tr1);

  tr_multiply(&tr1,&xtr,&tr2);

  point.x=posn->x;
  point.y=posn->y;
   
  tr_inverseset(&point,1,&tr1);

  for(j=1;j<4;j++)
  {
   getsubbox(j,&pictp->fcurve,&cx);

   tr_transformset(&cx,1,&ytr);

   c.box.x=cx.x-c.box.w/2;
   c.box.y=cx.y-c.box.h/2;

   if(insidebox(point.x,point.y,&c.box))
   {
    posn->handle=j;
    return(1);
   }
  }
 }

 return(0);
}




/****************************************************************************/


#define PIPSCALE     0
#define PIPSCALEDEC  1
#define PIPSCALEINC  2

#define PIPASPECT    3
#define PIPASPECTDEC 4
#define PIPASPECTINC 5

#define PIPX         6
#define PIPXDEC      7
#define PIPXINC      8

#define PIPY         9
#define PIPYDEC      10
#define PIPYINC      11

#define PIPANGLE     12
#define PIPANGLEINC  13
#define PIPANGLEDEC  14

#define PIPFIT       15

#define PIPCEN       16





static iconmap pipmap[]=
{
 51,0,0,IP_FSUB|IP_TIPS,    /* PIPSCALE     */
 52,0,0,IP_TIPS,    /* PIPSCALEDEC  */
 3, 0,0,IP_TIPS,    /* PIPSCALEINC  */

 5, 0,0,IP_FSUB|IP_TIPS,    /* PIPASPECT    */
 6, 0,0,IP_TIPS,    /* PIPASPECTDEC */
 7, 0,0,IP_TIPS,    /* PIPASPECTINC */

 9, 0,0,IP_FSUB|IP_TIPS,    /* PIPX         */
 10,0,0,IP_TIPS,    /* PIPXDEC      */
 11,0,0,IP_TIPS,    /* PIPXINC      */

 13,0,0,IP_FSUB|IP_TIPS,    /* PIPY         */
 14,0,0,IP_TIPS,    /* PIPYDEC      */
 15,0,0,IP_TIPS,    /* PIPYINC      */

 17,0,0,IP_FSUB|IP_TIPS,    /* PIPANGLE     */
 19,0,0,IP_TIPS,    /* PIPANGLEDEC  */
 18,0,0,IP_TIPS,    /* PIPANGLEINC  */


 22,0,0,IP_TIPS,    /* PIPFIT       */

 24,0,0,IP_TIPS,    /* PIPCEN       */

 0, 0,0,0,    /* terminator   */
};





int pixsnap(viewstr * view,int posn)
{
 int mul;
 int div;

 switch(view->data.units)
 {
  case  INCHES:
               mul=(72000/20);
               div=1;
               break;

  case  POINTS:
               mul=(3*1000);
               div=1;
               break;

  case  MILIMS:
       default:
               mul=360000;
               div=127;
               break;
 }

 posn=scale(posn,div,mul);
 posn=scale(posn,mul,div);

 return(posn);
}



int pixsnaps(int s,int step)
{
 s=scale(s,100,0x10000);
 s=scale(s,0x10000,100);
 return(s);
 USE(step);
}









static os_error * pixaction(viewstr * view,int handle,int step,int index)
{
 os_error                * err;
 char                    * p;
 pictboxstr              * pictp;
 unpackedpicturedatastr    upd;
 unpackedpicturedatastr    oupd;
 filestr                 * file;
 coordstr                  cx;
 transformstr              tr;
 int                       dx;
 int                       dy;


 err=NULL;

 file=view->file;

 if(pix.valid && pix.file==file)
 {
  pictp=(pictboxstr*)fob_find(pix.object,file);

  unpackpicturedata(&upd,pictp);
  oupd=upd;

  if(upd.pd.lockmode==2) err=geterror(EPX1);
  else
  if(upd.pd.lockmode==1 && (index==PIPX || index==PIPY)) err=geterror(EPX1);

  if(!err)
  {
   if(handle)
   {
             err=iconaddr(handle,pipmap[PIPX].realicon,&p);
    if(!err) err=stringtounits(p,&upd.pd.xshift,view->data.units);
   }
   if(index==PIPX) upd.pd.xshift=pixsnap(view,upd.pd.xshift+step);
  }

  if(!err)
  {
   if(handle)
   {
             err=iconaddr(handle,pipmap[PIPY].realicon,&p);
    if(!err) err=stringtounits(p,&upd.pd.yshift,view->data.units);
   }
   if(index==PIPY) upd.pd.yshift=pixsnap(view,upd.pd.yshift+step);
  }

  if(!err)
  {
   if(handle)
   {
             err=iconaddr(handle,pipmap[PIPSCALE].realicon,&p);
    if(!err) err=readpixpc(&upd.pd.scale,p);
   }
   if(index==PIPSCALE) upd.pd.scale=pixcutscale(pixsnaps(upd.pd.scale+step,step));
  }

  if(!err)
  {
   if(handle)
   {
             err=iconaddr(handle,pipmap[PIPASPECT].realicon,&p);
    if(!err) err=readpixpc(&upd.pd.aspect,p);
   }
   if(index==PIPASPECT) upd.pd.aspect=pixcutscale(pixsnaps(upd.pd.aspect+step,step));
  }

  if(!err)
  {
   if(handle)
   {
             err=iconaddr(handle,pipmap[PIPANGLE].realicon,&p);
    if(!err) err=readangle(&upd.pd.angle,p);
   }
   if(index==PIPANGLE) upd.pd.angle=snapangle(upd.pd.angle+step,step);
  }

  if(!err)
  {
   pictcentre(pix.object,file,NULL,&cx);
   cx.x=oupd.pd.xshift-cx.x;
   cx.y=oupd.pd.yshift-cx.y;

   dx=cx.x;
   dy=cx.y;

   tr_setidentity(&tr);
   tr_setrotationa(&tr,upd.pd.angle-oupd.pd.angle);
   tr_delta(&tr,&dx,&dy);

   upd.pd.xshift+=dx-cx.x;
   upd.pd.yshift+=dy-cx.y;


   if(index==PIPFIT) err=pictscaletofit(pix.object,&upd.pd,file);
   else
   if(index==PIPCEN) err=pictcentrepict(pix.object,file,&upd.pd);

   if(!err)          err=pictcheckcentre(pix.object,file,&upd.pd);
  }

  if(!err) err=pictupdatecontents(pix.object,pix.section,file,&upd);
 }

 return(err);
}







int pxunitstep(viewstr * view)
{

 switch(view->data.units)
 {
  case  INCHES:
               return(72000/20);
               break;

  case  POINTS:
               return(3*1000);
               break;

  case  MILIMS:
       default:
               return(MMSIZE);
               break;

 }

}




static os_error * pipclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error        * err;
 viewstr         * view;
 filestr         * file;
 int               sign;
 int               step;

 err=NULL;

 view=(viewstr *)userhandle;
 file=view->file;

 if(m->bbits & 0x1) sign=-1;
 else               sign=1;


 switch(m->i)
 {

  case 52:  /* PIPSCALEDEC  */
          sign=-sign;
  case  3:  /* PIPSCALEINC  */
          step=((0x10000+49)/100);
          if(isshift) sign*=10;
          err=pixaction(view,handle,sign*step,PIPSCALE);
          break;

  case  6:  /* PIPASPECTDEC */
          sign=-sign;
  case  7:  /* PIPASPECTINC */
          step=((0x10000+49)/100);
          if(isshift) sign*=10;
          err=pixaction(view,handle,sign*step,PIPASPECT);
          break;

  case 10:  /* PIPXDEC      */
          sign=-sign;
  case 11:  /* PIPXINC      */
          step=pxunitstep(view);
          if(isshift) sign*=10;
          err=pixaction(view,handle,sign*step,PIPX);
          break;

  case 15:  /* PIPYINC      */
          sign=-sign;
  case 14:  /* PIPYDEC      */
          step=pxunitstep(view);
          if(isshift) sign*=10;
          err=pixaction(view,handle,sign*step,PIPY);
          break;


  case 19:  /* PIPANGLEINC  */
          sign=-sign;
  case 18:  /* PIPANGLEDEC  */
          step=0x10000;
          if(isshift) sign*=10;
          err=pixaction(view,handle,sign*step,PIPANGLE);
          break;


  case 22:  /* PIPFIT       */
          err=pixaction(view,handle,0,PIPFIT);
          break;

  case 24:  /* PIPCEN       */
          err=pixaction(view,handle,0,PIPCEN);
          break;


 }

 return(err);
}




static int findinc(int icon,int inc)
{
 int i;

 i=0;

 while(1)
 {
  if(pipmap[i].originalicon==0) break;
  if(pipmap[i].realicon==icon)
  {
   if(inc) return(pipmap[i+2].realicon);
   else    return(pipmap[i+1].realicon);
  }
  i++;
 }

 return(0);
}



static os_error * pipkey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 viewstr  * view;
 int        ch;
 wimp_mousestr m; 

 err=NULL;

 ch=*key;


 switch(ch)
 {
     case CUP:
   case CDOWN:
              m.i=findinc(icon,ch==CUP);
              if(m.i>0)
              {
               m.w=handle;
               m.bbits=wimp_BLEFT;
               pipclick(handle,userhandle,&m);
              }
              else return(err);
              break;
 
  case RETURN:
              view=(viewstr*)userhandle;
              pixaction(view,handle,0,-1);
              break;

      default:
              return(err);
 }

 *key=-1;

 return(err);
}






static os_error * piprefresh(viewstr * view,int handle,int code)
{
 pictboxstr * pictp;
 filestr    * file;
 char         string[16];

 file=view->file;

 if(code & 0x1) 
 {
  if(pix.valid)
  {
   pictp=(pictboxstr*)fob_find(pix.object,file);
   if(pictp->picture)
   {
    writeiconc(handle,pipmap[PIPX].realicon,
                      unitstostring(pictp->pictdata.xshift,view->data.units));
    writeiconc(handle,pipmap[PIPY].realicon,
                      unitstostring(pictp->pictdata.yshift,view->data.units));

    writepixpc(pictp->pictdata.scale,string);
    writeiconc(handle,pipmap[PIPSCALE].realicon,string);

    writepixpc(pictp->pictdata.aspect,string);
    writeiconc(handle,pipmap[PIPASPECT].realicon,string);

    writeangle(pictp->pictdata.angle,string);
    writeiconc(handle,pipmap[PIPANGLE].realicon,string);
   }
   else
   {
    writeiconc(handle,pipmap[PIPX].realicon,"");
    writeiconc(handle,pipmap[PIPY].realicon,"");
    writeiconc(handle,pipmap[PIPSCALE].realicon,"");
    writeiconc(handle,pipmap[PIPASPECT].realicon,"");
    writeiconc(handle,pipmap[PIPANGLE].realicon,"");
   }
  }
 }
 return(NULL);
}



static ipstr pipstr=
{
 pipclick,         /* click    */
 pipkey,           /* key      */
 pipmap,           /* icon map */
 TPICTURETOOL,     /* template */
 0,                /* code     */
 piprefresh,       /* refresh  */
};



void pixchange(int pict,filestr * file)
{
 int tooln;

 if(pix.valid && pix.file==file && pix.object==pict)
 {
  tooln=toolcurrent(file);
  if(tooln==TL_SELECT) iprefreshpane(file,0x1,IP_PANE2);
  else
  if(tooln==TL_ROTATE) rotupdate(file,0);
 }
}


static void pixclaim(int pict,filestr * file,int claim)
{
 int tooln;

 if(pix.valid && pix.file==file && pix.object==pict)
 {
  tooln=toolcurrent(file);
  if(tooln==TL_SELECT) iprefreshpane(file,0x1,IP_PANE2);
  else
  if(tooln==TL_ROTATE) rotupdate(file,claim);
 }
}


/***************************************************************************/


static os_error * pixolesave(char * name,filestr * file,oledatastr * oledata)
{
 pictboxstr * pictp;
 pictp=(pictboxstr*)fob_find(oledata->user1,file);
 return(export(name,pictp->picture,pictp->ftype,1,file));
}


static os_error * pixoleload(char * name,int ftype,filestr * file,
                                                          oledatastr * oledata)
{
 os_error     * err;
 int            xnew;
 int            old;
 int            section;
 pagestr      * pagep;
 pictboxstr   * pictp;
 transformstr   trx;
 picturestr   * picturep;
 coordstr       cx;
 int            pict;
 int            picture;
 int            page;
 char         * path;
 char           oldname[FILENAMELEN];
 pxpreftagstr * tag;
 char         * impname;
 pxproxytagstr  proxytag;
 char           expname[FILENAMELEN];


 page=oledata->page;
 pict=oledata->user1;
 picture=oledata->user2;
 path=oledata->path;


 pagep=(pagestr*)fob_find(page,file);
 section=pagep->section;


 err=modfile(file,section);
 if(!err)
 {
  pictcalctransform2(pict,file,&trx); /* maintain image posn over ole */

  pxreadtag((pxtagstr*)&proxytag,PXPROXYTAG,picture,file);

  if(path) /* referenced object */
  {
   /* potentially the 'name' may not be the same as the original path... */

   pxuncachename(path,file);

   impname=name;

   if(!cstrcmp(path,name))
   {
    picturep=(picturestr*)fob_find(picture,file);
    tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF1TAG);
    if(tag)
    {
     strcpy(oldname,tag->name);
     impname=oldname;
    }
   }

            err=pxexpandpath(expname,NITEM(expname),impname,file);
   if(!err) err=importreferencereload(impname,expname,ftype,picture,file); 
   xnew=picture;
  }
  else
  {
   err=importload(name,ftype,1,&xnew,file);
   if(!err)
   {
    pictp=(pictboxstr*)fob_find(pict,file);
				ftype=pictp->ftype;
    err=importloadpost(ftype,xnew,file);
			}
  }

  if(!err)
  {
   pictp=(pictboxstr*)fob_find(pict,file);
   old=pictp->picture;

   pictp->picture=xnew;
   pictp->ftype=ftype;
   pictp->flags.masterdata=0;
   oledata->user2=xnew;


/*   picturep=fob_find(old,file);
   cx.x=picturep->abox.x0;
   cx.y=picturep->abox.y1;
   tr_transformset(&cx,1,&trx); */

/* dprintf(0,"cx.x=%d cx.y=%d xshift=%d yshift=%d",cx.x,cx.y,
                         pictp->pictdata.xshift,pictp->pictdata.yshift); */

/* dprintf(1,"cx.x=%d cx.y=%d",cx.x,cx.y);  */


   if(pictp->pictdata.lockmode==1)
   {
    pictcentrepict(pict,file,NULL);
   }
   else
   {
    picturep=(picturestr*)fob_find(xnew,file);
    cx.x=picturep->abox.x0;
    cx.y=picturep->abox.y1;
    tr_transformset(&cx,1,&trx);
   
    pictp->pictdata.xshift=cx.x;
    pictp->pictdata.yshift=cx.y;
   }

   if(!path) fob_delete(old,file);

   if(proxytag.len) importmakeproxy(ftype,xnew,file,&proxytag.proxy);

   pictcalctransform(pict,file);

   pxrefresh(pict,section,page,file);

   pixchange(pict,file); 
  }
 }

 return(err);
}



static os_error * pixole(posnstr * posn)
{
 os_error     * err;
 oledatastr     data;
 pictboxstr   * pictp;
 picturestr   * picturep;
 int            picture;
 char           path[FILENAMELEN];
 pxpreftagstr * tag;


 pictp=(pictboxstr*)fob_find(posn->object,posn->file);

 if(!pictp->flags.masterdata || pictp->flags.local)
 {
  picture=pictp->picture;

  memset(&data,0,sizeof(oledatastr));

  data.type=pictp->ftype;
  data.file=posn->file;
  data.user1=posn->object;
  data.user2=picture;
  data.page=posn->page;
  data.section=posn->section;
  data.save=(olesavefn)pixolesave;
  data.load=(oleloadfn)pixoleload;
  data.dwindow=(posn->view)->handle;
  data.dx=posn->mousex;
  data.dy=posn->mousey;

  picturep=(picturestr*)fob_find(picture,posn->file);

  if(picturep->imagelen==0)
  {
   tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF1TAG);

   if(tag)
   {
    err=pxexpandpath(path,NITEM(path),tag->name,posn->file);  /* likely to return error */
    if(!err)
    {
     data.path=path;
     return(oleobject(&data));
    }
   }
  }
  else
  {
   return(oleobject(&data));
  }
 }

 return(NULL);
}



/***************************************************************************/

static os_error * pxdragndrop(posnstr * posn,int copy)
{
 os_error   * err;
 pictboxstr * pictp;
 objectloc    dloc;
 objectloc    sloc;
 int          copied;

 err=NULL;


 if(posn->valid)
 {
  if(!(posn->view)->data.nodnd)
  {
   findbox(posn,-1);
   if(posn->object)
   {
    memset(&sloc,0,sizeof(objectloc));
    sloc.file=pix.file;
    sloc.page=pix.page;
    sloc.section=sectionofpage(pix.page,pix.file);
    sloc.object=pix.object;

    posntoloc(posn,&dloc);

    pictp=(pictboxstr*)fob_find(dloc.object,dloc.file);
    if(pictp->type==OPICTBOX)
    {
     if(pictp->master && !pictp->flags.local && pictp->flags.masterdata)
     {
      err=geterror(EPX4);
     }
    }
    else
    if(pictp->type==OTEXTBOX)
    {
     err=txconvertable(dloc.object,dloc.section,dloc.file);
    }
    else
    {
     err=geterror(EPX4);
    }

    cprintf("pxdrag n drop err %x",err);

    if(!err)
    {
     err=modfile(dloc.file,dloc.section);
     if(!err)
     {
      if(pix.file!=posn->file)
      {
       copy^=1;

       if(!copy) err=modfile(sloc.file,sloc.section);
       if(!err)
       {
        err=undostart(dloc.file);
        if(!err)
        {
         err=pxdropcopypicture(&dloc,&sloc,posn->otype,&copied);
         undoend(dloc.file);

         if(!copy && copied && !err)
         {
          err=undostart(sloc.file);
          if(!err)
          {
           err=pxdeletepicture(pix.object,pix.file);
           undoend(sloc.file);
          }
         }
        }
       }
      }
      else
      if(pix.object!=posn->object)
      {
       err=modfile(dloc.file,dloc.section);
       if(!err) err=undostart(pix.file);
       if(!err)
       {
        err=pxdropcopypicture(&dloc,&sloc,posn->otype,&copied);

        if(!copy && copied && !err)
        {
         err=pxdeletepicture(pix.object,pix.file);
        }

        undoend(pix.file);
       }
      }
     }
    }
   }
  }
 }
 else
 {
  pictp=(pictboxstr*)fob_find(pix.object,pix.file);
//  err=exportdirect(pictp->ftype,pictp->picture,pix.file);
 }

 return(err);
}


os_error * pictintexport(int pict,int ftype,filestr * file,posnstr * posn)
{
 return(pxdragndrop(posn,file==posn->file));
 USE(ftype);
 USE(pict);
}



/***************************************************************************/


static pointstr resizeptr=
{
 "p_resize",2,2
};


static pointstr ddptr=
{
 "p_export",0,0
};




static os_error * pxptr(toolboxstr * toolbox,posnstr * posn)
{
 if(pxpass)
 {
  if(pix.valid==PIXMARKED && 
     pix.file==posn->file && 
     pix.page==posn->page &&
     !posn->ghost)
  {
   if(toolcurrent(posn->file)==TL_SELECT)
   {
    if(pxfindcarethandle(posn)) toolschangepointer(1,USERPOINTER,&resizeptr);
   }
  }
 }

 return(NULL);

 USE(toolbox);
}








static os_error * setpix(posnstr * posn)
{
 os_error * err;
 filestr  * file;
 int        tool;
 int        wasvalid;

 err=NULL;

 if(posn->bits.localdata || posn->bits.local)
 {
  file=posn->file;
  wasvalid=(posn->object==pix.object) && (pix.file==file);

  if(!(pix.valid==PIXMARKED && wasvalid))
  {
   wasvalid=wasvalid && pix.valid;

   err=undostart(file);
   if(!err)
   {
    clearpix(PIXNONE,1);

    toolclaimsubtool(file,OPICTBOX);

    pix.valid=PIXMARKED;
    pix.file=file;
    pix.object=posn->object;
    pix.page=posn->page;
    pix.section=posn->section;

    viewrefresharea(pix.file,pix.page,NULL,VRTOOLS2|VRONELAYER);

    if(!wasvalid)
    {
     tool=toolcurrent(file);
     if(tool==TL_SELECT) ipchangepane(file->toolbox,IP_PANE2,&pipstr);
    }

    event(EVENT_SUBTOOL,file,pix.object);

    undoend(file);
   }
  }
 }

 return(err);
}



static os_error * setpixobject(int object,int page,int section,filestr * file)
{
// cprintf("setpix object %d",object);
 pix.valid=PIXOBJECT;
 pix.file=file;
 pix.object=object;
 pix.page=page;
 pix.section=section;
 return(NULL);
}









/* NB if you set off a drag with a single click, then if there is a cancel */
/* the drag click will then appear...                                      */

static os_error * pxclick(toolboxstr * toolbox,posnstr * posn)
{
 os_error    * err;
 pictboxstr  * pictp;
 int           hit;

 err=NULL;

 if(!posn->ghost)
 {
//  cprintf("pxpass %d",pxpass);
  
  if(pxpass)
  {
   if(posn->object && posn->otype==OPICTBOX && !posn->handle)
   {
    if(posn->buttons==VBDBLCLICKS)
    {
     err=setpix(posn);
    }
    else
    if(posn->buttons==(VBDBLCLICKS|VBCTRL))
    {
     err=pixole(posn);
    }
    else
    if(posn->buttons==VBTRIPCLICKS)
    {
     if(pix.valid==PIXMARKED && pix.file==posn->file 
                             && pix.object==posn->object)
     {
      err=openpicturebox1(pix.object,pix.section,pix.file,posn->view);
     }
    }
   }
  }
  else
  {
   if(posn->buttons==VBCLICKA     || posn->buttons==VBCLICKS ||
      posn->buttons==VBLONGCLICKS ||
      posn->buttons==(VBLONGCLICKS|VBSHIFT) ||
      posn->buttons==VBDRAGS      || posn->buttons==VBDRAGSS)
   {
//    cprintf("buttons %x",posn->buttons);
//    cprintf("valid %d file %d page %d",
//             pix.valid==PIXMARKED,
//             pix.file==posn->file,pix.page==posn->page);

    if(pix.valid==PIXMARKED && pix.file==posn->file && pix.page==posn->page)
    {
     pixstart=*posn;
     pixstart.object=pix.object;
     hit=0;

     if(pxfindcarethandle(&pixstart))
     {
      hit=1;
     }
     else
     {
      if(!findboxhandle(posn))
      {
       findbox(posn,-1); /* duplicating what comes next - never mind */
       if(posn->object==pix.object)   hit=2;
      }
     }

     if(hit)
     {
      if(posn->buttons==VBDRAGS       || 
         posn->buttons==VBDRAGSS      ||
         posn->buttons==VBLONGCLICKS  || 
         posn->buttons==(VBLONGCLICKS|VBSHIFT)) /* a drag */
      {
       pxupdate();
 
       pictp=(pictboxstr*)fob_find(pix.object,posn->file);
       pxscale=pictp->pictdata.scale;
       pxaspect=pictp->pictdata.aspect;
       pxxshift=pictp->pictdata.xshift;
       pxyshift=pictp->pictdata.yshift;


       if(pictp->pictdata.lockmode==2 || 
           (pictp->pictdata.lockmode==1 && hit!=1))
       {
        pxdrag=PXLOCK;
        toolschangepointer(128,USERPOINTER,&lockptr);
       }
       else
       if(hit==1)  /* NB setting handle in posn */
       {
        pxdrag=PXSCALE;
        toolschangepointer(128,USERPOINTER,&resizeptr);
       }
       else
       {
        pxdrag=PXSOLID;
        toolschangepointer(128,USERPOINTER,&handptr);
       }

       toolsstartdrag(posn,/*TOOLDRAGNS|TOOLDRAGSCREEN|*/TOOLDRAGWINDOW|
                            TOOLDRAGKN|TOOLDRAGPTR);
      }
      else
      if(posn->buttons==VBCLICKA)
      {
       clearpix(PIXOBJECT,1);
      }
      pxclaim=0;
     } 
    }
   }
   else
   if(posn->buttons==(VBDRAGS|VBALT) || 
      posn->buttons==(VBDRAGS|VBALT|VBSHIFT) ||
      posn->buttons==(VBLONGCLICKS|VBALT) ||
      posn->buttons==(VBLONGCLICKS|VBALT|VBSHIFT))
   {
    if(pix.valid==PIXMARKED && pix.file==posn->file && pix.page==posn->page)
    {
     if(!findboxhandle(posn))
     {
      findbox(posn,-1); /* duplicating what comes next - never mind */
      if(posn->object==pix.object)
      {
       toolschangepointer(128,USERPOINTER,&ddptr);

       toolsstartdrag(posn,TOOLDRAGTRANSFER|TOOLDRAGPTR);

       if(!(posn->buttons & VBSHIFT)) pxddrag=1;
       else                           pxddrag=2;
   
       pxclaim=0;
      }
     }
    }
   }
  }
 }

 return(err);

 USE(toolbox);
}



static os_error * rpxclick(toolboxstr * toolbox,posnstr * posn)
{
 if(pxpass)
 {
  if(posn->object && posn->otype==OPICTBOX && !posn->handle)
  {
   if(posn->buttons==VBDBLCLICKS)
   {
    setpix(posn);
    pixclaim(posn->object,posn->file,1);
   }
  }
 }
 else
 {
  if(posn->buttons==VBCLICKA)
  {
   if(pix.valid==PIXMARKED && pix.file==posn->file)
   {
    findbox(posn,-1);  /* duplicating what comes next - never mind */
    if(posn->object==pix.object)
    {
     clearpix(PIXOBJECT,1);
     pixclaim(pix.object,pix.file,1);
     pxclaim=0;
    }
   }
  }
 }

 return(NULL);

 USE(toolbox);
}



static os_error * pxselect(toolboxstr * toolbox,viewstr * view,
                                                filestr * file,int select)
{
 int          n;
 pictboxstr * pictp;
 int          object;
 int          next;
 int          last;

 if((pxpass && select) || (!pxpass && !select))
 {
  n=nselected(&object,file);
  if(n==1)
  {
   if(pix.valid && file==pix.file && (object==pix.object ||
                           objectinobject(pix.object,object,file)))
   {
    if(select)
    {
     if(toolcurrent(file)==TL_SELECT) ipchangepane(toolbox,IP_PANE2,&pipstr);
    }
    else
    {
     ipchangepane(toolbox,IP_PANE2,NULL);
     next=nexttool();
     if(next!=TL_SELECT && next!=TL_ROTATE) clearpix(PIXNONE,0);
    }
   }
   else
   {
    pictp=(pictboxstr*)fob_find(object,file);
    if(pictp->type==OPICTBOX && (!pictp->flags.masterdata||pictp->flags.local))
    {
     if(toolcurrent(file)==TL_SELECT) ipchangepane(toolbox,IP_PANE2,&pipstr);
     last=lasttool();
     if(last!=TL_SELECT && last!=TL_ROTATE) 
                               setpixobject(object,selpagek,selsectk,file);
    }
   }
  }
 }

 return(NULL);

 USE(view);
 USE(toolbox);
}


static os_error * pxmove(toolboxstr * toolbox,posnstr * posn,int move)
{
 pictboxstr * pictp;
 int          dx;
 int          dy;
 int          dx2;
 int          dy2;
 boxbitstr    bp;
 transformstr tr;
 transformstr tr1;
 transformstr tr2;
 transformstr tr3;
 int          angle;
 coordstr     point;
 int          cx;
 int          cy;
 int          newscale;
 coordstr     centre;
 coordstr     oldcentre;
 int          fixaspect;
 int          xscale;
 int          yscale;
 filestr    * file;

 file=posn->file;

 if(!posn->ghost)
 {
  if(pxddrag && !pxpass)
  {
   pxclaim=0;


  }
  else
  if(pxdrag && pxpass && move)
  {
   if(pxdrag==PXSOLID)
   {
    pictp=(pictboxstr*)fob_find(pix.object,file);

    dx=posn->x-pixstart.x;
    dy=pixstart.y-posn->y;

    if(pixstart.shift)
    {
     if((ABS(dx))>(ABS(dy))) dy=0;
     else                    dx=0;
    }
   
    getboxbits(&pictp->fcurve.box,&pictp->transform,&bp);
   
    tr_setidentity(&tr);
    tr_setrotationa(&tr,bp.angle);
    tr_delta(&tr,&dx,&dy);

    pictp->pictdata.xshift=pxxshift+dx;
    pictp->pictdata.yshift=pxyshift-dy;

    pictcalctransform(pix.object,file);
   
    pxrefresh(pix.object,posn->section,posn->page,file);

    pixchange(pix.object,file);

    toolschangepointer(128,USERPOINTER,&handptr);
   }
   else
   if(pxdrag==PXROT)
   {
    angle=scaleatan2(posn->x-pixstart.x,posn->y-pixstart.y)-pxinitangle;
    angle=-angle;

    pictp=(pictboxstr*)fob_find(pix.object,file);
    getboxbits(&pictp->fcurve.box,&pictp->transform,&bp);

    pictp->pictdata.angle=pxangle+angle;

    dx=(pixstart.x-bp.orgx);

    if(pictp->pictdata.hbits & HBBOTLEFT)
    {
     dy=(bp.org2y-pixstart.y);
    }
    else
    {
     dy=(bp.orgy-pixstart.y);
    }

    tr_setidentity(&tr);
    tr_setrotationa(&tr,bp.angle);
    tr_delta(&tr,&dx,&dy);

    dx2=pxxshift-dx;
    dy2=pxyshift+dy;

    tr_setrotationa(&tr,angle);
    tr_delta(&tr,&dx2,&dy2);

    pictp->pictdata.xshift=dx2+dx;
    pictp->pictdata.yshift=dy2-dy;
  
    pictcalctransform(pix.object,file);

    pxrefresh(pix.object,posn->section,posn->page,file);

    pixchange(pix.object,file);
   }
   else
   if(pxdrag==PXSCALE)
   {
    pictcentre(pix.object,file,NULL,&oldcentre);

    pictp=(pictboxstr*)fob_find(pix.object,file);
    fixaspect=pictp->pictdata.fixaspect;

    getboxbits(&pictp->fcurve.box,&pictp->transform,&bp);

    tr_setshift(&tr1,-bp.cx,-bp.cy);
    tr_setidentity(&tr2);
    tr_setrotationa(&tr2,pictp->pictdata.angle);
    tr_multiply(&tr3,&tr1,&tr2);
    tr_setshift(&tr1,bp.cx,bp.cy);
    tr_multiply(&tr2,&tr3,&tr1);

    tr_multiply(&tr1,&pictp->transform,&tr2);

    point.x=posn->x;
    point.y=posn->y;

    tr_inverseset(&point,1,&tr1);
    cx=pictp->fcurve.box.x+pictp->fcurve.box.w/2;
    cy=pictp->fcurve.box.y+pictp->fcurve.box.h/2;
    point.x-=cx;
    point.y-=cy;


    switch(pixstart.handle)
    {
     case 1:
            newscale=scale(pxaspect,point.x,pictp->fcurve.box.w/4);
            newscale=SGN(newscale)*CUT(ABS(newscale),PIXMINSCALE,PIXMAXSCALE);
            pictp->pictdata.aspect=newscale;
            break;

     case 2:
            if(fixaspect)
            {
             newscale=scale(pxscale,point.y,pictp->fcurve.box.h/4);
             newscale=SGN(newscale)*CUT(ABS(newscale),PIXMINSCALE,PIXMAXSCALE);
             pictp->pictdata.scale=newscale;
            }
            else
            {
             yscale=pxscale;
             xscale=ttmul(yscale,pxaspect);

             yscale=scale(yscale,point.y,pictp->fcurve.box.h/4);
             yscale=SGN(yscale)*CUT(ABS(yscale),PIXMINSCALE,PIXMAXSCALE);

             xscale=scale(xscale,point.x,pictp->fcurve.box.w/4);
             xscale=SGN(xscale)*CUT(ABS(xscale),PIXMINSCALE,PIXMAXSCALE);

             pictp->pictdata.scale=yscale;
             pictp->pictdata.aspect=scale(0x10000,xscale,yscale);
            }
            break;

     case 3:
            newscale=scale(pxscale,point.y,pictp->fcurve.box.h/4);
            newscale=SGN(newscale)*CUT(ABS(newscale),PIXMINSCALE,PIXMAXSCALE);
            pictp->pictdata.scale=newscale;
            pictp->pictdata.aspect=scale(pxaspect,pxscale,newscale);
            break;
    }

    pictcentre(pix.object,file,NULL,&centre);

    pictp=(pictboxstr*)fob_find(pix.object,file);

    pictp->pictdata.xshift+=oldcentre.x-centre.x;
    pictp->pictdata.yshift+=oldcentre.y-centre.y;

    pictcalctransform(pix.object,file);

    pxrefresh(pix.object,posn->section,posn->page,file);

    pixchange(pix.object,file);
   }

   pxclaim=0;
  }
  else
  if(move && pxpass)
  {
   if(pix.valid==PIXMARKED && pix.file==file && pix.page==posn->page)
   {
    if(toolcurrent(file)==TL_SELECT)
    {
     if(pxfindcarethandle(posn)) toolschangepointer(1,USERPOINTER,&resizeptr);
    }
   }
  }
 }

 return(NULL);

 USE(toolbox);
}



static os_error * pxpictchange(int scrap,int cancel)
{
 os_error               * err;
 unpackedpicturedatastr   upd;
 pictboxstr             * pictp;


 err=NULL;

 if(pxdrag==PXSOLID || pxdrag==PXROT || pxdrag==PXSCALE)
 {
  if(!scrap)                                                                      {
   err=modfile(pixstart.file,pixstart.section);
   if(err) scrap=1;
  }

  pictp=(pictboxstr*)fob_find(pix.object,pixstart.file);
  unpackpicturedata(&upd,pictp);
  pictp->pictdata.xshift=pxxshift;
  pictp->pictdata.yshift=pxyshift;

  if(pxdrag==PXROT) pictp->pictdata.angle=pxangle;
  else
  if(pxdrag==PXSCALE)
  {
   pictp->pictdata.scale=pxscale;
   pictp->pictdata.aspect=pxaspect;
  }

  if(scrap)
  {
   pictcalctransform(pix.object,pixstart.file);
   pxrefresh(pix.object,pixstart.section,pixstart.page,pixstart.file);
   pixchange(pix.object,pixstart.file);
  }
  else
  {
   pictcheckcentre(pix.object,pixstart.file,&upd.pd);
   pictupdatecontents(pix.object,pix.section,pixstart.file,&upd);
  }
 }

 pxdrag=0;
 pxupdate();
 pxclaim=0;

 if(cancel) toolsstopdrag();

 return(err);
}



static os_error * pxdragend(toolboxstr * toolbox,posnstr * posn,wimp_box * box)
{
 os_error * err;
 int        copy;

 err=NULL;

 if(pxddrag)
 {
  copy=(pxddrag-1);

  pxddrag=0;

  err=pxdragndrop(posn,copy);  /* note refresh/redraw resets pxclaim */

  pxclaim=0;
 }
 else
 if(pxdrag)
 {
  err=pxpictchange(0,0);
 }

 return(err);

 USE(posn);
 USE(box);
 USE(toolbox);
}




static os_error * pxcancel(toolboxstr * toolbox,viewstr * view,filestr * file)
{

 if(pxddrag)
 {
  pxddrag=0;
  toolsstopdrag();
  pxclaim=0;
 }
 else
 if(pxdrag)
 {
  pxpictchange(1,1);
 }

 return(NULL);

 USE(file);
 USE(view);
 USE(toolbox);
}



/****************************************************************************/


static os_error * pxredraw(toolboxstr * toolbox,viewredrawstr * v)
{

 if(pxpass && pix.valid==PIXMARKED && pix.file==v->file && pix.page==v->page)
 {
  pixcaret(v);
 }

 return(NULL);

 USE(v);
 USE(toolbox);
}

/*****************************************************************************/


static os_error * pxkey(toolboxstr * toolbox,int * key,fkeyfn * fk)
{
 os_error * err;
 int        ch;
 int        tool;

 err=NULL;

 if(pxpass==0 && pix.valid==PIXMARKED && pix.file==menuview->file)
 {
/*  err=actionkey(key);
  if(*key==-1) *fk=actionkey; */

  tool=toolcurrent(pix.file);

  if(tool==TL_SELECT)
  {
   ch=*key;
   switch(ch)
   {


  case CTRL_E:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],0,PIPCEN);
              break;


  case CTRL_J:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],0,PIPFIT);
              break;


  case  CLEFT:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],-pxunitstep(menuview),PIPX);
              break;

  case  CRIGHT:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],pxunitstep(menuview),PIPX);
              break;

  case    CUP:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],-pxunitstep(menuview),PIPY);
              break;

  case  CDOWN:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],pxunitstep(menuview),PIPY);
              break;
              
  case  SHFT_CLEFT:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],-10*pxunitstep(menuview),PIPX);
              break;

  case  SHFT_CRIGHT:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],10*pxunitstep(menuview),PIPX);
              break;

  case  SHFT_CUP:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],-10*pxunitstep(menuview),PIPY);
              break;

  case  SHFT_CDOWN:
              err=pixaction(menuview,toolbox->iphandle[IP_PANE2],10*pxunitstep(menuview),PIPY);
              break;


  default:
          return(err);

   }

   *key=-1;
   *fk=NULL;
  }
 }
 return(err);
}




static os_error * pxmessage(toolboxstr * toolbox,filestr * file,
                                               int message,void * data)
{
 if(!pxpass)
 {
  if(message==TSAVEPOSN) pxsaveact(file);
  else
  if(message==TACTPOINT)
  {
   if(pix.valid==PIXMARKED && pix.file==file)
   {
    ((toolactstr*)data)->value=pix.valid;
    ((toolactstr*)data)->object=pix.object;
   }
  }
  else
  if(message==TCLAIMSUB && ((int)data)!=OPICTBOX)
  {
   if(pix.valid && pix.file==file)
   {
    clearpix(PIXNONE,1);
    ipchangepane(pix.file->toolbox,IP_PANE2,NULL);
   }
  }
 }

 return(NULL);

 USE(toolbox);
}





static subtoolstr pxtool=
{
 TL_SELECT,
 pxclick,
 pxmove,
 pxselect,
 pxptr,
 pxcancel,
 pxredraw,
 pxdragend,
 NULL,
 pxkey,
 NULL,
 NULL,
 pxmessage,
 &pxpass,
 &pxclaim
};



static subtoolstr rpxtool=
{
 TL_ROTATE,
 rpxclick,
 pxmove,
 pxselect,
 pxptr,
 pxcancel,
 pxredraw,
 pxdragend,
 NULL,
 pxkey,
 NULL,
 NULL,
 pxmessage,
 &pxpass,
 &pxclaim
};


/*****************************************************************************/

static os_error * pxaclear(int eventn,int user,filestr * file,int * claim)
{
 os_error * err;

 err=NULL;

 if(pix.valid==PIXMARKED && file==pix.file) 
 {
  *claim=1;
  err=clearpix(PIXOBJECT,1);
 }

 return(err);

 USE(eventn);
 USE(user);
}



static os_error * pxadelete(int eventn,int user,filestr * file,int * claim)
{
 os_error * err;

 err=NULL;

 if(pix.valid==PIXMARKED && file==pix.file) 
 {
  *claim=1;
  err=modfile(pix.file,pix.section);
  if(!err)
  {
   err=pxdeletepicture(pix.object,file);
  }
 }

 return(err);

 USE(eventn);
 USE(user);
}




static os_error * pxacopys(filestr * file)
{
 os_error   * err;
 int          after;
 int          parent;
 boxstr       box;
 objectloc    sloc;
 objectloc    dloc;
 transformstr tr;
 int          page;
 int          sect;
 filestr    * dfile;
 pictboxstr * pictp;
 int          ftype[2];


 err=NULL;

 pictp=(pictboxstr*)fob_find(pix.object,file);
 box=pictp->box;

 ftype[0]=pictp->ftype;
 ftype[1]=0;

	if(ftype[0]==BMP) ftype[0]=DIB;

 clipstart(&box,&page,&sect,&dfile);

 parent=page;
 after=0;

 sloc.file=file;
 sloc.object=pix.object;
 sloc.page=selpagek;
 sloc.section=selsectk;
 sloc.parent=0;
 sloc.after=0;
 sloc.chain=0;
 sloc.branch=0;
 sloc.copymode=0;

 dloc.file=dfile;
 dloc.object=0;
 dloc.page=page;
 dloc.section=sect;
 dloc.parent=parent;
 dloc.after=after;
 dloc.chain=0;
 dloc.branch=0;
 dloc.copymode=LOCCLIP;

 tr_setshift(&tr,-box.x,-box.y);

 err=objectcopy(&sloc,&dloc,&tr);

 clipend(CLIP_PIXCONTENTS,ftype);

 return(err);
}



static os_error * pxacopy(int eventn,int user,filestr * file,int * claim)
{
 os_error   * err;

 err=NULL;

 if(pix.valid==PIXMARKED && file==pix.file) 
 {
  *claim=1;
  err=pxacopys(file);
 }

 return(err);

 USE(eventn);
 USE(user);
}


static os_error * pxacancopy(int eventn,int user,filestr * file,int * claim)
{

 if(pix.valid==PIXMARKED && file==pix.file) 
 {
  *claim=1;
 }
 return(NULL);

 USE(eventn);
 USE(user);
}



static os_error * pxacut(int eventn,int user,filestr * file,int * claim)
{
 os_error * err;

 err=NULL;

 if(pix.valid==PIXMARKED && file==pix.file) 
 {
  *claim=1;

  err=modfile(file,pix.section);
  if(!err)
  {
   err=pxacopys(file);
   if(!err)
   {
    err=pxdeletepicture(pix.object,file);
   }
  }
 }

 return(err);

 USE(eventn);
 USE(user);
}




static os_error * pxapastename(int eventn,int user,filestr * file,char ** name)
{
 os_error * err;
 int        cbtype;

 err=NULL;

 clipboardtype(&cbtype,NULL);
 if(cbtype==CLIP_PIXCONTENTS) *name="{PX03}";

 return(err);

 USE(eventn);
 USE(user);
 USE(file);
}





static os_error * pxapaste(int eventn,int user,filestr * file,int * claim)
{
 os_error   * err;
 int          object;
 pictboxstr * pictp;
 int          copied;
 objectloc    dloc;
 objectloc    sloc;
 int          cbtype;
 int        * ftypes;

	cprintf("pxapaste");

 err=NULL;

 memset(&dloc,0,sizeof(objectloc));
 memset(&sloc,0,sizeof(objectloc));

 clipboardtype(&cbtype,&ftypes);

 if(cbtype==CLIP_PIXCONTENTS)
 {
  err=clipopen(&sloc.object,&sloc.page,&sloc.section,&sloc.file);
  if(!err)
  {
   *claim=1;

   if(nselected(&object,file)==1)
   {
    if(pix.valid==PIXMARKED && file==pix.file) object=pix.object;

    pictp=(pictboxstr*)fob_find(object,file);
    if(pictp->type==OPICTBOX)
    {
     if(pictp->master && !pictp->flags.local && pictp->flags.masterdata)
     {
      err=geterror(EPX4);
     }
    }
    else
    if(pictp->type==OTEXTBOX)
    {
     err=txconvertable(object,selsectk,file);
    }
    else
    {
     err=geterror(EPX4);
    }

    if(!err)
    {
     dloc.file=file;
     dloc.page=selpagek;
     dloc.section=selsectk;
     dloc.object=object;

     sloc.copymode=LOCCLIP;

     err=modfile(dloc.file,dloc.section);
     if(!err) err=undostart(file);
     if(!err)
     {
      pictp=(pictboxstr*)fob_find(object,file);
      err=pxdropcopypicture(&dloc,&sloc,pictp->type,&copied);
      undoend(file);
     }
    }
   }
   clipclose(sloc.file);
  }
 }
 else     // case of select pict frame in a group
 if(cbtype==CLIP_GLOBAL)
 {
  if(clippicturetype(ftypes))
  {
   if(pix.valid && file==pix.file) 
   {
    viewstr    * view;
    sectionstr * sectionp;
    posnstr      loadposn;


    sectionp=(sectionstr*)fob_find(pix.section,file);

    if(caretview && caretview->file==file) view=caretview;
    else
    {
     view=file->view;
     while(view)
     {
      if((int)sectionp->branch==view->branch) break;
      view=view->next;
     }
    }

    if(view)
    {
     *claim=1;

     memset(&loadposn,0,sizeof(posnstr));
     loadposn.view=view;
     loadposn.file=file;
     loadposn.object=pix.object;
     loadposn.otype=OPICTBOX;
     loadposn.section=pix.section;
     loadposn.page=pix.page;

					cprintf("pict importglobal");
     importglobal(NULL,&loadposn,ftypes[0],OBDIRECTLOAD);
    }
   }
  }
 }

 return(err);

 USE(eventn);
 USE(user);
}


/*****************************************************************************/

/* called when file is closed */

static os_error * pxclose(int eventn,int user,filestr * file,int data1)
{
 if(pix.valid && pix.file==file)
 {
  pix.valid=0;
 }

 return(NULL);

 USE(eventn);
 USE(user);
 USE(data1);
}




// frame changes from text to picture
// this is called in many places, including from select events
// for a select event key is 0

os_error * pixobjectchange(filestr * file,int key)
{
 int          n;
 pictboxstr * pictp;
 int          object;
 toolboxstr * toolbox;
 int          tool;


 toolbox=file->toolbox;

// cprintf("pixobject change");

 n=nselected(&object,file);
 if(n==1)
 {
  pictp=(pictboxstr*)fob_find(object,file);

  if(!(pix.valid && pix.object==object))
  {
   if(pictp->type==OPICTBOX && (!pictp->flags.masterdata || pictp->flags.local))
   {
    tool=toolcurrent(file);

// cprintf("pixobject change event");    

    if(tool==TL_SELECT) ipchangepane(toolbox,IP_PANE2,&pipstr);
 //   if(tool==TL_SELECT || tool==TL_ROTATE || tool==TL_PASTE) 
                                 setpixobject(object,selpagek,selsectk,file);
   }
  }
  else
  {
   if(pictp->type!=OPICTBOX ||(pictp->flags.masterdata && !pictp->flags.local))
   {
    ipchangepane(toolbox,IP_PANE2,NULL);
    pix.valid=PIXNONE;
   }
  }
 }


 if(key) event(EVENT_PICTOBJECTCHANGE,file,key);

 return(NULL);
}



static os_error * pxpref(int eventn,int user,viewstr * view,prefdatastr * old)
{
 filestr     * file;
 prefdatastr * xnew;
 int           tool;

 file=view->file;

 if(pix.valid && pix.file==file)
 {
  tool=toolcurrent(file);

  if(tool==TL_SELECT || tool==TL_ROTATE)
  {
   xnew=prefp(file);
   if(xnew->units!=old->units) iprefreshpane(file,0x1,IP_PANE2);
  }
 }

 return(NULL);
 USE(eventn);
 USE(user);
}



static os_error * pxselection(int eventn,int user,filestr * file,int object)
{
 toolboxstr * toolbox;
 int          tool;

 toolbox=file->toolbox;


 if(eventn==EVENT_OBJECTSELECTED0)
 {
  if(pix.valid && file==pix.file && object!=pix.object && 
                 !objectinobject(pix.object,object,file)) 
  {
   tool=toolcurrent(file);
   if(tool==TL_SELECT) ipchangepane(toolbox,IP_PANE2,NULL);
   clearpix(PIXNONE,0);
  }
 }
 else
 if(eventn==EVENT_OBJECTDESELECTED0)
 {
  if(pix.valid && file==pix.file && (pix.object==object ||
                  objectinobject(pix.object,object,file))) 
  {
   tool=toolcurrent(file);
   if(tool==TL_SELECT) ipchangepane(toolbox,IP_PANE2,NULL);
   clearpix(PIXNONE,0);
  }
 }
 else
 if(eventn==EVENT_OBJECTSELECTED1 || eventn==EVENT_OBJECTDESELECTED1)
 {
  pixobjectchange(file,0);
 }

 return(NULL);

 USE(eventn);
 USE(user);
}




static os_error * pxschange0(int eventn,int user,filestr * file,int object)
{
 if(pix.valid==PIXMARKED && file==pix.file)
 {
  pxupdate();
  pxskip=1;
 }


 return(NULL);

 USE(eventn);
 USE(user);
 USE(object);
}



static os_error * pxschange1(int eventn,int user,filestr * file,int object)
{
 if(pix.valid==PIXMARKED && file==pix.file)
 {
  pxskip=0;
  pxupdate();
 }

 return(NULL);

 USE(eventn);
 USE(user);
 USE(object);
}







static os_error * pxcon(int eventn,int user,filestr * file,char ** name)
{

 if(pix.valid && file==pix.file)
 {
  if(eventn==EVENT_CONTENTNAME || 
      (eventn==EVENT_CONTENTSELECTEDNAME && pix.valid==PIXMARKED)) 
                                *name="{PX03}";
  else
  if(eventn==EVENT_CONTENTMENU) *name="picture_menu";
  else
  if(eventn==EVENT_CONTENTMENUNAME) *name="{PX07}";
 }

 return(NULL);

 USE(user);
}



static os_error * pxconbox(int eventn,int user,filestr * file,viewstr * view)
{
 os_error * err;

 err=NULL;

 if(pix.valid && file==pix.file)
 {
  err=openpicturebox1(pix.object,pix.section,file,view);
 }

 return(err);

 USE(user);
 USE(eventn);
}




static os_error * pxexname(int eventn,int user,filestr * file,char ** name)
{
 pictboxstr * pictp;

 if(pix.valid && file==pix.file)
 {
  pictp=(pictboxstr*)fob_find(pix.object,pix.file);
  if(pictp->picture) *name="{PX04}";
 }
 return(NULL);
 USE(user);
 USE(eventn);
}


#ifdef NEVER
static os_error * pxexbox(int eventn,int user,filestr * file,int * handle)
{
 os_error   * err;
 pictboxstr * pictp;

 err=NULL;

 if(pix.valid && file==pix.file)
 {
  pictp=(pictboxstr*)fob_find(pix.object,pix.file);

  err=exportsave(pictp->ftype,pictp->picture,file,handle);
 }

 return(err);
 USE(eventn);
 USE(user);
}

#endif


static os_error * pxexbox2(int eventn,int user,viewstr * view,int spare)
{
 os_error   * err;
 pictboxstr * pictp;

 err=NULL;

 cprintf("exebox2");

 if(pix.valid && view->file==pix.file)
 {
  pictp=(pictboxstr*)fob_find(pix.object,pix.file);

  err=exportsave2(pictp->ftype,pictp->picture,view,spare);
 }

 return(err);
 USE(eventn);
 USE(user);
}








static os_error * pxglobal(int eventn,int user,int * ack,int filetype)
{
 os_error   * err;
 filestr    * file;
 int          object;
 pictboxstr * pictp;

 err=NULL;

	cprintf("pxglobal");

 if(filetype==DIB || filetype==EMETAF || filetype==WMETAF)
 {
  clipinfo(&object,NULL,NULL,&file);

  *ack=1;

  pictp=(pictboxstr*)fob_find(object,file);
  err=exportglobal(filetype,pictp->picture,file,NULL);
 }

 return(err);
 USE(user);
 USE(eventn);
}



/* problem with things like pixref dbox, needing to find */
/* what is selected, e.g. grouped pix frame              */


os_error * pixselected(int * cpictbox,filestr * file)
{

 if(pix.valid && pix.file==file)
 {
  *cpictbox=pix.object;
 }
 else
 {
  *cpictbox=0;
 }

 return(NULL);
}




os_error * pixtoolinit(void)
{
 os_error * err;

          err=subtoolregister(&pxtool);
 if(!err) err=subtoolregister(&rpxtool);
 if(!err) err=addevent(EVENT_FCLOSE,(eventfn)pxclose,0);
 if(!err) err=addevent(EVENT_OBJECTSELECTED0,(eventfn)pxselection,0);
 if(!err) err=addevent(EVENT_OBJECTDESELECTED0,(eventfn)pxselection,0);
 if(!err) err=addevent(EVENT_OBJECTSELECTED1,(eventfn)pxselection,0);
 if(!err) err=addevent(EVENT_OBJECTDESELECTED1,(eventfn)pxselection,0);
 if(!err) err=addevent(EVENT_ROTANGLE,(eventfn)pxrot,0);
 if(!err) err=addevent(EVENT_ROTSTART,(eventfn)pxrotstart,0);
 if(!err) err=addevent(EVENT_ROTDO,(eventfn)pxdorot,0);
 if(!err) err=addevent(EVENT_ROTLOCK,(eventfn)pxrotlock,0);

 if(!err) err=addevent(EVENT_CLEARSELECTION,(eventfn)pxaclear,0);
 if(!err) err=addevent(EVENT_DELETESELECTION,(eventfn)pxadelete,0);
 if(!err) err=addevent(EVENT_CANDELETESELECTION,(eventfn)pxacancopy,0);
 if(!err) err=addevent(EVENT_COPYSELECTION,(eventfn)pxacopy,0);
 if(!err) err=addevent(EVENT_CANCOPYSELECTION,(eventfn)pxacancopy,0);
 if(!err) err=addevent(EVENT_CUTSELECTION,(eventfn)pxacut,0);
 if(!err) err=addevent(EVENT_PASTESELECTION,(eventfn)pxapaste,0);
 if(!err) err=addevent(EVENT_PASTENAME,(eventfn)pxapastename,0);

 if(!err) err=addevent(EVENT_CONTENTNAME,(eventfn)pxcon,0);
 if(!err) err=addevent(EVENT_CONTENTMENU,(eventfn)pxcon,0);
 if(!err) err=addevent(EVENT_CONTENTMENUNAME,(eventfn)pxcon,0);
 if(!err) err=addevent(EVENT_CONTENTSELECTEDNAME,(eventfn)pxcon,0);
 if(!err) err=addevent(EVENT_CONTENTBOX,(eventfn)pxconbox,0);

 if(!err) err=addevent(EVENT_EXPORTNAME,(eventfn)pxexname,0);
// if(!err) err=addevent(EVENT_EXPORTBOX,(eventfn)pxexbox,0);
 if(!err) err=addevent(EVENT_EXPORTBOX2,(eventfn)pxexbox2,0);
 if(!err) err=addevent(EVENT_GLOBALPASTE,(eventfn)pxglobal,0);

 if(!err) err=addevent(EVENT_PREFERENCES,(eventfn)pxpref,0);


 if(!err) err=addevent(EVENT_MODIFYSELECTION0,(eventfn)pxschange0,0);
 if(!err) err=addevent(EVENT_MODIFYSELECTION1,(eventfn)pxschange1,0);
 if(!err) err=addevent(EVENT_TRANSFORMSELECTION0,(eventfn)pxschange0,0);
 if(!err) err=addevent(EVENT_TRANSFORMSELECTION1,(eventfn)pxschange1,0);


 return(err);
}

