/*->c.pxref */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>
#include <time.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "flex.h"


#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "bits.h"
#include "fsx.h"
#include "bf.h"
#include "xprocess.h"
#include "csv.h"
#include "avl.h"
#include "deb.h"


#include "constants.h"
#include "str.h"

#include "object.h"
#include "undo.h"

#include "reslink.h"
#include "units.h"

#include "file.h"
#include "view.h"
#include "viewr.h"
#include "chain.h"

#include "macros.h"


#include "codes.h"

#include "merge.h"


#include "pxstr.h"
#include "pxconstant.h"

#include "impex.h"

#include "pict.h"
#include "pxcache.h"


#include "pxref.h"










void * pxfindtag(picturestr * picturep,int tagvalue)
{
 pxtagstr * tag;
 pxtagstr * limit;
 int        len;

 len=(picturep->imagelen+0x3) & (~0x3);
 len+=picturep->proxylen;

 tag=(pxtagstr*)(picturep->data+len);
 limit=(pxtagstr*)(picturep->data+len+picturep->tagslen);

 while(tag<limit)
 {
  if(tag->tag==tagvalue) return(tag);
  tag=(pxtagstr*)(((char*)tag)+tag->len);
 }

 return(NULL);
}





os_error * pxtagsize(int picturekey,filestr * file,int type,int size) 
{
 os_error         * err;
 picturestr       * picturep;
 pxtagstr         * tag;
 int                delta;
 int                length;
 int                offset;
 int                taglen;
 int                totlen;


 err=NULL;

 size=(size+3)&(~0x3);

 picturep=(picturestr*)fob_find(picturekey,file);

 tag=(pxtagstr*)pxfindtag(picturep,type);

 taglen=tag?tag->len:0;
 delta=(size-taglen);


 if(delta)
 {
  if(tag) offset=((char*)tag)-(char*)picturep->data;
  else    offset=((picturep->imagelen+0x3) & (~0x3))+picturep->proxylen+
                                                     picturep->tagslen;

  totlen=((picturep->imagelen+0x3) & (~0x3))+picturep->proxylen+
                                             picturep->tagslen;

  if(delta<0)
  {
   memmove(((char*)tag)+size,
          ((char*)tag)+taglen,totlen-(offset+taglen));
  }

  length=totlen+sizeof(picturestr);
  err=fob_change(picturekey,file,length+delta,(fobjptr)&picturep);
  if(!err)
  {
   tag=(pxtagstr*)((char*)picturep->data+offset);

   if(delta>0 && taglen)
   {
    memmove(((char*)tag)+size,((char*)tag)+taglen,totlen-(offset+taglen));
   }

   picturep->tagslen+=delta;

   if(size)
   {
    tag->len=size;
    tag->tag=type;
   }
  }
 }

 return(err);
}





os_error * pxreadtag(pxtagstr * dest,int type,int picturekey,filestr * file)
{
 picturestr * picturep;
 pxtagstr   * tag;

 picturep=(picturestr*)fob_find(picturekey,file);
 if(picturep)
 {
  tag=(pxtagstr*)pxfindtag(picturep,type);
  if(tag) XMEMCPYX(dest,tag,tag->len);
  else    dest->len=0;
 }
 else dest->len=0;

 return(NULL);
}




os_error * pxwritetag(pxtagstr * src,int picturekey,filestr * file)
{
 os_error   * err;
 picturestr * picturep;
 pxtagstr   * tag;


 err=pxtagsize(picturekey,file,src->tag,src->len);

 if(!err)
 {
  picturep=(picturestr*)fob_find(picturekey,file);
  tag=(pxtagstr*)pxfindtag(picturep,src->tag);

  XMEMCPYX(tag,src,src->len);
 }

 return(err);
}









static TCHAR   * exstring;
static int       exlength;
static filestr * exfile;



static os_error * expfn(int c)
{
 os_error * err;
 int        ch;

 err=NULL;

 *exstring=0;

 switch(c)
 {

   case     XDOCNAME:
                     strcpy(exstring,fs_leaf(exfile->name));
                     break;

   case     XDOCPATH:
                     if(!exfile->saved) err=geterror(EPX6);
                     else
                     {
                      strcpy(exstring,exfile->name);
                     }
                     break;

   case      XDOCDIR:
                     if(!exfile->saved) err=geterror(EPX6);
                     else
                     {
                      fs_path(exfile->name,exstring,exlength);
                     }
                     break;


             default:
                     ch=-1;

                     if(c>255)
                     {
                      ch=code16inv(c);
                     }
                     else
                     {
 	                    ch=code8symbolinv(c);

                      if(ch<0)
                      {
                       c=code16win(c);
                      }
                     }

                     if(ch>=0)
                     {
                      exstring[0]=ch;
                      exstring[1]=0;
                     }
                     break;


 }

 exstring+=strlen(exstring);
	exlength-=strlen(exstring);

 return(err);
}


/*

  Definitely Acorn if

  contains {filepath}.^.

  ends with   /ext

  contains    .$.


  Definitely Windows if

  starts with letter:\

  ends with   .ext

  starts with .\   ./

  contains    ..\  ../

*/




static int isriscospath(char * path)
{
 int len;
 int dots;
 int slashes;

 len=strlen(path);

 if(strstr(path,"{filepath}.^.")) return(1);
 if(strstr(path,".$.")) return(1);
 if(strstr(path,"::")) return(1);
 if(strchr(path,'>')) return(1);
 if(strchr(path,'<')) return(1);
 if(strchr(path,'|')) return(1);

 if(len>3)
 {
  if(isalpha(path[0]) && path[1]==':' && 
     (path[2]=='/' || path[2]=='\\')) return(0);
 }
 if(strstr(path,".\\")) return(0);
 if(strstr(path,"./")) return(0);
 if(strstr(path,"..\\")) return(0);
 if(strstr(path,"../")) return(0);
 if(strstr(path,"{filedir}\\")) return(0);

 dots=xstrcount(path,'.');
 slashes=xstrcount(path,'/')+xstrcount(path,'\\');

 if(dots==1 && path[len-3-1-1]=='.' && slashes>0) return(0);
 if(slashes==1 && path[len-3-1-1]=='/' && dots>0) return(1);
 
 if(dots>1 || slashes>1) return(dots>slashes);

 return(0);
}





static void riscos2windows(char * path)
{
 xstrislice(path,"{filepath}.^.","{filedir}.");

 xstrmap(path,'.','\\');
 xstrmap(path,'/','.');
}


os_error * pxexpandpath(char * newpath,int newsize,char * oldpath,filestr * file)
{
 os_error * err;
 int        relative;

 exfile=file;
 exstring=newpath;
	exlength=newsize;
 *exstring=0;

 if(isriscospath(oldpath))
 {
  riscos2windows(oldpath);
 }

 err=expandmacro(expfn,oldpath);
 if(!err)
 {
  err=fs_isrelativepath(newpath,&relative);
  if(!err)
  {
   if(relative &&  !exfile->saved) err=geterror(EPX6);
   else
   {
    char filepath[MAX_PATH];
    char dirpath[MAX_PATH];

    strcpy(filepath,newpath);
    fs_path(file->name,dirpath,NITEM(dirpath));
    fs_combinepath(newpath,dirpath,filepath);

//    cprintf("newpath %s",newpath);
   }
  }
 }

 return(err);
}








static int tpicture;
static int tftype;



static os_error * pictboxchange(int pict,int picture,int ftype,filestr * file)
{
 transformstr trx;
 picturestr * picturep;
 coordstr     cx;
 pictboxstr * pictp;
 int          page;
 int          section;



 pictcalctransform2(pict,file,&trx); /* maintain image posn over ole */

 pictp=(pictboxstr*)fob_find(pict,file);

 pictp->ftype=ftype;

 if(pictp->pictdata.lockmode==1)
 {
  pictcentrepict(pict,file,NULL);
 }
 else
 {
  picturep=(picturestr*)fob_find(picture,file);
  cx.x=picturep->abox.x0;
  cx.y=picturep->abox.y1;
  tr_transformset(&cx,1,&trx);

  pictp->pictdata.xshift=cx.x;
  pictp->pictdata.yshift=cx.y;
 }

 pictcalctransform(pict,file);

 pagesectionof((chainobject*)pictp,file,&page,&section);
 pxrefresh(pict,section,page,file);

 return(NULL);
}





static os_error * pfn(sobjectstr * sob,filestr * file,int * message)
{
 pictboxstr * pictp;
 int          pict;

 if(sob->type==OPICTBOX)
 {
  pictp=(pictboxstr*)sob;
  pict=pictp->key;
  if(pictp->picture==tpicture)
  {
   pictboxchange(pict,tpicture,tftype,file);
  }
 }

 return(NULL);
 USE(message);
}




static os_error * pxrefchange(char * newname,char * expname,int ftype,
                              int picture,filestr * file)
{
 os_error           * err;
 pxproxytagstr        proxytag;
 pxpreftagstaticstr   reftag;
 int                  message;


 pxreadtag((pxtagstr*)&reftag,PXPREF2TAG,picture,file);
 if(reftag.len)
 {
  pxuncachename(reftag.name,file);
 }

 err=importreferencereload(newname,expname,ftype,picture,file);
 if(!err)
 {
  pxreadtag((pxtagstr*)&proxytag,PXPROXYTAG,picture,file);
  if(proxytag.len) importmakeproxy(ftype,picture,file,&proxytag.proxy);

  tpicture=picture;
  tftype=ftype;

  message=OM_FUNCTION2;
  err=broadcastmessage(file,&message,(void*)pfn);
 }

 return(err);
}





static os_error * pxwriterefchange(int picture,filestr * file)
{
 os_error           * err;
 pxpreftagstaticstr   reftag;
 int                  ftype;
 int                  len;
 picturestr         * picturep;


 err=pxreadtag((pxtagstr*)&reftag,PXPREF1TAG,picture,file);
 if(reftag.len)
 {
  picturep=(picturestr*)fob_find(picture,file);
  ftype=picturep->ftype;

  undowritefn(file,UPXCHREF,&picture,sizeof(int));
  undowrite(file,&ftype,sizeof(int));
  len=strlen(reftag.name)+1;
  undowrite(file,&len,sizeof(int));
  undowrite(file,reftag.name,len);
 }

 return(err);
}





os_error * pxundorefchange(filestr * file)
{
 os_error           * err;
 int                  picture;
 char                 expname[FILENAMELEN];
 char                 name[FILENAMELEN];
 int                  ftype=0;
 int                  len=0;

          err=undoread(file,&picture,sizeof(int));
 if(!err) err=undoread(file,&ftype,sizeof(int));
 if(!err) err=undoread(file,&len,sizeof(int));
 if(!err) err=undoread(file,name,len);

          err=pxwriterefchange(picture,file);
 if(!err) err=pxexpandpath(expname,NITEM(expname),name,file);
 if(!err) err=pxrefchange(name,expname,ftype,picture,file);

 return(err);
}





/* recreate proxy                           */
/* seek out all pictureboxes which use this */
/* update from masters                      */


os_error * pxreferencechanged(int pict,int picture,char * newname,
                                                              filestr * file)
{
 os_error           * err;
 char                 expname[FILENAMELEN];
 fstat                fs;
 pictboxstr         * pictp;
 int                  page;
 int                  section;


 pictp=(pictboxstr*)fob_find(pict,file);
 pagesectionof((chainobject*)pictp,file,&page,&section);

 err=modfile(file,section);
 if(!err)
 {
  err=pxexpandpath(expname,NITEM(expname),newname,file);
  if(!err)
  {
   err=fs_stat(expname,&fs);
   if(!err && !fs.object) err=geterrorf(EPX5,expname);

   if(!err)
   {
    err=undostart(file);
    if(!err)
    {
     pxwriterefchange(picture,file);
     err=pxrefchange(newname,expname,fs.type,picture,file);

     undoend(file);
    }
   }
  }
 }

 return(err);
}



// what goes on here must be similar to viewimport()

os_error * pxnewreference(int pict,int picture,char * newname,viewstr * view,filestr * file)
{
 os_error           * err;
 char                 expname[FILENAMELEN];
 fstat                fs;
 pictboxstr         * pictp;
 int                  page;
 int                  section;
	int                  object;
	posnstr              posn;
//	picturestr         * picturep;
 pxproxytagstr        proxytag;



 pictp=(pictboxstr*)fob_find(pict,file);
 pagesectionof((chainobject*)pictp,file,&page,&section);

 err=modfile(file,section);
 if(!err)
 {
  pxreadtag((pxtagstr*)&proxytag,PXPROXYTAG,picture,file);

  err=pxexpandpath(expname,NITEM(expname),newname,file);
  if(!err)
  {
   err=fs_stat(expname,&fs);
   if(!err && !fs.object) err=geterrorf(EPX5,expname);
			if(!err)
			{
		  err=importreferenceload(newname,fs.type,&object,file);

    if(!err)
    {
     if(proxytag.len) err=importmakeproxy(fs.type,object,file,&proxytag.proxy);

					if(!err)
					{
//      picturep=(picturestr*)fob_find(object,file);

 					memset(&posn,0,sizeof(posnstr));
 					posn.branch=view->branch;
 					posn.section=section;
 					posn.page=page;
 					posn.file=file;
 					posn.view=view;
 					posn.object=pict;

      if(!err)
      {
       err=pictloadsub(fs.type,object,&posn);
						}
					}
    }
			}
  }
 }

 return(err);
}




/*****************************************************************************/


#define SMAPCHUNK 0x1000


static char * smap;
static int    smaplen;
static int    srootp;



typedef struct smapstr
{
 int          parent;
 int          sibls[2];
 int          balance;
 int          picture;
 int          ftype;
} smapstr;





static int smcmp(void * key1,void * key2)
{
 return((*((int*)key1))-(*((int*)key2)));
}



static int ssearchmap(int picture)
{
 return(avlfind(&picture,srootp,smap,smcmp));
}




static os_error * saddtomap(int picture,int ftype)
{
 os_error * err;
 int        len;
 smapstr  * s;

 len=sizeof(smapstr);

 err=flex_chunk((flex_ptr)&smap,smaplen+len,SMAPCHUNK);
 if(!err)
 {
  s=(smapstr*)(smap+smaplen);
  s->picture=picture;
  s->ftype=ftype;
  avlsearch(smaplen,&srootp,smap,smcmp);
  smaplen+=len;
 }

 return(err);
}


static os_error * smapinit(void)
{
 os_error * err;

 err=NULL;

 if(smap==NULL) err=flex_alloc((flex_ptr)&smap,SMAPCHUNK);
 if(!err)
 {
  smaplen=0;
  srootp=-1;
 }

 return(err);
}


static os_error * smapfinit(void)
{
 return(flex_free((flex_ptr)&smap));
}









static os_error * pxcheckreference(int pkey,filestr * file,int * status)
{
 os_error          * err;
 TCHAR               temp[FILENAMELEN];
 picturestr        * picturep;
 pxpreftagstr      * tag;
 pxpreftagstaticstr  reftag;


 err=NULL;

 *status=0;

 if(pkey)
 {
  picturep=(picturestr*)fob_find(pkey,file);

  tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF1TAG);
  if(tag)
  {
   err=xzstrncpyu(temp,tag->name,NITEM(temp));
   if(!err) err=pxexpandpath(reftag.name,NITEM(reftag.name),temp,file);  /* likely to return error */
   if(!err)
   {
    tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF2TAG);

    if(tag)
    {
     if(cstrcmp(tag->name,reftag.name)) /* path has changed */                
     {
      xzstrncpyu(temp,tag->name,NITEM(temp));
      pxuncachename(temp,file);

      *status=1;
 
      reftag.tag=PXPREF2TAG;
      reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
      err=pxwritetag((pxtagstr*)&reftag,pkey,file);
     }
    }
   }
  }
 }

 return(err);
}





os_error * pxmakereferenceabsolute(int pkey,filestr * sfile,filestr * dfile)
{
 os_error          * err;
 char                temp[FILENAMELEN];
 picturestr        * picturep;
 pxpreftagstr      * tag;
 pxpreftagstaticstr  reftag;


 err=NULL;



 if(pkey)
 {
  picturep=(picturestr*)fob_find(pkey,dfile);

  tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF1TAG);
  if(tag)
  {
   strcpy(temp,tag->name);
   err=pxexpandpath(reftag.name,NITEM(reftag.name),temp,sfile);  /* likely to return error */
   if(!err)
   {
    cprintf("making reference abs %s %s",temp,reftag.name);

    reftag.tag=PXPREF1TAG;
    reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
    err=pxwritetag((pxtagstr*)&reftag,pkey,dfile);

    reftag.tag=PXPREF2TAG;
    reftag.len=sizeof(pxtagstr)+((strlen(reftag.name)+1+3)&(~0x3));
    err=pxwritetag((pxtagstr*)&reftag,pkey,dfile);
   }
  }
 }

 return(err);
}









os_error * pictmerge(pictboxstr * pictp,int mergecommand,filestr * file)
{
 os_error         * err;
 int                picture;
 int                pict;
 pxpreftagstaticstr reftag1;
 pxpreftagstaticstr reftag2;
 int                status;
 fstat              fs;
 pxproxytagstr      proxytag;
 int                offset;

 err=NULL;


 pict=pictp->key;
 picture=pictp->picture;


 if((offset=ssearchmap(picture))>=0)
 {
  if(mergecommand==MERGEDATA || mergecommand==MERGEOFF)
  {
   pictboxchange(pict,picture,((smapstr*)(smap+offset))->ftype,file);
  }
 }
 else
 {
  if(mergecommand==MERGESTRIP)
  {
   pxreadtag((pxtagstr*)&reftag2,PXPREF2TAG,picture,file);
   reftag2.tag=PXPREF1TAG;
   err=pxwritetag((pxtagstr*)&reftag2,picture,file);
  }
  else
  if(mergecommand==MERGEDATA || mergecommand==MERGEOFF)
  {
   err=pxcheckreference(picture,file,&status);
   if(!err && status)
   {
    pxreadtag((pxtagstr*)&reftag1,PXPREF1TAG,picture,file);
    pxreadtag((pxtagstr*)&reftag2,PXPREF2TAG,picture,file);
    if(reftag2.len)
    {
     err=fs_stat(reftag2.name,&fs);
     if(!err && !fs.object) err=geterrorf(EPX5,reftag2.name);
     if(!err) err=importreferencereload(reftag1.name,reftag2.name,
                                                     fs.type,picture,file);

     if(!err)
     {
      pxreadtag((pxtagstr*)&proxytag,PXPROXYTAG,picture,file);
      if(proxytag.len) importmakeproxy(fs.type,picture,file,&proxytag.proxy);

      pictboxchange(pict,picture,fs.type,file);
      saddtomap(picture,fs.type);
     }
    }
   }
  }
 }
 return(err);
}



os_error * pictmergeall(int mergecommand,int pass,filestr * file)
{
 os_error * err;

 err=NULL;

 if(mergecommand==MERGEDATA || mergecommand==MERGEOFF)
 {
  if(pass==0) err=smapinit();
  else
  if(pass==1) err=smapfinit();
 }

 return(err);

 USE(file);
}



