/*->c.codes */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"

#include "xext.h"

#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"

#include "str.h"
#include "constants.h"
#include "reslink.h"

#include "file.h"
#include "codes.h"
#include "txstr.h"




/* bullet sequence */

/* BSEQ          0 */
/* TAB data      1 */
/* TAB data      2 */
/* TAB data      3 */

/* level 1 data  4 */
/* level 1 data  5 */

/* ...             */

/* level 8 data  18 */
/* level 8 data  19 */




#define BSLEN    (1+3+2*8) 


int codex[256]=
{
 EOTLEN|CODECODE|CODETERMINATOR, /* 0 EOT     */
 1|CODECODE,                     /* 1 GCODE   */
 1|CODECODE|CODETERMINATOR,      /* 2 EOBOX   */
 1|CODECODE|CODETERMINATOR,      /* 3 EOPAGE  */
 1|CODECODE,                     /* 4 CHAPNO  */
 1|CODECODE,                     /* 5 ACTDATE */
 BSLEN|CODECODE,                 /* 6 BULLET SEQ */
 SPACELEN|CODECODE,              /* 7 SPACE SEQ  */
 UNC16LEN|CODECODE,              /* 8 Unicode 16 bit char */
 1|CODENONE,                     /* 9 */
 1|CODECODE|CODETERMINATOR,      /* 10 NL     */
 1|CODENONE,                     /* 11 */
 1|CODENONE,                     /* 12 */
 1|CODECODE|CODETERMINATOR,      /* 13 CR      */
 1|CODENONE,                     /* 14 */
 1|CODENONE,                     /* 15 */
 1|CODENONE,                     /* 16 */
 EINTLEN|CODECODE,               /* 17 EINTSEQ */
 TSLEN|CODECODE|CODEWHITE,       /* 18 TABSEQ */
 MSLEN|CODECODE,                 /* 19 MACSEQ */
 SNLEN|CODECODE,                 /* 20 SNO    */
 1|CODECODE,                     /* 21 DCHYPH */
 EOBLEN|CODENONE,                /* 22 EOB    */
 1|CODENONE,                     /* 23 */
 1|CODENONE,                     /* 24 */
 1|CODENONE,                     /* 25 */
 1|CODENONE,                     /* 26 */
 1|CODENONE,                     /* 27 */
 1|CODENONE,                     /* 28 */ 
 1|CODENONE,                     /* 29 */
 1|CODECODE,                     /* 30 PAGENO */
 1|CODENONE,                     /* 31 */
 1|CODEWHITE,                    /* 32 SPACE  */
 1|CODEPUNCT,                    /* 33 ! */
 1|CODEPUNCT,                    /* 34 " */
 1|CODESYMBOL,                   /* 35 # */
 1|CODESYMBOL,                   /* 36 $ */
 1|CODESYMBOL,                   /* 37 % */
 1|CODESYMBOL,                   /* 38 & */
 1|CODEPUNCT,                    /* 39 ' */
 1|CODEPUNCT,                    /* 40 ( */
 1|CODEPUNCT,                    /* 41 ) */
 1|CODESYMBOL,                   /* 42 * */
 1|CODESYMBOL,                   /* 43 + */
 1|CODEPUNCT,                    /* 44 , */
 1|CODEPUNCT,                    /* 45 - */
 1|CODEPUNCT,                    /* 46 . */
 1|CODESYMBOL,                   /* 47 / */
 1|CODEDIGIT,                    /* 48 0 */
 1|CODEDIGIT,                    /* 49 1 */
 1|CODEDIGIT,                    /* 50 2 */
 1|CODEDIGIT,                    /* 51 3 */
 1|CODEDIGIT,                    /* 52 4 */
 1|CODEDIGIT,                    /* 53 5 */
 1|CODEDIGIT,                    /* 54 6 */
 1|CODEDIGIT,                    /* 55 7 */
 1|CODEDIGIT,                    /* 56 8 */
 1|CODEDIGIT,                    /* 57 9 */
 1|CODEPUNCT,                    /* 58 : */
 1|CODEPUNCT,                    /* 59 ; */
 1|CODESYMBOL,                   /* 60 < */
 1|CODESYMBOL,                   /* 61 = */
 1|CODESYMBOL,                   /* 62 > */
 1|CODEPUNCT,                    /* 63 ? */
 1|CODESYMBOL,                   /* 64 @ */
 1|CODEALPHA|CODEUPPER,          /* 65 A */
 1|CODEALPHA|CODEUPPER,          /* 66 B */
 1|CODEALPHA|CODEUPPER,          /* 67 C */
 1|CODEALPHA|CODEUPPER,          /* 68 D */
 1|CODEALPHA|CODEUPPER,          /* 69 E */
 1|CODEALPHA|CODEUPPER,          /* 70 F */
 1|CODEALPHA|CODEUPPER,          /* 71 G */
 1|CODEALPHA|CODEUPPER,          /* 72 H */
 1|CODEALPHA|CODEUPPER,          /* 73 I */
 1|CODEALPHA|CODEUPPER,          /* 74 J */
 1|CODEALPHA|CODEUPPER,          /* 75 K */
 1|CODEALPHA|CODEUPPER,          /* 76 L */
 1|CODEALPHA|CODEUPPER,          /* 77 M */
 1|CODEALPHA|CODEUPPER,          /* 78 N */
 1|CODEALPHA|CODEUPPER,          /* 79 O */
 1|CODEALPHA|CODEUPPER,          /* 80 P */
 1|CODEALPHA|CODEUPPER,          /* 81 Q */
 1|CODEALPHA|CODEUPPER,          /* 82 R */
 1|CODEALPHA|CODEUPPER,          /* 83 S */
 1|CODEALPHA|CODEUPPER,          /* 84 T */
 1|CODEALPHA|CODEUPPER,          /* 85 U */
 1|CODEALPHA|CODEUPPER,          /* 86 V */
 1|CODEALPHA|CODEUPPER,          /* 87 W */
 1|CODEALPHA|CODEUPPER,          /* 88 X */
 1|CODEALPHA|CODEUPPER,          /* 89 Y */
 1|CODEALPHA|CODEUPPER,          /* 90 Z */
 1|CODEPUNCT,                    /* 91 [ */
 1|CODESYMBOL,                   /* 92 \ */
 1|CODEPUNCT,                    /* 93 ] */
 1|CODESYMBOL,                   /* 94 ^ */
 1|CODESYMBOL,                   /* 95 _ */
 1|CODEPUNCT,                    /* 96 ` */
 1|CODEALPHA,                    /* 97 a */
 1|CODEALPHA,                    /* 98 b */
 1|CODEALPHA,                    /* 99 c */
 1|CODEALPHA,                    /* 100 d */
 1|CODEALPHA,                    /* 101 e */
 1|CODEALPHA,                    /* 102 f */
 1|CODEALPHA,                    /* 103 g */
 1|CODEALPHA,                    /* 104 h */
 1|CODEALPHA,                    /* 105 i */
 1|CODEALPHA,                    /* 106 j */
 1|CODEALPHA,                    /* 107 k */
 1|CODEALPHA,                    /* 108 l */
 1|CODEALPHA,                    /* 109 m */
 1|CODEALPHA,                    /* 110 n */
 1|CODEALPHA,                    /* 111 o */
 1|CODEALPHA,                    /* 112 p */
 1|CODEALPHA,                    /* 113 q */
 1|CODEALPHA,                    /* 114 r */
 1|CODEALPHA,                    /* 115 s */
 1|CODEALPHA,                    /* 116 t */
 1|CODEALPHA,                    /* 117 u */
 1|CODEALPHA,                    /* 118 v */
 1|CODEALPHA,                    /* 119 w */
 1|CODEALPHA,                    /* 120 x */
 1|CODEALPHA,                    /* 121 y */
 1|CODEALPHA,                    /* 122 z */
 1|CODEPUNCT,                    /* 123 { */
 1|CODESYMBOL,                   /* 124 | */
 1|CODEPUNCT,                    /* 125 } */
 1|CODESYMBOL,                   /* 126 ~ */
 1|CODENONE,                     /* 127   */
 1|CODESYMBOL,                   /* 128  Euro  */
 1|CODEALPHA|CODEUPPER,          /* 129  W */
 1|CODEALPHA,                    /* 130  w */
 1|CODENONE,                     /* 131   */
 1|CODENONE,                     /* 132   */
 1|CODEALPHA|CODEUPPER,          /* 133  Y */
 1|CODEALPHA,                    /* 134  y */
 1|CODENONE,                     /* 135   */
 1|CODENONE,                     /* 136   */
 1|CODENONE,                     /* 137   */
 1|CODENONE,                     /* 138   */
 1|CODENONE,                     /* 139   */
 1|CODENONE,                     /* 140  ... */
 1|CODENONE,                     /* 141   */
 1|CODENONE,                     /* 142   */
 1|CODENONE,                     /* 143   */
 1|CODEPUNCT,                    /* 144  single quote 6 */
 1|CODEPUNCT,                    /* 145  single quote 9 */
 1|CODENONE,                     /* 146   */
 1|CODENONE,                     /* 147   */
 1|CODEPUNCT,                    /* 148  double quote 66 */
 1|CODEPUNCT,                    /* 149  double quote 99 */
 1|CODENONE,                     /* 150   */
 1|CODENONE,                     /* 151   */
 1|CODENONE,                     /* 152   */
 1|CODENONE,                     /* 153   */
 1|CODELIGATURE|CODEUPPER,       /* 154  OE  */
 1|CODELIGATURE,                 /* 155  oe  */
 1|CODENONE,                     /* 156      */
 1|CODENONE,                     /* 157      */
 1|CODELIGATURE,                 /* 158  fi  */
 1|CODELIGATURE,                 /* 159  fl  */
 1|CODEWHITE,                    /* 160  */
 1|CODESYMBOL,                   /* 161  */
 1|CODESYMBOL,                   /* 162  */
 1|CODESYMBOL,                   /* 163  */
 1|CODESYMBOL,                   /* 164  */
 1|CODESYMBOL,                   /* 165  */
 1|CODESYMBOL,                   /* 166  */
 1|CODESYMBOL,                   /* 167  */
 1|CODESYMBOL,                   /* 168  */
 1|CODESYMBOL,                   /* 169  */
 1|CODESYMBOL,                   /* 170  */
 1|CODEPUNCT,                    /* 171  */
 1|CODESYMBOL,                   /* 172  */
 1|CODESYMBOL,                   /* 173  */
 1|CODESYMBOL,                   /* 174  */
 1|CODESYMBOL,                   /* 175  */
 1|CODESYMBOL,                   /* 176  */
 1|CODESYMBOL,                   /* 177  */
 1|CODESYMBOL,                   /* 178  */
 1|CODESYMBOL,                   /* 179  */
 1|CODEPUNCT,                    /* 180  */
 1|CODESYMBOL,                   /* 181  */
 1|CODESYMBOL,                   /* 182  */
 1|CODESYMBOL,                   /* 183  */
 1|CODEPUNCT,                    /* 184  */
 1|CODESYMBOL,                   /* 185  */
 1|CODESYMBOL,                   /* 186  */
 1|CODEPUNCT,                    /* 187  */
 1|CODESYMBOL,                   /* 188  */
 1|CODESYMBOL,                   /* 189  */
 1|CODESYMBOL,                   /* 190  */
 1|CODEPUNCT,                    /* 191  */
 1|CODEALPHA|CODEUPPER,          /* 192  */
 1|CODEALPHA|CODEUPPER,          /* 193  */
 1|CODEALPHA|CODEUPPER,          /* 194  */
 1|CODEALPHA|CODEUPPER,          /* 195  */
 1|CODEALPHA|CODEUPPER,          /* 196  */
 1|CODEALPHA|CODEUPPER,          /* 197  */
 1|CODEALPHA|CODEUPPER,          /* 198  */
 1|CODEALPHA|CODEUPPER,          /* 199  */
 1|CODEALPHA|CODEUPPER,          /* 200  */
 1|CODEALPHA|CODEUPPER,          /* 201  */
 1|CODEALPHA|CODEUPPER,          /* 202  */
 1|CODEALPHA|CODEUPPER,          /* 203  */
 1|CODEALPHA|CODEUPPER,          /* 204  */
 1|CODEALPHA|CODEUPPER,          /* 205  */
 1|CODEALPHA|CODEUPPER,          /* 206  */
 1|CODEALPHA|CODEUPPER,          /* 207  */
 1|CODEALPHA|CODEUPPER,          /* 208  */
 1|CODEALPHA|CODEUPPER,          /* 209  */
 1|CODEALPHA|CODEUPPER,          /* 210  */
 1|CODEALPHA|CODEUPPER,          /* 211  */
 1|CODEALPHA|CODEUPPER,          /* 212  */
 1|CODEALPHA|CODEUPPER,          /* 213  */
 1|CODEALPHA|CODEUPPER,          /* 214  */
 1|CODEALPHA|CODEUPPER,          /* 215  */
 1|CODEALPHA|CODEUPPER,          /* 216  */
 1|CODEALPHA|CODEUPPER,          /* 217  */
 1|CODEALPHA|CODEUPPER,          /* 218  */
 1|CODEALPHA|CODEUPPER,          /* 219  */
 1|CODEALPHA|CODEUPPER,          /* 220  */
 1|CODEALPHA|CODEUPPER,          /* 221  */
 1|CODEALPHA|CODEUPPER,          /* 222  */
 1|CODEALPHA|CODEUPPER,          /* 223  */
 1|CODEALPHA,                    /* 224  */
 1|CODEALPHA,                    /* 225  */
 1|CODEALPHA,                    /* 226  */
 1|CODEALPHA,                    /* 227  */
 1|CODEALPHA,                    /* 228  */
 1|CODEALPHA,                    /* 229  */
 1|CODEALPHA,                    /* 230  */
 1|CODEALPHA,                    /* 231  */
 1|CODEALPHA,                    /* 232  */
 1|CODEALPHA,                    /* 233  */
 1|CODEALPHA,                    /* 234  */
 1|CODEALPHA,                    /* 235  */
 1|CODEALPHA,                    /* 236  */
 1|CODEALPHA,                    /* 237  */
 1|CODEALPHA,                    /* 238  */
 1|CODEALPHA,                    /* 239  */
 1|CODEALPHA,                    /* 240  */
 1|CODEALPHA,                    /* 241  */
 1|CODEALPHA,                    /* 242  */
 1|CODEALPHA,                    /* 243  */
 1|CODEALPHA,                    /* 244  */
 1|CODEALPHA,                    /* 245  */
 1|CODEALPHA,                    /* 246  */
 1|CODEALPHA,                    /* 247  */
 1|CODEALPHA,                    /* 248  */
 1|CODEALPHA,                    /* 249  */
 1|CODEALPHA,                    /* 250  */
 1|CODEALPHA,                    /* 251  */
 1|CODEALPHA,                    /* 252  */
 1|CODEALPHA,                    /* 253  */
 1|CODEALPHA,                    /* 254  */
 1|CODEALPHA,                    /* 255  */
};


// index is riscos code, value is unicode

int code16tab[256]=
{
 0x0,                     /* 0 EOT     */
 0x1,                     /* 1 GCODE   */
 0x2,                     /* 2 EOBOX   */
 0x3,                     /* 3 EOPAGE  */
 0x4,                     /* 4 CHAPNO  */
 0x5,                     /* 5 ACTDATE */
 0x6,                     /* 6 BULLET SEQ */
 0x7,                     /* 7 SPACE SEQ  */
 0x8,                     /* 8 */
 0x9,                     /* 9 */
 0xA,                     /* 10 NL     */
 0xB,                     /* 11 */
 0xC,                     /* 12 */
 0xD,                     /* 13 CR      */
 0xE,                     /* 14 */
 0xF,                     /* 15 */
 0x10,                    /* 16 */
 0x11,                    /* 17 EINTSEQ */
 0x12,                    /* 18 TABSEQ */
 0x13,                    /* 19 MACSEQ */
 0x14,                    /* 20 SNO    */
 0x15,                    /* 21 DCHYPH */
 0x16,                    /* 22 EOB    */
 0x17,                    /* 23 */
 0x18,                    /* 24 */
 0x19,                    /* 25 */
 0x1A,                    /* 26 */
 0x1B,                    /* 27 */
 0x1C,                    /* 28 */ 
 0x1D,                    /* 29 */
 0x1E,                    /* 30 PAGENO */
 0x1F,                    /* 31 */
 0x20,                    /* 32 SPACE  */
 0x21,                    /* 33 ! */
 0x22,                    /* 34 " */
 0x23,                    /* 35 # */
 0x24,                    /* 36 $ */
 0x25,                    /* 37 % */
 0x26,                    /* 38 & */
 0x27,                    /* 39 ' */
 0x28,                    /* 40 ( */
 0x29,                    /* 41 ) */
 0x2A,                    /* 42 * */
 0x2B,                    /* 43 + */
 0x2C,                    /* 44 , */
 0x2D,                    /* 45 - */
 0x2E,                    /* 46 . */
 0x2F,                    /* 47 / */
 0x30,                    /* 48 0 */
 0x31,                    /* 49 1 */
 0x32,                    /* 50 2 */
 0x33,                    /* 51 3 */
 0x34,                    /* 52 4 */
 0x35,                    /* 53 5 */
 0x36,                    /* 54 6 */
 0x37,                    /* 55 7 */
 0x38,                    /* 56 8 */
 0x39,                    /* 57 9 */
 0x3A,                    /* 58 : */
 0x3B,                    /* 59 ; */
 0x3C,                    /* 60 < */
 0x3D,                    /* 61 = */
 0x3E,                    /* 62 > */
 0x3F,                    /* 63 ? */
 0x40,                    /* 64 @ */
 0x41,                    /* 65 A */
 0x42,                    /* 66 B */
 0x43,                    /* 67 C */
 0x44,                    /* 68 D */
 0x45,                    /* 69 E */
 0x46,                    /* 70 F */
 0x47,                    /* 71 G */
 0x48,                    /* 72 H */
 0x49,                    /* 73 I */
 0x4A,                    /* 74 J */
 0x4B,                    /* 75 K */
 0x4C,                    /* 76 L */
 0x4D,                    /* 77 M */
 0x4E,                    /* 78 N */
 0x4F,                    /* 79 O */
 0x50,                    /* 80 P */
 0x51,                    /* 81 Q */
 0x52,                    /* 82 R */
 0x53,                    /* 83 S */
 0x54,                    /* 84 T */
 0x55,                    /* 85 U */
 0x56,                    /* 86 V */
 0x57,                    /* 87 W */
 0x58,                    /* 88 X */
 0x59,                    /* 89 Y */
 0x5A,                    /* 90 Z */
 0x5B,                    /* 91 [ */
 0x5C,                    /* 92 \ */
 0x5D,                    /* 93 ] */
 0x5E,                    /* 94 ^ */
 0x5F,                    /* 95 _ */
 0x60,                    /* 96 ` */
 0x61,                    /* 97 a */
 0x62,                    /* 98 b */
 0x63,                    /* 99 c */
 0x64,                    /* 100 d */
 0x65,                    /* 101 e */
 0x66,                    /* 102 f */
 0x67,                    /* 103 g */
 0x68,                    /* 104 h */
 0x69,                    /* 105 i */
 0x6A,                    /* 106 j */
 0x6B,                    /* 107 k */
 0x6C,                    /* 108 l */
 0x6D,                    /* 109 m */
 0x6E,                    /* 110 n */
 0x6F,                    /* 111 o */
 0x70,                    /* 112 p */
 0x71,                    /* 113 q */
 0x72,                    /* 114 r */
 0x73,                    /* 115 s */
 0x74,                    /* 116 t */
 0x75,                    /* 117 u */
 0x76,                    /* 118 v */
 0x77,                    /* 119 w */
 0x78,                    /* 120 x */
 0x79,                    /* 121 y */
 0x7A,                    /* 122 z */
 0x7B,                    /* 123 { */
 0x7C,                    /* 124 | */
 0x7D,                    /* 125 } */
 0x7E,                    /* 126 ~ */
 UNIBLANK,                /* 127   */
 0x20AC,                  /* 128  Euro   */
 0x174,                   /* 129   */
 0x175,                   /* 130   */
 UNIBLANK,                /* 131   */
 UNIBLANK,                /* 132   */
 0x176,                   /* 133   */
 0x177,                   /* 134   */
 UNIBLANK,                /* 135   */
 UNIBLANK,                /* 136   */
 UNIBLANK,                /* 137   */
 UNIBLANK,                /* 138   */
 UNIBLANK,                /* 139   */
 0x2026,                  /* 140   ... */
 0x2122,                  /* 141   TM  */
 0x2030,                  /* 142      */
 0x2022,                  /* 143   bullet point */
 0x2018,                  /* 144   single quote 6   */
 0x2019,                  /* 145   single quote 9  */
 0x2039,                  /* 146   */
 0x203A,                  /* 147   */
 0x201C,                  /* 148   double quote 66    */
 0x201D,                  /* 149   double quote 99 */
 0x201E,                  /* 150   bottom 99*/
 0x2013,                  /* 151   en dash */
 0x2014,                  /* 152   em dash */
 0x2212,                  /* 153   minus sign */
 0x152,                   /* 154   OE   */
 0x153,                   /* 155   oe      */
 0x2020,                  /* 156   dagger   */
 0x2021,                  /* 157   double dagger */
 0xFB01,                  /* 158   fi */
 0xFB02,                  /* 159   fl  */
 0xA0,                    /* 160   NBSPC */
 0xA1,                    /* 161  */
 0xA2,                    /* 162  */
 0xA3,                    /* 163  */
 0xA4,                    /* 164  */
 0xA5,                    /* 165  */
 0xA6,                    /* 166  */
 0xA7,                    /* 167  */
 0xA8,                    /* 168  */
 0xA9,                    /* 169  */
 0xAA,                    /* 170  */
 0xAB,                    /* 171  */
 0xAC,                    /* 172  */
 0xAD,                    /* 173  */
 0xAE,                    /* 174  */
 0xAF,                    /* 175  */
 0xB0,                    /* 176  */
 0xB1,                    /* 177  */
 0xB2,                    /* 178  */
 0xB3,                    /* 179  */
 0xB4,                    /* 180  */
 0xB5,                    /* 181  */
 0xB6,                    /* 182  */
 0xB7,                    /* 183  */
 0xB8,                    /* 184  */
 0xB9,                    /* 185  */
 0xBA,                    /* 186  */
 0xBB,                    /* 187  */
 0xBC,                    /* 188  */
 0xBD,                    /* 189  */
 0xBE,                    /* 190  */
 0xBF,                    /* 191  */
 0xC0,                    /* 192  */
 0xC1,                    /* 193  */
 0xC2,                    /* 194  */
 0xC3,                    /* 195  */
 0xC4,                    /* 196  */
 0xC5,                    /* 197  */
 0xC6,                    /* 198  */
 0xC7,                    /* 199  */
 0xC8,                    /* 200  */
 0xC9,                    /* 201  */
 0xCA,                    /* 202  */
 0xCB,                    /* 203  */
 0xCC,                    /* 204  */
 0xCD,                    /* 205  */
 0xCE,                    /* 206  */
 0xCF,                    /* 207  */
 0xD0,                    /* 208  */
 0xD1,                    /* 209  */
 0xD2,                    /* 210  */
 0xD3,                    /* 211  */
 0xD4,                    /* 212  */
 0xD5,                    /* 213  */
 0xD6,                    /* 214  */
 0xD7,                    /* 215  */
 0xD8,                    /* 216  */
 0xD9,                    /* 217  */
 0xDA,                    /* 218  */
 0xDB,                    /* 219  */
 0xDC,                    /* 220  */
 0xDD,                    /* 221  */
 0xDE,                    /* 222  */
 0xDF,                    /* 223  */
 0xE0,                    /* 224  */
 0xE1,                    /* 225  */
 0xE2,                    /* 226  */
 0xE3,                    /* 227  */
 0xE4,                    /* 228  */
 0xE5,                    /* 229  */
 0xE6,                    /* 230  */
 0xE7,                    /* 231  */
 0xE8,                    /* 232  */
 0xE9,                    /* 233  */
 0xEA,                    /* 234  */
 0xEB,                    /* 235  */
 0xEC,                    /* 236  */
 0xED,                    /* 237  */
 0xEE,                    /* 238  */
 0xEF,                    /* 239  */
 0xF0,                    /* 240  */
 0xF1,                    /* 241  */
 0xF2,                    /* 242  */
 0xF3,                    /* 243  */
 0xF4,                    /* 244  */
 0xF5,                    /* 245  */
 0xF6,                    /* 246  */
 0xF7,                    /* 247  */
 0xF8,                    /* 248  */
 0xF9,                    /* 249  */
 0xFA,                    /* 250  */
 0xFB,                    /* 251  */
 0xFC,                    /* 252  */
 0xFD,                    /* 253  */
 0xFE,                    /* 254  */
 0xFF,                    /* 255  */
};



// index is risc os code, value is Windows code


int code8tab[256]=
{
 0x0,                     /* 0 EOT     */
 0x1,                     /* 1 GCODE   */
 0x2,                     /* 2 EOBOX   */
 0x3,                     /* 3 EOPAGE  */
 0x4,                     /* 4 CHAPNO  */
 0x5,                     /* 5 ACTDATE */
 0x6,                     /* 6 BULLET SEQ */
 0x7,                     /* 7 SPACE SEQ  */
 0x8,                     /* 8 */
 0x9,                     /* 9 */
 0xA,                     /* 10 NL     */
 0xB,                     /* 11 */
 0xC,                     /* 12 */
 0xD,                     /* 13 CR      */
 0xE,                     /* 14 */
 0xF,                     /* 15 */
 0x10,                    /* 16 */
 0x11,                    /* 17 EINTSEQ */
 0x12,                    /* 18 TABSEQ */
 0x13,                    /* 19 MACSEQ */
 0x14,                    /* 20 SNO    */
 0x15,                    /* 21 DCHYPH */
 0x16,                    /* 22 EOB    */
 0x17,                    /* 23 */
 0x18,                    /* 24 */
 0x19,                    /* 25 */
 0x1A,                    /* 26 */
 0x1B,                    /* 27 */
 0x1C,                    /* 28 */ 
 0x1D,                    /* 29 */
 0x1E,                    /* 30 PAGENO */
 0x1F,                    /* 31 */
 0x20,                    /* 32 SPACE  */
 0x21,                    /* 33 ! */
 0x22,                    /* 34 " */
 0x23,                    /* 35 # */
 0x24,                    /* 36 $ */
 0x25,                    /* 37 % */
 0x26,                    /* 38 & */
 0x27,                    /* 39 ' */
 0x28,                    /* 40 ( */
 0x29,                    /* 41 ) */
 0x2A,                    /* 42 * */
 0x2B,                    /* 43 + */
 0x2C,                    /* 44 , */
 0x2D,                    /* 45 - */
 0x2E,                    /* 46 . */
 0x2F,                    /* 47 / */
 0x30,                    /* 48 0 */
 0x31,                    /* 49 1 */
 0x32,                    /* 50 2 */
 0x33,                    /* 51 3 */
 0x34,                    /* 52 4 */
 0x35,                    /* 53 5 */
 0x36,                    /* 54 6 */
 0x37,                    /* 55 7 */
 0x38,                    /* 56 8 */
 0x39,                    /* 57 9 */
 0x3A,                    /* 58 : */
 0x3B,                    /* 59 ; */
 0x3C,                    /* 60 < */
 0x3D,                    /* 61 = */
 0x3E,                    /* 62 > */
 0x3F,                    /* 63 ? */
 0x40,                    /* 64 @ */
 0x41,                    /* 65 A */
 0x42,                    /* 66 B */
 0x43,                    /* 67 C */
 0x44,                    /* 68 D */
 0x45,                    /* 69 E */
 0x46,                    /* 70 F */
 0x47,                    /* 71 G */
 0x48,                    /* 72 H */
 0x49,                    /* 73 I */
 0x4A,                    /* 74 J */
 0x4B,                    /* 75 K */
 0x4C,                    /* 76 L */
 0x4D,                    /* 77 M */
 0x4E,                    /* 78 N */
 0x4F,                    /* 79 O */
 0x50,                    /* 80 P */
 0x51,                    /* 81 Q */
 0x52,                    /* 82 R */
 0x53,                    /* 83 S */
 0x54,                    /* 84 T */
 0x55,                    /* 85 U */
 0x56,                    /* 86 V */
 0x57,                    /* 87 W */
 0x58,                    /* 88 X */
 0x59,                    /* 89 Y */
 0x5A,                    /* 90 Z */
 0x5B,                    /* 91 [ */
 0x5C,                    /* 92 \ */
 0x5D,                    /* 93 ] */
 0x5E,                    /* 94 ^ */
 0x5F,                    /* 95 _ */
 0x60,                    /* 96 ` */
 0x61,                    /* 97 a */
 0x62,                    /* 98 b */
 0x63,                    /* 99 c */
 0x64,                    /* 100 d */
 0x65,                    /* 101 e */
 0x66,                    /* 102 f */
 0x67,                    /* 103 g */
 0x68,                    /* 104 h */
 0x69,                    /* 105 i */
 0x6A,                    /* 106 j */
 0x6B,                    /* 107 k */
 0x6C,                    /* 108 l */
 0x6D,                    /* 109 m */
 0x6E,                    /* 110 n */
 0x6F,                    /* 111 o */
 0x70,                    /* 112 p */
 0x71,                    /* 113 q */
 0x72,                    /* 114 r */
 0x73,                    /* 115 s */
 0x74,                    /* 116 t */
 0x75,                    /* 117 u */
 0x76,                    /* 118 v */
 0x77,                    /* 119 w */
 0x78,                    /* 120 x */
 0x79,                    /* 121 y */
 0x7A,                    /* 122 z */
 0x7B,                    /* 123 { */
 0x7C,                    /* 124 | */
 0x7D,                    /* 125 } */
 0x7E,                    /* 126 ~ */
 -1,                      /* 127   */
 128,                     /* 128 Euro */
 -1,  /* 142,*/           /* 129 Cap Welsh W   */
 -1,  /* 158,*/           /* 130 Small Welsh w  */
 -1,  /* 130,*/           /* 131 blank  */
 -1,  /* 136,*/           /* 132 blank  */
 -1,  /* 138,*/           /* 133 Cap Y with ^   */
 -1,  /* 154,*/           /* 134 Small y with ^  */
 -1,  /* 152,*/           /* 135 blank  */
 -1,  /* 144,*/           /* 136 blank  */
 -1,  /* 157,*/           /* 137 blank  */
 -1,  /* 131,*/           /* 138 blank  */
 -1,  /* 159,*/           /* 139 blank  */
 133,                     /* 140 Ellipsis ...  */
 153,                     /* 141 TM  */
 137,                     /* 142 o/oo  */
 149,                     /* 143 bullet point */
 145,                     /* 144  single quote 6   */
 146,                     /* 145 single quote 9  */
 139,                     /* 146 < */
 155,                     /* 147 > */
 147,                     /* 148   double quote 66    */
 148,                     /* 149  double quote 99 */
 132,                     /* 150  double quote bottom */
 150,                     /* 151  en dash */
 151,                     /* 152  em dash */
 -1,                      /* 153  minus  */
 140,                     /* 154  OE    */
 156,                     /* 155  oe      */
 134,                     /* 156  dagger    */
 135,                     /* 157  double dagger */
 -1,                      /* 158  fi f*/
 -1,                      /* 159  fl f*/
 0xA0,                    /* 160 NBSPC */
 0xA1,                    /* 161  */
 0xA2,                    /* 162  */
 0xA3,                    /* 163  */
 0xA4,                    /* 164  */
 0xA5,                    /* 165  */
 0xA6,                    /* 166  */
 0xA7,                    /* 167  */
 0xA8,                    /* 168  */
 0xA9,                    /* 169  */
 0xAA,                    /* 170  */
 0xAB,                    /* 171  */
 0xAC,                    /* 172  */
 0xAD,                    /* 173  */
 0xAE,                    /* 174  */
 0xAF,                    /* 175  */
 0xB0,                    /* 176  */
 0xB1,                    /* 177  */
 0xB2,                    /* 178  */
 0xB3,                    /* 179  */
 0xB4,                    /* 180  */
 0xB5,                    /* 181  */
 0xB6,                    /* 182  */
 0xB7,                    /* 183  */
 0xB8,                    /* 184  */
 0xB9,                    /* 185  */
 0xBA,                    /* 186  */
 0xBB,                    /* 187  */
 0xBC,                    /* 188  */
 0xBD,                    /* 189  */
 0xBE,                    /* 190  */
 0xBF,                    /* 191  */
 0xC0,                    /* 192  */
 0xC1,                    /* 193  */
 0xC2,                    /* 194  */
 0xC3,                    /* 195  */
 0xC4,                    /* 196  */
 0xC5,                    /* 197  */
 0xC6,                    /* 198  */
 0xC7,                    /* 199  */
 0xC8,                    /* 200  */
 0xC9,                    /* 201  */
 0xCA,                    /* 202  */
 0xCB,                    /* 203  */
 0xCC,                    /* 204  */
 0xCD,                    /* 205  */
 0xCE,                    /* 206  */
 0xCF,                    /* 207  */
 0xD0,                    /* 208  */
 0xD1,                    /* 209  */
 0xD2,                    /* 210  */
 0xD3,                    /* 211  */
 0xD4,                    /* 212  */
 0xD5,                    /* 213  */
 0xD6,                    /* 214  */
 0xD7,                    /* 215  */
 0xD8,                    /* 216  */
 0xD9,                    /* 217  */
 0xDA,                    /* 218  */
 0xDB,                    /* 219  */
 0xDC,                    /* 220  */
 0xDD,                    /* 221  */
 0xDE,                    /* 222  */
 0xDF,                    /* 223  */
 0xE0,                    /* 224  */
 0xE1,                    /* 225  */
 0xE2,                    /* 226  */
 0xE3,                    /* 227  */
 0xE4,                    /* 228  */
 0xE5,                    /* 229  */
 0xE6,                    /* 230  */
 0xE7,                    /* 231  */
 0xE8,                    /* 232  */
 0xE9,                    /* 233  */
 0xEA,                    /* 234  */
 0xEB,                    /* 235  */
 0xEC,                    /* 236  */
 0xED,                    /* 237  */
 0xEE,                    /* 238  */
 0xEF,                    /* 239  */
 0xF0,                    /* 240  */
 0xF1,                    /* 241  */
 0xF2,                    /* 242  */
 0xF3,                    /* 243  */
 0xF4,                    /* 244  */
 0xF5,                    /* 245  */
 0xF6,                    /* 246  */
 0xF7,                    /* 247  */
 0xF8,                    /* 248  */
 0xF9,                    /* 249  */
 0xFA,                    /* 250  */
 0xFB,                    /* 251  */
 0xFC,                    /* 252  */
 0xFD,                    /* 253  */
 0xFE,                    /* 254  */
 0xFF,                    /* 255  */
};



// index is risc os code, values are replacement codes

int altcode8tab[256]=
{
 -1,           // code  0  
 -1,           // code  1  
 -1,           // code  2  
 -1,           // code  3  
 -1,           // code  4  
 -1,           // code  5  
 -1,           // code  6  
 -1,           // code  7  
 -1,           // code  8  
 -1,           // code  9  
 -1,           // code  10  
 -1,           // code  11  
 -1,           // code  12  
 -1,           // code  13  
 -1,           // code  14  
 -1,           // code  15  
 -1,           // code  16  
 -1,           // code  17  
 -1,           // code  18  
 -1,           // code  19  
 -1,           // code  20  
 -1,           // code  21  
 -1,           // code  22  
 -1,           // code  23  
 -1,           // code  24  
 -1,           // code  25  
 -1,           // code  26  
 -1,           // code  27  
 -1,           // code  28  
 -1,           // code  29  
 -1,           // code  30  
 -1,           // code  31  
 -1,           // code  32  
 -1,           // code  33 !
 -1,           // code  34 "
 -1,           // code  35 #
 -1,           // code  36 $
 -1,           // code  37 %
 -1,           // code  38 &
 -1,           // code  39 '
 -1,           // code  40 (
 -1,           // code  41 )
 -1,           // code  42 *
 -1,           // code  43 +
 -1,           // code  44 ,
 -1,           // code  45 -
 -1,           // code  46 .
 -1,           // code  47 /
 -1,           // code  48 0
 -1,           // code  49 1
 -1,           // code  50 2
 -1,           // code  51 3
 -1,           // code  52 4
 -1,           // code  53 5
 -1,           // code  54 6
 -1,           // code  55 7
 -1,           // code  56 8
 -1,           // code  57 9
 -1,           // code  58 :
 -1,           // code  59 ;
 -1,           // code  60 <
 -1,           // code  61 =
 -1,           // code  62 >
 -1,           // code  63 ?
 -1,           // code  64 @
 -1,           // code  65 A
 -1,           // code  66 B
 -1,           // code  67 C
 -1,           // code  68 D
 -1,           // code  69 E
 -1,           // code  70 F
 -1,           // code  71 G
 -1,           // code  72 H
 -1,           // code  73 I
 -1,           // code  74 J
 -1,           // code  75 K
 -1,           // code  76 L
 -1,           // code  77 M
 -1,           // code  78 N
 -1,           // code  79 O
 -1,           // code  80 P
 -1,           // code  81 Q
 -1,           // code  82 R
 -1,           // code  83 S
 -1,           // code  84 T
 -1,           // code  85 U
 -1,           // code  86 V
 -1,           // code  87 W
 -1,           // code  88 X
 -1,           // code  89 Y
 -1,           // code  90 Z
 -1,           // code  91 [
 -1,           // code  92 \/
 -1,           // code  93 ]
 -1,           // code  94 ^
 -1,           // code  95 _
 -1,           // code  96 `
 -1,           // code  97 a
 -1,           // code  98 b
 -1,           // code  99 c
 -1,           // code  100 d
 -1,           // code  101 e
 -1,           // code  102 f
 -1,           // code  103 g
 -1,           // code  104 h
 -1,           // code  105 i
 -1,           // code  106 j
 -1,           // code  107 k
 -1,           // code  108 l
 -1,           // code  109 m
 -1,           // code  110 n
 -1,           // code  111 o
 -1,           // code  112 p
 -1,           // code  113 q
 -1,           // code  114 r
 -1,           // code  115 s
 -1,           // code  116 t
 -1,           // code  117 u
 -1,           // code  118 v
 -1,           // code  119 w
 -1,           // code  120 x
 -1,           // code  121 y
 -1,           // code  122 z
 -1,           // code  123 {
 -1,           // code  124 |
 -1,           // code  125 }
 -1,           // code  126 ~
 -1,           // code  127  
 'e',          // code  128 
 'W',          // code  129 
 'w',          // code  130 
 -1,           // code  131 
 -1,           // code  132 
 'Y',          // code  133 
 'y',          // code  134 
 -1,           // code  135 
 -1,           // code  136 
 -1,           // code  137 
 -1,           // code  138 
 -1,           // code  139 
 -1,           // code  140 
 -1,           // code  141 
 -1,           // code  142 
 -1,           // code  143 
 -1,           // code  144 
 -1,           // code  145 
 -1,           // code  146 
 -1,           // code  147 
 -1,           // code  148 
 -1,           // code  149 
 -1,           // code  150 
 -1,           // code  151 
 -1,           // code  152 
 '-',          // code  153 
 'O'+('E'<<8), // code  154 
 'o'+('e'<<8), // code  155 
 -1,           // code  156 
 -1,           // code  157 
 'f'+('i'<<8), // code  158 
 'f'+('l'<<8), // code  159 
 -1,           // code  160 
 -1,           // code  161 
 -1,           // code  162 
 -1,           // code  163 
 -1,           // code  164 
 -1,           // code  165 
 -1,           // code  166 
 -1,           // code  167 
 -1,           // code  168 
 -1,           // code  169 
 -1,           // code  170 
 -1,           // code  171 
 -1,           // code  172 
 -1,           // code  173 
 -1,           // code  174 
 -1,           // code  175 
 -1,           // code  176 
 -1,           // code  177 
 -1,           // code  178 
 -1,           // code  179 
 -1,           // code  180 
 -1,           // code  181 
 -1,           // code  182 
 -1,           // code  183 
 -1,           // code  184 
 -1,           // code  185 
 -1,           // code  186 
 -1,           // code  187 
 -1,           // code  188 
 -1,           // code  189 
 -1,           // code  190 
 -1,           // code  191 
 -1,           // code  192 
 -1,           // code  193 
 -1,           // code  194 
 -1,           // code  195 
 -1,           // code  196 
 -1,           // code  197 
 -1,           // code  198 
 -1,           // code  199 
 -1,           // code  200 
 -1,           // code  201 
 -1,           // code  202 
 -1,           // code  203 
 -1,           // code  204 
 -1,           // code  205 
 -1,           // code  206 
 -1,           // code  207 
 -1,           // code  208 
 -1,           // code  209 
 -1,           // code  210 
 -1,           // code  211 
 -1,           // code  212 
 -1,           // code  213 
 -1,           // code  214 
 -1,           // code  215 
 -1,           // code  216 
 -1,           // code  217 
 -1,           // code  218 
 -1,           // code  219 
 -1,           // code  220 
 -1,           // code  221 
 -1,           // code  222 
 -1,           // code  223 
 -1,           // code  224 
 -1,           // code  225 
 -1,           // code  226 
 -1,           // code  227 
 -1,           // code  228 
 -1,           // code  229 
 -1,           // code  230 
 -1,           // code  231 
 -1,           // code  232 
 -1,           // code  233 
 -1,           // code  234 
 -1,           // code  235 
 -1,           // code  236 
 -1,           // code  237 
 -1,           // code  238 
 -1,           // code  239 
 -1,           // code  240 
 -1,           // code  241 
 -1,           // code  242 
 -1,           // code  243 
 -1,           // code  244 
 -1,           // code  245 
 -1,           // code  246 
 -1,           // code  247 
 -1,           // code  248 
 -1,           // code  249 
 -1,           // code  250 
 -1,           // code  251 
 -1,           // code  252 
 -1,           // code  253 
 -1,           // code  254 
 -1,           // code  255 
};



// index is Windows code, value is RISC OS code

static int code8invtab[256]=
{
 0x0,                     /* 0   */
 0x1,                     /* 1   */
 0x2,                     /* 2   */
 0x3,                     /* 3   */
 0x4,                     /* 4   */
 0x5,                     /* 5   */
 0x6,                     /* 6   */
 0x7,                     /* 7   */
 0x8,                     /* 8   */
 0x9,                     /* 9   */
 0xa,                     /* 10   */
 0xb,                     /* 11   */
 0xc,                     /* 12   */
 0xd,                     /* 13   */
 0xe,                     /* 14   */
 0xf,                     /* 15   */
 0x10,                    /* 16   */
 0x11,                    /* 17   */
 0x12,                    /* 18   */
 0x13,                    /* 19   */
 0x14,                    /* 20   */
 0x15,                    /* 21   */
 0x16,                    /* 22   */
 0x17,                    /* 23   */
 0x18,                    /* 24   */
 0x19,                    /* 25   */
 0x1a,                    /* 26   */
 0x1b,                    /* 27   */
 0x1c,                    /* 28   */
 0x1d,                    /* 29   */
 0x1e,                    /* 30   */
 0x1f,                    /* 31   */
 0x20,                    /* 32   */
 0x21,                    /* 33 ! */
 0x22,                    /* 34 " */
 0x23,                    /* 35 # */
 0x24,                    /* 36 $ */
 0x25,                    /* 37 % */
 0x26,                    /* 38 & */
 0x27,                    /* 39 ' */
 0x28,                    /* 40 ( */
 0x29,                    /* 41 ) */
 0x2a,                    /* 42 * */
 0x2b,                    /* 43 + */
 0x2c,                    /* 44 , */
 0x2d,                    /* 45 - */
 0x2e,                    /* 46 . */
 0x2f,                    /* 47 / */
 0x30,                    /* 48 0 */
 0x31,                    /* 49 1 */
 0x32,                    /* 50 2 */
 0x33,                    /* 51 3 */
 0x34,                    /* 52 4 */
 0x35,                    /* 53 5 */
 0x36,                    /* 54 6 */
 0x37,                    /* 55 7 */
 0x38,                    /* 56 8 */
 0x39,                    /* 57 9 */
 0x3a,                    /* 58 : */
 0x3b,                    /* 59 ; */
 0x3c,                    /* 60 < */
 0x3d,                    /* 61 = */
 0x3e,                    /* 62 > */
 0x3f,                    /* 63 ? */
 0x40,                    /* 64 @ */
 0x41,                    /* 65 A */
 0x42,                    /* 66 B */
 0x43,                    /* 67 C */
 0x44,                    /* 68 D */
 0x45,                    /* 69 E */
 0x46,                    /* 70 F */
 0x47,                    /* 71 G */
 0x48,                    /* 72 H */
 0x49,                    /* 73 I */
 0x4a,                    /* 74 J */
 0x4b,                    /* 75 K */
 0x4c,                    /* 76 L */
 0x4d,                    /* 77 M */
 0x4e,                    /* 78 N */
 0x4f,                    /* 79 O */
 0x50,                    /* 80 P */
 0x51,                    /* 81 Q */
 0x52,                    /* 82 R */
 0x53,                    /* 83 S */
 0x54,                    /* 84 T */
 0x55,                    /* 85 U */
 0x56,                    /* 86 V */
 0x57,                    /* 87 W */
 0x58,                    /* 88 X */
 0x59,                    /* 89 Y */
 0x5a,                    /* 90 Z */
 0x5b,                    /* 91 [ */
 0x5c,                    /* 92 \ */
 0x5d,                    /* 93 ] */
 0x5e,                    /* 94 ^ */
 0x5f,                    /* 95 _ */
 0x60,                    /* 96 ` */
 0x61,                    /* 97 a */
 0x62,                    /* 98 b */
 0x63,                    /* 99 c */
 0x64,                    /* 100 d */
 0x65,                    /* 101 e */
// 0x9f,                    /* 102 f */
 0x66,                    /* 102 f */
// 0x9e,                    /* 102 f */
 0x67,                    /* 103 g */
 0x68,                    /* 104 h */
 0x69,                    /* 105 i */
 0x6a,                    /* 106 j */
 0x6b,                    /* 107 k */
 0x6c,                    /* 108 l */
 0x6d,                    /* 109 m */
 0x6e,                    /* 110 n */
 0x6f,                    /* 111 o */
 0x70,                    /* 112 p */
 0x71,                    /* 113 q */
 0x72,                    /* 114 r */
 0x73,                    /* 115 s */
 0x74,                    /* 116 t */
 0x75,                    /* 117 u */
 0x76,                    /* 118 v */
 0x77,                    /* 119 w */
 0x78,                    /* 120 x */
 0x79,                    /* 121 y */
 0x7a,                    /* 122 z */
 0x7b,                    /* 123 { */
 0x7c,                    /* 124 | */
 0x7d,                    /* 125 } */
 0x7e,                    /* 126 ~ */
 0x7f,                    /* 127  */
 0x80,                    /* 128  */
	-1,	  																			/* 129   blank in win */
 -1, /*0x83,*/            /* 130  not in risc os*/
 -1, /*0x8a,*/            /* 131  not in risc os*/
 0x96,                    /* 132  */
 0x8c,                    /* 133  */
 0x9c,                    /* 134  */
 0x9d,                    /* 135  */
 -1, /*0x84,*/            /* 136  not in risc os*/
 0x8e,                    /* 137  */
 -1, /* 0x85, */          /* 138  not in risc os*/
 0x92,                    /* 139  */
 0x9a,                    /* 140  */
	-1,  																				/* 141   blank in win	*/
 -1, /*0x81, */           /* 142  not in risc os*/
	-1,	  																			/* 143   blank in win	*/
 -1, /*0x88 */            /* 144   blank in win */
 0x90,                    /* 145  */
 0x91,                    /* 146  */
 0x94,                    /* 147  */
 0x95,                    /* 148  */
 0x8f,                    /* 149  */
 0x97,                    /* 150  */
// 0x99,                    /* 150  */
 0x98,                    /* 151  */
 -1, /* 0x87,*/           /* 152  not in risc os*/
 0x8d,                    /* 153  */
 -1, /* 0x86,*/           /* 154  not in risc os*/
 0x93,                    /* 155  */
 0x9b,                    /* 156  */
 -1, /* 0x89,*/           /* 157   blank in win */
 -1, /* 0x82,*/           /* 158  not in risc os*/
 -1, /* 0x8b,*/           /* 159  not in risc os*/
 0xa0,                    /* 160 NBSP */
 0xa1,                    /* 161  */
 0xa2,                    /* 162  */
 0xa3,                    /* 163  */
 0xa4,                    /* 164  */
 0xa5,                    /* 165  */
 0xa6,                    /* 166  */
 0xa7,                    /* 167  */
 0xa8,                    /* 168  */
 0xa9,                    /* 169  */
 0xaa,                    /* 170  */
 0xab,                    /* 171  */
 0xac,                    /* 172  */
 0xad,                    /* 173  */
 0xae,                    /* 174  */
 0xaf,                    /* 175  */
 0xb0,                    /* 176  */
 0xb1,                    /* 177  */
 0xb2,                    /* 178  */
 0xb3,                    /* 179  */
 0xb4,                    /* 180  */
 0xb5,                    /* 181  */
 0xb6,                    /* 182  */
 0xb7,                    /* 183 + */
 0xb8,                    /* 184 + */
 0xb9,                    /* 185  */
 0xba,                    /* 186  */
 0xbb,                    /* 187 + */
 0xbc,                    /* 188 + */
 0xbd,                    /* 189 + */
 0xbe,                    /* 190 + */
 0xbf,                    /* 191 + */
 0xc0,                    /* 192 + */
 0xc1,                    /* 193 - */
 0xc2,                    /* 194 - */
 0xc3,                    /* 195 + */
 0xc4,                    /* 196 - */
 0xc5,                    /* 197 + */
 0xc6,                    /* 198  */
 0xc7,                    /* 199  */
 0xc8,                    /* 200 + */
 0xc9,                    /* 201 + */
 0xca,                    /* 202 - */
 0xcb,                    /* 203 - */
 0xcc,                    /* 204  */
 0xcd,                    /* 205 - */
 0xce,                    /* 206 + */
 0xcf,                    /* 207 - */
 0xd0,                    /* 208 - */
 0xd1,                    /* 209 - */
 0xd2,                    /* 210 - */
 0xd3,                    /* 211 + */
 0xd4,                    /* 212 + */
 0xd5,                    /* 213 + */
 0xd6,                    /* 214 + */
 0xd7,                    /* 215 + */
 0xd8,                    /* 216 + */
 0xd9,                    /* 217 + */
 0xda,                    /* 218 + */
 0xdb,                    /* 219  */
 0xdc,                    /* 220 _ */
 0xdd,                    /* 221  */
 0xde,                    /* 222  */
 0xdf,                    /* 223  */
 0xe0,                    /* 224 a */
 0xe1,                    /* 225  */
 0xe2,                    /* 226 G */
 0xe3,                    /* 227 p */
 0xe4,                    /* 228 S */
 0xe5,                    /* 229 s */
 0xe6,                    /* 230  */
 0xe7,                    /* 231 t */
 0xe8,                    /* 232 F */
 0xe9,                    /* 233 T */
 0xea,                    /* 234 O */
 0xeb,                    /* 235 d */
 0xec,                    /* 236 8 */
 0xed,                    /* 237 f */
 0xee,                    /* 238 e */
 0xef,                    /* 239 n */
 0xf0,                    /* 240 = */
 0xf1,                    /* 241  */
 0xf2,                    /* 242 = */
 0xf3,                    /* 243 = */
 0xf4,                    /* 244 ( */
 0xf5,                    /* 245 ) */
 0xf6,                    /* 246  */
 0xf7,                    /* 247  */
 0xf8,                    /* 248  */
 0xf9,                    /* 249  */
 0xfa,                    /* 250  */
 0xfb,                    /* 251 v */
 0xfc,                    /* 252 n */
 0xfd,                    /* 253  */
 0xfe,                    /* 254  */
 0xff                     /* 255  */
};







static char code8symbolinvtab[256]=
{
 0x0,                     /* 0   */
 0x1,                     /* 1   */
 0x2,                     /* 2   */
 0x3,                     /* 3   */
 0x4,                     /* 4   */
 0x5,                     /* 5   */
 0x6,                     /* 6   */
 0x7,                     /* 7   */
 0x8,                     /* 8   */
 0x9,                     /* 9   */
 0xa,                     /* 10   */
 0xb,                     /* 11   */
 0xc,                     /* 12   */
 0xd,                     /* 13   */
 0xe,                     /* 14   */
 0xf,                     /* 15   */
 0x10,                    /* 16   */
 0x11,                    /* 17   */
 0x12,                    /* 18   */
 0x13,                    /* 19   */
 0x14,                    /* 20   */
 0x15,                    /* 21   */
 0x16,                    /* 22   */
 0x17,                    /* 23   */
 0x18,                    /* 24   */
 0x19,                    /* 25   */
 0x1a,                    /* 26   */
 0x1b,                    /* 27   */
 0x1c,                    /* 28   */
 0x1d,                    /* 29   */
 0x1e,                    /* 30   */
 0x1f,                    /* 31   */
 0x20,                    /* 32   */
 0x21,                    /* 33 ! */
 0x22,                    /* 34 " */
 0x23,                    /* 35 # */
 0x24,                    /* 36 $ */
 0x25,                    /* 37 % */
 0x26,                    /* 38 & */
 0x27,                    /* 39 ' */
 0x28,                    /* 40 ( */
 0x29,                    /* 41 ) */
 0x2a,                    /* 42 * */
 0x2b,                    /* 43 + */
 0x2c,                    /* 44 , */
 0x2d,                    /* 45 - */
 0x2e,                    /* 46 . */
 0x2f,                    /* 47 / */
 0x30,                    /* 48 0 */
 0x31,                    /* 49 1 */
 0x32,                    /* 50 2 */
 0x33,                    /* 51 3 */
 0x34,                    /* 52 4 */
 0x35,                    /* 53 5 */
 0x36,                    /* 54 6 */
 0x37,                    /* 55 7 */
 0x38,                    /* 56 8 */
 0x39,                    /* 57 9 */
 0x3a,                    /* 58 : */
 0x3b,                    /* 59 ; */
 0x3c,                    /* 60 < */
 0x3d,                    /* 61 = */
 0x3e,                    /* 62 > */
 0x3f,                    /* 63 ? */
 0x40,                    /* 64 @ */
 0x41,                    /* 65 A */
 0x42,                    /* 66 B */
 0x43,                    /* 67 C */
 0x44,                    /* 68 D */
 0x45,                    /* 69 E */
 0x46,                    /* 70 F */
 0x47,                    /* 71 G */
 0x48,                    /* 72 H */
 0x49,                    /* 73 I */
 0x4a,                    /* 74 J */
 0x4b,                    /* 75 K */
 0x4c,                    /* 76 L */
 0x4d,                    /* 77 M */
 0x4e,                    /* 78 N */
 0x4f,                    /* 79 O */
 0x50,                    /* 80 P */
 0x51,                    /* 81 Q */
 0x52,                    /* 82 R */
 0x53,                    /* 83 S */
 0x54,                    /* 84 T */
 0x55,                    /* 85 U */
 0x56,                    /* 86 V */
 0x57,                    /* 87 W */
 0x58,                    /* 88 X */
 0x59,                    /* 89 Y */
 0x5a,                    /* 90 Z */
 0x5b,                    /* 91 [ */
 0x5c,                    /* 92 \ */
 0x5d,                    /* 93 ] */
 0x5e,                    /* 94 ^ */
 0x5f,                    /* 95 _ */
 0x60,                    /* 96 ` */
 0x61,                    /* 97 a */
 0x62,                    /* 98 b */
 0x63,                    /* 99 c */
 0x64,                    /* 100 d */
 0x65,                    /* 101 e */
 0x66,                    /* 102 f */
 0x67,                    /* 103 g */
 0x68,                    /* 104 h */
 0x69,                    /* 105 i */
 0x6a,                    /* 106 j */
 0x6b,                    /* 107 k */
 0x6c,                    /* 108 l */
 0x6d,                    /* 109 m */
 0x6e,                    /* 110 n */
 0x6f,                    /* 111 o */
 0x70,                    /* 112 p */
 0x71,                    /* 113 q */
 0x72,                    /* 114 r */
 0x73,                    /* 115 s */
 0x74,                    /* 116 t */
 0x75,                    /* 117 u */
 0x76,                    /* 118 v */
 0x77,                    /* 119 w */
 0x78,                    /* 120 x */
 0x79,                    /* 121 y */
 0x7a,                    /* 122 z */
 0x7b,                    /* 123 { */
 0x7c,                    /* 124 | */
 0x7d,                    /* 125 } */
 0x7e,                    /* 126 ~ */
 0x7f,                    /* 127  */
 0x80,                    /* 128  */
	      0x81,	   										/* 129 x81  blank in win */
       0x82,              /* 130 x82  not in risc os*/
       0x83,              /* 131 x83  not in risc os*/
 0x96,                    /* 132 x84  */
 0x8c,                    /* 133 x85  */
 0x9c,                    /* 134 x86  */
 0x9d,                    /* 135 x87  */
       0x88,              /* 136 x88  not in risc os*/
 0x8e,                    /* 137 x89  */
       0x8a,              /* 138 x8a  not in risc os*/
 0x92,                    /* 139 x8b  */
 0x9a,                    /* 140 x8c  */
	      0x84,														/* 141 x8d  blank in win	*/
       0x85,              /* 142 x8e  not in risc os*/
       0x86,	 												/* 143 x8f  blank in win	*/
       0x87,              /* 144 x90  blank in win */
 0x90,                    /* 145 x91  */
 0x91,                    /* 146 x92  */
 0x94,                    /* 147 x93  */
 0x95,                    /* 148 x94  */
 0x8f,                    /* 149 x95  */
 0x97, /* 151*/           /* 150 x96  */
 0x98, /* 152*/           /* 151 x97  */
       0x89,              /* 152 x98  not in risc os*/
 0x8d,                    /* 153 x99  */
       0x8b,              /* 154 x9a  not in risc os*/
 0x93,                    /* 155 x9b  */
 0x9b,                    /* 156 x9c  */
       0x99,/*153*/       /* 157 x9d  blank in win */
       0x9e,              /* 158 x9e  not in risc os*/
       0x9f,              /* 159 x9f  not in risc os*/
 0xa0,                    /* 160 NBSP */
 0xa1,                    /* 161  */
 0xa2,                    /* 162  */
 0xa3,                    /* 163  */
 0xa4,                    /* 164  */
 0xa5,                    /* 165  */
 0xa6,                    /* 166  */
 0xa7,                    /* 167  */
 0xa8,                    /* 168  */
 0xa9,                    /* 169  */
 0xaa,                    /* 170  */
 0xab,                    /* 171  */
 0xac,                    /* 172  */
 0xad,                    /* 173  */
 0xae,                    /* 174  */
 0xaf,                    /* 175  */
 0xb0,                    /* 176  */
 0xb1,                    /* 177  */
 0xb2,                    /* 178  */
 0xb3,                    /* 179  */
 0xb4,                    /* 180  */
 0xb5,                    /* 181  */
 0xb6,                    /* 182  */
 0xb7,                    /* 183 + */
 0xb8,                    /* 184 + */
 0xb9,                    /* 185  */
 0xba,                    /* 186  */
 0xbb,                    /* 187 + */
 0xbc,                    /* 188 + */
 0xbd,                    /* 189 + */
 0xbe,                    /* 190 + */
 0xbf,                    /* 191 + */
 0xc0,                    /* 192 + */
 0xc1,                    /* 193 - */
 0xc2,                    /* 194 - */
 0xc3,                    /* 195 + */
 0xc4,                    /* 196 - */
 0xc5,                    /* 197 + */
 0xc6,                    /* 198  */
 0xc7,                    /* 199  */
 0xc8,                    /* 200 + */
 0xc9,                    /* 201 + */
 0xca,                    /* 202 - */
 0xcb,                    /* 203 - */
 0xcc,                    /* 204  */
 0xcd,                    /* 205 - */
 0xce,                    /* 206 + */
 0xcf,                    /* 207 - */
 0xd0,                    /* 208 - */
 0xd1,                    /* 209 - */
 0xd2,                    /* 210 - */
 0xd3,                    /* 211 + */
 0xd4,                    /* 212 + */
 0xd5,                    /* 213 + */
 0xd6,                    /* 214 + */
 0xd7,                    /* 215 + */
 0xd8,                    /* 216 + */
 0xd9,                    /* 217 + */
 0xda,                    /* 218 + */
 0xdb,                    /* 219  */
 0xdc,                    /* 220 _ */
 0xdd,                    /* 221  */
 0xde,                    /* 222  */
 0xdf,                    /* 223  */
 0xe0,                    /* 224 a */
 0xe1,                    /* 225  */
 0xe2,                    /* 226 G */
 0xe3,                    /* 227 p */
 0xe4,                    /* 228 S */
 0xe5,                    /* 229 s */
 0xe6,                    /* 230  */
 0xe7,                    /* 231 t */
 0xe8,                    /* 232 F */
 0xe9,                    /* 233 T */
 0xea,                    /* 234 O */
 0xeb,                    /* 235 d */
 0xec,                    /* 236 8 */
 0xed,                    /* 237 f */
 0xee,                    /* 238 e */
 0xef,                    /* 239 n */
 0xf0,                    /* 240 = */
 0xf1,                    /* 241  */
 0xf2,                    /* 242 = */
 0xf3,                    /* 243 = */
 0xf4,                    /* 244 ( */
 0xf5,                    /* 245 ) */
 0xf6,                    /* 246  */
 0xf7,                    /* 247  */
 0xf8,                    /* 248  */
 0xf9,                    /* 249  */
 0xfa,                    /* 250  */
 0xfb,                    /* 251 v */
 0xfc,                    /* 252 n */
 0xfd,                    /* 253  */
 0xfe,                    /* 254  */
 0xff                     /* 255  */
};



// index is risc os code, value is Windows symbol font

static char code8symboltab[256]=
{
 0x0,                     /* 0   */
 0x1,                     /* 1   */
 0x2,                     /* 2   */
 0x3,                     /* 3   */
 0x4,                     /* 4   */
 0x5,                     /* 5   */
 0x6,                     /* 6   */
 0x7,                     /* 7   */
 0x8,                     /* 8   */
 0x9,                     /* 9   */
 0xa,                     /* 10   */
 0xb,                     /* 11   */
 0xc,                     /* 12   */
 0xd,                     /* 13   */
 0xe,                     /* 14   */
 0xf,                     /* 15   */
 0x10,                    /* 16   */
 0x11,                    /* 17   */
 0x12,                    /* 18   */
 0x13,                    /* 19   */
 0x14,                    /* 20   */
 0x15,                    /* 21   */
 0x16,                    /* 22   */
 0x17,                    /* 23   */
 0x18,                    /* 24   */
 0x19,                    /* 25   */
 0x1a,                    /* 26   */
 0x1b,                    /* 27   */
 0x1c,                    /* 28   */
 0x1d,                    /* 29   */
 0x1e,                    /* 30   */
 0x1f,                    /* 31   */
 0x20,                    /* 32   */
 0x21,                    /* 33 ! */
 0x22,                    /* 34 " */
 0x23,                    /* 35 # */
 0x24,                    /* 36 $ */
 0x25,                    /* 37 % */
 0x26,                    /* 38 & */
 0x27,                    /* 39 ' */
 0x28,                    /* 40 ( */
 0x29,                    /* 41 ) */
 0x2a,                    /* 42 * */
 0x2b,                    /* 43 + */
 0x2c,                    /* 44 , */
 0x2d,                    /* 45 - */
 0x2e,                    /* 46 . */
 0x2f,                    /* 47 / */
 0x30,                    /* 48 0 */
 0x31,                    /* 49 1 */
 0x32,                    /* 50 2 */
 0x33,                    /* 51 3 */
 0x34,                    /* 52 4 */
 0x35,                    /* 53 5 */
 0x36,                    /* 54 6 */
 0x37,                    /* 55 7 */
 0x38,                    /* 56 8 */
 0x39,                    /* 57 9 */
 0x3a,                    /* 58 : */
 0x3b,                    /* 59 ; */
 0x3c,                    /* 60 < */
 0x3d,                    /* 61 = */
 0x3e,                    /* 62 > */
 0x3f,                    /* 63 ? */
 0x40,                    /* 64 @ */
 0x41,                    /* 65 A */
 0x42,                    /* 66 B */
 0x43,                    /* 67 C */
 0x44,                    /* 68 D */
 0x45,                    /* 69 E */
 0x46,                    /* 70 F */
 0x47,                    /* 71 G */
 0x48,                    /* 72 H */
 0x49,                    /* 73 I */
 0x4a,                    /* 74 J */
 0x4b,                    /* 75 K */
 0x4c,                    /* 76 L */
 0x4d,                    /* 77 M */
 0x4e,                    /* 78 N */
 0x4f,                    /* 79 O */
 0x50,                    /* 80 P */
 0x51,                    /* 81 Q */
 0x52,                    /* 82 R */
 0x53,                    /* 83 S */
 0x54,                    /* 84 T */
 0x55,                    /* 85 U */
 0x56,                    /* 86 V */
 0x57,                    /* 87 W */
 0x58,                    /* 88 X */
 0x59,                    /* 89 Y */
 0x5a,                    /* 90 Z */
 0x5b,                    /* 91 [ */
 0x5c,                    /* 92 \ */
 0x5d,                    /* 93 ] */
 0x5e,                    /* 94 ^ */
 0x5f,                    /* 95 _ */
 0x60,                    /* 96 ` */
 0x61,                    /* 97 a */
 0x62,                    /* 98 b */
 0x63,                    /* 99 c */
 0x64,                    /* 100 d */
 0x65,                    /* 101 e */
 0x66,                    /* 102 f */
 0x67,                    /* 103 g */
 0x68,                    /* 104 h */
 0x69,                    /* 105 i */
 0x6a,                    /* 106 j */
 0x6b,                    /* 107 k */
 0x6c,                    /* 108 l */
 0x6d,                    /* 109 m */
 0x6e,                    /* 110 n */
 0x6f,                    /* 111 o */
 0x70,                    /* 112 p */
 0x71,                    /* 113 q */
 0x72,                    /* 114 r */
 0x73,                    /* 115 s */
 0x74,                    /* 116 t */
 0x75,                    /* 117 u */
 0x76,                    /* 118 v */
 0x77,                    /* 119 w */
 0x78,                    /* 120 x */
 0x79,                    /* 121 y */
 0x7a,                    /* 122 z */
 0x7b,                    /* 123 { */
 0x7c,                    /* 124 | */
 0x7d,                    /* 125 } */
 0x7e,                    /* 126 ~ */
 0x7f,                    /* 127  */
 0x80,                    /* 128  */
	      0x81,	   										/* 129 x81  blank in win    index 129*/
       0x82,              /* 130 x82  not in risc os index 130 */
       0x83,              /* 131 x83  not in risc os index 131 */
	      0x8d,														/* 141 x84  blank in win	   index 132 */
       0x8e,              /* 142 x85  not in risc os index 133 */
       0x8f,	 												/* 143 x86  blank in win	   index 134 */
       0x90,              /* 144 x87  blank in win    index 135 */
       0x88,              /* 136 x88  not in risc os index 136*/
       0x98,              /* 152 x89  not in risc os index 137*/
       0x8a,              /* 138 x8a  not in risc os index 138 */
       0x9a,              /* 154 x8b  not in risc os index 139 */       
       0x85,              /* 133 x8c                 index 140 */       
       0x99,              /* 153 x8d                 index 141 */
       0x89,              /* 137 x8e                 index 142 */ 
       0x95,              /* 149 x8f                 index 143 */
       0x91,              /* 145 x90                 index 144 */
       0x92,              /* 146 x91                 index 145 */
       0x8b,              /* 139 x92                 index 146 */
       0x9b,              /* 155 x93                 index 147 */
       0x93,              /* 147 x94                 index 148 */
       0x94,              /* 148 x95                 index 149 */
       0x84,              /* 132 x96                 index 150*/
       0x96,              /* 157 x97  blank in win * to 150 x96 index 151 */
       0x97,              /* 151 x98                to 151 x97 index 152 */
       0x9d,              /* 150 x99                 index 153 */
       0x8c,              /* 140 x9a  */
       0x9c,              /* 156 x9b  */
       0x86,              /* 134 x9c  */
       0x87,              /* 135 x9d  */
       0x9e,              /* 158 x9e  not in risc os*/
       0x9f,              /* 159 x9f  not in risc os*/
 0xa0,                    /* 160 NBSP */
 0xa1,                    /* 161  */
 0xa2,                    /* 162  */
 0xa3,                    /* 163  */
 0xa4,                    /* 164  */
 0xa5,                    /* 165  */
 0xa6,                    /* 166  */
 0xa7,                    /* 167  */
 0xa8,                    /* 168  */
 0xa9,                    /* 169  */
 0xaa,                    /* 170  */
 0xab,                    /* 171  */
 0xac,                    /* 172  */
 0xad,                    /* 173  */
 0xae,                    /* 174  */
 0xaf,                    /* 175  */
 0xb0,                    /* 176  */
 0xb1,                    /* 177  */
 0xb2,                    /* 178  */
 0xb3,                    /* 179  */
 0xb4,                    /* 180  */
 0xb5,                    /* 181  */
 0xb6,                    /* 182  */
 0xb7,                    /* 183 + */
 0xb8,                    /* 184 + */
 0xb9,                    /* 185  */
 0xba,                    /* 186  */
 0xbb,                    /* 187 + */
 0xbc,                    /* 188 + */
 0xbd,                    /* 189 + */
 0xbe,                    /* 190 + */
 0xbf,                    /* 191 + */
 0xc0,                    /* 192 + */
 0xc1,                    /* 193 - */
 0xc2,                    /* 194 - */
 0xc3,                    /* 195 + */
 0xc4,                    /* 196 - */
 0xc5,                    /* 197 + */
 0xc6,                    /* 198  */
 0xc7,                    /* 199  */
 0xc8,                    /* 200 + */
 0xc9,                    /* 201 + */
 0xca,                    /* 202 - */
 0xcb,                    /* 203 - */
 0xcc,                    /* 204  */
 0xcd,                    /* 205 - */
 0xce,                    /* 206 + */
 0xcf,                    /* 207 - */
 0xd0,                    /* 208 - */
 0xd1,                    /* 209 - */
 0xd2,                    /* 210 - */
 0xd3,                    /* 211 + */
 0xd4,                    /* 212 + */
 0xd5,                    /* 213 + */
 0xd6,                    /* 214 + */
 0xd7,                    /* 215 + */
 0xd8,                    /* 216 + */
 0xd9,                    /* 217 + */
 0xda,                    /* 218 + */
 0xdb,                    /* 219  */
 0xdc,                    /* 220 _ */
 0xdd,                    /* 221  */
 0xde,                    /* 222  */
 0xdf,                    /* 223  */
 0xe0,                    /* 224 a */
 0xe1,                    /* 225  */
 0xe2,                    /* 226 G */
 0xe3,                    /* 227 p */
 0xe4,                    /* 228 S */
 0xe5,                    /* 229 s */
 0xe6,                    /* 230  */
 0xe7,                    /* 231 t */
 0xe8,                    /* 232 F */
 0xe9,                    /* 233 T */
 0xea,                    /* 234 O */
 0xeb,                    /* 235 d */
 0xec,                    /* 236 8 */
 0xed,                    /* 237 f */
 0xee,                    /* 238 e */
 0xef,                    /* 239 n */
 0xf0,                    /* 240 = */
 0xf1,                    /* 241  */
 0xf2,                    /* 242 = */
 0xf3,                    /* 243 = */
 0xf4,                    /* 244 ( */
 0xf5,                    /* 245 ) */
 0xf6,                    /* 246  */
 0xf7,                    /* 247  */
 0xf8,                    /* 248  */
 0xf9,                    /* 249  */
 0xfa,                    /* 250  */
 0xfb,                    /* 251 v */
 0xfc,                    /* 252 n */
 0xfd,                    /* 253  */
 0xfe,                    /* 254  */
 0xff                     /* 255  */
};







typedef struct pairstr
{
	int riscos;
	int unicode;


}	pairstr;




static pairstr code16invtab[]=
{

 0x0,0x0,                    /* 0   */
 0x1,0x1,                    /* 1   */
 0x2,0x2,                    /* 2   */
 0x3,0x3,                    /* 3   */
 0x4,0x4,                    /* 4   */
 0x5,0x5,                    /* 5   */
 0x6,0x6,                    /* 6   */
 0x7,0x7,                    /* 7   */
 0x8,0x8,                    /* 8   */
 0x9,0x9,                    /* 9   */
 0xa,0xa,                    /* 10   */
 0xb,0xb,                    /* 11   */
 0xc,0xc,                    /* 12   */
 0xd,0xd,                    /* 13   */
 0xe,0xe,                    /* 14   */
 0xf,0xf,                    /* 15   */
 0x10,0x10,                    /* 16   */
 0x11,0x11,                    /* 17   */
 0x12,0x12,                    /* 18   */
 0x13,0x13,                    /* 19   */
 0x14,0x14,                    /* 20   */
 0x15,0x15,                    /* 21   */
 0x16,0x16,                    /* 22   */
 0x17,0x17,                    /* 23   */
 0x18,0x18,                    /* 24   */
 0x19,0x19,                    /* 25   */
 0x1a,0x1a,                    /* 26   */
 0x1b,0x1b,                    /* 27   */
 0x1c,0x1c,                    /* 28   */
 0x1d,0x1d,                    /* 29   */
 0x1e,0x1e,                    /* 30   */
 0x1f,0x1f,                    /* 31   */
 0x20,0x20,                    /* 32   */
 0x21,0x21,                    /* 33 ! */
 0x22,0x22,                    /* 34 " */
 0x23,0x23,                    /* 35 # */
 0x24,0x24,                    /* 36 $ */
 0x25,0x25,                    /* 37 % */
 0x26,0x26,                    /* 38 & */
 0x27,0x27,                    /* 39 ' */
 0x28,0x28,                    /* 40 ( */
 0x29,0x29,                    /* 41 ) */
 0x2a,0x2a,                    /* 42 * */
 0x2b,0x2b,                    /* 43 + */
 0x2c,0x2c,                    /* 44 , */
 0x2d,0x2d,                    /* 45 - */
 0x2e,0x2e,                    /* 46 . */
 0x2f,0x2f,                    /* 47 / */
 0x30,0x30,                    /* 48 0 */
 0x31,0x31,                    /* 49 1 */
 0x32,0x32,                    /* 50 2 */
 0x33,0x33,                    /* 51 3 */
 0x34,0x34,                    /* 52 4 */
 0x35,0x35,                    /* 53 5 */
 0x36,0x36,                    /* 54 6 */
 0x37,0x37,                    /* 55 7 */
 0x38,0x38,                    /* 56 8 */
 0x39,0x39,                    /* 57 9 */
 0x3a,0x3a,                    /* 58 : */
 0x3b,0x3b,                    /* 59 ; */
 0x3c,0x3c,                    /* 60 < */
 0x3d,0x3d,                    /* 61 = */
 0x3e,0x3e,                    /* 62 > */
 0x3f,0x3f,                    /* 63 ? */
 0x40,0x40,                    /* 64 @ */
 0x41,0x41,                    /* 65 A */
 0x42,0x42,                    /* 66 B */
 0x43,0x43,                    /* 67 C */
 0x44,0x44,                    /* 68 D */
 0x45,0x45,                    /* 69 E */
 0x46,0x46,                    /* 70 F */
 0x47,0x47,                    /* 71 G */
 0x48,0x48,                    /* 72 H */
 0x49,0x49,                    /* 73 I */
 0x4a,0x4a,                    /* 74 J */
 0x4b,0x4b,                    /* 75 K */
 0x4c,0x4c,                    /* 76 L */
 0x4d,0x4d,                    /* 77 M */
 0x4e,0x4e,                    /* 78 N */
 0x4f,0x4f,                    /* 79 O */
 0x50,0x50,                    /* 80 P */
 0x51,0x51,                    /* 81 Q */
 0x52,0x52,                    /* 82 R */
 0x53,0x53,                    /* 83 S */
 0x54,0x54,                    /* 84 T */
 0x55,0x55,                    /* 85 U */
 0x56,0x56,                    /* 86 V */
 0x57,0x57,                    /* 87 W */
 0x58,0x58,                    /* 88 X */
 0x59,0x59,                    /* 89 Y */
 0x5a,0x5a,                    /* 90 Z */
 0x5b,0x5b,                    /* 91 [ */
 0x5c,0x5c,                    /* 92 \ */
 0x5d,0x5d,                    /* 93 ] */
 0x5e,0x5e,                    /* 94 ^ */
 0x5f,0x5f,                    /* 95 _ */
 0x60,0x60,                    /* 96 ` */
 0x61,0x61,                    /* 97 a */
 0x62,0x62,                    /* 98 b */
 0x63,0x63,                    /* 99 c */
 0x64,0x64,                    /* 100 d */
 0x65,0x65,                    /* 101 e */
 0x66,0x66,                    /* 102 f */
 0x67,0x67,                    /* 103 g */
 0x68,0x68,                    /* 104 h */
 0x69,0x69,                    /* 105 i */
 0x6a,0x6a,                    /* 106 j */
 0x6b,0x6b,                    /* 107 k */
 0x6c,0x6c,                    /* 108 l */
 0x6d,0x6d,                    /* 109 m */
 0x6e,0x6e,                    /* 110 n */
 0x6f,0x6f,                    /* 111 o */
 0x70,0x70,                    /* 112 p */
 0x71,0x71,                    /* 113 q */
 0x72,0x72,                    /* 114 r */
 0x73,0x73,                    /* 115 s */
 0x74,0x74,                    /* 116 t */
 0x75,0x75,                    /* 117 u */
 0x76,0x76,                    /* 118 v */
 0x77,0x77,                    /* 119 w */
 0x78,0x78,                    /* 120 x */
 0x79,0x79,                    /* 121 y */
 0x7a,0x7a,                    /* 122 z */
 0x7b,0x7b,                    /* 123 { */
 0x7c,0x7c,                    /* 124 | */
 0x7d,0x7d,                    /* 125 } */
 0x7e,0x7e,                    /* 126 ~ */
 0x7f,0x7f,                    /* 127  */
 0xa0,0xa0,                    /* 160  */
 0xa1,0xa1,                    /* 161  */
 0xa2,0xa2,                    /* 162  */
 0xa3,0xa3,                    /* 163  */
 0xa4,0xa4,                    /* 164  */
 0xa5,0xa5,                    /* 165  */
 0xa6,0xa6,                    /* 166  */
 0xa7,0xa7,                    /* 167  */
 0xa8,0xa8,                    /* 168  */
 0xa9,0xa9,                    /* 169  */
 0xaa,0xaa,                    /* 170  */
 0xab,0xab,                    /* 171  */
 0xac,0xac,                    /* 172  */
 0xad,0xad,                    /* 173  */
 0xae,0xae,                    /* 174  */
 0xaf,0xaf,                    /* 175  */
 0xb0,0xb0,                    /* 176  */
 0xb1,0xb1,                    /* 177  */
 0xb2,0xb2,                    /* 178  */
 0xb3,0xb3,                    /* 179  */
 0xb4,0xb4,                    /* 180  */
 0xb5,0xb5,                    /* 181  */
 0xb6,0xb6,                    /* 182  */
 0xb7,0xb7,                    /* 183 + */
 0xb8,0xb8,                    /* 184 + */
 0xb9,0xb9,                    /* 185  */
 0xba,0xba,                    /* 186  */
 0xbb,0xbb,                    /* 187 + */
 0xbc,0xbc,                    /* 188 + */
 0xbd,0xbd,                    /* 189 + */
 0xbe,0xbe,                    /* 190 + */
 0xbf,0xbf,                    /* 191 + */
 0xc0,0xc0,                    /* 192 + */
 0xc1,0xc1,                    /* 193 - */
 0xc2,0xc2,                    /* 194 - */
 0xc3,0xc3,                    /* 195 + */
 0xc4,0xc4,                    /* 196 - */
 0xc5,0xc5,                    /* 197 + */
 0xc6,0xc6,                    /* 198  */
 0xc7,0xc7,                    /* 199  */
 0xc8,0xc8,                    /* 200 + */
 0xc9,0xc9,                    /* 201 + */
 0xca,0xca,                    /* 202 - */
 0xcb,0xcb,                    /* 203 - */
 0xcc,0xcc,                    /* 204  */
 0xcd,0xcd,                    /* 205 - */
 0xce,0xce,                    /* 206 + */
 0xcf,0xcf,                    /* 207 - */
 0xd0,0xd0,                    /* 208 - */
 0xd1,0xd1,                    /* 209 - */
 0xd2,0xd2,                    /* 210 - */
 0xd3,0xd3,                    /* 211 + */
 0xd4,0xd4,                    /* 212 + */
 0xd5,0xd5,                    /* 213 + */
 0xd6,0xd6,                    /* 214 + */
 0xd7,0xd7,                    /* 215 + */
 0xd8,0xd8,                    /* 216 + */
 0xd9,0xd9,                    /* 217 + */
 0xda,0xda,                    /* 218 + */
 0xdb,0xdb,                    /* 219  */
 0xdc,0xdc,                    /* 220 _ */
 0xdd,0xdd,                    /* 221  */
 0xde,0xde,                    /* 222  */
 0xdf,0xdf,                    /* 223  */
 0xe0,0xe0,                    /* 224 a */
 0xe1,0xe1,                    /* 225  */
 0xe2,0xe2,                    /* 226 G */
 0xe3,0xe3,                    /* 227 p */
 0xe4,0xe4,                    /* 228 S */
 0xe5,0xe5,                    /* 229 s */
 0xe6,0xe6,                    /* 230  */
 0xe7,0xe7,                    /* 231 t */
 0xe8,0xe8,                    /* 232 F */
 0xe9,0xe9,                    /* 233 T */
 0xea,0xea,                    /* 234 O */
 0xeb,0xeb,                    /* 235 d */
 0xec,0xec,                    /* 236 8 */
 0xed,0xed,                    /* 237 f */
 0xee,0xee,                    /* 238 e */
 0xef,0xef,                    /* 239 n */
 0xf0,0xf0,                    /* 240 = */
 0xf1,0xf1,                    /* 241  */
 0xf2,0xf2,                    /* 242 = */
 0xf3,0xf3,                    /* 243 = */
 0xf4,0xf4,                    /* 244 ( */
 0xf5,0xf5,                    /* 245 ) */
 0xf6,0xf6,                    /* 246  */
 0xf7,0xf7,                    /* 247  */
 0xf8,0xf8,                    /* 248  */
 0xf9,0xf9,                    /* 249  */
 0xfa,0xfa,                    /* 250  */
 0xfb,0xfb,                    /* 251 v */
 0xfc,0xfc,                    /* 252 n */
 0xfd,0xfd,                    /* 253  */
 0xfe,0xfe,                    /* 254  */
 0xff,0xff,                    /* 255  */
 0x9a,0x152,                    /* 338 R */
 0x9b,0x153,                    /* 339 S */
 0x81,0x174,                    /* 372 t */
 0x82,0x175,                    /* 373 u */
 0x85,0x176,                    /* 374 v */
 0x86,0x177,                    /* 375 w */
 0x97,0x2013,                    /* 8211 ? */
 0x98,0x2014,                    /* 8212  */
 0x90,0x2018,                    /* 8216 ? */
 0x91,0x2019,                    /* 8217 ? */
 0x94,0x201c,                    /* 8220 ? */
 0x95,0x201d,                    /* 8221 ? */
 0x96,0x201e,                    /* 8222 ? */
 0x9c,0x2020,                    /* 8224   */
 0x9d,0x2021,                    /* 8225 ! */
 0x8f,0x2022,                    /* 8226 " */
 0x8c,0x2026,                    /* 8230 & */
 0x8e,0x2030,                    /* 8240 0 */
 0x92,0x2039,                    /* 8249 9 */
 0x93,0x203a,                    /* 8250 : */
 0x80,0x20ac,                    /* 8364  */
 0x8d,0x2122,                    /* 8482 " */
 0x99,0x2212,                    /* 8722 ? */
 0x9e,0xfb01,                    /* 64257 ? */
 0x9f,0xfb02,                    /* 64258 ? */
#ifdef NEVER
 0x8b,0xfffd,                    /* 65533  */
 0x8a,0xfffd,                    /* 65533  */
 0x89,0xfffd,                    /* 65533  */
 0x88,0xfffd,                    /* 65533  */
 0x87,0xfffd,                    /* 65533  */
 0x84,0xfffd,                    /* 65533  */
#endif
 0x83,0xfffd,                    /* 65533  */

};




static pairstr code16invshorttab[]=
{
 0x9a,0x152,                    /* 338 R */
 0x9b,0x153,                    /* 339 S */
 0x81,0x174,                    /* 372 t */
 0x82,0x175,                    /* 373 u */
 0x85,0x176,                    /* 374 v */
 0x86,0x177,                    /* 375 w */
 0x97,0x2013,                    /* 8211 ? */
 0x98,0x2014,                    /* 8212  */
 0x90,0x2018,                    /* 8216 ? */
 0x91,0x2019,                    /* 8217 ? */
 0x94,0x201c,                    /* 8220 ? */
 0x95,0x201d,                    /* 8221 ? */
 0x96,0x201e,                    /* 8222 ? */
 0x9c,0x2020,                    /* 8224   */
 0x9d,0x2021,                    /* 8225 ! */
 0x8f,0x2022,                    /* 8226 " */
 0x8c,0x2026,                    /* 8230 & */
 0x8e,0x2030,                    /* 8240 0 */
 0x92,0x2039,                    /* 8249 9 */
 0x93,0x203a,                    /* 8250 : */
 0x80,0x20ac,                    /* 8364  */
 0x8d,0x2122,                    /* 8482 " */
 0x99,0x2212,                    /* 8722 ? */
 0x9e,0xfb01,                    /* 64257 ? */
 0x9f,0xfb02,                    /* 64258 ? */
#ifdef NEVER
 0x8b,0xfffd,                    /* 65533  */
 0x8a,0xfffd,                    /* 65533  */
 0x89,0xfffd,                    /* 65533  */
 0x88,0xfffd,                    /* 65533  */
 0x87,0xfffd,                    /* 65533  */
 0x84,0xfffd,                    /* 65533  */
#endif
 0x83,0xfffd,                    /* 65533  */


};



static int paircmp(const void * p1,const void * p2)
{
 return(((pairstr*)p1)->unicode-((pairstr*)p2)->unicode);
}



// return RISC OS code
// nb this is unicode in, and RISC OS *if* it exists out,
// you can't feed in something like 0x80 (Euro) and get 0x80 out

int code16inv(int unicode)
{
 pairstr   pair;
 pairstr * p;

	if(unicode<128) return(unicode);
	if(unicode<160) return(-1);
	if(unicode<256) return(unicode);

 pair.unicode=unicode;

 p=(pairstr*)bsearch(&pair,code16invshorttab,sizeof(code16invshorttab)/sizeof(pairstr),sizeof(pairstr),paircmp);

 if(p) return(p->riscos);
 return(-1);
}





int code16winindex(int unicode)
{
	int i;


	if(unicode<256) return(unicode);

	for(i=128;i<160;i++)
	{
		if(font_code16wintab[i]==unicode) return(i);
	}

 return(-1);
}


// return win8

int code16winindexcharset(int unicode,int charset)
{
	int win8;

	if(unicode<256) return(unicode);

	for(win8=32;win8<256;win8++)
	{
		if(font_code16win(win8,charset)==unicode) return(win8);
	}

 return(-1);
}



// return unicode

int code16(int riscos8)
{
	if(riscos8>=0 && riscos8<256) return(code16tab[riscos8]);
	else																										return(riscos8);
}


// return unicode

int code16win(int win8)
{
 if(win8<256 && win8>=0) return(font_code16wintab[win8]);
	return(-1);
}


// return unicode

int code16wincharset(int win8,int charset)
{
 return(font_code16win(win8,charset));
}



int code8(int riscos8)
{
	if(riscos8<256 && riscos8>=0) return(code8tab[riscos8]);
	return(-1);
}


int altcode8(int riscos8)
{
 if(riscos8<256 && riscos8>=0) return(altcode8tab[riscos8]);
	return(-1);
}


int code8inv(int win8)
{
 if(win8<256 && win8>=0) return(code8invtab[win8]);
	return(-1);
}



int code8symbolinv(int win8)
{
 if(win8<256 && win8>=0) return(code8symbolinvtab[win8]);
	return(-1);
}



int code16symbolinv(int win16)
{
 int win8;

 win8=code16winindex(win16);
	if(win8<256 && win8>=0) return(code8symbolinvtab[win8]);
	return(-1);
}



int code8symbol(int riscos8)
{
 if(riscos8<256 && riscos8>=0) return(code8symboltab[riscos8]);
	return(-1);
}




// can return <0 

int code16symbol(int riscos8)
{
 int win8;

 if(riscos8<256 && riscos8>=0)
 {
  win8=code8symboltab[riscos8];

 	if(win8<256 && win8>=0) return(font_code16wintab[win8]);
	}

	return(-1);
}





int codefn(int c)
{
 return(codex[c]);
}


int spaceisdelim(char * p)
{
 int fspace;

 fspace=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
 return((fspace & SPACESEQDL)!=0);
}


os_error * txunccheck(filestr * file)
{
	if(file->compatability<UNICOMPAT) return(geterror(EUNC));
	return(NULL);
}


os_error * txunccheckstring(unsigned short * p,filestr * file)
{
	int c;

	if(file->compatability<UNICOMPAT)
 {
		while((c=*p++)!=0)
		{
			if(c>255) return(geterror(EUNC));
		}
	}
	return(NULL);
}




os_error *	txstring21(unsigned short * s,char * d,int maxlen,int * len)
{
	int    c16;
	char * lt;

	lt=d+(maxlen-1);

	while((c16=*s++)!=0)
	{
		if(c16>256)
		{
			if(d>(lt-3)) break;
			*d++=UNC16;
			*d++=(char)(c16 & 0xFF);
			*d++=(char)((c16>>8)&0xFF);
		}
		else
		{
			if(d>lt) break;
			*d++=(char)c16;
		}
	}

	*d++=0;
	if(len) *len=(d-(lt-(maxlen-1)));

	return(NULL);
}




os_error *	txstring12(char * s,int maxin,unsigned short * d,int maxlen,int * len)
{
	int              c;
	unsigned short * lt;
	char           * ltin;

	lt=d+(maxlen-1);
	ltin=s+maxin;

	while(s<ltin && (c=*s++)!=0)
	{
		if(c==UNC16)
		{
			c=(*s)+((*(s+1))<<8);
			s+=2;
		}

		if(d>=lt) break;
		*d++=(unsigned short)c;
	}

	*d++=0;

	if(len) *len=(d-(lt-(maxlen-1)));

	return(NULL);
}





int riscos_isupper(int c)
{
 if(c==0x81 || c==0x85 || c==0x9A) return(1);
 if(c==0x82 || c==0x86 || c==0x9B) return(0);

 return(isupper(c));
}


int riscos_islower(int c)
{
 if(c==0x81 || c==0x85 || c==0x9A) return(0);
 if(c==0x82 || c==0x86 || c==0x9B) return(1);

 return(isupper(c));
}


int riscos_isalpha(int c)
{
 if(c==0x81 || c==0x85 || c==0x9A) return(1);
 if(c==0x82 || c==0x86 || c==0x9B) return(1);


 return(isalpha(c));
}

int riscos_isalnum(int c)
{
 if(c==0x81 || c==0x85 || c==0x9A) return(1);
 if(c==0x82 || c==0x86 || c==0x9B) return(1);

 return(isalnum(c));
}



int riscos_toupper(int c)
{

 if(c==0x82) return(0x81);
 if(c==0x86) return(0x85);
 if(c==0x9B) return(0x9A);

 if(c==0x81) return(0x81);
 if(c==0x85) return(0x85);
 if(c==0x9A) return(0x9A);

 return(toupper(c));
}

int riscos_tolower(int c)
{

 if(c==0x82) return(0x82);
 if(c==0x86) return(0x86);
 if(c==0x9B) return(0x9B);

 if(c==0x81) return(0x82);
 if(c==0x85) return(0x86);
 if(c==0x9A) return(0x9B);

 return(tolower(c));
}



void codeinit(void)
{
 xsetcasefns(riscos_toupper,riscos_tolower,riscos_isupper,riscos_islower);

}
