/*->c.dbcolumn */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "etc.h"
#include "trans.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"
#include "dbhi.h"


#include "str.h"
#include "reslink.h"
#include "mhi.h"


#include "units.h"
#include "xcolour.h"


#include "dbcolour.h"
#include "dbscale.h"


#include "txstr.h"
#include "tx.h"


#include "dbcolumn.h"


extern dboxstr      colbox;


static dbcolumnstr    db;
static filestr      * cfile;

static columnclosefn  cfn;


#define COLICON 11


static os_error * colredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,COLICON,
                                vfindcolour2(NULL,cfile,&db.ccol.colour));
  wimp_get_rectangle(redrawstr,&more);
 }
 return(err);
}


static os_error * colredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) colredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void pickclose(colourvalue * colour)
{
 db.ccol.colour=*colour;
 wimp_set_icon_state(colbox.handle,COLICON,
                               (wimp_iconflags)0,(wimp_iconflags)0);
}


static os_error * colicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case  9:
          err=openmenuparent("guidewidth_menu",handle);
          break;

  case 12:
          err=pickcolour(cfile,&db.ccol.colour,pickclose,&colbox);
          break;

 }

 return(err);

 USE(handle);
 USE(userhandle);
}




#define MINGUTTER      MMSIZE
#define MAXGUTTER      288000




os_error * columncheck(int width,int columns,columnstr * ccol
                                                       /*,int * gutterp*/)
{
 os_error * err;
 int        gutter;

 err=NULL;

 if(columns>MAXCOLUMNS) err=geterror(NE00); /* Too many columns */
 else
 if(columns<1)          err=geterror(NE01); /* Too few columns */
 else
 if(columns>1)
 {
  if(ccol->mode)
  {
   if(columns>1) gutter=(width-columns*ccol->width)/(columns-1);
   else          gutter=(width-ccol->width);

   if(gutter<0) err=geterror(NE10); /* column too wide */
  }
  else  gutter=ccol->width;

  if(!err)
  {
   if(gutter*(columns-1)>=width) err=geterror(NE08); /* Gutter too large */
   else
   {
    if(gutter>MAXGUTTER) err=geterror(NE08); /* Gutter too large */
    else
    if(gutter<MINGUTTER) err=geterror(NE09); /* Gutter too small */
   /* else                 *gutterp=gutter; */
   }
  }
 }
 return(err);
}



static os_error * colclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  db.ccol.mode=db.mode;

  if(db.ccol.mode) db.ccol.width=db.columnwidth;
  else             db.ccol.width=db.gutterwidth;

  db.ccol.guidewidth=db.guidewidth;
  db.ccol.guides=db.guides;

  err=columncheck(db.width,db.columns,&db.ccol/*,&db.gutter*/);
  if(!err) cfn(&db);
 }
 return(err);
}



int getguidewidth(int fp)
{
 return(db.guidewidth);
 USE(fp);
}


void setguidewidth(int fp)
{
 db.guidewidth=stack[fp];
 dbchangevalue(&db.guidewidth,&colbox);
 USE(fp);
}



static os_error * coloutu(int value,char * string)
{
 strcpy(string,unitstostring(value,db.units));
 return(NULL);
}

static os_error * colinu(int * value,char * string)
{
 return(stringtounits(string,value,db.units));
}


#ifdef NEVER

static os_error * colout(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}

static os_error * colin(int * value,char * string)
{
 return(stringtonumber(string,value));
 return(NULL);
}

#endif



static os_error * wrthick(int value,char * string)
{
 if(value) return(coloutu(value,string));
 else
 {
  tsprintf(32,string,"{THIN}");
  return(NULL);
 }
}


static os_error * rdthick(int * value,char * string)
{
 os_error * err;
 char       temp[64];

 err=NULL;

 tsprintf(sizeof(temp),temp,"{THIN}");
 if(!cstrcmp(temp,string)) *value=0;
 else                      err=stringtounits(string,value,db.units);

 return(err);
}




static dbiconstr colicondefs[9]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   -   -   clickfn 0 */
    0,  &db.mode,    DBRADIO, 0,    0,      0,  F2,    1,  0,  NULL,   0,
   14,  &db.mode,    DBRADIO, 0,    0,      1,  F3,    1,  0,  NULL,   0,

 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   13, &db.gutterwidth,DBWRITE,0,   0,   -1, -1,  3, -1, colinu, coloutu,
    3, &db.columnwidth,DBWRITE,0,   0,   -1, -1, -1,  1, colinu, coloutu,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL, 0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

    6, &db.guides,    DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,
    8, &db.guidewidth,DBTEXT,0,   0,     0,  0,  0, 0,     rdthick, wrthick,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr colbox=
{
 0,
 TCOLUMN,
 DBFIX,
 0,
 colclose,
 colicon,
 NULL,
 colredraw,
 colicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};


/* script function opens the new document dialogue box */

os_error * docolumn(columnclosefn cfx,dbcolumnstr * c,filestr * file,
                                                          dboxstr * parent)
{
 os_error * err;

 cfile=file;
 db=*c;
 cfn=cfx;

 if(db.ccol.mode)
 {
  if(db.columns>1)
  db.gutterwidth=(db.width-db.columns*db.ccol.width)/(db.columns-1);
  else
  db.gutterwidth=(db.width-db.ccol.width);
  db.gutterwidth=FLOOR(db.gutterwidth,0);
  db.columnwidth=db.ccol.width;
 }
 else
 {
  db.columnwidth=(db.width-(db.columns-1)*db.ccol.width)/db.columns;
  db.gutterwidth=db.ccol.width;
 }

 db.guides=db.ccol.guides;
 db.guidewidth=db.ccol.guidewidth;
 db.mode=db.ccol.mode;

 err=dodboxsp(&colbox,1,parent,&dbviewstack);

 return(err);
}


