/*->c.fcache */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "bbc.h"
#include "akbd.h"
#include "font.h"
#include "colour.h"

#include "transform.h"
#include "poll.h"
#include "key.h"
#include "etc.h"
#include "err.h"
#include "hourglass.h"
#include "bits.h"
#include "fsx.h"
#include "bf.h"
#include "timex.h"
#include "deb.h"
#include "osunits.h"
#include "xmath.h"



#include "str.h"
#include "constants.h"
#include "reslink.h"


#include "xprint.h"


#include "codes.h"

#include "fox.h"


#include "fcache.h"



/*****************************************************************************/
                              /* Font Cache */

#define MAXCACHE 64

static int osxs;
static int osys;
static int vxdpi;
static int vydpi;
static int fontscalechanged;


static int cached;             /* number of fonts we have cached */
static int fontno[MAXCACHE];   /* font name number               */
static int fonth[MAXCACHE];    /* font manager handle            */
static int xpts[MAXCACHE];     /* x points                       */
static int ypts[MAXCACHE];     /* y points                       */
static int angle[MAXCACHE];    /* font angle                     */
static int fprev[MAXCACHE];    /* previous font */
static int fnext[MAXCACHE];    /* next font     */
static int first;              /* number of most recently used font  */
static int last;               /* number of least recently used font */


/* nb all this takes no account of zooming */
/* idea, do tabs by embedding ctrl codes   */



/* ideally want to call this on a time delay, and !inprinter */

os_error * fontcachetrash(void)
{
 int i;


 cprintf("cached %d",cached);

 for(i=0;i<cached;i++)
 {
//  cprintf("xp %d yp %d angle %d",xpts[i],ypts[i],angle[i]);
  font_lose(fonth[i]);
 }
 cached=0;

 return(NULL);
}



static os_error * fontcachemode(wimp_msgstr * msg,int * ack)
{
 USE(ack);
 USE(msg);
// fontcachetrash();
/* dprintf(0,"mode change"); */
 return(NULL);
}


static os_error * eventhandler(int eventn,int userhandle,void * data,int data1)
{
 fontcachetrash();
 return(NULL);
 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}



os_error * fontcacheinit(void)
{
 cached=0;
 addmessage(fontcachemode,wimp_MMODECHANGE);
 addevent(EVENT_ENDPROGRAM,eventhandler,0);

 return(NULL);
}



static void cachezero(int handle)
{
/* dprintf(1,"cached=%d zerotime=%d cachetime=%d",cached,zerotime,cachetime);*/
 if(!inprinter)
 {
 /* dprintf(2,"cache trash"); */
  fontcachetrash();
 }

 USE(handle);
}


void fontsetcachetrap(void)
{
 addscheduledevent(cachezero,0,500);
}


static os_error * loseone(void)
{
 int        fl=last;
 os_error * error;

 error=font_lose(fonth[fl]);

 cached--;
 if(!cached) return(error);

 last=fprev[fl];
 fnext[last]=-1;

 fontno[fl]=fontno[cached];
 fonth[fl]=fonth[cached];  
 xpts[fl]=xpts[cached];
 ypts[fl]=ypts[cached]; 
 angle[fl]=angle[cached];
 fprev[fl]=fprev[cached];
 if(fprev[fl]!=-1) fnext[fprev[fl]]=fl;
 fnext[fl]=fnext[cached];
 if(fnext[fl]!=-1) fprev[fnext[fl]]=fl;

 if(last==cached) last=fl;
 if(first==cached) first=fl;

 return(error);
}


static os_error * addtocache(int osfont,int fxpts,int fypts,int fangle,int * fp)
{
 os_error * err;
 int        fh;
 int        ffxpts;
 int        ffypts;
 char     * p;



 ffxpts=fxpts;
 ffypts=fypts;

//	if(ffypts==0) cprintf("****** ffypts==0");


 if(ffxpts==ffypts || fxpts==0)
 {
  ffxpts=0;
 }
 else
 {
  err=fontreadfontdata(osfont);  // calls validfont and hence addtocache
  ffxpts=scale(fontaveragewidth(osfont),ffxpts,fontdesignsize(osfont));
//  cprintf("osf %d av %d fx %d fin %d des %d",osfont,fontsos[osfont].averagewidth,
//          ffxpts,fxpts,fontsos[osfont].designsize);
 }

 if(cached>=MAXCACHE) err=loseone();
 else                 err=NULL;

 if(!err)
 {
  p=fontosname(osfont);

		if(ISW9X)
		{
   err=font_find4(p,fontcharset(osfont),0,fontitalic(osfont),
                    fontfamily(osfont),fontpitch(osfont),ffxpts,ffypts,fangle,&fh);
		}
		else
		{
   err=font_find4(p,fontcharset(osfont),fontweight(osfont),fontitalic(osfont),
                    fontfamily(osfont),fontpitch(osfont),ffxpts,ffypts,fangle,&fh);
		}

//  cprintf("font %s charset %d",p,fonts[font].charset);

  if(err) /* || err->errnum==0x20D) no more font handles */
  {
   if(cached)
   {
    err=loseone();

    if(ISW9X)
    {
     // because of the thing with bold weight fonts losing unicode glyphs if opened with their defined weight on W98

     err=font_find4(p,fontcharset(osfont),0,fontitalic(osfont),
                      fontfamily(osfont),fontpitch(osfont),ffxpts,ffypts,fangle,&fh);
    }
    else
    {
     err=font_find4(p,fontcharset(osfont),fontweight(osfont),fontitalic(osfont),
                      fontfamily(osfont),fontpitch(osfont),ffxpts,ffypts,fangle,&fh);
    }
   }
/* else
   {
    err=geterror(FOXNOF);
   } */
  }

  if(!err)
  {
   fonth[cached]=fh;
   fontno[cached]=osfont;
   xpts[cached]=fxpts;
   ypts[cached]=fypts;
   angle[cached]=fangle;

   cached++;

   fh=cached-1;

   if(cached>1)     /* there is something in the cache */
   {
    fprev[first]=fh;
    fnext[fh]=first;
    fprev[fh]=-1;
    first=fh;
   }
   else
   {                /* cache was empty */
    first=last=fh;
    fprev[fh]=-1;
    fnext[fh]=-1;
   }

   *fp=fonth[fh];
   return(NULL);
  }
 }
 return(err);
}



/* see if this font is in the cache and if not cache it */ 
/* return the font manager handle for the font */

os_error * validfont(int osfont,int fxpts,int fypts,int fangle,int * fh,int * fchange)
{
 int i;
 int next;
 int prev;

 static int flagged=0;

 if(osfont>=fontostotal() || osfont<0)
 {
  if(!flagged) 
  {
   flagged=1;
   return(geterror(FOXBAD));
  }
  osfont=0;
 }


 for(i=0;i<cached;i++)
 {
  if(
     osfont==fontno[i] &&
     fxpts==xpts[i]   &&
     fypts==ypts[i]   &&
     fangle==angle[i]
    )
  {
   prev=fprev[i];
   if(prev!=-1)
   {
    next=fnext[i];
    if(next!=-1)
    {
     fnext[prev]=next;
     fprev[next]=prev;
    }
    else
    {
     last=prev;
     fnext[prev]=-1;
    }
    fnext[i]=first;
    fprev[first]=i;
    fprev[i]=-1;
    first=i;
   }
   *fh=fonth[i];
   return(NULL);
  }
 }

 /* add font to cache */

 if(fchange) *fchange=1;

 return(addtocache(osfont,fxpts,fypts,fangle,fh));
}


/*****************************************************************************/

