/*->c.fl2 */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"


#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "bits.h"
#include "deb.h"
#include "etc.h"

#include "constants.h"
#include "str.h"

#include "object.h"

#include "geometry.h"
#include "view.h"
#include "viewr.h"
#include "file.h"
#include "xredraw.h"
#include "curve.h"
#include "posn.h"
#include "chain.h"
#include "new.h"
#include "xcolour.h"


#include "txstr.h"
#include "tx.h"
#include "text.h"
#include "codes.h"
#include "vl.h"
#include "fx.h"
#include "vec.h"
#include "tabs.h"
#include "hp.h"
#include "style.h"
#include "act.h"
#include "fox.h"

#include "fl.h"

#include "fl2.h"







os_error * flowvalidate(vector * v,int extent)
{
 flowdatastr * fldp;
 int           fld;
 int           over;
 int           offset;


 if(flentered) return(NULL);

 switch(extent)
 {
      case FLVBOX:
                  /* we've set up on box, got its offset               */
                  /* vector is locked                                  */
                  /* as a result of this operation, offsets may change */
                  /* but box and sources will not                      */

                  /* dprintf(5,"FLVBOX"); */

                  fld=v->textsrc.vsourcep->fldstack;
                  if(fld)
                  {
                   fldp=(flowdatastr*)fob_find(fld,v->file);

                   /* dprintf(5,"fldp"); */

                   if(fldp->fv.textsrc.offset<=v->textsrc.offset)
                   {
                    over=0;
                    while(!over && fld)
                    {
                     fldp=(flowdatastr*)fob_find(fld,v->file);
                     if(fldp->fv.textsrc.text==v->textsrc.text)
                     {
                      v->textsrc.offset=v->textsrc.loffset=
                      v->boffset=fldp->fv.boffset;

                      if(v->textsrc.offset==0) v->textsrc.offset=SNLEN;

                      v->textsrc.voffset=v->bvoffset=fldp->fv.bvoffset;
                      over=1;
                     }
                     flv.file=v->file;
                     flowcont(fld);
                     fld=v->textsrc.vsourcep->fldstack;
                    }
                   }
                  }
                  break;

  case FLVNEXTBOX:
                  /* set up a locked vector on a valid box */

                  fld=v->textsrc.vsourcep->fldstack;
                  if(fld)
                  {
                   fldp=(flowdatastr*)fob_find(fld,v->file);
                   if(fldp->fv.textsrc.text==v->textsrc.text)
                   {
                    flowcont(fld);

                    fld=v->textsrc.vsourcep->fldstack;
                    if(fld) fldp=(flowdatastr*)fob_find(fld,v->file);
                   }

                   if(fld && fldp->fv.textsrc.text==
                                          v->textsrc.textp->fchain.next)
                   {
                    flowcont(fld);
                   }
                  }
                  break;


  case FLVLEXTENT:
                  fld=v->textsrc.vsourcep->fldstack;
                  if(fld)
                  {
                   fldp=(flowdatastr*)fob_find(fld,v->file);
                   offset=v->textsrc.voffset+sizeof(vlstr);

                   while(fld && fldp->fv.textsrc.voffset<=offset)
                   {
                    flv.file=v->file;
                    flowcont(fld);
                    fld=v->textsrc.vsourcep->fldstack;
                    if(fld)
                    {
                     fldp=(flowdatastr*)fob_find(fld,v->file);
                    }
                   }
                  }
                  break;
 }

 return(NULL);
}



os_error * flowvalidbox(int text,filestr * file)
{
 textboxstr  * textp;
 int           header;
 int           footer;
 int           vsource[3];
 int           usize;
 vsourcestr  * vsourcep;
 flowdatastr * fldp;
 int           fld;
 int           vtext;
 int           fprev;
 int           seen;
 texsrc      * texsp;
 int           i;


 if(flentered) return(NULL);

// cprintf("valid enter %d",text);

 /* because pages are auto uncatted we may end up being called */
 /* on a box that no longer exists */

 textp=(textboxstr*)fob_find(text,file);
 if(textp && textp->type==OTEXTBOX)
 {
  header=textp->data.header;
  footer=textp->data.footer;

  if(header || footer) usize=3;
  else                 usize=1;

  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

  for(i=0;i<usize;i++)
  {
   vsource[i]=texsp->vsource;
   texsp++;
  }

  for(i=0;i<3;i++)
  {
   if(i==0 || (i==1 && header) || (i==2 && footer))
   {
    vsourcep=(vsourcestr*)fob_find(vsource[i],file);
    fld=vsourcep->fldstack;
    if(fld)
    {
     fldp=(flowdatastr*)fob_find(fld,file);
     vtext=fldp->fv.textsrc.text;

     /* question is vtext>text in flow chain? */

     fprev=text;
  
     while(fprev!=vtext && fprev && i==0)
     {
      textp=(textboxstr*)fob_find(fprev,file);
      fprev=textp->fchain.prev;
     }

     if(vtext==fprev)
     {
      seen=(vtext==text);

      while(1)
      {
       flv.file=file;
       flowcont(fld);

       vsourcep=(vsourcestr*)fob_find(vsource[i],file);
       if(!vsourcep) break;

       fld=vsourcep->fldstack;
       if(!fld) break;

       fldp=(flowdatastr*)fob_find(fld,file);
       if(fldp->fv.textsrc.text==text) seen=1;
       else
       if(seen) break;
      }
     }
    }
   }
  }
 }


// cprintf("valid exit %d",text);

 return(NULL);
}



os_error * flowvalidsection(int section,filestr * file)
{
 os_error   * err;
 int          ns;
 int          branch;
 sectionstr * sectionp;

 err=NULL;

/* dprintf(0,"flowvalidsection"); */


 if(flentered) return(NULL);

 if(file->hdr.flowsection)
 {
  sectionp=(sectionstr*)fob_find(section,file);
  ns=sectionp->data.number;
  branch=sectionp->branch;

  if(sectionp->flows)
  {
   while(1)
   {
    if(!file->hdr.flowsection) break;
    sectionp=(sectionstr*)fob_find(file->hdr.flowsection,file);
    if(!branch && sectionp->branch) break;
    if(sectionp->data.number>ns) break;

    if(flv.file!=file) 
    {
     fldkey=0;
     flv.file=file;
    }

    if(!fldkey)
    {
     sectionp=(sectionstr*)fob_find(flv.file->hdr.flowsection,file);
     fldkey=sectionp->flows;
    }

    flowcont(fldkey);
   }
  }
 }

 return(err);
}




os_error * flowvalidfile(filestr * file)
{
 sectionstr  * sectionp;

 if(flentered) return(NULL);

 while(1)
 {
  if(!file->hdr.flowsection) break;
  sectionp=(sectionstr*)fob_find(file->hdr.flowsection,file);

  if(flv.file!=file) 
  {
   fldkey=0;
   flv.file=file;
  }

  if(!fldkey)
  {
   sectionp=(sectionstr*)fob_find(flv.file->hdr.flowsection,file);
   fldkey=sectionp->flows;
  }

  flowcont(fldkey);
 }

 return(NULL);
}



/* gives lowest unflowed point on locked vector */

/*
os_error * flowvalidoffset(vector * v,int * offset)
{


 USE(v);
 USE(offset);

 return(NULL);
}
*/

int flvalidsource;

void flowvalidatesource(int source)
{
 flvalidsource=source;
}


os_error * flowvalidlimit(filestr * file,int source,vsourcestr * vsourcep,
                                                              int * vlimitp)
{
 os_error    * err;
 int           flstack;
 flowdatastr * fldp;
 int           vlimit;

 err=NULL;

 vlimit=vsourcep->len;

 if(flvalidsource!=source)
 {
  if(flv.valid && flv.file==file && flv.textsrc.source==source)
  {
   vlimit=flv.textsrc.voffset;
  }
  else
  if((flstack=vsourcep->fldstack)!=0)
  {
   fldp=(flowdatastr*)fob_find(flstack,file);
   vlimit=fldp->fv.textsrc.voffset;
  }
 }

 *vlimitp=vlimit;

 return(err);
}




/* create vboxes for everything and then reflow them */

os_error * textvbreflow(filestr * file)
{
 int message;

 message=OM_REFLOW2;
 broadcastmessage(file,&message,(void*)(FLNONE|TXREFLOWVBOX));
 message=OM_REFLOW2;
 return(broadcastmessage(file,&message,(void*)FLDELTA));
}



os_error * reflowfile(filestr * file)
{
 int message;
 message=OM_REFLOW2;
 return(broadcastmessage(file,&message,(void*)FLDIRTY));
}



/**************************************************************************/

#define FPFSECT  0x1
#define FPFPAGE  0x2

static os_error * pageflow(vector * v,int bytes,filestr * file)
{
 os_error * err;
 int        bits;
 char     * p;
 int        c;
 int        limit;
 flowstr    fl;


/* dprintf(0,"pageflow %d",bytes);*/

 err=txlock(&v->textsrc,file);
 if(!err)
 {
  if(bytes>=0) limit=v->textsrc.offset+bytes;
  else         limit=0x7FFFFFFF;

  while(1)
  {
   p=txptr(v->textsrc.sourcep,v->textsrc.offset);
   c=*p;
   bits=codex[c];

   if(c==PAGENO)
   {
    resetpoint(v,v->textsrc.offset);

    fl.opcode=FWAIT|FDATA;

    fl.data.type=FLDIRTY;
    fl.data.offset=v->textsrc.offset;
    fl.data.delta=0;
    fl.data.length=1;

    flow(v,&fl);
   }
   else
   if(c==EOT) break;

   v->textsrc.offset+=bits & CODELEN;
   if(v->textsrc.offset>limit) break;
  }

  txunlock(&v->textsrc,file);
 }

 return(err);
}



os_error * pagereflowmessage(textboxstr * textp,int data,filestr * file)
{
 int    dochain;
 int    dobox;
 int    doheader;
 int    dofooter;
 int    text;
 int    bytes;
 vector v;

 dochain=(data==FPFSECT && !textp->fchain.prev);
 dobox=(data!=FPFSECT);

 doheader=textp->data.header;
 dofooter=textp->data.footer;
 bytes=-1;

 if(dochain || dobox || doheader || dofooter)
 {
  text=textp->key;

  if(dobox) boxcontents(textp,0,&bytes,NULL);

  if(doheader)
  {
   setvectorfrombox(&v,1,text,file);
   pageflow(&v,-1,file);
  }

  if(dofooter)
  {
   setvectorfrombox(&v,2,text,file);
   pageflow(&v,-1,file);
  }

  if(dochain || (dobox && bytes))
  {
   setvectorfrombox(&v,0,text,file);
   pageflow(&v,bytes,file);
  }
 }

 return(NULL);
}



os_error * pagereflowpage(int page,filestr * file)
{
 pagestr * pagep;
 int       message;

 message=OM_PAGENOREFLOW;

 pagep=(pagestr*)fob_find(page,file);

 return(objectchainmessage(pagep->chain.child,file,&message,(void*)FPFPAGE));
}



os_error * pagereflowsectionplus(int page,filestr * file)
{
 os_error * err;
 pagestr  * pagep;
 int        message;

 err=NULL;

 while(page)
 {
  message=OM_PAGENOREFLOW;
  pagep=(pagestr*)fob_find(page,file);
  page=pagep->chain.next;
  err=objectchainmessage(pagep->chain.child,file,&message,(void*)FPFPAGE);
  if(err) break;
 }

 return(err);
}




os_error * pagereflowsection(int section,filestr * file)
{
 sectionstr * sectionp;
 int          message;

 message=OM_PAGENOREFLOW;

 sectionp=(sectionstr*)fob_find(section,file);

 return(objectchainmessage(sectionp->chain.child,file,&message,(void*)FPFSECT));
}







/****************************************************************************/


os_error * flsourcechange(textsrcstr * textsrc,filestr * file,int n)
{
 flowdatastr * fldstack;
 int           fldkey;
 int           i;

 if(textsrc->vsourcep && (fldkey=(textsrc->vsourcep)->fldstack)!=0)
 {
  fldstack=(flowdatastr*)fob_find(fldkey,file);

  i=fldstack->sp-1;

  if(n>0)
  {
   while(i>=0)
   {
    if(fldstack->data[i].offset>=textsrc->offset)
    {
     fldstack->data[i].offset+=n;

   /*  dprintf(0,"inc by %d at %d %d",n,fldstack->data[i].offset,textsrc->offset);     dprintf(1,"state=%d delta=%d",fldstack->data[i].type,
                                   fldstack->data[i].delta); */

    }
    i--;
   }
  }
  else
  {
   while(i>=0)
   {
    if(fldstack->data[i].offset>textsrc->offset) 
    {
     fldstack->data[i].offset+=n;
     if(fldstack->data[i].offset<textsrc->offset) 
                                fldstack->data[i].offset=textsrc->offset;
    }
    i--;
   }
  }
 }

 return(NULL);
}

