/*->c.hp     */

/* Ovation!   (c) D. J. Pilling,  December 1988                     */
/*                        Hyphenator                                */




#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "os.h"
#include "wimp.h"
#include "wimpt.h"


#include "transform.h"

#include "etc.h"
#include "err.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "wos.h"



#include "constants.h"
#include "str.h"
#include "reslink.h"

#include "obj.h"

#include "txstr.h"
#include "codes.h"
#include "tx.h"
#include "spell.h"

#include "hp.h"




#define MAXHPLEN 128
#define MAXBRKS  16



typedef struct
{
 char name[32];
 char  mark[8];
 char copy[64];
 char stuff[152];
} hheader;



typedef struct Ovnbuffer
{
  struct Ovnbuffer ** anchor;  /* this points at the anchor in the source   */
  int     len;               /* amount of stuff in buffer */
  int     maxlen;            /* maximum length of buffer  */
  int     previous;          /* offset of previous buffer */
  int     goffset;           /* offset of gap in buffer   */
  char    buff[4];           /* character buffer          */
} Ovnbuffer;



static char  *  codes;
static char  *  trie;
       int      hyphens[MAXBRKS];



static os_error * loadbuffer(flex_ptr anchor,fshandle fh)
{
 os_error * err;
 Ovnbuffer  temp;
 int        blen;

 err=fs_read(fh,&temp,sizeof(Ovnbuffer)-4);
 if(!err)
 {
  blen=temp.len-sizeof(Ovnbuffer)+4;
  err=flex_alloc(anchor,blen);
  if(!err) err=fs_read(fh,*anchor,blen);
 }

 return(err);
}




static os_error * loadhyphdata(void)
{
 os_error * err;
 fshandle   fh;
 hheader    hh;

 err=fs_open("<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\UK\\HyphData.dat",'r',&fh);
 if(!err && fh)
 {
           err=fs_read(fh,&hh,sizeof(hheader));
  if(!err) err=loadbuffer((flex_ptr)&trie,fh);
  if(!err) err=loadbuffer((flex_ptr)&codes,fh);

  err=fs_close(fh,err);
 }
 else err=geterror(ERRNOHYP);

 return(err);
}



os_error * inithp(void)
{
 os_error * err;

 err=loadhyphdata();
 /* inithpdc(); */

 return(err);
}




/************************************************************************/




static void autohyphenate(char * string,int * n,int * brks)
{
 char word[MAXHPLEN];
 char data[MAXHPLEN];
 int  i;
 int  j;
 int  q;
 int  len=0;
 int  cchar;
 int  codeoff=0;  /* compiler */
 int  code;
 int  next;
 int  skip;
 int  val;
 int  first;
 int  term;
 char * tree=trie;
 char * codebuff=codes;



 word[0]='{'-'a';

 i=1;

 while(*string)
 {
  word[i++]=(char)(*string++-'a');
  len++;
 }

 word[i++]='{'-'a';
 word[i]=0;

 len+=2;

 memset(data,0,len+1);

 for(i=0;i<(len-1);i++)
 {
  /* scan trie for each sub word */

  q=0;
  j=i;

  while(1)
  {
   cchar=tree[q++];

   next=tree[q++];
   if((next & 0x74)==0x74)
   {
    term=next & 0x80;
    next&=~0xF4;
    next=next<<16;
    next+=(tree[q++])<<8;
    next+=tree[q++];
    if(term)
    {
     codeoff=tree[q++];
     codeoff+=(cchar & 0x60)<<3;
    }
   }
   else
   if((next & 0xF8)==0xF8)
   {
    term=1;
    next=next<<8;
    next+=tree[q++];
    codeoff=next & 0x03FF;
    next=-1;
   }
   else
   {
    term=next & 0x80;
    next&=~0x80;
    next=next<<8;
    next+=tree[q++];
  
    if(term)
    {
     codeoff=tree[q++];
     codeoff+=(cchar & 0x60)<<3;
    }
   }


   if(word[j]==(cchar & 0x1F))
   {
    if(term)
    {
     skip=i;
     first=1;

     while(1)
     {
      code=codebuff[codeoff];

      skip+=(code>>3) & 0xF;
      val=code & 7;
      if(!first) skip++;
      else       first=0;

      if(val>data[skip]) data[skip]=(char)val;
      if(code & 0x80) break;
      codeoff++;
     }
    }

    j++;
    if(j>=len) break;

    if(next<0) break; /* end of path */
    else       q=next;
   }
   else
   {
    if(cchar & 0x80) break; /* didn't fit this edge */
   }
  }
 }

 j=0;
 for(i=2;i<(len-1);i++)
 {
  if(data[i] & 0x1) 
   {
    brks[j++]=i-1;
   }
 }

 *n=j;
}








#ifdef NEVER


static void autohyphenate(char * string,int * n,int * brks)
{
 char word[MAXHPLEN];
 char data[MAXHPLEN];
 int  i;
 int  j;
 int  q;
 int  len=0;
 int  cchar;
 int  codeoff;
 int  code;
 int  next;
 int  skip;
 int  val;
 int  first;
 char * tree=trie;
 char * codebuff=codes;


 i=1;

 word[0]='{'-'a';

 while(*string)
 {
  word[i++]=*string++-'a';
  len++;
 }

 word[i++]='{'-'a';
 word[i]=0;

 len+=2;

 for(i=0;i<=len;i++) data[i]=0;

 for(i=0;i<(len-1);i++)
 {
  /* scan trie for each sub word */

  q=0;
  j=i;

  while(1)
  {
   cchar=tree[q++];
   next=tree[q++]<<8;
   next+=tree[q++];

   if(word[j]==(cchar & 0x1F))
   {
    if(next & 0x8000)
      {
       if((next & 0xF800)!=0xF800) 
       {
        codeoff=tree[q++];
        codeoff+=(cchar & 0x60)<<3;
       }
       else
       {
        codeoff=next & 0x03FF;
       }

       skip=i;
       first=1;

       while(1)
       {
        code=codebuff[codeoff];
        skip+=(code>>3) & 0xF;
        val=code & 7;
        if(!first) skip++;
        else       first=0;

        if(val>data[skip]) data[skip]=val;
        if(code & 0x80) break;
        codeoff++;
       }

      }

    j++;
    if(j>=len) break;

    if((next & 0xF800)!=0xF800) q=next & 0x7FFF;
    else                        break; /* end of path */
   }
   else
   {
    if(next & 0x8000)
       if((next & 0xF800)!=0xF800) q++;
    if(cchar & 0x80) break; /* didn't fit this edge */
   }
  }
 }


 j=0;
 for(i=3;i<(len-1);i++)   /* was 2 and (len-1) */
 {
  if(data[i] & 0x1) 
   {
    brks[j++]=i-1;
    if(j==MAXBRKS) break;
   }
 }
 *n=j;
}


#endif






/* source and offset point to space                                   */
/* frame word                                                         */
/* if it contains hard hyphen return -1                               */
/* if it does not contain hyphen or hyphenation off etc. return 0     */
/* finally, auto hyphenate and return n number of hyphens             */
/*
   return 
          0 No hyphens
          1 Hard hyphens
          2 Auto hyphenation
          3 Hit a discretionary hyphen
 */



int hyphenate(textsrcstr * src,int llen,int * hyphenc,
                                           xstylestr * style,unsigned short * hyphenchar)
{
 int    terminated=0;
 int    startword=0;
 int    dchyphens=0;
 char   word[MAXHPLEN];
 char   buff[MAXHPLEN];
 char   shiftx[MAXHPLEN];
 int    i=0;
 int    brks[MAXBRKS];
 int    n;
 int    wordoff;
 int    c;
 int    bits;
 int    hpcaps;
 int    hplast;
 int    minwlen;
 int    hpbefore;
 int    hpafter;
 int    hpconsec;
 int    len;
 int    seenupper;
 int    off;
 int    loff;
 sourcestr * sourcep;
 int    wordlen;
 int    a;
 int    b;
 int    no;
 int    hpchar;
 char * p;
 int    fspace;

 loff=src->loffset;
 off=loff+llen;
 sourcep=src->sourcep;


 wordoff=off; /* keep compiler happy */

 *hyphenc=0;

 hpcaps=style->data.hpbreakcaps;
 hplast=style->data.hpbreaklast;
 minwlen=style->data.hpmin;
 hpbefore=style->data.hpbefore;
 hpafter=style->data.hpafter;
 hpconsec=style->data.hpconsec;


 seenupper=0;

 while(!terminated)
 {
  c=*(p=txptr(sourcep,off));
  bits=codex[c];

  switch(c)
  {
   case TABSEQ:
   case MACSEQ:
    case SPACE:                            /* not same as characters */
               if(startword) terminated=1;
               break;

/*      case '-':
               return(HPHARDTYPE); */

   case DCHYPH:
               if(!i)
               {
                startword=0;
                terminated=1;
               }
               dchyphens=1;
               shiftx[i]=(char)(off-wordoff);
               word[i++]=(char)c;
               if(i==MAXHPLEN) 
               {
                startword=0;
                terminated=1;
               }
               break;

  case NBSPACE:
               startword=0;
               terminated=1;
               break;

 case SPACESEQ:
               fspace=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
               if(fspace & SPACESEQDL)
               {
                if(fspace & SPACESEQNB)
                {
                 if(startword) terminated=1;
                }
                else
                {
                 startword=0;
                 terminated=1;
                }
               }
               break;

       default:
               hpchar=0;
               while(hyphenchar[hpchar])
               {
                if(c==hyphenchar[hpchar])
                {
                 return(startword?HPHARDTYPE:HPNONE);
                }
                hpchar++;
               }


               if(!(((bits & CODETYPE)==CODEALPHA) ||
                    ((bits & CODETYPE)==CODELIGATURE)
                   )) /* punctuation  ?  */
               {
                if((bits & CODETYPE)==CODEPUNCT)
                {
                 /* skip e.g. "'s */

                }
                else
                if(!((bits & CODETYPE)==CODECODE)) /* allow GCODE/SNO */
                {
                 startword=0;
                 terminated=1;
                }
                else /* Con codes */
                {
                 if(bits & CODETERMINATOR)
                 {
                  if(!hplast) return(HPNONE);
                  terminated=1;
                 }
                }
               }
               else  /* Alpha */
               {
                if(!startword)
                {
                 startword=1;
                 wordoff=off;
                }

                shiftx[i]=(char)(off-wordoff);

                if((bits & CODETYPE)==CODELIGATURE)
                {
                 if(c==LIGFL || c==LIGFI) word[i++]='f';
                 else
                 if(c==LIGoe)             word[i++]='o';
                 else                     word[i++]='O';

                 if(i==MAXHPLEN) 
                 {
                  startword=0;
                  terminated=1;
                 }
                 else
                 {
                  shiftx[i]=(char)(off-wordoff);

                  if(c==LIGFL) word[i++]='l';
                  else
                  if(c==LIGFI) word[i++]='i';
                  else
                  if(c==LIGoe) word[i++]='e';
                  else         word[i++]='E';
                 }
                }
                else
                {
                 word[i++]=(char)c;
                }

                if(i==MAXHPLEN) 
                {
                 startword=0;
                 terminated=1;
                }

                if(bits & CODEUPPER) seenupper=1;
               }
               break;
  }

  off+=bits & CODELEN;
 }

 if(!startword) return(HPNONE);  /* couldn't frame up word */
 word[i]=0;                      /* framed word */
 wordlen=i;


 if(dchyphens)
 {
  /* word contains discretionary hyphens */
  n=0;
  for(i=0;i<wordlen;i++) 
  {
   if(word[i]==DCHYPH && word[i+1]!=DCHYPH)
   {
    brks[n]=i;
    n++;
    if(n==MAXBRKS) break;
   }
  }
 }
 else
 {
  if(!style->data.hyphenation) return(HPNONE); /* hyphenation off */
 
  if(i<minwlen)  return(HPNONE);  /* too short to hyphenate */

  if(!hpcaps && seenupper) return(HPNONE); /* seen caps */


  if(checkhpdc(word,buff,hpbefore))
  {
   /* this word is in the hyphenation exceptions dictionary */
   /* we've just been handed back a hyphenated version      */
   n=0;
   len=strlen(buff);
   for(i=0;i<len;i++) 
   {
    if(buff[i]=='-')
    {
     brks[n]=i-n;
     n++;
     if(n==MAXBRKS) break;
    }
   }
  }
  else
  {
   autohyphenate(word,&n,brks);
  }
 }

 no=0;
 for(i=0;i<n;i++)
 {
  b=brks[i];
  a=wordlen-b;

  if((b>=hpbefore && a>=hpafter) || dchyphens)
  {
   if(b==0 || (shiftx[b-1]!=shiftx[b])) /* don't split ligatures */
   {
    hyphens[no++]=shiftx[b]+wordoff-loff+1;
   }
  }
 }

 *hyphenc=no;

 if(dchyphens) return(HPDCTYPE);
 else          return(HPAUTOTYPE);
}

