/*->c.txds */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"
#include "bbc.h"
#include "werr.h"
#include "deb.h"
#include "flex.h"

#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "fsx.h"
#include "bf.h"
#include "timex.h"
#include "xmath.h"
#include "bits.h"
#include "dbhi.h"
#include "alloc.h"
#include "keylegacy.h"


#include "str.h"
#include "constants.h"
#include "codes.h"

#include "object.h"
#include "chain.h"

#include "xredraw.h"
#include "geometry.h"
#include "curve.h"
#include "xcolour.h"
#include "units.h"

#include "file.h"
#include "view.h"
#include "viewr.h"
#include "viewo.h"

#include "new.h"

#include "section.h"

#include "border.h"
#include "fillstub.h"

#include "dscript.h"

#include "dbfields.h"


#include "txstr.h"
#include "txprivate.h"
#include "tx.h"
#include "vec.h"
#include "sx.h"
#include "vl.h"
#include "fx.h"
#include "mx.h"
#include "style.h"
#include "ustyle.h"
#include "fl.h"
#include "act.h"
#include "fmap.h"
#include "fmapstr.h"
#include "tabs.h"
#include "fox.h"
#include "vi.h"
#include "stylemap.h"
#include "styleif.h"
#include "texttool.h"


#include "txds.h"




#define DSTSTYLE               0x601
#define DSTTEXT                0x602
#define DSTSTORY               0x603

#define DSTLEFTTAB             0x610
#define DSTRIGHTTAB            0x611
#define DSTDECIMALTAB          0x612
#define DSTCENTRETAB           0x613
#define DSTRULEPOSN            0x614

#define DSTTAB                 0x615
#define DSTEOT                 0x616
#define DSTNL                  0x617
#define DSTCR                  0x618
#define DSTACTDATE             0x619
#define DSTPAGEO               0x61A

#define DSTCOLUMNS             0x61B
#define DSTVERTALIGN           0x61C


#define DSTSUPER               0x61D
#define DSTSUB                 0x61E

#define DSTWORDUNDERLINE       0x61F
#define DSTDOUBLEUNDERLINE     0x620

#define DSTLEFTRULE            0x621
#define DSTRIGHTRULE           0x622

#define DSTABOVERULE           0x623
#define DSTBELOWRULE           0x624

#define DSTADDUSER             0x625
#define DSTREMUSER             0x626

#define DSTMERGE               0x627

#define DSTCHAPNO              0x628
#define DSTENDOFBOX            0x629
#define DSTENDOFPAGE           0x62A

/* #define DSTNOEFFECT            0x62B */
#define DSTTABDEC              0x62B
#define DSTTABLEADER           0x62C
#define DSTTSCOPE              0x62D

#define DSTHEADERSTORY         0x62F
#define DSTFOOTERSTORY         0x630
#define DSTGUTTERWIDTH         0x631
#define DSTCOLUMNWIDTH         0x632
#define DSTCOLUMGUIDES         0x633
#define DSTHEADER              0x634
#define DSTFOOTER              0x635
#define DSTTEXTCHAIN           0x636
#define DSTMASTERFRAME         0x637
#define DSTAUTOLINK            0x638

#define DSTBULLETBEFORE        0x639
#define DSTBULLETAFTER         0x63A
#define DSTBULLETSTYLE         0x63B
#define DSTBULLETTAB           0x63C
#define DSTBULLETSTART         0x63D
#define DSTBULLETSYMBOL        0x63E
#define DSTBULLETFORMAT        0x63F

#define DSTFONTSTYLE           0x640


#define DSTHPMINSIZE           0x641
#define DSTHPMINBEFORE         0x642
#define DSTHPMINAFTER          0x643
#define DSTHPMAXCONSEC         0x644
#define DSTHPZONE              0x645
#define DSTHPBREAKPARA         0x646
#define DSTHPBREAKCAPS         0x647

#define DSTJMINLETTER          0x648
#define DSTJMAXLETTER          0x649
#define DSTJMINWORD            0x64A
#define DSTJMAXWORD            0x64B
#define DSTJFLUSHZONE          0x64C
#define DSTJSINGLEWORDS        0x64D

#define DSTSTYLENAME           0x64E

#define DSTFONTEFFECT          0x64F

#define DSTEMBED               0x650

#define DSTLAYER               0x651

#define DSTSOFTHYPHEN          0x652

#define DSTFIRSTLINE           0x653

#define DSTSPACE               0x654






#define DSTBOLD                0x700
#define DSTITALIC              0x701
#define DSTUNDERLINE           0x702
#define DSTREVERSE             0x703
#define DSTSUPERSUB            0x704
#define DSTSTRIKE              0x705
#define DSTVERTICALRULE        0x706
#define DSTHORIZONTALRULE      0x707
#define DSTFONT                0x708
#define DSTFOREGROUND          0x709
#define DSTBACKGROUND          0x70A
#define DSTTEXTSIZE            0x70B
#define DSTTEXTSCALE           0x70C
#define DSTTRACK               0x70D
#define DSTBASESHIFT           0x70E
#define DSTALIGN               0x70F
#define DSTSPACEBEFORE         0x710
#define DSTSPACEAFTER          0x711
#define DSTLEADING             0x712
#define DSTLEFTINDENT          0x713
#define DSTRIGHTINDENT         0x714
#define DSTFIRSTINDENT         0x715
#define DSTCASE                0x716
#define DSTDROP                0x717
#define DSTBULLET              0x718
#define DSTHYPHENATION         0x719
#define DSTAUTOKERN            0x71A
#define DSTWORDWRAP            0x71B
#define DSTINDEX               0x71C
#define DSTCONTENTS            0x71D
#define DSTLEVEL               0x71E
#define DSTBASELINELOCK        0x71F
#define DSTSMALLCAPS           0x720
#define DSTKEEPLINES           0x721
#define DSTKEEPPARA            0x722
#define DSTKEEPNEXT            0x723
#define DSTLANGUAGE            0x724
#define DSTTABRULER            0x725
#define DSTTEXTANGLE           0x726
#define DSTTEXTSKEW            0x727
#define DSTJUSTIFICATION       0x728





static char * bitname(int bit);



/************************************************************************/

static os_error * txdsfontnamesub(int i,fmapbasestr * fbase,buffer * bf)
{
 return(bf_printfeol(bf,"FONT_%02x={font \"%s\"}",fbase->fmaphdr[i].key,
                        ((char*)fbase->fmaphdr)+fbase->fmaphdr[i].offset));
}


/* save out font names that are referenced in maps */

os_error * txdsfontnames(filestr * file,buffer * bf)
{
 os_error       * err;
 fmapbasestr    * fbase;
 fmaphdrstr       fmaphdr;
 fmaphdrstr     * f1;
 int              fmap;
 int              i;

 err=NULL;

 fmap=file->hdr.fmap;
 fbase=(fmapbasestr*)fob_find(fmap,file);
 if(fbase)
 {
  for(i=0;i<tabentries;i++)
  {
   fmaphdr.key=tabmap[i].old;

   f1=(fmaphdrstr*)bsearch(&fmaphdr,fbase->fmaphdr,fbase->n,
                                         sizeof(fmaphdrstr),cmpfmapn);
   if(f1)
   {
    err=txdsfontnamesub(f1-fbase->fmaphdr,fbase,bf);
    if(err) break;
   }
  }
 }

 bf_printfeoln(bf,2,"");

 return(err);
}



static os_error * fmapds(filestr * file,buffer * bf)
{
 os_error       * err;
 fmapbasestr    * fbase;
 int              fmap;
 int              i;

 err=NULL;

 fmap=file->hdr.fmap;
 fbase=(fmapbasestr*)fob_find(fmap,file);
 if(fbase)
 {
  for(i=0;i<fbase->n;i++)
  {
   err=txdsfontnamesub(i,fbase,bf);
   if(err) break;
  }
 }

 bf_printfeoln(bf,2,"");

 return(err); 
}


// convert UNC16 string to DDL {u } string			+			quote C controls

char * dsmkunistr1(char * src,char * temp,int maxlen)
{
	int    c;
	char * p;
	char * q;
	char * lt;
	int    instring;
	int    unistring;

	unistring=0;
 instring=0;
	p=src;
	q=temp;
	lt=temp+maxlen-32;

	while((c=*p++)!=0)
	{
		if(c==UNC16)
		{
			unistring=1;
			break;
		}
	}

	p=src;

	if(unistring)
	{
		*q++='{';
		*q++='u';
		*q++=' ';
	}

	while((c=*p++)!=0)
	{
		if(q>lt) break;

		if(c==UNC16)
		{
			if(instring)
 		{
				*q++='\"';
				*q++=' ';
				instring=0;
			}

			c=*p++;
			c+=(*p++)<<8;
			q+=sprintf(q,"0x%x ",c);

		}
		else
		{
			if(instring)
			{
				q=unquotechar(c,q,0);
			}
			else
			{
				*q++='\"';
			 q=unquotechar(c,q,0);
				instring=1;
			}
		}
	}

	if(instring) *q++='\"';
	else
	{
		if(q==temp)
		{
			*q++='\"';
			*q++='\"';
		}
	}

	if(unistring)
	{
		*q++='}';
	}

	*q++=0;

 return(temp);
}





// convert wide string to DDL {u } string

char * dsmkunistr2(unsigned short * src,char * temp,int maxlen)
{
	int              c;
	unsigned short * p;
	char           * q;
	char           * lt;
	int              instring;
	int              unistring;

	unistring=0;
 instring=0;
	p=src;
	q=temp;
	lt=temp+maxlen-32;

	while((c=*p++)!=0)
	{
		if(c>255)
		{
			unistring=1;
			break;
		}
	}

	p=src;

	if(unistring)
	{
		*q++='{';
		*q++='u';
		*q++=' ';
	}

	while((c=*p++)!=0)
	{
		if(q>lt) break;

		if(c>255)
		{
			if(instring)
 		{
				*q++='\"';
				*q++=' ';
				instring=0;
			}

			q+=sprintf(q,"0x%x ",c);
		}
		else
		{
			if(instring)
			{
				q=unquotechar(c,q,0);
			}
			else
			{
				*q++='\"';
				q=unquotechar(c,q,0);
				instring=1;
			}
		}
	}

	if(instring) *q++='\"';
	else
	{
		if(q==temp)
		{
			*q++='\"';
			*q++='\"';
		}
	}

	if(unistring)
	{
		*q++='}';
	}

	*q++=0;

 return(temp);
}










// convert UNC16 string to user readable string

char * mkunistr1(char * src,char * temp,int maxlen)
{
	int    c;
	char * p;
	char * q;
	char * lt;

	p=src;
	q=temp;
	lt=temp+maxlen-16;

	p=src;

	while((c=*p++)!=0)
	{
		if(q>lt) break;

		if(c==UNC16)
		{
			c=*p++;
			c+=(*p++)<<8;
			q+=sprintf(q,"<U+%x>",c);

		}
		else
		{
			q=unquotechar(c,q,0);
		}
	}

	*q++=0;

 return(temp);
}






static char      leader1[LEADERMAXLEN*3];
static int       leaderlen;
static char      dectab1[DECTABMAXLEN*3];
static int       dectablen;



static int styletab(char * p,int i,datawords * d,filestr * file,int * len)
{
 char           * q;
 int              stype;
	char             temp[256];


 q=p;


//	cprintf("i %d rulern %d",i,tabrulern);

 if(i==0)
 {
  gettabruler(file,d->tab);

  XMEMCPYX(leader1,d->leaderchar,LEADERLEN);
		leaderlen=LEADERLEN;

		dectablen=0;

  q+=sprintf(q,"{tabruler ");
 }

	if(i>=tabrulern || tabruler[i].type!=TABDATA)
	{
 	if(leaderlen)
 	{
//			cprintf("leaderlen %d",leaderlen);

			leader1[leaderlen]=0;
   q+=sprintf(q,"{tableader %s}",dsmkunistr1(leader1,temp,sizeof(temp)));
 		leaderlen=0;
 	}

 	if(dectablen)
 	{
//			cprintf("dectablen %d",dectablen);

			dectab1[dectablen]=0;
   q+=sprintf(q,"{tabdec %s}",dsmkunistr1(dectab1,temp,sizeof(temp)));
 		dectablen=0;
 	}
	}

 if(i<tabrulern)
 {
  switch(tabruler[i].type)
  {
   case   TLEFT:
                q+=sprintf(q,"{lefttab %d}",tabruler[i].posn);
                break;

    case TRIGHT:
                q+=sprintf(q,"{righttab %d}",tabruler[i].posn);
                break;

    case   TDEC:
                q+=sprintf(q,"{decimaltab %d}",tabruler[i].posn);
                break;

    case TCENTRE:
                 q+=sprintf(q,"{centretab %d}",tabruler[i].posn);
                 break;

    case  TVRULE:
                 q+=sprintf(q,"{ruleposn %d}",tabruler[i].posn);
                 break;

    case TABDATA:
                 stype=(tabruler[i].posn>>24);
                 if(stype==TSUBLEAD)
                 {
//																			cprintf("sublead");
																		if(leaderlen<(LEADERMAXLEN-3))
																		{
                   XMEMCPYX(leader1+leaderlen,&tabruler[i],3);
																	 	leaderlen+=3;
																		}
                 }
                 else
                 if(stype==TSUBDEC)
                 {
//																			cprintf("subdec");
																		if(dectablen<(DECTABMAXLEN-3))
																		{
                   XMEMCPYX(dectab1+dectablen,&tabruler[i],3);
                   dectablen+=3;
																		}
                 }
                 else
                 {
                  //cprintf("bad tab data");
                  *q++=' ';
                 }
                 break;

         default:
                 //cprintf("bad tab type %d",tabruler[i].type);
                 *q++=' ';
                 break;
  }
 }

 if(i==tabrulern) {*q++='}';*q++='\r';*q++='\n';}

	*len=(q-p);

	if(*len) *(q+1)=0; //cprintf("return %s",p);}

 return(i>tabrulern);
}




static int textstyletab(char * p,int i,datawords * d,viewstr * view,int * len)
{
 char    * q;
 char      string[256];
 int       stype;
 filestr * file;
 int       units;

 file=view->file;
 units=view->data.units;

 q=p;

 if(i==0)
 {
  gettabruler(file,d->tab);

  XMEMCPYX(leader1,d->leaderchar,LEADERLEN);
		leaderlen=LEADERLEN;

		dectablen=0;
 }


	if(i>=tabrulern || tabruler[i].type!=TABDATA)
	{
 	if(leaderlen)
 	{
			leader1[leaderlen]=0;

   q+=sprintf(q,"leader \"%s\" ",mkunistr1(leader1,string,sizeof(string)));
 		leaderlen=0;
 	}

 	if(dectablen)
 	{
			dectab1[dectablen]=0;

   q+=sprintf(q,"decimal char \"%s\" ",mkunistr1(dectab1,string,sizeof(string)));
 		dectablen=0;
 	}
	}



 if(i<tabrulern)
 {
  switch(tabruler[i].type)
  {
   case   TLEFT:
           q+=sprintf(q,"lefttab %s ",unitstostring(tabruler[i].posn,units));
           break;

    case TRIGHT:
           q+=sprintf(q,"righttab %s ",unitstostring(tabruler[i].posn,units));
           break;

    case   TDEC:
          q+=sprintf(q,"decimaltab %s ",unitstostring(tabruler[i].posn,units));
          break;

    case TCENTRE:
           q+=sprintf(q,"centretab %s ",unitstostring(tabruler[i].posn,units));
           break;

    case  TVRULE:
           q+=sprintf(q,"ruleposn %s ",unitstostring(tabruler[i].posn,units));
           break;

    case TABDATA:
                 stype=(tabruler[i].posn>>24);
                 if(stype==TSUBLEAD)
                 {
																		if(leaderlen<(LEADERMAXLEN-3))
																		{
                   XMEMCPYX(leader1+leaderlen,&tabruler[i],3);
																	 	leaderlen+=3;
																		}
                 }
                 else
                 if(stype==TSUBDEC)
                 {
																		if(dectablen<(DECTABMAXLEN-3))
																		{
                   XMEMCPYX(dectab1+dectablen,&tabruler[i],3);
                   dectablen+=3;
																		}
                 }
                 break;
  }
 }


	*len=(q-p);

	if(*len) *(q+1)=0; //cprintf("return %s",p);}

 return(i>tabrulern);
}






os_error * tabsavetext(buffer * bf,datawords * d,viewstr * cview)
{
 os_error * err;
 int        i;
 int        n;
	int        eof;
 char       string[256];

 err=NULL;

 i=0;
 while(1)
 {
  eof=textstyletab(string,i,d,cview,&n);
  if(eof) break;
  err=bf_write(bf,string,n);
  i++;
 }

 return(err);
}






static int bulletdef(char * p,datawords * d,filestr * file)
{
 int            n;
 unsigned short after[4];
 unsigned short before[4];
 unsigned short symbol[4];
 char           style[STYLENAMELEN];
 userstylestr * us;
	char           temp1[128];
	char           temp2[128];


 after[0]=(unsigned short)(d->bulletafter1+(d->bulletafter2<<8));
 after[1]=0;

 before[0]=(unsigned short)(d->bulletbefore1+(d->bulletbefore2<<8));
 before[1]=0;

 symbol[0]=(unsigned short)(d->bulletdata1+(d->bulletdata2<<8));
 symbol[1]=0;

 if(d->bulletstyle==BULLETNOSTYLE) strcpy(style,"");
 else
 {
  finduserstylep(&us,d->bulletstyle,file);
  if(us) xzstrncpy(style,us->name,sizeof(style));
  else   xzstrncpy(style,"",sizeof(style));
 }

 n=sprintf(p,"%d {bulletbefore %s} {bulletafter %s} {bulletstyle \"%s\"} {bullettab %d} {bulletstart %d}",
                         d->bullet,
                         dsmkunistr2(before,temp1,sizeof(temp1)),
                         dsmkunistr2(after,temp2,sizeof(temp2)),
                         style,
                         d->bullettab,
                         d->bulletstart);
 p+=n;
 if(d->bulletornumber) n+=sprintf(p,"{bulletsymbol %s}",dsmkunistr2(symbol,temp2,sizeof(temp2)));
 else                  n+=sprintf(p,"{bulletformat %d}",d->bulletdata1+(d->bulletdata2<<8));

 return(n);
}



static int hpdef(char * p,datawords * d)
{
 return(sprintf(p,"%d {hpminsize %d} {hpminbefore %d} {hpminafter %d} {hpmaxconsecutive %d} {hpzone %d} {hpbreakpara %d} {hpbreakcaps %d}",
                         d->hyphenation,
                         d->hpmin,
                         d->hpbefore,
                         d->hpafter,
                         d->hpconsec,
                         d->hpzone,
                         d->hpbreaklast,d->hpbreakcaps));
}


static int justdef(char * p,datawords * d)
{

 return(sprintf(p,"%d {justminletter 0x%x} {justmaxletter 0x%x} {justminword 0x%x} {justmaxword 0x%x} {justflushzone %d} {justsinglewords %d}",
          d->justification,
          (d->justlettermin*0x10000)/100,
          (d->justlettermax*0x10000)/100,
          (d->justwordmin*JUSTWORDSCALE*0x10000)/100,
          (d->justwordmax*JUSTWORDSCALE*0x10000)/100,
          d->justflushzone,
          d->justsingle));
}



#define ABITMAX  41
#define TABINDEX 37




static int stylesub2(int bit,char * p,datawords * d,filestr * file)
{

 switch(bit)
 {
  case  0:
          return(sprintf(p,"%d",d->bold));
          break;

  case  1:
          return(sprintf(p,"%d",d->italic));
          break;

  case  2:
          return(sprintf(p,"%d {type %d} {thickness %d} %s {wordunderline %d} {doubleunderline %d}",
                  d->underline,d->ultype,d->ulthickness,
                  dscvstring(&d->ulcolour,file),d->ulword,d->uldouble));
          break;


  case  3:
          return(sprintf(p,"%d",d->reverse));
          break;


  case  5:
          return(sprintf(p,"%d {type %d} {thickness %d} %s",
              d->strikeout,d->sttype,
              d->stthickness,dscvstring(&d->stcolour,file)));
          break;


  case  6:
          return(sprintf(p,"{leftrule %d %d} {rightrule %d %d} {thickness %d} %s",
              d->ruleleft,d->ruleleftshift,
              d->ruleright,d->rulerightshift,
              d->vrulethickness,dscvstring(&d->vrulecolour,file)));
          break;

  case  7:
          return(sprintf(p,"{aboverule %d %d} {belowrule %d %d} {thickness %d} %s",
               d->ruleabove,d->ruleaboveshift,
               d->rulebelow,d->rulebelowshift,
               d->hrulethickness,dscvstring(&d->hrulecolour,file)));
          break;

  case  9:
          return(sprintf(p,"%s",dscvstring2(&d->fcolour,file)));
          break;

  case 10:
          return(sprintf(p,"%s",dscvstring2(&d->bcolour,file)));
          break;

  case 11:
          return(sprintf(p,"%d",d->ypts));
          break;

  case 12:
          return(sprintf(p,"0x%x",scale(0x10000,d->xpts,d->ypts)));
          break;

  case 13:
          /* should be emsize() */
          return(sprintf(p,"0x%x",scale(0x10000,d->track,d->ypts)));
          break;

  case 14:
          /* should be emsize() */
          return(sprintf(p,"0x%x",scale(0x10000,d->baseshift,d->ypts)));
          break;

  case 15:
          return(sprintf(p,"%d",d->align));
          break;

  case 16:
          return(sprintf(p,"%d",d->before));
          break;

  case 17:
          return(sprintf(p,"%d",d->after));
          break;

  case 18:
          return(sprintf(p,"%d %d",d->leadingtype,d->leading));
          break;

  case 19:
          return(sprintf(p,"%d %d",d->lefttype,d->leftshift));
          break;

  case 20:
          return(sprintf(p,"%d %d",d->righttype,d->rightshift));
          break;

  case 21:
          return(sprintf(p,"%d",d->firstshift));
          break;

  case 22:
          return(sprintf(p,"%d",d->xcase));
          break;

  case 23:
          return(sprintf(p,"%d %d",d->drop,d->dropno));
          break;

  case 24:
          return(bulletdef(p,d,file));
          break;

  case 25:
          return(hpdef(p,d));
          break;

  case 26:
          return(sprintf(p,"%d",d->akern));
          break;

  case 27:
          return(sprintf(p,"%d",d->wordwrap));
          break;

  case 28:
          return(sprintf(p,"%d",d->index));
          break;

  case 29:
          return(sprintf(p,"%d",d->contents));
          break;

  case 30:
          return(sprintf(p,"%d",d->layer));
          break;

  case 31:
          return(sprintf(p,"%d",d->baselinelock));
          break;

  case 32:
          return(sprintf(p,"%d",d->smlcaps));
          break;

  case 33:
          return(sprintf(p,"%d %d",d->keeplines,d->keeplinesno));
          break;

  case 34:
          return(sprintf(p,"%d",d->keeppara));
          break;

  case 35:
          return(sprintf(p,"%d",d->keepnext));
          break;

  case 36:
          return(sprintf(p,"%d",d->language));
          break;

  case 37:       /* tabs */
          break;

  case 38:
          return(sprintf(p,"0x%x",360*d->rotate));
          break;

  case 39:
          return(sprintf(p,"0x%x",360*d->skew));
          break;

  case 40:
          return(justdef(p,d));
          break;
 }

 return(0);
}





static int stylesub1(int bit,char * p,datawords * d,filestr * file)
{
 char * q;
 int    n1;
 int    n2;

 switch(bit)
 {
  case  4:
          return(sprintf(p,"{super %d}{sub %d}",
                                     d->supersub==1,d->supersub==2));
          break;

  case  8:
          return(sprintf(p," FONT_%02x ",d->mfont));
          break;




   default:
           *p++='{';
           q=bitname(bit);
           strcpy(p,q);
           n1=strlen(q);
           p+=n1;
           *p++=' ';
           n2=stylesub2(bit,p,d,file);
           p+=n2;
           *p++='}';
           return(3+n1+n2);
           break;

 }

 return(0);
}



static os_error * stylesub(xstylestr * s,filestr * file,buffer * bf)
{
 os_error * err;
 char       string[1920];
 int        mask;
 int      * bits;
 char     * p;
 int        i;
 int        n;
	int        eof;

 p=string;

 bits=(int*)&s->action;
 mask=0x1;

 for(i=0;i<ABITMAX;i++)
 {
  if(((*bits) & mask) && i!=TABINDEX)
  {
   p+=stylesub1(i,p,&s->data,file);
			*p++='\r';
   *p++='\n';
  }

  if(mask<0) {mask=0x1;bits++;}
  else       mask<<=1;
 }

 err=bf_write(bf,string,p-string);
 if(!err && s->action.tab)
 {
  i=0;
  while(1)
  {
   eof=styletab(string,i,&s->data,file,&n);
   if(eof) break;
			string[n++]='\r';
   string[n++]='\n';
   err=bf_write(bf,string,n);
   i++;
  }
 }

 return(err);
}


static os_error * styledssub(userstylestr * s,filestr * file,buffer * bf)
{
 os_error * err;
 char       temp[256];

 err=bf_printfeol(bf,"STYLE_%02x={style \"%s\"",
                                         s->style.n,unquotec(s->name,temp));

 cprintf("style name %s",s->name);

 err=bf_printfeol(bf,"{keypress \"%s\"}",(s->key>=0)?unquotec(keystring(keycodefromlegacy(s->key)),temp):"");

// cprintf("key %d string K %s K %s",s->key,temp,keystring(s->key));


 err=bf_printfeol(bf,"{scope %d}",s->scope);

 stylesub(&s->style,file,bf);
 
 bf_printfeoln(bf,2,"}");

 return(err);
}



static os_error * styleds(filestr * file,buffer * bf)
{
 os_error          * err;
 userstylebasestr  * sbase;
 int                 i;
 int                 styles;
 userstylestr      * s;

 err=NULL;

 styles=file->hdr.ustyles;

 i=0;
 while(1)
 {
  sbase=(userstylebasestr*)fob_find(styles,file);
  if(i>=sbase->n) break;

  s=&sbase->userstyle[i];
  err=styledssub(s,file,bf);

  i++;
 }

 bf_printfeoln(bf,2,"");

 return(err); 
}


os_error * txdsusernames(filestr * file,buffer * bf)
{
 os_error          * err;
 userstylebasestr  * sbase;
 int                 i;
 int                 styles;
 userstylestr      * s;
 userstylestr        temp;

 err=NULL;

 styles=file->hdr.ustyles;

 for(i=0;i<userentries;i++)
 {
  sbase=(userstylebasestr*)fob_find(styles,file);

  temp.style.n=usermap[i].old;

  s=(userstylestr*)bsearch(&temp,sbase->userstyle,sbase->n,sizeof(userstylestr),cmpustylen);

  err=styledssub(s,file,bf);
 }

 return(err);
}



static os_error * txevent(int eventn,int user,filestr * file,buffer * bf)
{
 os_error      * err;

 err=bf_printfeoln(bf,2,"// Text styles etc. ");

          err=fmapds(file,bf);
 if(!err) err=styleds(file,bf);
 if(!err) err=fieldds(file,bf);

 return(err);

 USE(user);
 USE(eventn);
}






/**************************************************************************/


typedef os_error * (*codetextfn)(char * p,filestr * file);


typedef struct codetextstr
{
 void * name;
 int    len;
} codetextstr;




#define QLEN 80


static char   * txbase;
static char   * txp;
static char   * txbrk;
static char   * txqbrk;
static char   * txsplit;
static int      inquotemode;
static buffer * txbf;



static void txinit(char * buff,buffer * bf)
{
 inquotemode=0;
 txbase=txp=txsplit=buff;
 txbf=bf;
 txbrk=txbase+QLEN;
 txqbrk=txbrk-1;
}


static os_error * txgomode(int quotes)
{
 if(quotes!=inquotemode)
 {
  if(!inquotemode)
  {
   if(txp>txbase)
   {
				*txp++='\r';
    *txp++='\n';
    bf_write(txbf,txbase,txp-txbase);
    txp=txbase;
   }
   txsplit=txp;
   inquotemode=1;
   *txp++='"';
  }
  else
  {
   if(txp>(txbase+1))
   {
    *txp++='"';
				*txp++='\r';
    *txp++='\n';
    bf_write(txbf,txbase,txp-txbase);
   }
   txp=txsplit=txbase;
   inquotemode=0;
  }
 }

 return(NULL);
}


static os_error * txflush(int split)
{
 int c1;
 int c2;
	int c3;

 if(!inquotemode)
 {
  if(txp>=txbrk)
  {
   if(txsplit>txbase)
   {
    c1=*txsplit;
    c2=*(txsplit+1);
    *txsplit='\r';
    *(txsplit+1)='\n';
    bf_write(txbf,txbase,txsplit-txbase+2);
    *txsplit=(char)c1;
    *(txsplit+1)=(char)c2;
    XMEMCPYX(txbase,txsplit,txp-txsplit);
    txp=txbase+(txp-txsplit);
    txsplit=txbase;
   }
   else
   {
				*txp++='\r';
    *txp++='\n';
    bf_write(txbf,txbase,txp-txbase);
    txp=txsplit=txbase;
   }
  }
 }
 else
 {
  if(txp>=txqbrk)
  {
   if(txsplit>txbase)
   {
    c1=*txsplit;
    c2=*(txsplit+1);
    c3=*(txsplit+2);
    *txsplit='"';
    *(txsplit+1)='\r';
    *(txsplit+2)='\n';
    bf_write(txbf,txbase,txsplit-txbase+3);
    *txsplit=(char)c1;
    *(txsplit+1)=(char)c2;
    *(txsplit+2)=(char)c3;
    XMEMCPYX(txbase+1,txsplit,txp-txsplit);
    txp=txbase+1+(txp-txsplit);
    *txbase='"';
    txsplit=txbase;
   }
   else
   {
    *txp++='"';
				*txp++='\r';
    *txp++='\n';
    bf_write(txbf,txbase,txp-txbase);
    txp=txsplit=txbase;
    *txp++='"';
   }
  }
 }

 if(split) txsplit=txp;

 return(NULL);
}




static os_error * mailtag(char * p,filestr * file)
{
 txp+=sprintf(txp,"{merge %d}",(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16));
 return(NULL);
 USE(file);
}



static os_error * spaceseq(char * p,filestr * file)
{
 int         fspace;
 int         hspace;
 int         vspace;
 int         xspace;

 fspace=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
 hspace=(*(p+4))+((*(p+5))<<8)+((*(p+6))<<16)+((*(p+7))<<24); 
 vspace=(*(p+8))+((*(p+9))<<8)+((*(p+10))<<16)+((*(p+11))<<24); 
 xspace=(*(p+12))+((*(p+13))<<8)+((*(p+14))<<16)+((*(p+15))<<24);

 txp+=sprintf(txp,"{space %d %d %d %d}",fspace,hspace,vspace,xspace);
 return(NULL);
 USE(file);
}



static os_error * unicodeseq(char * p,filestr * file)
{
	int code;

 code=(*(p+1))+((*(p+2))<<8);

 txp+=sprintf(txp,"{u %d}",code);

 return(NULL);
 USE(file);
}





static os_error * eobtag(char * p,filestr * file)
{
 int         object;
 objhdrstr * obj;
 char        string[32];
 int         message;

 object=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16)+((*(p+4))<<24);
 obj=(objhdrstr*)fob_find(object,file);
	if(obj)
	{
  message=OM_DSNAME;

  objectmessage(obj,file,&message,string);

  txp+=sprintf(txp,"{embed %s}",string);
	}
 return(NULL);

}





static char * stylenull1(int bit,char * p)
{
 char * q;

 *p++='{';
 q=bitname(bit);
 strcpy(p,q);
 p+=strlen(q);
 *p++='}';

 return(p);
}



static int         * currentchain;
static int           currentchainn;
static absstylestr * currentstyle;
static int           seenstyle;

static os_error * stylecode(char * p,filestr * file)
{
 int        sn;
 int        nextchain[MAXCHAIN];
 int        nextchainn;
 absstylestr nextstyle;
 int        minn;
 int        i;
 int        j;
 int        n;
 actionbits acteor;
 actionbits actset;
 actionbits actclr;
 int        mask;
 int      * bits;
 int        seeneffect;
	int        eof;


 sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);

 findabsstyle(file,sn,&nextstyle);

 if(!currentchainn || nextstyle.chain!=currentstyle->chain)
 {
  findstylechains(file,nextstyle.chain,nextchain,&nextchainn);

  minn=MIN(nextchainn,currentchainn);

  i=0;
  while(i<minn)
  {
   if(currentchain[currentchainn-i-1]!=nextchain[nextchainn-i-1]) break;
   i++;
  }

  j=i;
  while(j<currentchainn)
  {
   txp+=sprintf(txp,"{remuserstyle STYLE_%02x}",
                                      currentchain[currentchainn-j-1]);
   j++;
   txflush(1);
  }

  memmove(currentchain+(nextchainn-i),currentchain+(currentchainn-i),
                                                        i*sizeof(int));

  currentchainn=nextchainn;

  for(j=i;j<currentchainn;j++)
  {
   txp+=sprintf(txp,"{adduserstyle STYLE_%02x}",nextchain[nextchainn-j-1]);
   currentchain[currentchainn-j-1]=nextchain[nextchainn-j-1];
   txflush(1);
  }
 }

 /* sort out style */

 /* (1) output values for any new act bits            */
 /* (old ^ new) & new                                 */

 /* (2) output any values that have changed           */
 /* bits=1, diff, eor 1, or with previous             */

 /* (3) clear any values whose act bits have vanished */
 /* (old ^ new) & old                                 */


 if(seenstyle)
 {
  stylexorbits(&acteor,&currentstyle->style.action,&nextstyle.style.action);
  styleandbits(&actset,&acteor,&nextstyle.style.action);
  styleandbits(&actclr,&acteor,&currentstyle->style.action);

  stylesetall(&currentstyle->style);
  stylediffbits(&currentstyle->style,&nextstyle.style);
  styleflipall(&currentstyle->style);
  styleandbits(&currentstyle->style.action,
               &currentstyle->style.action,&nextstyle.style.action);
  styleorrbits(&actset,&actset,&currentstyle->style.action);

  seeneffect=0;
 }
 else
 {
  actset=nextstyle.style.action;
  seenstyle=1;
  seeneffect=1;
 }


 bits=(int*)&actset;
 mask=0x1;

 for(i=0;i<ABITMAX;i++)
 {
  if((*bits) & mask)
  {
   txp+=stylesub1(i,txp,&nextstyle.style.data,file);
   txflush(1);
  }

  if(mask<0) {mask=0x1;bits++;}
  else       mask<<=1;
 }


 if(actset.tab)
 {
  j=0;
  while(1)
  {
   eof=styletab(txp,j,&nextstyle.style.data,file,&n);
   txp+=n;
   if(eof) break;
   txflush(1);
   j++;
  }
 }


 if(!seeneffect)
 {
  bits=(int*)&actclr;
  mask=0x1;

  for(i=0;i<ABITMAX;i++)
  {
   if((*bits) & mask)
   {
    if(!seeneffect)
    {
    /* txp+=sprintf(txp,"{noeffect "); */
     seeneffect=1;
    }


  /*  if(i==TABINDEX)
    {
     j=0;
     while(1)
     {
      n=styletab(txp,j,&nextstyle.style.data,file);
      txp+=n;
      if(!n) break;
      txflush(1);
      j++;
     }
    }
    else
    {
     txp+=stylesub1(i,txp,&currentstyle->style.data,file);
     txflush(1);
    } */

    txp=stylenull1(i,txp);
    txflush(1);
   }

   if(mask<0) {mask=0x1;bits++;}
   else       mask<<=1;
  }
/* if(seeneffect) *txp++='}'; */
 }

 *currentstyle=nextstyle;

 return(NULL);
}




static codetextstr codetexttable[32]=
{
 "{endoftext}",    11,   /* 0 EOT        */
  NULL,            0,    /* 1 blank      */
 "{newframe}",     10,   /* 2 end of box */
 "{newpage}",      9,    /* 3            */
 "{chapterno}",    11,   /* 4            */
 "{activedate}",   12,   /* 5            */
 NULL,             0,    /* 6 bullet     */
 (void*)spaceseq,  0,    /* 7 blank      */ 
 (void*)unicodeseq,0,    /* 8 blank      */
 NULL,             0,    /* 9 blank      */
 "{newpara}",      9,    /* 10           */
 NULL,             0,    /* 11 blank     */ 
 NULL,             0,    /* 12 blank     */
 "{newline}",      9,    /* 13           */
 NULL,             0,    /* 14 blank     */
 NULL,             0,    /* 15 blank     */ 
 NULL,             0,    /* 16 blank     */ 
 NULL,             0,    /* 17 blank     */
 "{tab}",          5,    /* 18           */
 (void*)mailtag,   0,    /* 19 mail tag  */
 (void*)stylecode, 0,    /* 20 style     */
 "{softhyphen}",   12,   /* 21 blank     */
 (void*)eobtag,    0,    /* 22 embedded object */
 NULL,             0,    /* 23 blank     */
 NULL,             0,    /* 24 blank     */ 
 NULL,             0,    /* 25 blank     */
 NULL,             0,    /* 26 blank     */ 
 NULL,             0,    /* 27 blank     */ 
 NULL,             0,    /* 28 blank     */
 NULL,             0,    /* 29 blank     */
 "{pageno}",       8,    /* 30 page no   */
 NULL,             0,    /* 31 blank     */
};




/*****************************************************************************/



os_error * txwriteeobs(int source,int offset,int maxoffset,
                                                   filestr * file,buffer * bf)
{
 os_error  * err;
 sourcestr * sourcep;
 objhdrstr * obj;
 char      * p;
 int         c;
 int         bits;
 int         slen;
 int         object;
 int         message;


 err=fob_lock((fobjptr)&sourcep,source,file);
 if(!err)
 {
  if(maxoffset<0) maxoffset=sourcep->len;

  do
  {
   p=txptr(sourcep,offset);
   c=*p;
   bits=codex[c];
   slen=bits & CODELEN;

   if(c==EOB)
   {
    object=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16)+((*(p+4))<<24);
    obj=(objhdrstr*)fob_find(object,file);
				if(obj!=NULL)
				{
     message=OM_DSSAVE;

     objectmessage(obj,file,&message,bf);
				}
   }


   offset+=slen;
   if(offset>=maxoffset) break;

  } while(c!=EOT);

  fob_unlock((fobjptr)&sourcep,file);
 }

 return(NULL);
}





/*****************************************************************************/





static char * tustring[3]={"","header","footer"};


os_error * txwritestory(int source,int unit,int offset,int maxoffset,
                                                   filestr * file,buffer * bf)
{
 os_error  * err;
 sourcestr * sourcep;
 int         bits;
 int         slen;
 char        buffer[4*QLEN];
 int         c;
 char      * p;
 codetextfn  textfn;
 absstylestr s;
 int         chain[MAXCHAIN];
 int         coffset;
 int         snoffset;

 currentchain=chain;
 currentchainn=0;
 currentstyle=&s;
 seenstyle=0;


 bf_printfeol(bf,"STORY_%02x={%sstory ",source,
                           tustring[(unit<0)?0:unit]); /* unit needed */

 txinit(buffer,bf);

 err=fob_lock((fobjptr)&sourcep,source,file);
 if(!err)
 {
  if(maxoffset<0) maxoffset=sourcep->len;

  coffset=0;
  snoffset=-1;

  /* code to ensure a style sequence always starts text */

  while(1)
  {
   p=txptr(sourcep,coffset);
   c=*p;
   bits=codex[c];
   slen=bits & CODELEN;
   if(c==SNO) snoffset=coffset;
   if(coffset>=offset) break;
   coffset+=slen;
   if(slen<=0) break;
  }

  if(snoffset>=0 && snoffset!=offset)
  {
   txgomode(0);

   p=txptr(sourcep,snoffset);
   c=*p;
   textfn=(codetextfn)codetexttable[c].name;
   if(textfn) textfn(p,file);

   txflush(1);
  }

  do
  {
   p=txptr(sourcep,offset);
   c=*p;
   bits=codex[c];
   slen=bits & CODELEN;

   if(c>=32)
   {
    txgomode(1);

    if(c=='"' || c=='\\') *txp++='\\';
    *txp++=(char)c;

    txflush(c==32);
   }
   else
   {
    txgomode(0);

    if(codetexttable[c].len)
    {
     strcpy(txp,(char*)codetexttable[c].name);
     txp+=codetexttable[c].len;
    }
    else
    {
     textfn=(codetextfn)codetexttable[c].name;
     if(textfn) textfn(p,file);
    }

    txflush(1);
   }
   offset+=slen;

   if(offset>=maxoffset) break;
  } while(c!=EOT);


  txgomode(!inquotemode);

  fob_unlock((fobjptr)&sourcep,file);
 }

 bf_printfeoln(bf,2,"}");

 return(NULL);
}







static os_error * txdssave(textboxstr * textp,filestr * file,buffer * bf)
{
 os_error    * err;
 int           text;
 texsrc      * texsp;
 texhdr      * texhp;
 textdatastr   data;
 int           page;
 int           section;
 sectionstr  * sectionp;
 int           i;


 text=textp->key;
 data=textp->data;
 pagesectionof((chainobject*)textp,file,&page,&section);

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));


 if(data.header && (txeditable(text,section,1,file)==NULL))
 {
  txwriteeobs(texsp[1].source,0,-1,file,bf);
 }

 if(data.footer && (txeditable(text,section,2,file)==NULL))
 {
  txwriteeobs(texsp[2].source,0,-1,file,bf);
 }

 if(!textp->fchain.prev && (txeditable(text,section,0,file)==NULL))
 {
  txwriteeobs(texsp[0].source,0,-1,file,bf);
 }


 err=bf_printfeol(bf,"TEXT_%02x={textframe",text);

 textp=(textboxstr*)fob_find(text,file);

 if(textp->master)
 {
  bf_printfeol(bf,"{master TEXT_%02x}{local %d}",textp->master,
                                              textp->flags.local);

 }

 if(!textp->master || textp->flags.local)
 {
  bf_printfeol(bf,"{lock %d} {spread %d}",textp->flags.locked,
                                         textp->flags.spread);

  if(data.repeat)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   for(i=0;i<=sectionp->data.dble;i++)
   {
    if(sectionp->data.mainkey[i]==text) break;
   }

   if(i<=sectionp->data.dble) bf_printfeol(bf,"{masterframe 1}");
   else                       bf_printfeol(bf,"{autolink 1}");
  }

  bf_printfeol(bf,"{fillcolour %s}",dscvstring2(&data.colour,file));

  bf_printfeol(bf,"{radius %d}",data.radius);

  dswritefill(&data.fill,bf,file);

  bf_printf(bf,"{columns %d}",data.columns);

  if(data.columndata.mode)
  {
   bf_printf(bf,"{columnwidth %d}",data.columndata.width);
  }
  else
  {
   bf_printf(bf,"{gutterwidth %d}",data.columndata.width);
  }

  bf_printfeol(bf,"{columnguides %d {thickness %d} %s}",
                    data.columndata.guides,
                    data.columndata.guidewidth,
                    dscvstring(&data.columndata.colour,file));

  bf_printfeol(bf,"{vertalign %d}",data.valign & 0x3);
  bf_printfeol(bf,"{firstline %d}",data.valign >> 2);

  dswriteframeborder(textp->frame,bf,file);

  if(data.changei)
  {
   dscurve(&textp->icurve,&textp->transform,"icurve",bf,file);
  }
  else
  {
   bf_printfeol(bf,"{inset %d}",data.i);
  }

  dstextflow(&textp->textflow,bf,file);

  if(textp->textflow.changeo)
  {
   dscurve(&textp->ocurve,&textp->transform,"ocurve",bf,file);
  }

  dscurve(&textp->fcurve,&textp->transform,"fcurve",bf,file);
  dstransform(&textp->fcurve.box,&textp->transform,bf);

  if(data.header || data.footer)
  {
   texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
   bf_printf(bf,"{header %d}",texhp->header);
   bf_printf(bf,"{footer %d}",texhp->footer);
  }
 }

 err=bf_printfeoln(bf,2,"}");

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 if(data.header && (txeditable(text,section,1,file)==NULL))
 {
  txwritestory(texsp[1].source,1,0,-1,file,bf);
 }

 if(data.footer && (txeditable(text,section,2,file)==NULL))
 {
  txwritestory(texsp[2].source,2,0,-1,file,bf);
 }

 if(!textp->fchain.prev && (txeditable(text,section,0,file)==NULL))
 {
  txwritestory(texsp[0].source,0,0,-1,file,bf);
 }

 return(err);
}


static os_error * txdssect(textboxstr * textp,filestr * file,buffer * bf)
{
 os_error * err;
 int        text;
 texsrc   * texsp;

 err=NULL;

 if(!textp->fchain.prev && textp->fchain.next)
 {
  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
 
  err=bf_printfeol(bf,"CHAIN_%02x={textchain",texsp[0].source);
  while(1)
  {
   bf_printfeol(bf,"TEXT_%02x",textp->key);
   text=textp->fchain.next;
   if(!text) break;
   textp=(textboxstr*)fob_find(text,file);
  }
  bf_printfeoln(bf,2,"}");
 }

 return(err);
}



os_error * txdsmessage(textboxstr * textp,int * message,
                                          filestr * file,buffer * bf)
{

 switch(*message)
 {
  case OM_DSSAVE:
                 return(txdssave(textp,file,bf));
                 break;

  case OM_DSNAME:
                 sprintf((char*)bf,"TEXT_%02x",textp->key);
                 break;

  case OM_DSSECT:
                 return(txdssect(textp,file,bf));
                 break;

 }

 return(NULL);
}

/****************************************************************************/


static absstylestr dstyle;
static int         dchain[MAXCHAIN];
static int         dchainn;
static int         dquotemode;
static textsrcstr  dtextsrc;
static int         dactionchange;
static int         dchainchange;
static int         dstylechange;
static int         dchangefont;
static int         dchangesize;
static int         dtabruler;
/*static int         dchangeleader; */
static int         dcurrentsn;





static os_error * dsfont(int fp,int argc,objectloc * loc)
{
 dsobjectstr * ds;
 int           fh;

 dsneeddoc(loc);

 if(argc)
 {
  ds=(dsobjectstr*)(dsstack+fp+2);
  fh=findxuserfont(ds->data.string);

  if(fh<0)
  {
   fh=findreplacementfont(ds->data.string);
   cprintf("replacement %d %s",fh,ds->data.string);
   if(fh<0) fh=defltfont(); /* default font */
  }

  ds=(dsobjectstr*)(dsstack+fp);
  ds->data.integer=fh;
  ds->len=3*sizeof(int);
 }
 else
 {
  ds=(dsobjectstr*)(dsstack+fp);
  ds->len=2*sizeof(int);
 }

 return(NULL);
}



static os_error * dssname(int fp,int argc,objectloc * loc)
{
 dsobjectstr * ds;
 userstylestr  us;

 ds=(dsobjectstr*)(dsstack+fp+2);

 finduserstylebyname(ds->data.string,loc->file,&us);

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=us.style.n;
 ds->len=3*sizeof(int);

 return(NULL);

 USE(argc);
}




static os_error * stsub(datawords * d,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;

 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case         DSTINT:
                       d->strikeout=ds->data.integer;
                       break;

   case        DSTTYPE:
                       d->sttype=ds1->data.integer;
                       break;

   case   DSTTHICKNESS:
                       d->stthickness=ds1->data.integer;
                       break;

   case DSTCOLOURVALUE:
                       d->stcolour.data.tint.key=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       d->stcolour.data.tint.tint=ds1->data.integer;
                       if(nsp>(sp+2+6))
                       {
                        ds1=(dsobjectstr*)(dsstack+sp+2+6);
                        d->stcolour.data.tint.overprint=ds1->data.integer;
                       }
                       break;
  }

  sp=nsp;
 }

 return(NULL);
}




static os_error * ulsub(datawords * d,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;

 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case              DSTINT:
                            d->underline=ds->data.integer;
                            break;

   case            DSTTYPE:
                           d->ultype=ds1->data.integer;
                           break;

   case       DSTTHICKNESS:
                           d->ulthickness=ds1->data.integer;
                           break;

   case     DSTCOLOURVALUE:
                           d->ulcolour.data.tint.key=ds1->data.integer;
                           ds1=(dsobjectstr*)(dsstack+sp+2+3);
                           d->ulcolour.data.tint.tint=ds1->data.integer;
                           if(nsp>(sp+2+6))
                           {
                            ds1=(dsobjectstr*)(dsstack+sp+2+6);
                            d->ulcolour.data.tint.overprint=ds1->data.integer;
                           }
                           break;

   case   DSTWORDUNDERLINE:
                           d->ulword=ds1->data.integer;
                           break;

   case DSTDOUBLEUNDERLINE:
                           d->uldouble=ds1->data.integer;
                           break;
  }
  sp=nsp;
 }

 return(NULL);
}


static os_error * vrsub(datawords * d,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;

 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case    DSTLEFTRULE:
                       d->ruleleft=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       d->ruleleftshift=ds1->data.integer;
                       break;

   case   DSTRIGHTRULE:
                       d->ruleright=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       d->rulerightshift=ds1->data.integer;
                       break;

   case   DSTTHICKNESS:
                       d->vrulethickness=ds1->data.integer;
                       break;

   case DSTCOLOURVALUE:
                       d->vrulecolour.data.tint.key=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       d->vrulecolour.data.tint.tint=ds1->data.integer;
                       if(nsp>(sp+2+6))
                       {
                        ds1=(dsobjectstr*)(dsstack+sp+2+6);
                        d->vrulecolour.data.tint.overprint=ds1->data.integer;
                       }
                       break;
  }
  sp=nsp;
 }

 return(NULL);
}


static os_error * hrsub(datawords * d,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;

 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case   DSTABOVERULE:
                       d->ruleabove=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       d->ruleaboveshift=ds1->data.integer;
                       break;

   case   DSTBELOWRULE:
                       d->rulebelow=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       d->rulebelowshift=ds1->data.integer;
                       break;

   case   DSTTHICKNESS:
                       d->hrulethickness=ds1->data.integer;
                       break;

   case DSTCOLOURVALUE:
                       d->hrulecolour.data.tint.key=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       d->hrulecolour.data.tint.tint=ds1->data.integer;
                       if(nsp>(sp+2+6))
                       {
                        ds1=(dsobjectstr*)(dsstack+sp+2+6);
                        d->hrulecolour.data.tint.overprint=ds1->data.integer;
                       }
                       break;
  }
  sp=nsp;
 }

 return(NULL);
}




static os_error * bulletsub(filestr * file,datawords * d,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;
 char          string[STYLENAMELEN];
 int           key;
 int           di1;


 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);
  di1=ds1->data.integer;

  switch(ds->type)
  {
   case           DSTINT:
                         d->bullet=ds->data.integer;
                         break;

   case  DSTBULLETBEFORE:
																									if(ds1->type==DSTSTR)
																									{
                          d->bulletbefore1=ds1->data.string[0];
																										d->bulletbefore2=0;
																									}
																									else
																									if(ds1->type==DSTUNISTR)
																									{
                          d->bulletbefore1=(ds1->data.unistring[0] & 0xFF);
																										d->bulletbefore2=(char)(((ds1->data.unistring[0])>>8) & 0xFF);
																									}
                         break;

   case   DSTBULLETAFTER:
																									if(ds1->type==DSTSTR)
																									{
                          d->bulletafter1=ds1->data.string[0];
																					 				d->bulletafter2=0;
																									}
																									else
																									if(ds1->type==DSTUNISTR)
																									{
                          d->bulletafter1=(ds1->data.unistring[0] & 0xFF);
																										d->bulletafter2=(char)(((ds1->data.unistring[0])>>8) & 0xFF);
																									}
                         break;

   case   DSTBULLETSTYLE:
                         xzstrncpy(string,ds1->data.string,sizeof(string));
                         if(strlen(string))
                         {
                          makeuserstyle(file,string,&key);
                          d->bulletstyle=key;
                         }
                         else
                         {
                          d->bulletstyle=BULLETNOSTYLE;
                         }
                         break;

   case     DSTBULLETTAB:
                         d->bullettab=di1;
                         break;

   case   DSTBULLETSTART:
                         d->bulletstart=di1;
                         break;

   case  DSTBULLETSYMBOL:
                         d->bulletornumber=1;
																									if(ds1->type==DSTSTR)
																									{
                          d->bulletdata1=ds1->data.string[0];
																					 				d->bulletdata2=0;
																									}
																									else
																									if(ds1->type==DSTUNISTR)
																									{
                          d->bulletdata1=(char)(ds1->data.unistring[0] & 0xFF);
																										d->bulletdata2=(char)(((ds1->data.unistring[0])>>8) & 0xFF);
																									}
                         break;

    case DSTBULLETFORMAT:
                         d->bulletornumber=0;
                         d->bulletdata1=(char)(di1 & 0xFF);
                         d->bulletdata2=(char)((di1>>8) & 0xFF);
                         break;
  }
  sp=nsp;
 }

 return(NULL);
}




static os_error * hpsub(datawords * d,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;
 int           di1;


 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);
  di1=ds1->data.integer;

  switch(ds->type)
  {
   case         DSTINT:
                       d->hyphenation=ds->data.integer;
                       break;

   case   DSTHPMINSIZE:
                       d->hpmin=di1;
                       break;

   case DSTHPMINBEFORE:
                       d->hpbefore=di1;
                       break;

    case DSTHPMINAFTER:
                       d->hpafter=di1;
                       break;

   case DSTHPMAXCONSEC:
                       d->hpconsec=di1;
                       break;

        case DSTHPZONE:
                       d->hpzone=di1;
                       break;

   case DSTHPBREAKPARA:
                       d->hpbreaklast=di1;
                       break;

   case DSTHPBREAKCAPS:
                       d->hpbreakcaps=di1;
                       break;

  }
  sp=nsp;
 }

 return(NULL);
}




static os_error * justsub(datawords * d,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;
 int           di1;


 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);
  di1=ds1->data.integer;

  switch(ds->type)
  {
   case          DSTINT:
                        d->justification=ds->data.integer;
                        break;

   case   DSTJMINLETTER:
                        d->justlettermin=(di1*100)/0x10000;
                        break;

   case   DSTJMAXLETTER:
                        d->justlettermax=(di1*100)/0x10000;
                        break;

   case     DSTJMINWORD:
                        d->justwordmin=(di1*100)/(0x10000*JUSTWORDSCALE);
                        break;

   case     DSTJMAXWORD:
                        d->justwordmax=(di1*100)/(0x10000*JUSTWORDSCALE);
                        break;

   case   DSTJFLUSHZONE:
                        d->justflushzone=di1;
                        break;

   case DSTJSINGLEWORDS:
                        d->justsingle=di1;
                        break;

  }
  sp=nsp;
 }

 return(NULL);
}


#define TABCHUNK 64


static os_error * dstabruler(int fp,int argc,objectloc * loc)
{
	os_error    * err;
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           n;
 tabstr      * tabs;
 int           sp;
 int           key;
 char          string[8];
 char          string2[256];
 int           seenfirstleader;
	char        * p=NULL;
	int           len;
	int           xlen;
	tabstr      * tabtemp;
	filestr     * file;


	err=NULL;

 dsneeddoc(loc);

 seenfirstleader=0;

 if(argc)
 {
		file=loc->file;

  sp=fp+2;

  n=argc;

		err=salloc((flex_ptr)&tabtemp,(n+TABCHUNK)*sizeof(tabstr));
		if(!err)
		{
			tabs=tabtemp;

   while(n--)
   {
    ds=(dsobjectstr*)(dsstack+sp);
    nsp=sp+ds->len/sizeof(int);
    ds1=(dsobjectstr*)(dsstack+sp+2);

    err=schunk((flex_ptr)&tabtemp,(tabs-tabtemp+LEADERMAXLEN)*sizeof(tabstr),TABCHUNK*sizeof(tabstr));
				if(err) break;

    if(ds->type==DSTTABLEADER)
    {
					len=0;

					if(ds1->type==DSTSTR)
     {
     	len=strlen(ds1->data.string);
						len=MIN(len,LEADERMAXLEN);
						p=ds1->data.string;
					}
					else
					if(ds1->type==DSTUNISTR)
					{
						xlen=xstrlen2(ds1->data.unistring);
						xlen=MIN(xlen,LEADERMAXLEN);
      ds1->data.unistring[xlen]=0;
      txstring21(ds1->data.unistring,string2,sizeof(string2),&len);
						if(len>xlen)
      {
       err=txunccheck(file);
							if(err) break;
						}
						p=string2;
					}

//					cprintf("unistr len %d",len);

					do
					{
      if(seenfirstleader)
      {
       tabs->type=TABDATA;
       tabs->posn=p[0]|(p[1]<<8)|(p[2]<<16)|(TSUBLEAD<<24);
//							cprintf("out %x",tabs->posn);
       tabs++;
      }
      else
      {
       XMEMCPYX(string,p,3);
							string[4]=0;
       seenfirstleader=1;
      }
						p+=3;
 					len-=3;
						if(file->compatability<UNICOMPAT) break;
					}while(len>0);
    }
    else
    if(ds->type==DSTTABDEC)
    {
					len=0;

					if(ds1->type==DSTSTR)
     {
     	len=strlen(ds1->data.string);
     	len=strlen(ds1->data.string);
						len=MIN(len,DECTABMAXLEN);
						p=ds1->data.string;
					}
					else
					if(ds1->type==DSTUNISTR)
					{
						xlen=xstrlen2(ds1->data.unistring);
						xlen=MIN(xlen,DECTABMAXLEN);
      ds1->data.unistring[xlen]=0;
      txstring21(ds1->data.unistring,string2,sizeof(string2),&len);
						if(len>xlen)
      {
       err=txunccheck(file);
							if(err) break;
						}
						p=string2;
					}

					do
					{
      tabs->type=TABDATA;
      tabs->posn=p[0]|(p[1]<<8)|(p[2]<<16)|(TSUBDEC<<24);
						p+=3;
 					len-=3;
      tabs++;
						if(file->compatability<UNICOMPAT) break;
					}while(len>0);
    }
    else
    {
     tabs->posn=ds1->data.integer;
 
     switch(ds->type)
     {
      case    DSTLEFTTAB:
                         tabs->type=TLEFT;
                         break;

      case   DSTRIGHTTAB:
                         tabs->type=TRIGHT;
                         break;

      case DSTDECIMALTAB:
                         tabs->type=TDEC;
                         break;

      case  DSTCENTRETAB:
                         tabs->type=TCENTRE;
                         break;

      case   DSTRULEPOSN:
                         tabs->type=TVRULE;
                         break;
     }        
     tabs++;
    }
    sp=nsp;
   }


//   cprintf("dst tab ruler");
   addtabruler(loc->file,&tabtemp,0,tabs-tabtemp,&key);

			sfree((flex_ptr)&tabtemp);

   ds=(dsobjectstr*)(dsstack+fp);
   ds->data.array[0]=key;
   ds->data.array[1]=*((int*)string);
   ds->len=4*sizeof(int);
		}
 }
 else
 {
  ds=(dsobjectstr*)(dsstack+fp);
  ds->len=2*sizeof(int);
 }

 return(err);
}




static void dssub1(filestr * file,int type,xstylestr * xd,
                                                   int sp,dsobjectstr * ds1)
{
 dsobjectstr * ds;
 int           key;
 int         * bits;
 int           xword;
 int           xbit;
 datawords   * d;
 int           di1;
 int           stylebits;
 int           oldbold;
 int           olditalics;
 int           nsp;


 d=&xd->data;
 oldbold=olditalics=0;

 if(type==DSTFONTSTYLE || type==DSTFONTEFFECT)
 {
  if(type==DSTFONTEFFECT)
  {
   oldbold=xd->action.bold;
   olditalics=xd->action.italic;
  }

  xd->action.bold=xd->action.italic=xd->action.font=(ds1!=NULL);
 }
 else
 {
  if(type==DSTSKEW)  key=DSTTEXTSKEW;
  else
  if(type==DSTANGLE) key=DSTTEXTANGLE;
  else
  if(type==DSTSCALE) key=DSTTEXTSCALE;
  else
  if(type==DSTLAYER) key=DSTLEVEL;
  else
  if(type==DSTSUB || type==DSTSUPER) key=DSTSUPERSUB;
  else                               key=type;


  bits=(int*)&xd->action;

  key-=DSTBOLD;
  if(key>=0 && key<ABITMAX)
  {
   xbit=key & 31;
   xword=key/32;
   if(ds1) *(bits+xword)|=(1<<xbit);
   else    *(bits+xword)&=~(1<<xbit);
  }
  else dprintf(15,"bad key type=%x",type);
 }


 if(ds1)
 {
  di1=ds1->data.integer;

  switch(type)
  {
     case       DSTBOLD:
                        d->bold=di1;
                        dchangefont|=CHANGEFONTSTYLE;
                        break;
  
      case    DSTITALIC:
                        d->italic=di1;
                        dchangefont|=CHANGEFONTSTYLE;
                        break;

     case    DSTREVERSE:
                        d->reverse=di1;
                        break;
   
    case       DSTSUPER:
                        if(di1) d->supersub=SUPS;
                        else    d->supersub&=~SUPS;
                        break;

    case         DSTSUB:
                        if(di1) d->supersub=SUBS;
                        else    d->supersub&=~SUBS;
                        break;

    case      DSTSTRIKE:
                        stsub(d,sp);
                        break;

    case   DSTUNDERLINE:
                        ulsub(d,sp);
                        break;

   case DSTVERTICALRULE:
                        vrsub(d,sp);
                        break;

  case  DSTHORIZONTALRULE:
                          hrsub(d,sp);
                          break;

    case          DSTFONT:
                          ds=(dsobjectstr*)(dsstack+sp);
                          d->font=ds->data.integer;
                          dchangefont|=CHANGEFONTNAME;
                          break;

    case     DSTFONTSTYLE:
    case    DSTFONTEFFECT:
                          ds=(dsobjectstr*)(dsstack+sp);
                          d->font=ds->data.integer;
                          dchangefont|=CHANGEFONTNAME;
                          stylebits=fontuserstyle(d->font);
                          if(!olditalics) d->italic=(stylebits>>1)&0x1;
                          if(!oldbold)    d->bold=(stylebits & 0x1);
                          break;

    case    DSTFOREGROUND:
                          nsp=sp+ds1->len/sizeof(int);

                          d->fcolour.data.tint.key=di1;
                          ds1=(dsobjectstr*)(dsstack+sp+2+3);
                          d->fcolour.data.tint.tint=ds1->data.integer;

                          if(nsp>(sp+2+6))
                          {
                           ds1=(dsobjectstr*)(dsstack+sp+2+6);
                           d->fcolour.data.tint.overprint=ds1->data.integer;
                          }
                          break;

    case    DSTBACKGROUND:
                          nsp=sp+ds1->len/sizeof(int);

                          d->bcolour.data.tint.key=di1;
                          ds1=(dsobjectstr*)(dsstack+sp+2+3);
                          d->bcolour.data.tint.tint=ds1->data.integer;

                          if(nsp>(sp+2+6))
                          {
                           ds1=(dsobjectstr*)(dsstack+sp+2+6);
                           d->bcolour.data.tint.overprint=ds1->data.integer;
                          }
                          break;

    case      DSTTEXTSIZE:
                          /* should use emsize() here */
                          d->track=scale(d->track,di1,d->ypts);
                          d->baseshift=scale(d->baseshift,di1,d->ypts);
                          d->xpts=scale(di1,d->xpts,d->ypts);
                          d->ypts=di1;
                          dchangesize=1;
                          break;

    case         DSTSCALE:
                          d->xpts=scale(d->ypts,di1,0x10000);
                          dchangesize=1;
                          break;
    
    case         DSTTRACK:
                          d->track=scale(emsize(xd),di1,0x10000);
                          break;

    case     DSTBASESHIFT:
                          d->baseshift=scale(emsize(xd),di1,0x10000);
                          break;

    case         DSTALIGN:
                          d->align=di1;
                          break;


    case  DSTSPACEBEFORE:
                         d->before=di1;
                         break;

    case   DSTSPACEAFTER:
                         d->after=di1;
                         break;

    case      DSTLEADING:
                         d->leadingtype=di1;
                         ds1=(dsobjectstr*)(dsstack+sp+2+3);
                         d->leading=ds1->data.integer;
                         break;

    case   DSTLEFTINDENT:
                         d->lefttype=di1;
                         ds1=(dsobjectstr*)(dsstack+sp+2+3);
                         d->leftshift=ds1->data.integer;
                         break;

    case  DSTRIGHTINDENT:
                         d->righttype=di1;
                         ds1=(dsobjectstr*)(dsstack+sp+2+3);
                         d->rightshift=ds1->data.integer;
                         break;

    case  DSTFIRSTINDENT:
                         d->firstshift=di1;
                         break;

    case         DSTCASE:
                         d->xcase=di1;
                         break;

    case         DSTDROP:
                         d->drop=di1;
                         ds1=(dsobjectstr*)(dsstack+sp+2+3);
                         d->dropno=ds1->data.integer;
                         break;

    case       DSTBULLET:
                         bulletsub(file,d,sp);
                         break;

   case   DSTHYPHENATION:
                         hpsub(d,sp);
                         break;

    case     DSTAUTOKERN:
                         d->akern=di1;
                         break;

    case     DSTWORDWRAP:
                         d->wordwrap=di1;
                         break;

    case        DSTINDEX:
                         d->index=di1;
                         break;

    case     DSTCONTENTS:
                         d->contents=di1;
                         break;
   
    case        DSTLAYER:
    case        DSTLEVEL:
                         d->layer=di1;
                         break;

    case DSTBASELINELOCK:
                         d->baselinelock=di1;
                         break;

  case      DSTSMALLCAPS:
                         d->smlcaps=di1;
                         break;

   case     DSTKEEPLINES:
                         d->keeplines=di1;
                         ds1=(dsobjectstr*)(dsstack+sp+2+3);
                         d->keeplinesno=ds1->data.integer;
                         break;

    case     DSTKEEPPARA:
                         d->keeppara=di1;
                         break;

    case     DSTKEEPNEXT:
                         d->keepnext=di1;
                         break;

    case     DSTTABRULER:
                         ds=(dsobjectstr*)(dsstack+sp);
                         if(dtabruler) remtabruler(file,dtabruler);
                         d->tab=dtabruler=ds->data.array[0];
                         XMEMCPYX(d->leaderchar,&ds->data.array[1],LEADERLEN);
                         /* dchangeleader=1; */
                         break;
      
    case        DSTANGLE:
                         d->rotate=(short int)(di1/360);
                         break;
   
    case         DSTSKEW:
                         d->skew=(short int)(di1/360);
                         break;

   case DSTJUSTIFICATION:
                         justsub(d,sp);

                         break;
  }
 }
 else
 {
  dactionchange=1;
 }
}


/* find text frame story belongs to - get source, lock it */
/* set offset                                             */



static void dsaddchain(int n)
{
 int i;


 if(dchainn)
 {
  if(dchain[0]==n) return;

  for(i=1;i<dchainn;i++)
  {
   if(dchain[i]==n)
   {
    memmove(dchain+1,dchain,i*sizeof(int));
    dchain[0]=n;
    break;
   }
  }

  if(i>=dchainn)
  {
   memmove(dchain+1,dchain,dchainn*sizeof(int));
   dchain[0]=n;
   dchainn++;
   if(dchainn>=MAXCHAIN)
   {
    dchainn--;
   }
  }
 }
 else
 {
  dchain[0]=n;
  dchainn=1;
 }

 dchainchange=1;
}

static void dsremchain(int n)
{
 int i;

 for(i=0;i<dchainn;i++)
 {
  if(dchain[i]==n)
  {
   memmove(dchain+i,dchain+i+1,(dchainn-1-i)*sizeof(int));
   dchainn--;
   break;
  }
 }

 dchainchange=1;
}


#ifdef NEVER

static void dsnoeffect(int fp)
{
 dsobjectstr * ds;
 int           len;
 int           type;
 int         * bits;
 int           xbit;
 int           xword;
 int           key;


 ds=(dsobjectstr*)(dsstack+fp);
 len=ds->len-2*sizeof(int);
 fp+=2;

 bits=(int*)&dstyle.style.action;

 while(len)
 {
  ds=(dsobjectstr*)(dsstack+fp);
  type=ds->type;

  if(type==DSTSKEW) key=DSTTEXTSKEW;
  else
  if(type==DSTANGLE) key=DSTTEXTANGLE;
  else
  if(type==DSTSCALE) key=DSTTEXTSCALE;
  else
  if(type==DSTSUB || type==DSTSUPER) key=DSTSUPERSUB;
  else                               key=type;

  key-=DSTBOLD;
  if(key>=0 && key<ABITMAX)
  {
   xbit=key & 31;
   xword=key/32;
   *(bits+xword)&=~(1<<xbit);
  }
  else dprintf(15,"bad key type=%x",type);

  dactionchange=1;

  len-=ds->len;
  fp+=ds->len/sizeof(int);
 }
}

#endif





static os_error * dsflushstyle(filestr * file)
{
 os_error * err;
 char     * p;
 char       data[16];

 err=NULL;

 if(!dquotemode) /* flush style */
 {
  if(dactionchange || dchainchange || dstylechange)
  {
   if(dactionchange || dchainchange)
   {
    if(dchainchange) 
        addstylechain(file,dchain,dchainn,&dstyle.chain,1);

    fillinstyle(&dstyle,file);
   }

   if(dstylechange)
   {
    checkfont(&dstyle.style,&dchangefont);
    if(dchangesize || dchangefont) dstyle.style.data.height=0;
    if(dchangefont)                dstyle.style.data.mfont=0;
  /* if(dchangeleader)              dstyle.style.data.leaderwidth=0; */
   }

   addabsstyle(file,&dstyle,1);
   if(dstyle.style.n==dcurrentsn) 
   {
    remabsstyle(file,dcurrentsn);
   }
   else
   {
    if(dtextsrc.offset==SNLEN)
    {
     remabsstyle(file,dcurrentsn);
     p=txptr(dtextsrc.sourcep,1);
     *p++=(char)dstyle.style.n;
     *p++=(char)(dstyle.style.n>>8);
     *p++=(char)(dstyle.style.n>>16);
    }
    else
    {
     data[0]=SNO;
     data[1]=(char)dstyle.style.n;
     data[2]=(char)(dstyle.style.n>>8);
     data[3]=(char)(dstyle.style.n>>16);
     err=txsourceinsert(data,SNLEN,&dtextsrc,file);
     dtextsrc.offset+=SNLEN;
    }
    dcurrentsn=dstyle.style.n;
   }

   if(dchainchange) remstylechain(file,dstyle.chain,1);

   dactionchange=dchainchange=dstylechange=0;
   dchangefont=dchangesize=0; /* dchangeleader=0; */
  }
 }

 dquotemode=1;

 return(NULL);
}





static os_error * dsonecode(int code,filestr * file)
{
 os_error * err;

 dsflushstyle(file);
 err=txsourceinsert((char*)&code,1,&dtextsrc,file);
 dtextsrc.offset+=1;

 return(err);
}



static os_error * dsstory(int fp,int argc,objectloc * loc)
{
 os_error    * err;
 textboxstr  * textp;
 texsrc      * texsp;
 texhdr      * texhp;
 char          data[256];
 int           len;
 dsobjectstr * ds;
 dsobjectstr * ds1;
 char        * p;
 filestr     * file;
 int           type;
 int           xlen;
 int           xshift;
 int           u;
 int           offset;
 chainobject * link;
	int           c;
	int           i;



 err=NULL;

 file=loc->file;

 if(argc==DSIMMINIT)
 {
  dsneeddoc(loc);
  file=loc->file;

  dquotemode=1;
  dchainn=0;
  dactionchange=dchainchange=dstylechange=0;
  dchangefont=dchangesize=0; /* dchangeleader=0; */
  dtabruler=0;

  ds=(dsobjectstr*)(dsstack+fp);

  dtextsrc.text=loc->object;

  textp=(textboxstr*)fob_find(loc->object,file);
  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));


  if(ds->type==DSTHEADERSTORY) 
  {
   u=1;
   offset=0;
  }
  else
  if(ds->type==DSTFOOTERSTORY) 
  {
   u=2;
   offset=0;
  }
  else /* if(ds->type==DSTSTORY) */
  {
   u=loc->u;
   offset=loc->offset;
  }


  dtextsrc.source=texsp[u].source;
  dtextsrc.u=u;
  dtextsrc.offset=offset;



  err=fob_lock((fobjptr)&dtextsrc.sourcep,dtextsrc.source,file);
  if(!err)
  {
   if(dtextsrc.offset<=SNLEN)
   {
    p=txptr(dtextsrc.sourcep,0);
    dcurrentsn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
    dtextsrc.offset=SNLEN;
   }
   else
   {
    vector v;

    setvectorfrombox(&v,u,loc->object,file);

    err=txlock(&v.textsrc,file);
    if(!err)
    {
     resetpoint(&v,dtextsrc.offset);
     getstylev(&v,0,&dcurrentsn);
     txunlock(&v.textsrc,file);
    }
   }

   findabsstyle(file,dcurrentsn,&dstyle);
   findstylechain(file,dstyle.chain,dchain,&dchainn);
  }
 }
 else
 if(argc==DSIMMERR)
 {
  txsourceclose(&dtextsrc,file);
  err=fob_unlock((fobjptr)&dtextsrc.sourcep,file);
 }
 else
 if(argc==DSIMMLAST)
 {
  vector      v;
  flowstr     flop;

  dsflushstyle(file);

  if(dtabruler)
  {
   remtabruler(loc->file,dtabruler);
   dtabruler=0;
  }

  txsourceclose(&dtextsrc,file);

  err=fob_unlock((fobjptr)&dtextsrc.sourcep,file);

  textp=(textboxstr*)fob_find(dtextsrc.text,file);
  if(textp->master && !textp->flags.local)
  {
   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

   if(!nullsource(texsp[dtextsrc.u].source,file))
   {
    if(dtextsrc.u==0) textp->flags.masterdata=0;
    else
    {
     texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
     if(dtextsrc.u==1) texhp->headerdata=0;
     else              texhp->footerdata=0;
    }
   }
  }


  setvectorfrombox(&v,loc->u,loc->object,file);
  movevector(&v,loc->offset);


  if(!(loc->copymode & LOCNOUPDATE))
  {
/*   setvectorfrombox(&v,loc->u,loc->object,file);
   movevector(&v,loc->offset); */

   flop.opcode=FDATA|FBOX;
   flop.data.type=FLDELTA;
   flop.data.length=0;
   flop.data.delta=dtextsrc.offset-loc->offset;
   flop.data.offset=loc->offset;

   flow(&v,&flop);
  }
 }
 else
 {
  ds=(dsobjectstr*)(dsstack+fp+2);
  type=ds->type;

  /* we must remake style if (1) chain change (2) action bit changed */
  /* we must reset font values if font changes, or bold/italic       */

  if(ds->len>2*sizeof(int)) ds1=(dsobjectstr*)(dsstack+fp+4);
  else                      ds1=NULL;

/*  dprintf(2,"type=%x len=%d",type,ds->len); */


/*  dprintf(2,"offset=%d gofset=%d len=%d maxlen=%d",
     dtextsrc.offset,dtextsrc.sourcep->goffset,
         dtextsrc.sourcep->len,dtextsrc.sourcep->maxlen); */



  switch(type)
  {
    case DSTADDUSER:
                    dsaddchain(ds1->data.integer);
                    dquotemode=0;
                    break;


    case DSTREMUSER:
                    dsremchain(ds1->data.integer);
                    dquotemode=0;
                    break;


    case     DSTSTR:
                    dsflushstyle(file);
                    len=strlen(ds->data.string);
                    xshift=0;
                    while(len)
                    {
                     xlen=MIN(sizeof(data),len);
                     XMEMCPYX(data,ds->data.string+xshift,xlen);
                     len-=xlen;
                     err=txsourceinsert(data,xlen,&dtextsrc,file);
                     dtextsrc.offset+=xlen;
                     xshift+=xlen;
                     ds=(dsobjectstr*)(dsstack+fp+2);
                    }
                    break;


    case   DSTMERGE:
                    dsflushstyle(file);
                    data[0]=MACSEQ;
                    data[1]=(char)ds->data.integer;
                    data[2]=(char)(ds->data.integer>>8);
                    data[3]=(char)(ds->data.integer>>16);
                    err=txsourceinsert(data,MSLEN,&dtextsrc,file);
                    dtextsrc.offset+=MSLEN;
                    break;

     case DSTUNISTR:
                    dsflushstyle(file);
																				err=txunccheck(file);
																				if(!err)
																				{
																					i=0;
																					while(1)
																					{
																						c=ds->data.unistring[i++];
																						if(!c) break;
                      data[0]=UNC16;
                      data[1]=(char)c;
                      data[2]=(char)(c>>8);
                      err=txsourceinsert(data,UNC16LEN,&dtextsrc,file);
                      dtextsrc.offset+=UNC16LEN;
																					}
																				}
                    break;

      case DSTSPACE:
                    dsflushstyle(file);

                    data[0]=SPACESEQ;

                    xshift=ds1->data.integer;
                    data[1]=(char)xshift;
                    data[2]=(char)(xshift>>8);
                    data[3]=(char)(xshift>>16);

                    ds1=(dsobjectstr*)(dsstack+fp+4+3);
                    xshift=ds1->data.integer;
                    data[4]=(char)xshift;
                    data[5]=(char)(xshift>>8);
                    data[6]=(char)(xshift>>16);
                    data[7]=(char)(xshift>>24);

                    ds1=(dsobjectstr*)(dsstack+fp+4+6);
                    xshift=ds1->data.integer;
                    data[8]=(char)xshift;
                    data[9]=(char)(xshift>>8);
                    data[10]=(char)(xshift>>16);
                    data[11]=(char)(xshift>>24);

                    ds1=(dsobjectstr*)(dsstack+fp+4+9);
                    xshift=ds1->data.integer;
                    data[12]=(char)xshift;
                    data[13]=(char)(xshift>>8);
                    data[14]=(char)(xshift>>16);
                    data[15]=(char)(xshift>>24);

                    err=txsourceinsert(data,SPACELEN,&dtextsrc,file);
                    dtextsrc.offset+=SPACELEN;
                    break;


    case   DSTEMBED:
                    dsflushstyle(file);
                    memset(data,0,EOBLEN);
                    data[0]=EOB;
                    data[1]=(char)ds1->data.integer;
                    data[2]=(char)(ds1->data.integer>>8);
                    data[3]=(char)(ds1->data.integer>>16);
                    data[4]=(char)(ds1->data.integer>>24);
                    err=txsourceinsert(data,EOBLEN,&dtextsrc,file);
                    dtextsrc.offset+=EOBLEN;
                    unlinkobject(ds1->data.integer,0,file);
                    link=(chainobject*)fob_find(ds1->data.integer,file);
                    link->chain.next=link->chain.prev=0;
                    link->chain.parent=dtextsrc.text;
                    break;


    case     DSTTAB:
                    dsflushstyle(file);
                    data[0]=TABSEQ;
                    data[1]=data[2]=data[3]=0;
                    err=txsourceinsert(data,TSLEN,&dtextsrc,file);
                    dtextsrc.offset+=TSLEN;
                    break;


    case      DSTNL:
                    dsonecode('\n',file);
                    break;


    case     DSTEOT:
                    break;


    case      DSTCR:
                    dsonecode('\r',file);
                    break;

    case DSTACTDATE:
                    dsonecode(ACTDATE,file);
                    break;

     case  DSTPAGEO:
                    dsonecode(PAGENO,file);
                    break;

     case DSTCHAPNO:
                    dsonecode(CHAPNO,file);
                    break;

   case DSTENDOFBOX:
                    dsonecode(EOBOX,file);
                    break;

  case DSTENDOFPAGE:
                    dsonecode(EOPAGE,file);
                    break;

 case DSTSOFTHYPHEN:
                    dsonecode(DCHYPH,file);
                    break;


/*   case DSTNOEFFECT:
                    dsnoeffect(fp+2);
                    dquotemode=0;
                    break; */

            default:
                    dstylechange=1;
                    dquotemode=0;
                    dssub1(file,type,&dstyle.style,fp+2,ds1);
                    break;
  }
 }

 return(err);
}





static os_error * dsstyle(int fp,int argc,objectloc * loc)
{
 os_error *    err;
 userstylestr  s;
 int           sp;
 int           nsp;
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           key;
 int           type;
 filestr     * file;
 int         * bits;
 int           tab=0;


 err=NULL;

 dsneeddoc(loc);

 file=loc->file;

 sp=fp+2; /* skip leading type/len */

 s=defstyle;
 s.key=-1;

 styleclrall(&s.style);
 bits=(int*)&s.style.action;
 dtabruler=0;

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  type=ds->type;
  nsp=sp+ds->len/sizeof(int);

  if(ds->len>2*sizeof(int)) ds1=(dsobjectstr*)(dsstack+sp+2);
  else                      ds1=NULL;

  switch(type)
  {
   case       DSTNAME:
                      xstrncpy(s.name,ds1->data.string,STYLENAMELEN);
                      break;

   case        DSTKEY:
                      s.key=ds->data.integer;
                      break;

   case     DSTTSCOPE:
                      s.scope=ds1->data.integer;
                      break;

   case        DSTSTR:
                      xstrncpy(s.name,ds->data.string,STYLENAMELEN);
                      break;

              default:
                      dssub1(file,type,&s.style,sp,ds1);
                      break;
  }

  sp=nsp;
 }

 if(!s.style.action.font)
 {
  s.style.data.font=defltfont();
 }

// cprintf("ds create user style");

 if(!s.style.action.tab)  
 {
  deftabruler(&tab,file);
  s.style.data.tab=tab;
//  cprintf("ds def tab");
 }

 adduserstyle2(&s,file,&key,1,0);

 if(!s.style.action.tab)
 {
//  cprintf("ds rem def tab");
  remtabruler(file,tab);
 }

 if(dtabruler)
 {
//  cprintf("dtab rem");
  remtabruler(file,dtabruler);
  dtabruler=0;
 }

// cprintf("ds create user style x");

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=key;
 ds->len=3*sizeof(int);

 return(err);
}



static os_error * columnguidessub(unpackedtextdatastr * data,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           sl;

 ds=(dsobjectstr*)(dsstack+sp);
 sl=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<sl)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case             DSTINT:
                           data->columndata.guides=ds->data.integer;
                           break;

   case     DSTCOLOURVALUE:
                           data->columndata.colour.data.tint.key=
                                                       ds1->data.integer;
                           ds1=(dsobjectstr*)(dsstack+sp+2+3);
                           data->columndata.colour.data.tint.tint=
                                                       ds1->data.integer;
                           if(nsp>(sp+2+6))
                           {
                            ds1=(dsobjectstr*)(dsstack+sp+2+6);
                            data->columndata.colour.data.tint.overprint=
                                                        ds1->data.integer;
                           }
                           break;

   case       DSTTHICKNESS:
                           data->columndata.guidewidth=ds1->data.integer;
                           break;
  }
  sp=nsp;
 }

 return(NULL);
}




static os_error * dstext(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 unpackedtextdatastr data;
 int                 sp;
 int                 nsp;
 dsobjectstr       * ds;
 dsobjectstr       * ds1;
 curvestr            c;
 curvestr            t;
 curvestr            ic;
 curvestr            oc;
 textflowstr         flow;
 transformstr        tr;
 int                 angle;
 int                 skew;
 int                 master;
 int                 local;
 int                 masterframe;
 textboxstr        * textp;
 sectionmapstr       map;
 objectloc           sloc;
 texsrc            * texsp;
 int                 di1;
 int                 frame;
 int                 changei;
 int                 changeo;
 int                 lock;
 int                 spread;


 err=NULL;

 sp=fp+2; /* skip leading type/len */

 data=deflttextdata;
 flow=deflttextflow;
 tr_setidentity(&tr);
 angle=skew=master=local=masterframe=frame=lock=spread=0;
 changei=changeo=0;

 nullcurve(&c);
 nullcurve(&ic);
 nullcurve(&oc);

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);
  di1=ds1->data.integer;


  switch(ds->type)
  {
   case     DSTLOCAL:
                     local=di1;
                     break;

   case    DSTMASTER:
                     master=di1;
                     textp=(textboxstr*)fob_find(master,loc->file);
                     unpacktextdata(&data,textp);
                     tr=textp->transform;
                     t=textp->fcurve;
                     deletecurve(&c,loc->file);
                     copycurve(&c,loc->file,&t,loc->file);
                     lock=textp->flags.locked;
                     spread=textp->flags.spread;
                     break;

   case      DSTLOCK:
                     lock=di1;
                     break;

   case    DSTSPREAD:
                     spread=di1;
                     break;

  case DSTMASTERFRAME:
                      masterframe=1;

  case    DSTAUTOLINK:
                      data.repeat=1;
                      break;

   case DSTFILLCOLOUR:
                      data.colour.data.tint.key=di1;
                      ds1=(dsobjectstr*)(dsstack+sp+2+3);
                      data.colour.data.tint.tint=ds1->data.integer;
                      if(nsp>(sp+2+6))
                      {
                       ds1=(dsobjectstr*)(dsstack+sp+2+6);
                       data.colour.data.tint.overprint=ds1->data.integer;
                      }
                      break;

   case     DSTRADIUS:
                      data.radius=di1;
                      break;

   case     DSTFCURVE:
                      deletecurve(&c,loc->file);
                      c=ds->data.curve;
                      break;

   case     DSTOCURVE:
                      oc=ds->data.curve;
                      changeo=1;
                      break;

   case     DSTICURVE:
                      ic=ds->data.curve;
                      changei=1;
                      break;

   case  DSTVERTALIGN:
                      data.valign&=~0x3;
                      data.valign|=(di1 & 0x3);
                      break;

   case  DSTFIRSTLINE:
                      data.valign&=~0xC;
                      data.valign|=((di1 & 0x3)<<2);
                      break;

   case    DSTCOLUMNS:
                      data.columns=di1;
                      break;

   case      DSTINSET:
                      data.inset=di1;
                      break;

   case   DSTTEXTFLOW:
                      flow.fmode=di1;
                      ds1=(dsobjectstr*)(dsstack+sp+2+3);
                      flow.omode=ds1->data.integer;
                      ds1=(dsobjectstr*)(dsstack+sp+2+6);
                      flow.o=ds1->data.integer;
                      break;

  case DSTGUTTERWIDTH:
                      data.columndata.mode=0;
                      data.columndata.width=di1;
                      break;

  case DSTCOLUMNWIDTH:
                      data.columndata.mode=1;
                      data.columndata.width=di1;
                      break;

  case DSTCOLUMGUIDES:
                      columnguidessub(&data,sp);
                      break;

   case     DSTHEADER:
                      data.header=di1;
                      break;

   case     DSTFOOTER:
                      data.footer=di1;
                      break;

    case     DSTANGLE:
                      angle=-di1;
                      break;

    case      DSTSKEW:
                      skew=-di1;
                      break;

  case DSTFRAMEBORDER:
//                      cprintf("set frame %d",ds->data.integer);
                      frame=ds->data.integer;
                      break;

   case       DSTFILL:
                      data.fill.fill=ds->data.integer;
                      break;


  }
  sp=nsp;
 }

 getboxtransform(&tr,&c,skew,angle);

 loc->copymode|=LOCNEW;

 if(master && !local && !loc->branch)
 {
  sloc=*loc;
  sloc.object=master;
  sloc.branch=1;

  tr_setidentity(&tr);
 
  err=textcopy(&sloc,loc,&tr);
 }
 else
 {
  err=createtexts1(loc,&c,&data,&flow,&tr,frame,
                                          changei?&ic:NULL,changeo?&oc:NULL);
  if(loc->branch && data.repeat)
  {
   textp=(textboxstr*)fob_find(loc->object,loc->file);
   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
   map.msource=texsp[0].source;
   map.mvsource=texsp[0].vsource;
   map.dsource=map.dvsource=0;
   sectionaddmap(&map,loc->section,loc->file,-1);
  }
 }

 if(!err)
 {
  textp=(textboxstr*)fob_find(loc->object,loc->file);
  textp->flags.local=local;
  textp->master=master;
  textp->flags.locked=lock;
  textp->flags.spread=spread;

//  cprintf("textk %d frame %d",loc->object,textp->frame);

 /* dprintf(0,"text=%d full=%d",loc->object,textp->flags.full); */


  loc->after=loc->object;
  loc->parent=0;

  loc->u=0;
  loc->offset=0;

  ds=(dsobjectstr*)(dsstack+fp);
  ds->data.integer=loc->object;
  ds->len=3*sizeof(int);

  if(masterframe)
  {
   setupmainframe(loc);
  }
 }

 deletecurve(&c,loc->file);
 deletecurve(&ic,loc->file);
 deletecurve(&oc,loc->file);

 return(err);
}





static os_error * dstextchain(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 filestr           * file;
 int                 linksource;
 int                 linkvsource;
 int                 prevtext;
 int                 source;
 int                 vsource;
 int                 text;
 textboxstr        * textp;
 texsrc            * texsp;
 int                 sp;
 int                 nsp;
 dsobjectstr       * ds;


 err=NULL;
 file=loc->file;

 sp=fp+2; /* skip leading type/len */
 linksource=linkvsource=0;
 prevtext=0;     /* compiler */



 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);

  text=ds->data.integer;

  textp=(textboxstr*)fob_find(text,file);

  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
  source=texsp[0].source;
  vsource=texsp[0].vsource;


  if(!linksource)
  {
   linksource=source;
   linkvsource=vsource;
  }
  else
  {
   texsp[0].source=linksource;
   texsp[0].vsource=linkvsource;
   textp->fchain.prev=prevtext; 
   textp=(textboxstr*)fob_find(prevtext,file);
   textp->fchain.next=text; 

   if(loc->branch && textp->data.repeat)
   {
    sectionremmap(source,loc->section,file,-1);
   }

   if(!textp->data.repeat || loc->branch)
   {
    if(source && source!=linksource)    txsourcedel(source,file,1);
    if(vsource && vsource!=linkvsource) vsourcedel(vsource,file);
   }
  }

  prevtext=text;

  sp=nsp;
 }

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=linksource;
 ds->len=3*sizeof(int);

 return(err);
}



os_error * txdscolours(filestr * file,buffer * bf)
{
 os_error * err;
 int        i;

 err=NULL;

 for(i=0;i<colourentries;i++)
 {
  err=dsputcolour(colourmap[i].old,file,bf);
  if(err) break;
 }

 return(err);
}




os_error * txdsloc(textboxstr * textp,int * message,filestr * file,void * data)
{
 os_error        * err;
 vector            v;
 dslocmessagestr * dm;

 err=NULL;

 dm=(dslocmessagestr*)data;

 if(dm->posn)
 {
  err=posn2vector(dm->posn,&v,NULL);
  if(!err && v.valid)
  {
   (dm->loc)->offset=v.textsrc.offset;
   (dm->loc)->u=v.textsrc.u;
   *message=0;
  }
 }
 else
 {
  if(act.valid)
  {
   (dm->loc)->offset=act.textsrc.offset;
   (dm->loc)->u=act.textsrc.u;
   *message=0;
  }
 }


 return(err);

 USE(textp);
 USE(file);
}


/*****************************************************************************/




static int dsnulllist[]={
                           DSTENDLIST
                          };



static dscreator dsdefs7[]=
{
 0,0,0,0, "bold",      NULL,     0, DSTBOLD,       dsnulllist,
 0,0,0,0, "italic",    NULL,     0, DSTITALIC,     dsnulllist,
 0,0,0,0, "underline", NULL,     0, DSTUNDERLINE,  dsnulllist,
 0,0,0,0, "reverse",   NULL,     0, DSTREVERSE,    dsnulllist,

 /* supersub */

 0,0,0,0, "strikeout", NULL,     0, DSTSTRIKE,     dsnulllist,
 0,0,0,0, "verticalrule",NULL,   0, DSTVERTICALRULE,dsnulllist,
 0,0,0,0, "horizontalrule",NULL, 0, DSTHORIZONTALRULE,dsnulllist,
 0,0,0,0, "font",      dsfont,   0, DSTFONT,       dsnulllist,
 0,0,0,0, "foreground",NULL,     0, DSTFOREGROUND, dsnulllist,
 0,0,0,0, "background",NULL,     0, DSTBACKGROUND, dsnulllist,
 0,0,0,0, "textsize"  ,NULL,     0, DSTTEXTSIZE,   dsnulllist,

 /* text scale */

 0,0,0,0, "track"     ,NULL,     0, DSTTRACK,      dsnulllist,
 0,0,0,0, "baseshift" ,NULL,     0, DSTBASESHIFT,  dsnulllist,
 0,0,0,0, "align"     ,NULL,     0, DSTALIGN,      dsnulllist,
 0,0,0,0, "spacebefore",NULL,    0, DSTSPACEBEFORE,dsnulllist,
 0,0,0,0, "spaceafter",NULL,     0, DSTSPACEAFTER, dsnulllist,
 0,0,0,0, "leading",   NULL,     0, DSTLEADING,    dsnulllist,
 0,0,0,0, "leftindent",NULL,     0, DSTLEFTINDENT, dsnulllist,
 0,0,0,0, "rightindent",NULL,    0, DSTRIGHTINDENT,dsnulllist,
 0,0,0,0, "firstindent",NULL,    0, DSTFIRSTINDENT,dsnulllist,
 0,0,0,0, "case",      NULL,     0, DSTCASE,       dsnulllist,
 0,0,0,0, "drop",      NULL,     0, DSTDROP,       dsnulllist,
 0,0,0,0, "bullet",    NULL,     0, DSTBULLET,     dsnulllist,
 0,0,0,0, "hyphenation",NULL,    0, DSTHYPHENATION,dsnulllist,
 0,0,0,0, "autokern",  NULL,     0, DSTAUTOKERN,   dsnulllist,
 0,0,0,0, "wordwrap",  NULL,     0, DSTWORDWRAP,   dsnulllist,
 0,0,0,0, "index",     NULL,     0, DSTINDEX,      dsnulllist,
 0,0,0,0, "contents",  NULL,     0, DSTCONTENTS,   dsnulllist,
 0,0,0,0, "level",     NULL,     0, DSTLEVEL,      dsnulllist,
 0,0,0,0, "baselinelock",NULL,   0, DSTBASELINELOCK,dsnulllist,
 0,0,0,0, "smallcaps", NULL,     0, DSTSMALLCAPS,  dsnulllist,
 0,0,0,0, "keeplines", NULL,     0, DSTKEEPLINES,  dsnulllist,
 0,0,0,0, "keeppara",  NULL,     0, DSTKEEPPARA,   dsnulllist,
 0,0,0,0, "keepnext",  NULL,     0, DSTKEEPNEXT,   dsnulllist,
 0,0,0,0, "language",  NULL,     0, DSTLANGUAGE,   dsnulllist,
 0,0,0,0, "tabruler", dstabruler,0, DSTTABRULER,   dsnulllist,

 /* angle */
 /* skew  */

 0,0,0,0, "justification",NULL,  0, DSTJUSTIFICATION,dsnulllist,

};


static dscreator dsdefs6[]=
{
 0,0,0,0, "style",     dsstyle,  0, DSTSTYLE,      dsnulllist,
 0,0,0,0, "stylename", dssname,  0, DSTSTYLE,      dsnulllist,

 0,0,0,0, "textframe", dstext,   0, DSTTEXT,       dsnulllist,

 0,0,0,0, "story",      dsstory,DSCREATEIMMEDIATE,DSTSTORY,dsnulllist,


 0,0,0,0, "lefttab",   NULL,     0, DSTLEFTTAB,    dsnulllist,
 0,0,0,0, "righttab",  NULL,     0, DSTRIGHTTAB,   dsnulllist,
 0,0,0,0, "decimaltab",NULL,     0, DSTDECIMALTAB, dsnulllist,
 0,0,0,0, "centretab", NULL,     0, DSTCENTRETAB,  dsnulllist,
 0,0,0,0, "ruleposn",  NULL,     0, DSTRULEPOSN,   dsnulllist,



 0,0,0,0, "tab",       NULL,     0, DSTTAB,        dsnulllist,
 0,0,0,0, "endoftext", NULL,     0, DSTEOT,        dsnulllist,
 0,0,0,0, "newpara",   NULL,     0, DSTNL,         dsnulllist,
 0,0,0,0, "newline",   NULL,     0, DSTCR,         dsnulllist,
 0,0,0,0, "activedate",NULL,     0, DSTACTDATE,    dsnulllist,
 0,0,0,0, "pageno",    NULL,     0, DSTPAGEO,      dsnulllist,

 0,0,0,0, "columns",   NULL,     0, DSTCOLUMNS,    dsnulllist,
 0,0,0,0, "vertalign", NULL,     0, DSTVERTALIGN,  dsnulllist,

 0,0,0,0, "super",     NULL,     0, DSTSUPER,      dsnulllist,
 0,0,0,0, "sub",       NULL,     0, DSTSUB,        dsnulllist,


 0,0,0,0, "wordunderline",NULL,  0, DSTWORDUNDERLINE,dsnulllist,
 0,0,0,0, "doubleunderline",NULL,0, DSTDOUBLEUNDERLINE,dsnulllist,

 0,0,0,0, "leftrule",  NULL,     0, DSTLEFTRULE,   dsnulllist,
 0,0,0,0, "rightrule", NULL,     0, DSTRIGHTRULE,  dsnulllist,

 0,0,0,0, "aboverule", NULL,     0, DSTABOVERULE,  dsnulllist,
 0,0,0,0, "belowrule", NULL,     0, DSTBELOWRULE,  dsnulllist,


 0,0,0,0, "adduserstyle",NULL,   0, DSTADDUSER,    dsnulllist,
 0,0,0,0, "remuserstyle",NULL,   0, DSTREMUSER,    dsnulllist,

 0,0,0,0, "merge",     dsmerge,  0, DSTMERGE,      dsnulllist,

 0,0,0,0, "chapterno", NULL,     0, DSTCHAPNO,     dsnulllist,
 0,0,0,0, "newframe",  NULL,     0, DSTENDOFBOX,   dsnulllist,
 0,0,0,0, "newpage",   NULL,     0, DSTENDOFPAGE,  dsnulllist,

/* 0,0,0,0, "noeffect",  NULL,   0, DSTNOEFFECT,   dsnulllist, */
 0,0,0,0, "tableader", NULL,     0, DSTTABLEADER,  dsnulllist,
 0,0,0,0, "tabdec",    NULL,     0, DSTTABDEC,     dsnulllist,
 0,0,0,0, "scope",     NULL,     0, DSTTSCOPE,     dsnulllist,


 0,0,0,0, "headerstory",dsstory,DSCREATEIMMEDIATE,DSTHEADERSTORY,dsnulllist,
 0,0,0,0, "footerstory",dsstory,DSCREATEIMMEDIATE,DSTFOOTERSTORY,dsnulllist,



 0,0,0,0, "gutterwidth",NULL,    0, DSTGUTTERWIDTH,dsnulllist,
 0,0,0,0, "columnwidth",NULL,    0, DSTCOLUMNWIDTH,dsnulllist,
 0,0,0,0, "columnguides",NULL,   0, DSTCOLUMGUIDES,dsnulllist,
 0,0,0,0, "header",    NULL,     0, DSTHEADER,     dsnulllist,
 0,0,0,0, "footer",    NULL,     0, DSTFOOTER,     dsnulllist,
 0,0,0,0, "textchain", dstextchain,0,DSTTEXTCHAIN, dsnulllist,
 0,0,0,0, "masterframe",NULL,    0, DSTMASTERFRAME,dsnulllist,
 0,0,0,0, "autolink",  NULL,     0, DSTAUTOLINK,   dsnulllist,

 0,0,0,0, "bulletbefore",NULL,   0, DSTBULLETBEFORE,dsnulllist,
 0,0,0,0, "bulletafter", NULL,   0, DSTBULLETAFTER, dsnulllist,
 0,0,0,0, "bulletstyle", NULL,   0, DSTBULLETSTYLE, dsnulllist,
 0,0,0,0, "bullettab"  , NULL,   0, DSTBULLETTAB,   dsnulllist,
 0,0,0,0, "bulletstart", NULL,   0, DSTBULLETSTART, dsnulllist,
 0,0,0,0, "bulletsymbol",NULL,   0, DSTBULLETSYMBOL,dsnulllist,
 0,0,0,0, "bulletformat",NULL,   0, DSTBULLETFORMAT,dsnulllist,
 0,0,0,0, "fontstyle",   dsfont, 0, DSTFONTSTYLE,   dsnulllist,

 0,0,0,0, "hpminsize",   NULL,   0, DSTHPMINSIZE,   dsnulllist,
 0,0,0,0, "hpminbefore", NULL,   0, DSTHPMINBEFORE, dsnulllist,
 0,0,0,0, "hpminafter",  NULL,   0, DSTHPMINAFTER,  dsnulllist,
 0,0,0,0, "hpmaxconsecutive",NULL,0,DSTHPMAXCONSEC, dsnulllist,
 0,0,0,0, "hpzone",      NULL,   0, DSTHPZONE,      dsnulllist,
 0,0,0,0, "hpbreakpara", NULL,   0, DSTHPBREAKPARA, dsnulllist,
 0,0,0,0, "hpbreakcaps", NULL,   0, DSTHPBREAKCAPS, dsnulllist,

 0,0,0,0, "justminletter",NULL,  0, DSTJMINLETTER,  dsnulllist,
 0,0,0,0, "justmaxletter",NULL,  0, DSTJMAXLETTER,  dsnulllist,
 0,0,0,0, "justminword",  NULL,  0, DSTJMINWORD,    dsnulllist,
 0,0,0,0, "justmaxword",  NULL,  0, DSTJMAXWORD,    dsnulllist,
 0,0,0,0, "justflushzone",NULL,  0, DSTJFLUSHZONE,  dsnulllist,
 0,0,0,0, "justsinglewords",NULL,0, DSTJSINGLEWORDS,dsnulllist,



 0,0,0,0, "fonteffect",  dsfont, 0, DSTFONTEFFECT,  dsnulllist,

 0,0,0,0, "embed",       NULL,   DSPRESERVELOC, DSTEMBED,dsnulllist,

 0,0,0,0, "layer",       NULL,   0, DSTLAYER,       dsnulllist,

 0,0,0,0, "softhyphen",  NULL,   0, DSTSOFTHYPHEN,  dsnulllist,

 0,0,0,0, "firstline",   NULL,   0, DSTFIRSTLINE,   dsnulllist,

 0,0,0,0, "space",       NULL,   0, DSTSPACE,       dsnulllist,


};




static char * bitname(int bit)
{
 if(bit>(DSTTEXTSKEW-DSTBOLD))   bit--;
 else
 if(bit==(DSTTEXTSKEW-DSTBOLD))  return("skew");

 if(bit>(DSTTEXTANGLE-DSTBOLD))  bit--;
 else
 if(bit==(DSTTEXTANGLE-DSTBOLD)) return("angle");

 if(bit>(DSTTEXTSCALE-DSTBOLD))  bit--;
 else
 if(bit==(DSTTEXTSCALE-DSTBOLD)) return("scale");

 if(bit>(DSTSUPERSUB-DSTBOLD))   bit--;
 else
 if(bit==(DSTSUPERSUB-DSTBOLD))  return("sub");

 return(dsdefs7[bit].name);
}





os_error * txdsinit(void)
{
 dsaddblock(dsdefs7,sizeof(dsdefs7)/sizeof(dscreator));
 dsaddblock(dsdefs6,sizeof(dsdefs6)/sizeof(dscreator));
 return(addevent(EVENT_DSSAVE2,(eventfn)txevent,0));
}


