/*->c.bff */

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "os.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"
#include "err.h"
#include "fsx.h"
#include "bf.h"
#include "wimpt.h"
#include "timex.h"
#include "etc.h"



os_error * bf_printf(buffer * bf,TCHAR * format, ...)
{
 os_error * err;
 va_list    args;
 TCHAR      string[1024];
 int        len;

	err=NULL;

 va_start(args,format);
 VSNPRINTF(string,sizeof(string)/sizeof(TCHAR),format,args,len);
 va_end(args);

// len=strlen(string);

// on error len can be -ve
	if(len>0)
	{
  err=bf_write(bf,string,len);
	}

 return(err);
}



os_error * bf_printfeoln(buffer * bf,int n,TCHAR * format, ...)
{
 os_error * err;
 va_list    args;
 TCHAR      string[1024];
 int        len;
	int        lt;

	err=NULL;

 va_start(args,format);
 VSNPRINTF(string,sizeof(string)/sizeof(TCHAR),format,args,len);
 va_end(args);

// len=strlen(string);
// on error len can be -ve

	lt=sizeof(string)/sizeof(TCHAR)-2;

	if(len>=0)
	{
		while(n--)
		{
			if(len<=lt)
			{
   	string[len++]='\r';
   	string[len++]='\n';
			}
		}

  err=bf_write(bf,string,len);
	}

 return(err);
}



os_error * bf_printfeol(buffer * bf,TCHAR * format, ...)
{
 os_error * err;
 va_list    args;
 TCHAR      string[1024];
 int        len;

	err=NULL;

 va_start(args,format);
 VSNPRINTF(string,sizeof(string)/sizeof(TCHAR),format,args,len);
 va_end(args);

// len=strlen(string);
// on error len can be -ve

	if(len>=0)
	{
 	string[len++]='\r';
 	string[len++]='\n';

  err=bf_write(bf,string,len);
	}

 return(err);
}



os_error * bf_getstring(buffer * bf,char * string,int maxlen,int * eof)
{
 os_error * err;
 char     * p;
 int        c;
	int        c2;

 err=NULL;
 p=string;
 *eof=0;

 while(maxlen)
 {
  err=bf_getc(bf,&c);

  if(err) break;

  if(!c) break;

  if(c=='\r' || c=='\n')
  {
			err=bf_peek(bf,&c2);

			if(!err && (c2=='\r' || c2=='\n') && c!=c2)
			{
				bf_getc(bf,&c2);
			}

   break;
		}

  if(c==EOF)
  {
   *eof=1;
   break;
  }

  *p++=(char)c;
  maxlen--;
 }

 if(maxlen==0) *(p-1)=0;
 else          *p=0;

 return(err);
}





os_error * stdfileheader(buffer * bf,char * name)
{
 char string[256];

 bf_printfeol(bf,"//->%s",name);

 writesystimedate(string);

 return(bf_printf(bf,
        "// Produced by %s at %s\r\n//\r\n//\r\n\r\n\r\n",wimpt_programname(),string));
}


