/*->c.drag */

#include "stdafx.h"


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <stdarg.h>

#include "os.h"
#include "wimp.h"
#include "sprite.h"
#include "werr.h"
#include "wimpt.h"
#include "bbc.h"
#include "akbd.h"


#include "oserr.h"
#include "osunits.h"


#include "wos.h"
#include "task.h"
#include "etc.h"
#include "colour.h"
#include "deb.h"



#include "drag.h"

#include "osdrag.h"


os_error * dragicon(int mx,int my,wimp_w w,int i)
{
 os_error   * err;
 wimp_dragstr drg;
 windowstr    window;
 iconstr      icon;

 err=getw(w,&window);
 if(!err) err=geti(w,i,&icon);
 if(!err)
 {
  drg.window=w;
  drg.type=wimp_USER_FIXED;
  drg.box.x0=window.bx+icon.ix0;
  drg.box.y0=window.by+icon.iy0;
  drg.box.x1=window.bx+icon.ix1;
  drg.box.y1=window.by+icon.iy1;
  drg.parent.x0=drg.box.x0-mx;
  drg.parent.y0=drg.box.y0-my;
  drg.parent.x1=drg.box.x1-mx+cvdu.screenx;
  drg.parent.y1=drg.box.y1-my+cvdu.screeny;

  err=wimp_drag_box(&drg);
 }
 return(err);
}




os_error * dragasprite(wimp_w w,int i)
{

 return(NULL);

 USE(w);
 USE(i);
}


os_error * dragaspritestop(void)
{
 return(NULL);
}


/* brings drag to sudden halt */

os_error * dragstop(void)
{
 return(wimp_drag_box((wimp_dragstr *)-1));
}



os_error * userdrag(wimp_w handle,int x0,int y0,int x1,int y1)
{
 wimp_dragstr dblock;
 mousestr mouse;

 getpointer(&mouse);

 dblock.window=handle;
 dblock.type=wimp_USER_HIDDEN;
 dblock.box.x0=mouse.x;
 dblock.box.y0=mouse.y;
 dblock.box.x1=mouse.x;
 dblock.box.y1=mouse.y;
 dblock.parent.x0=x0;
 dblock.parent.y0=y0;
 dblock.parent.x1=x1;
 dblock.parent.y1=y1;
 return(wimp_drag_box(&dblock));
}





os_error * dragawindow(wimp_mousestr * m)
{
 os_error   * err;
 wimp_dragstr drg;
 windowstr    window;

 err=getw(m->w,&window);
 if(!err)
 {
  drg.window=m->w;
  drg.type=wimp_MOVE_WIND;

  err=wimp_drag_box(&drg);
 }
 return(err);
}



static void DrawXorBar(HDC hdc,int x1,int y1,int width,int height,int update,int x2,int y2)
{
 static WORD _dotPatternBmp[8]= 
	{ 
		0x00aa, 0x0055, 0x00aa, 0x0055, 
		0x00aa, 0x0055, 0x00aa, 0x0055
	};

	HBITMAP hbm;
	HBRUSH  hbr, hbrushOld;

	hbm=CreateBitmap(8,8,1,1,_dotPatternBmp);
	hbr=CreatePatternBrush(hbm);
	
	SetBrushOrgEx(hdc,x1,y1,0);
	hbrushOld=(HBRUSH)SelectObject(hdc,hbr);
	
	PatBlt(hdc,x1,y1,width,height,PATINVERT);
 if(update)
 {
  UnrealizeObject(hbr);
 	SetBrushOrgEx(hdc,x2,y2,0);
  SelectObject(hdc, hbr);
  PatBlt(hdc,x2,y2,width,height,PATINVERT);
 }
	
	SelectObject(hdc,hbrushOld);
	
	DeleteObject(hbr);
	DeleteObject(hbm);
}



static int smx;
static int smy;
static int cmx;
static int cmy;

static wimp_dragstr drag;
static wimp_box     sbox;

#define SPLITSIZE 4


static os_error * dragdisplay2(HDC hdc,int update,int nmx,int nmy)
{
 HBRUSH oldbrush;
 HPEN   newpen;
 HPEN   oldpen;


 if(drag.type==wimp_USER_SPLITTER)
 {
  if(drag.box.x0==drag.box.x1)
  {
   DrawXorBar(hdc,drag.box.x0+cmx-smx,drag.box.y1,SPLITSIZE,drag.box.y0-drag.box.y1,
                  update,drag.box.x0+nmx-smx,drag.box.y1);
  }
  else
  {
   DrawXorBar(hdc,drag.box.x0,drag.box.y1+cmy-smy,drag.box.x1-drag.box.x0,SPLITSIZE,
                  update,drag.box.x0,drag.box.y1+cmy-smy);
  }
 }
 else
 if(drag.type==wimp_USER_FIXED)
 {
  int prevb;

  XSetBkMode(hdc,TRANSPARENT,&prevb);
  
  oldbrush=(HBRUSH)SelectObject(hdc,GetStockObject(NULL_BRUSH));
  newpen=CreatePen(PS_DOT,0,RGB(255,255,255));
  oldpen=(HPEN)SelectObject(hdc,newpen);
  SetROP2(hdc,R2_XORPEN);

  Rectangle(hdc,drag.box.x0+cmx-smx,drag.box.y1+cmy-smy,drag.box.x1+cmx-smx,drag.box.y0+cmy-smy);
  if(update)
  {
   Rectangle(hdc,drag.box.x0+nmx-smx,drag.box.y1+nmy-smy,drag.box.x1+nmx-smx,drag.box.y0+nmy-smy);
  }

  SelectObject(hdc,oldbrush);
  SelectObject(hdc,oldpen);
  XSetBkMode(hdc,prevb,&prevb);

  DeleteObject(newpen);
 }
 else
 if(drag.type==wimp_USER_RUBBER)
 {


 }

 return(NULL);
}


static os_error * dragdisplay(int update,int nmx,int nmy)
{
 os_error * err;
 HDC        hdc;

	err=NULL;

//	cprintf("drag handle %x",drag.window);
	if(drag.window)
	{
  hdc=GetDC((HWND)drag.window);

  err=dragdisplay2(hdc,update,nmx,nmy);

  ReleaseDC((HWND)drag.window,hdc);
	}

 return(err);
}




os_error * drageffectstart(wimp_dragstr * d)
{
 POINT pt;

 XGetCursorPos(&pt);
 ScreenToClient((HWND)(d->window),&pt);

 smx=cmx=pt.x;
 smy=cmy=pt.y;

 drag=*d;
 sbox=drag.box;

 pt.x=xcoordos2pix(drag.box.x0);
 pt.y=ycoordos2pix(drag.box.y0);

 ScreenToClient((HWND)(d->window),&pt);

 drag.box.x0=pt.x;
 drag.box.y0=pt.y;


 pt.x=xcoordos2pix(drag.box.x1);
 pt.y=ycoordos2pix(drag.box.y1);

 ScreenToClient((HWND)(d->window),&pt);

 drag.box.x1=pt.x;
 drag.box.y1=pt.y;


 dragdisplay(0,cmx,cmy);

 return(NULL);
}



os_error * drageffectend(wimp_box * box)
{
 dragdisplay(0,cmx,cmy);

 if(box) *box=sbox;

 if(drag.type==wimp_USER_SPLITTER)
 {
  if(drag.box.x0==drag.box.x1)
  {
   if(box) box->x0=box->x1=sbox.x0+xpix2os(cmx-smx);
  }
  else
  {
   if(box) box->y0=box->y1=sbox.y0-ypix2os(cmy-smy);
  }
 }
 else
 if(drag.type==wimp_USER_FIXED)
 {
  

 }
 else
 if(drag.type==wimp_USER_RUBBER)
 {


 }


 drag.window=0;

 return(NULL);
}



os_error * drageffectprocess(int x,int y)
{

 dragdisplay(1,x,y);

 cmx=x;
 cmy=y;

 return(NULL);
}



os_error * drageffectscroll(wimp_w handle,int pass)
{
 if(drag.window==handle) return(dragdisplay(0,cmx,cmy));
 return(NULL);
 USE(pass);
}




os_error * drageffectpaint(wimp_w handle,HDC hdc,int pass)
{
 os_error * err;

 err=NULL;

 if(drag.window==handle)
 {
  if(pass)
  {
            err=XSetMapMode(hdc, MM_TEXT,NULL);
   if(!err) err=XSetWindowOrgEx(hdc,0,0,NULL);
   if(!err) err=XSetViewportOrgEx(hdc,0,0,NULL);
  }

  dragdisplay2(hdc,0,cmx,cmy);
 }

 return(err);
}

