/*->c.ram     */


#include <stdafx.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <stdarg.h>


#include "os.h"
#include "wimp.h"


#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "flex.h"
#include "alloc.h"
#include "deb.h"


#include "ram.h"


/*****************************************************************************/
                         /* RAM Transfer code */


static char * readdata;
static char * readptr;
static char * readlt;
static int    readsize;


os_error * ramreadsize(int * size)
{
 *size=readlt-readptr;
 return(NULL);
}


os_error * ramreadn(void * buff,int size,int * n)
{
 *n=MIN(readlt-readptr,size);
 memcpy(buff,readptr,*n);
 readptr+=*n;
 return(NULL);
}


/* is the next file opened for read going to be from RAM */

int pendingramread(void)
{
 return(readdata!=NULL);
}


/* the next file to be open for read, will come from RAM */

os_error * ramnextreadfile(void * data,int length)
{
 readdata=(char*)data;
 readptr=(char*)data;
 readlt=readdata+length;
 return(NULL);
}




os_error * ramreadclose(os_error * ep)
{
 readptr=readdata;
 return(ep);
}



os_error * ramreadoff(void)
{
 readdata=readptr=readlt=NULL;
 return(NULL);
}






static void ** writedataptr;
static int  *  writesizeptr;

static int     writesize;
static char  * writedata;


#define WRCHUNK 0x1000


os_error * ramwriten(void * buff,int size,int * n)
{
 os_error * err;
 
 err=schunk((flex_ptr)&writedata,writesize+size,WRCHUNK);
 if(!err)
 {
  memcpy(writedata+writesize,buff,size);
  *n=size;
  writesize+=size;
 }

 return(NULL);
}



/* is the next file opened for write going to be to RAM */

int pendingramwrite(void)
{
// cprintf("pend ram write %d",writedataptr!=NULL);
 return(writedataptr!=NULL);    // writedata is not set up at this point
}


/* the next file to be open for write, will go to RAM */

os_error * ramnextwritefile(void ** data,int * length)
{
 writedataptr=data;
 writesizeptr=length;
 return(NULL);
}



os_error * ramwriteclose(os_error * ep)
{
 if(writedataptr!=NULL)
 {
  *writesizeptr=writesize;
  *writedataptr=(void*)writedata;
  writesize=0;
 }
 return(ep);
}



os_error * ramwriteoff(void)
{
 os_error * err;

 err=NULL;

 if(writedata) err=sfree((flex_ptr)&writedata);

 writesize=0;
 writedataptr=NULL;
// cprintf("ramwriteoff");

 return(err);
}

