/*->h.wos */


typedef struct mousestr
{
 int x;
 int y;
 int buttons;
 wimp_w handle;
 int icon;
} mousestr;


typedef struct windowstr
{
 int x0;
 int y0;
 int x1;
 int y1;
 int scx;
 int scy;
 wimp_w bhandle;
 int wflags;
 int bx;
 int by;
} windowstr;


typedef struct iconstr
{
 int ix0;
 int ix1;
 int iy0;
 int iy1;
} iconstr;



#define BADPOINTER     -2
#define NOPOINTER      -1
#define SYSTEMPOINTER   0
#define USERPOINTER     1
#define APPSTARTINGPOINTER 2 // Standard arrow and small hourglass 
#define CROSSPOINTER    3    // Crosshair 
#define HELPPOINTER     4    // Arrow and question mark 
#define IBEAMPOINTER    5    // I-beam 
#define XICONPOINTER    6    // Obsolete for applications marked version 4.0 or later. 
#define CANTPOINTER     7    // Slashed circle 
#define SIZEPOINTER     8    // Obsolete for applications marked version 4.0 or later. Use IDC_SIZEALL. 
#define SIZEALLPOINTER  9    // Four-pointed arrow pointing north, south, east, and west 
#define SIZENESWPOINTER 10   // Double-pointed arrow pointing northeast and southwest 
#define SIZENSPOINTER   11   // Double-pointed arrow pointing north and south 
#define SIZENWSEPOINTER 12   // Double-pointed arrow pointing northwest and southeast 
#define SIZEWEPOINTER   13   // Double-pointed arrow pointing west and east 
#define UPARROWPOINTER  14   // Vertical arrow 
#define WAITPOINTER     15   // Hourglass
#define ICONPOINTER     16







typedef struct pointstr 
{
 TCHAR * name;
 int     x;
 int     y;
} pointstr;






extern os_error * select(wimp_w handle,int icon);
extern os_error * deselect(wimp_w handle,int icon);
extern os_error * selectst(wimp_w handle,int icon,int state);
extern os_error * shadeicon(wimp_w window,int icon);
extern os_error * unshadeicon(wimp_w window,int icon);

extern os_error * enablewindow(wimp_w window,int state,int recurse);


extern os_error * shadeiconst(wimp_w window,int icon,int state);
extern os_error * writeableicon(wimp_w window,int icon);
extern os_error * unwriteableicon(wimp_w window,int icon);
extern os_error * writeableiconst(wimp_w window,int icon,int state);
extern os_error * getpointer(mousestr * mouse);
extern os_error * getospointer(mousestr * mouse);
extern os_error * changepointer(int type,pointstr * pointdata,TCHAR * sprites);
extern void       getws(windowstr * window,wimp_openstr * o);
extern void       getos(windowstr * window,wimp_openstr * o);
extern os_error * getw(wimp_w handle,windowstr * window);
extern os_error * geti(wimp_w handle,int iconid,iconstr * icon);
extern os_error * open(wimp_w handle,int x0,int y0,int x1,int y1,int scx,int scy,
                                                               wimp_w behind);
extern int        wonscreen(wimp_openstr * r);
extern os_error * wcheckopen(wimp_openstr * o,int offok);

extern os_error * extent(wimp_w handle,int x0,int y0,int x1,int y1);
extern os_error * iconaddr(wimp_w handle,int icon,TCHAR ** p);
extern os_error * readicon(wimp_w handle,int icon,TCHAR * p,int size);
extern os_error * readiconunicode(wimp_w handle,int icon,wchar_t * dest,int size);
extern os_error * caret(wimp_w handle,int icon,int x,int y,int height,int index);
extern os_error * iecarrot(wimp_w wh,int ih);
extern os_error * incarrot(wimp_w wh,int ih);
extern os_error * setfocus(wimp_w handle);
extern os_error * setfocusicon(wimp_w handle,int icon);
extern os_error * setactive(wimp_w handle);
extern os_error * getactive(wimp_w * handle);
extern os_error * setforegroundwindow(wimp_w handle);
extern os_error * minimisewindow(wimp_w handle);
extern os_error * maximisewindow(wimp_w handle);
extern os_error * applyshowcommand(wimp_w handle);
extern os_error * findcaret(wimp_w * chandle,int * cicon);
extern os_error * findnexttab(wimp_w handle,int icon,int previous,int * next);
extern os_error * findnexttabw(wimp_w parent,int child,int previous,int * next);
extern os_error * setnexttabw(wimp_w parent,int child,int previous);

extern os_error * getparent(wimp_w handle,wimp_w * parent);

extern os_error * repainticon(wimp_w window,int icon);
extern os_error * iconlength(wimp_w window,int icon,int * len);
extern os_error * writeicon(wimp_w window,int icon,TCHAR * string);
extern os_error * writeiconunicode(wimp_w window,int icon,wchar_t * string);
extern os_error * writeiconc(wimp_w window,int icon,TCHAR * string);
extern os_error * writeiconf(wimp_w window,int icon,TCHAR * format,...);
extern os_error * writeiconfc(wimp_w window,int icon,TCHAR * format,...);
extern os_error * geticonint(wimp_w handle,int icon,int * val);

extern os_error * geto(wimp_w windowid,windowstr * window);
extern os_error * setmouse(int x,int y);
extern os_error * refreshwindowtitle(wimp_w handle);
extern os_error * writetitle(wimp_w window,TCHAR * title);
extern os_error * refreshwindow(wimp_w handle);
extern os_error * centerwindow(wimp_wstate * wst,wimp_w handle,int i);
extern void       centerwindow2(wimp_wstate * wst,int i);
extern void       centerwindow3(wimp_openstr * o,int i);
extern os_error * popup(wimp_w handle,int i);
extern os_error * reopenw(wimp_w handle);
extern os_error * reopenwlimit(wimp_w handle);
extern os_error * openatscroll(wimp_w handle,int scx,int scy);
extern os_error * closedown(wimp_w * handle);

extern int taskhandle;


extern os_error * starttask(void);

extern os_error * findwindowtask(wimp_w handle,int icon,int * task);

#define MAX_USERNAME 256
extern os_error * getusername(TCHAR * buffer,int buffsize);

extern int osversion(void);


#define ISWNT ((osversion() & 0x80000000)==0)
#define ISW9X ((osversion() & 0x80000000)!=0)



extern void getsumwimpbox(wimp_box * maxbox,wimp_box * box);
extern os_error * geticonbox(wimp_w handle,int * group,wimp_box * box);
extern os_error * moveicongroup(wimp_w handle,int * group,int xshift,int yshift);

extern os_error * oscommand(wimp_w parent,TCHAR * verb,TCHAR * file,TCHAR * params,TCHAR * directory,int flags);



extern os_error * fx(int a,int x,int y);
